# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', '  88 ', 'PRO', 0.0, (157.275, 108.08300000000001, 143.03199999999995)), ('A', '  89 ', 'ASP', 0.01633602122805386, (161.026, 107.13400000000001, 142.384)), ('A', ' 138 ', 'LEU', 0.0, (145.304, 88.275, 136.56399999999994)), ('A', ' 163 ', 'SER', 0.0025720452392383525, (166.864, 110.12699999999997, 117.52799999999998)), ('A', ' 167 ', 'GLU', 0.006637007488942564, (159.095, 108.86199999999997, 120.17799999999998))]
data['omega'] = []
data['rota'] = [('A', ' 175 ', 'LEU', 0.0, (149.53, 106.15699999999997, 121.357))]
data['cbeta'] = [('A', '  43 ', 'ARG', ' ', 0.28313421497357755, (156.41, 119.884, 131.602)), ('A', '  76 ', 'ARG', ' ', 0.25136484317123886, (134.84, 88.97000000000001, 153.246)), ('A', ' 125 ', 'ASN', ' ', 0.27945774760737163, (140.513, 77.016, 152.607)), ('A', ' 147 ', 'GLU', ' ', 0.2540671075063289, (149.946, 96.31199999999997, 125.55399999999997)), ('A', ' 148 ', 'LEU', ' ', 0.3000660895797621, (152.452, 97.68299999999998, 129.317))]
data['probe'] = [(' A  87  LYS  CA ', ' A  87  LYS  N  ', -1.445, (155.44, 108.842, 145.535)), (' A  12  TYR  OH ', ' A  17  GLU  HB2', -1.248, (140.623, 89.885, 156.575)), (' A  87  LYS  N  ', ' A  88  PRO  CD ', -1.15, (156.385, 109.103, 145.712)), (' A 137  TYR  O  ', ' A 138  LEU  HB2', -1.081, (144.221, 87.436, 137.719)), (' A 137  TYR  O  ', ' A 138  LEU  CB ', -1.038, (143.383, 87.492, 136.815)), (' A  87  LYS  N  ', ' A  88  PRO  HD3', -1.003, (156.154, 107.787, 145.969)), (' A  38  SER  O  ', ' A  39  TYR  HB3', -0.987, (152.503, 114.414, 135.113)), (' A  32  TYR  HE2', ' A  88  PRO  HG2', -0.941, (154.919, 110.098, 144.181)), (' A 162  GLU  O  ', ' A 163  SER  HB3', -0.898, (167.242, 108.294, 117.211)), (' A  87  LYS  N  ', ' A  88  PRO  HD2', -0.893, (156.803, 109.101, 146.026)), (' A  41  PHE  HE1', ' A  55  PHE  CD2', -0.88, (153.292, 108.492, 130.165)), (' A  86  LYS  C  ', ' A  88  PRO  HD3', -0.873, (155.143, 107.177, 146.125)), (' A  41  PHE  HE1', ' A  55  PHE  HD2', -0.862, (153.56, 108.623, 130.894)), (' A  38  SER  O  ', ' A  39  TYR  CB ', -0.857, (151.381, 113.902, 135.091)), (' A  94  GLU  HB3', ' A  98  ASN  ND2', -0.84, (165.081, 108.571, 130.334)), (' A  32  TYR  CE2', ' A  88  PRO  HG2', -0.807, (154.098, 110.096, 143.756)), (' A 124  LYS  O  ', ' A 125  ASN  HB3', -0.798, (140.867, 77.992, 153.083)), (' A   5  THR  HG1', ' A   6  SER  N  ', -0.775, (130.367, 91.342, 160.602)), (' A  32  TYR  CE2', ' A  87  LYS  HA ', -0.752, (154.003, 110.234, 144.692)), (' A 144  ALA  O  ', ' A 148  LEU  HG ', -0.752, (151.166, 95.867, 128.887)), (' A 166  ALA  O  ', ' A 167  GLU  CB ', -0.748, (160.284, 110.096, 119.811)), (' A  29  TYR  HE1', ' A  86  LYS  HB3', -0.739, (155.592, 105.524, 146.887)), (' A  41  PHE  CE1', ' A  55  PHE  CD2', -0.737, (153.497, 108.909, 129.653)), (' A   6  SER  C  ', ' A   7  GLN  HG2', -0.735, (127.685, 91.375, 160.93)), (' A  32  TYR  HE2', ' A  87  LYS  HA ', -0.729, (154.834, 110.321, 144.914)), (' A 160  ALA  HA ', ' A 166  ALA  HB3', -0.724, (163.251, 106.685, 118.789)), (' A  29  TYR  CE1', ' A  86  LYS  HB3', -0.714, (155.482, 104.646, 146.387)), (' A 162  GLU  O  ', ' A 163  SER  CB ', -0.714, (166.741, 108.4, 117.783)), (' A 100  MET  HE2', ' A 151  HIS  HB2', -0.714, (154.674, 100.672, 124.731)), (' A  67  GLU  O  ', ' A  70  MET  HG2', -0.706, (137.442, 99.957, 146.602)), (' A   9  ARG  HD3', ' A  12  TYR  CD2', -0.683, (136.655, 88.077, 158.061)), (' A  41  PHE  CE1', ' A  55  PHE  HD2', -0.671, (153.875, 109.304, 130.51)), (' A 166  ALA  O  ', ' A 167  GLU  HB2', -0.666, (161.342, 109.189, 120.233)), (' A   9  ARG  HD3', ' A  12  TYR  HD2', -0.663, (136.329, 87.725, 158.656)), (' A  17  GLU  OE1', ' A  78  GLY  HA3', -0.661, (138.528, 92.379, 155.368)), (' A 151  HIS  HB3', ' A 170  PHE  HZ ', -0.659, (155.07, 101.527, 123.027)), (' A 163  SER  C  ', ' A 165  LEU  H  ', -0.654, (164.879, 110.607, 116.563)), (' A 100  MET  HB3', ' A 152  VAL HG22', -0.653, (158.251, 100.378, 127.339)), (' A  94  GLU  HB3', ' A  98  ASN HD22', -0.643, (164.289, 108.669, 131.326)), (' A 160  ALA  HB3', ' A 161  PRO  HD3', -0.643, (164.213, 104.614, 122.664)), (' A  12  TYR  HH ', ' A  17  GLU  HB2', -0.641, (140.249, 90.993, 157.361)), (' A 163  SER  HB2', ' A 165  LEU  HB3', -0.64, (165.435, 108.953, 115.682)), (' A  41  PHE  HB2', ' A  52  ALA  HB2', -0.638, (152.153, 113.575, 128.548)), (' A  90  CYS  HB3', ' A  93  TRP  CZ3', -0.632, (160.956, 108.143, 137.655)), (' A  32  TYR  CE2', ' A  88  PRO  CG ', -0.625, (154.611, 109.808, 143.893)), (' A   6  SER  O  ', ' A   7  GLN  HG2', -0.621, (128.377, 91.19, 160.957)), (' A  22  ARG  NH1', ' A  23  GLN HE21', -0.619, (149.314, 91.532, 147.636)), (' A   6  SER  O  ', ' A   7  GLN  CB ', -0.615, (127.644, 90.924, 159.673)), (' A 144  ALA  O  ', ' A 148  LEU  CG ', -0.602, (151.225, 96.654, 129.166)), (' A 104  LEU HD11', ' A 145  ILE HG23', -0.599, (155.348, 93.153, 131.184)), (' A 158  MET  HE1', ' A 170  PHE  HD1', -0.599, (156.652, 103.311, 118.297)), (' A  34  TYR  O  ', ' A  37  MET  HG2', -0.598, (152.297, 108.444, 134.971)), (' A  19  ALA  HA ', ' A  22  ARG  HD3', -0.594, (148.272, 91.388, 151.398)), (' A  89  ASP  O  ', ' A  90  CYS  HB2', -0.59, (162.815, 107.65, 139.424)), (' A  54  TYR  OH ', ' A 148  LEU HD22', -0.575, (150.368, 100.146, 128.23)), (' A  90  CYS  HB3', ' A  93  TRP  CH2', -0.575, (160.573, 107.618, 137.8)), (' A   9  ARG  CD ', ' A  12  TYR  HD2', -0.574, (136.424, 87.324, 158.863)), (' A   6  SER  O  ', ' A   7  GLN  CG ', -0.562, (128.076, 91.499, 160.206)), (' A  29  TYR  HA ', ' A  85  ILE HG23', -0.558, (150.757, 105.695, 145.885)), (' A 100  MET  HE2', ' A 151  HIS  CB ', -0.557, (154.98, 101.034, 124.54)), (' A  32  TYR  CD2', ' A  88  PRO  HG3', -0.548, (153.571, 108.789, 143.559)), (' A  21  ASN  O  ', ' A  24  ILE HG22', -0.548, (145.958, 98.406, 150.982)), (' A  40  TYR  CD2', ' A  93  TRP  CD1', -0.546, (157.86, 110.664, 135.011)), (' A 125  ASN  CG ', ' A 125  ASN  O  ', -0.534, (138.794, 77.811, 151.492)), (' A  41  PHE  CZ ', ' A  51  PHE  HB3', -0.53, (154.411, 109.405, 127.773)), (' A  51  PHE  CZ ', ' A 170  PHE  CD2', -0.528, (155.664, 106.744, 122.413)), (' A 158  MET  HE1', ' A 170  PHE  CD1', -0.526, (156.445, 103.899, 118.862)), (' A  30  ALA  O  ', ' A  34  TYR  CD1', -0.525, (150.12, 104.54, 138.875)), (' A  51  PHE  CZ ', ' A 170  PHE  HD2', -0.521, (155.291, 107.054, 122.33)), (' A  41  PHE  CD1', ' A  52  ALA  HA ', -0.517, (152.374, 111.282, 129.422)), (' A  30  ALA  O  ', ' A  34  TYR  HD1', -0.516, (150.03, 104.431, 138.98)), (' A 134  GLU  HA ', ' A 138  LEU HD22', -0.516, (142.815, 85.459, 137.706)), (' A 100  MET  CE ', ' A 151  HIS  HB2', -0.505, (154.502, 100.768, 125.639)), (' A 149  GLY  O  ', ' A 152  VAL  HB ', -0.504, (158.28, 97.179, 125.586)), (' A  12  TYR  OH ', ' A  17  GLU  CB ', -0.501, (141.212, 91.223, 157.454)), (' A  10  GLN  C  ', ' A  12  TYR  H  ', -0.493, (135.186, 83.555, 155.86)), (' A  38  SER  HB3', ' A  55  PHE  HB2', -0.492, (150.301, 109.662, 132.154)), (' A  80  ILE  O  ', ' A  80  ILE HG23', -0.491, (139.835, 101.064, 156.381)), (' A  40  TYR  HD2', ' A  93  TRP  CD1', -0.489, (157.524, 111.084, 134.871)), (' A  32  TYR  HD2', ' A  88  PRO  HG3', -0.487, (153.542, 108.531, 143.547)), (' A 144  ALA  HB1', ' A 148  LEU HD12', -0.487, (149.552, 96.61, 131.574)), (' A  73  GLN  HG2', ' A  74  ASN  N  ', -0.485, (135.955, 95.437, 152.028)), (' A  10  GLN  O  ', ' A  12  TYR  N  ', -0.474, (135.911, 83.65, 155.239)), (' A  30  ALA  HB1', ' A  34  TYR  HE1', -0.472, (149.909, 101.442, 138.576)), (' A 134  GLU  HG2', ' A 138  LEU HD22', -0.464, (143.226, 84.313, 137.969)), (' A  34  TYR  CE1', ' A  62  GLU  HG3', -0.463, (148.909, 102.383, 137.761)), (' A 133  ILE  O  ', ' A 137  TYR  O  ', -0.462, (142.718, 88.315, 138.697)), (' A  50  ASN  HB3', ' A 175  LEU  HB3', -0.461, (149.538, 108.774, 122.273)), (' A   6  SER  O  ', ' A   7  GLN  HB2', -0.46, (127.782, 90.922, 159.453)), (' A   9  ARG HH11', ' A  12  TYR  HE2', -0.457, (138.236, 89.314, 159.098)), (' A  37  MET  HE2', ' A  55  PHE  CE2', -0.454, (154.45, 105.941, 131.672)), (' A  80  ILE  CG2', ' A  80  ILE  O  ', -0.451, (139.471, 100.718, 156.522)), (' A  87  LYS  CB ', ' A  87  LYS  N  ', -0.449, (156.446, 110.101, 146.74)), (' A 121  ALA  HB2', ' A 129  LEU HD23', -0.449, (143.175, 84.851, 148.836)), (' A   5  THR  OG1', ' A   6  SER  N  ', -0.449, (131.153, 91.306, 160.74)), (' A 163  SER  OG ', ' A 164  GLY  N  ', -0.442, (164.845, 110.113, 118.068)), (' A  90  CYS  SG ', ' A  92  ASP  O  ', -0.442, (163.241, 110.536, 136.271)), (' A 163  SER  C  ', ' A 165  LEU  N  ', -0.438, (164.531, 111.452, 116.815)), (' A  26  LEU  HA ', ' A  26  LEU HD23', -0.438, (151.144, 100.175, 146.316)), (' A 104  LEU HD22', ' A 149  GLY  HA2', -0.431, (157.197, 95.841, 128.475)), (' A  54  TYR  OH ', ' A 148  LEU  CD2', -0.43, (150.147, 100.016, 128.224)), (' A  34  TYR  HA ', ' A  37  MET  HG2', -0.428, (152.087, 107.007, 135.607)), (' A  50  ASN  HB2', ' A 171  ASP  OD1', -0.425, (151.498, 110.559, 122.254)), (' A  65  HIS  CD2', ' A 137  TYR  HE2', -0.422, (142.511, 96.205, 139.177)), (' A  22  ARG  NH1', ' A  23  GLN  NE2', -0.42, (149.162, 91.814, 147.306)), (' A  65  HIS  CG ', ' A 137  TYR  HE2', -0.42, (142.809, 96.066, 139.667)), (' A 120  LEU  HA ', ' A 120  LEU HD23', -0.419, (148.922, 82.045, 151.299)), (' A   5  THR  N  ', ' A   9  ARG  NE ', -0.419, (134.716, 89.227, 161.248)), (' A 114  LEU  CD1', ' A 141  GLN  HG3', -0.419, (147.813, 91.396, 138.994)), (' A  73  GLN HE22', ' A  80  ILE HD12', -0.418, (139.05, 99.545, 152.209)), (' A  40  TYR  CE2', ' A  93  TRP  CD1', -0.416, (157.791, 110.89, 136.128)), (' A 144  ALA  O  ', ' A 145  ILE  C  ', -0.415, (151.823, 94.315, 129.305)), (' A 148  LEU  N  ', ' A 148  LEU HD23', -0.412, (151.249, 97.83, 127.364)), (' A  41  PHE  CZ ', ' A  55  PHE  CE2', -0.411, (154.498, 108.157, 129.774)), (' A  41  PHE  CD2', ' A  48  LEU  HB2', -0.405, (155.184, 112.42, 127.087)), (' A  90  CYS  HB3', ' A  93  TRP  CE3', -0.404, (161.108, 107.86, 137.2)), (' A  67  GLU  HA ', ' A  70  MET  HE2', -0.404, (137.367, 101.546, 145.948))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
