# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = []
data['omega'] = []
data['rota'] = []
data['cbeta'] = []
data['probe'] = [(' A  43  ARG  O  ', ' A  47  ALA  HB2', -1.142, (155.063, 119.03, 127.625)), (' A  41  PHE  CE1', ' A  55  PHE  HE1', -1.135, (154.874, 108.506, 129.706)), (' A 101  GLU  OE2', ' A 156  ARG  NH1', -1.065, (164.464, 99.953, 126.819)), (' A  43  ARG  O  ', ' A  47  ALA  CB ', -1.007, (155.625, 118.528, 126.407)), (' A  13  HIS  CD2', ' A 124  LYS  HB3', -0.978, (142.046, 81.571, 154.095)), (' A  41  PHE  CE1', ' A  55  PHE  CE1', -0.93, (154.585, 107.857, 129.841)), (' A  41  PHE  HE1', ' A  55  PHE  CE1', -0.924, (155.139, 107.674, 130.5)), (' A  41  PHE  HE1', ' A  55  PHE  HE1', -0.918, (155.637, 108.305, 130.754)), (' A  48  LEU HD11', ' A 167  GLU  OE1', -0.904, (160.21, 110.43, 123.297)), (' A  26  LEU HD21', ' A 110  VAL  HA ', -0.902, (151.793, 95.636, 142.087)), (' A  60  HIS  CE1', ' A  63  ARG HH11', -0.847, (137.114, 105.275, 135.346)), (' A  17  GLU  HG3', ' A  73  GLN HE22', -0.824, (140.082, 93.046, 154.983)), (' A 115  LEU  HA ', ' A 118  HIS  CE1', -0.791, (149.475, 84.884, 141.603)), (' A 135  THR  C  ', ' A 137  TYR  H  ', -0.784, (140.816, 89.281, 137.806)), (' A  30  ALA  HB3', ' A  62  GLU  OE1', -0.758, (148.464, 100.645, 139.804)), (' A  97  LEU HD22', ' A 160  ALA  CB ', -0.753, (163.721, 103.145, 123.361)), (' A  23  GLN  HB2', ' A 117  LEU HD11', -0.751, (146.754, 92.165, 146.782)), (' A  72  LEU HD22', ' A 132  PHE  CE2', -0.749, (138.983, 91.107, 145.522)), (' A  51  PHE  CD1', ' A 171  ASP  OD2', -0.732, (154.999, 109.818, 123.429)), (' A 135  THR  O  ', ' A 137  TYR  N  ', -0.731, (140.656, 90.464, 138.324)), (' A 134  GLU  HA ', ' A 138  LEU HD12', -0.73, (143.926, 85.808, 138.894)), (' A  41  PHE  O  ', ' A  47  ALA  HA ', -0.727, (154.858, 115.459, 127.097)), (' A 115  LEU  HA ', ' A 118  HIS  ND1', -0.719, (148.253, 85.521, 142.113)), (' A  24  ILE HG12', ' A  69  LEU  HB3', -0.714, (142.196, 96.984, 147.327)), (' A  37  MET  HE2', ' A  55  PHE  CZ ', -0.708, (154.83, 106.554, 131.693)), (' A 158  MET  HB3', ' A 170  PHE  CE1', -0.704, (160.822, 103.274, 114.91)), (' A  97  LEU HD22', ' A 160  ALA  HB3', -0.697, (163.859, 103.17, 123.458)), (' A 104  LEU HD11', ' A 145  ILE HG23', -0.697, (155.593, 94.043, 130.69)), (' A  23  GLN  HG3', ' A  69  LEU HD11', -0.678, (145.272, 95.199, 144.818)), (' A 160  ALA  HB3', ' A 161  PRO  HD3', -0.675, (164.877, 104.259, 123.232)), (' A  63  ARG  NH2', ' A  67  GLU  OE2', -0.656, (136.468, 104.268, 140.748)), (' A  72  LEU HD22', ' A 132  PHE  CD2', -0.649, (139.485, 90.682, 145.583)), (' A  34  TYR  OH ', ' A 107  GLU  OE2', -0.649, (151.197, 99.815, 135.123)), (' A  68  LYS  HB2', ' A 137  TYR  OH ', -0.646, (139.499, 95.997, 141.736)), (' A  80  ILE HG22', ' A  82  LEU  HG ', -0.645, (141.303, 101.606, 154.092)), (' A  97  LEU  HB2', ' A 160  ALA  HB1', -0.644, (162.164, 105.132, 123.905)), (' A 100  MET  HE1', ' A 148  LEU HD23', -0.629, (152.921, 100.986, 128.23)), (' A 114  LEU HD12', ' A 141  GLN  HG3', -0.617, (147.737, 92.064, 138.995)), (' A  23  GLN  HG3', ' A  69  LEU  CD1', -0.615, (144.293, 95.235, 145.396)), (' A  17  GLU  HB2', ' A  76  ARG  NH1', -0.601, (140.542, 89.459, 155.691)), (' A  43  ARG  O  ', ' A  47  ALA  HB3', -0.592, (156.121, 118.621, 126.411)), (' A  24  ILE  CG1', ' A  69  LEU  HB3', -0.591, (142.559, 97.096, 147.883)), (' A   6  SER  HB3', ' A   9  ARG  HB2', -0.581, (133.472, 89.277, 159.407)), (' A  80  ILE  CG2', ' A  82  LEU  HG ', -0.574, (141.31, 101.506, 153.583)), (' A 157  LYS  C  ', ' A 159  GLY  N  ', -0.571, (164.448, 103.173, 117.485)), (' A 160  ALA  HB3', ' A 161  PRO  CD ', -0.56, (164.746, 104.667, 122.938)), (' A 135  THR  C  ', ' A 137  TYR  N  ', -0.558, (140.889, 90.212, 137.928)), (' A  48  LEU HD12', ' A  51  PHE  CE1', -0.557, (156.962, 109.537, 123.524)), (' A  24  ILE HG12', ' A  69  LEU  CB ', -0.554, (142.121, 97.206, 147.209)), (' A 158  MET  O  ', ' A 166  ALA  HB1', -0.554, (162.348, 106.416, 116.448)), (' A  30  ALA  CB ', ' A  62  GLU  OE1', -0.551, (148.841, 101.213, 139.773)), (' A 159  GLY  O  ', ' A 166  ALA  HB3', -0.545, (163.823, 107.35, 118.576)), (' A  21  ASN HD21', ' A  81  PHE  HD1', -0.537, (142.514, 96.484, 156.808)), (' A 115  LEU HD23', ' A 118  HIS  CE1', -0.533, (149.307, 84.338, 140.706)), (' A  43  ARG  H  ', ' A  47  ALA  HB2', -0.524, (154.211, 117.945, 128.06)), (' A  51  PHE  CE1', ' A 171  ASP  HB2', -0.517, (155.864, 108.32, 122.484)), (' A  48  LEU  CD1', ' A 167  GLU  HG2', -0.516, (158.411, 109.596, 122.402)), (' A  48  LEU HD13', ' A 167  GLU  HG2', -0.511, (158.182, 109.631, 121.981)), (' A  97  LEU HD11', ' A 152  VAL HG13', -0.511, (161.229, 100.646, 125.78)), (' A  48  LEU  CD1', ' A 167  GLU  OE1', -0.501, (158.989, 110.136, 123.396)), (' A  51  PHE  CD2', ' A 175  LEU  CD1', -0.499, (153.468, 106.504, 124.453)), (' A 115  LEU  CD2', ' A 118  HIS  CE1', -0.499, (149.458, 84.271, 140.792)), (' A  60  HIS  CE1', ' A  63  ARG  NH1', -0.497, (136.775, 104.706, 136.062)), (' A 115  LEU  CD2', ' A 118  HIS  HE1', -0.495, (149.981, 84.662, 140.735)), (' A  27  GLU  HG3', ' A  69  LEU  CD1', -0.485, (144.575, 96.971, 143.984)), (' A 115  LEU  CA ', ' A 118  HIS  CE1', -0.472, (149.954, 85.164, 142.332)), (' A  29  TYR  OH ', ' A  89  ASP  OD1', -0.471, (157.44, 104.464, 143.974)), (' A 148  LEU  O  ', ' A 152  VAL HG23', -0.47, (156.877, 98.872, 126.745)), (' A  38  SER  HB3', ' A  55  PHE  HB2', -0.469, (150.031, 109.255, 131.68)), (' A 126  ASP  OD2', ' A 129  LEU  HB2', -0.468, (138.539, 84.808, 149.944)), (' A 171  ASP  OD1', ' A 175  LEU  HB2', -0.466, (151.684, 107.942, 122.119)), (' A  60  HIS  HE1', ' A  63  ARG HH11', -0.464, (136.691, 105.513, 135.477)), (' A 155  LEU  O  ', ' A 160  ALA  HB2', -0.464, (162.463, 103.59, 121.342)), (' A 157  LYS  O  ', ' A 158  MET  C  ', -0.458, (163.13, 103.015, 117.796)), (' A  27  GLU  HG3', ' A  69  LEU HD11', -0.456, (144.356, 96.441, 144.15)), (' A  50  ASN HD22', ' A 172  LYS  HA ', -0.447, (150.799, 110.587, 119.361)), (' A  34  TYR  CD1', ' A  62  GLU  HG3', -0.447, (148.217, 102.891, 137.37)), (' A 133  ILE  O  ', ' A 137  TYR  HB2', -0.441, (142.824, 89.536, 140.331)), (' A  50  ASN  ND2', ' A 172  LYS  HA ', -0.441, (150.791, 110.446, 118.822)), (' A 138  LEU  O  ', ' A 142  VAL HG23', -0.437, (147.967, 88.903, 134.328)), (' A 104  LEU  CD1', ' A 145  ILE HG23', -0.437, (155.146, 94.464, 131.192)), (' A 157  LYS  C  ', ' A 159  GLY  H  ', -0.434, (164.835, 102.944, 117.23)), (' A 100  MET  CE ', ' A 148  LEU HD23', -0.43, (153.582, 101.364, 128.127)), (' A  37  MET  HE2', ' A  55  PHE  CE1', -0.43, (154.47, 106.923, 131.916)), (' A  19  ALA  HB1', ' A 117  LEU  CD2', -0.428, (147.487, 89.498, 150.214)), (' A  37  MET  HE1', ' A 103  ALA  HB2', -0.428, (155.176, 103.942, 133.08)), (' A 171  ASP  OD1', ' A 175  LEU HD12', -0.427, (152.722, 107.596, 122.899)), (' A  43  ARG HH11', ' A  46  VAL HG22', -0.427, (159.811, 116.308, 131.404)), (' A  17  GLU  HB2', ' A  76  ARG  CZ ', -0.427, (140.446, 89.797, 155.499)), (' A 161  PRO  C  ', ' A 163  SER  H  ', -0.425, (167.002, 108.986, 121.829)), (' A  93  TRP  HZ3', ' A 102  CYS  HB2', -0.424, (159.169, 104.689, 134.922)), (' A  19  ALA  HB1', ' A 117  LEU HD23', -0.422, (147.542, 89.261, 150.235)), (' A  97  LEU HD13', ' A 155  LEU  HB2', -0.421, (160.542, 102.224, 124.168)), (' A 155  LEU HD22', ' A 167  GLU  HG3', -0.418, (158.823, 106.643, 122.305)), (' A   8  VAL HG12', ' A  76  ARG  O  ', -0.417, (132.082, 90.174, 155.343)), (' A  21  ASN  ND2', ' A  81  PHE  CD1', -0.414, (143.278, 96.191, 156.894)), (' A   8  VAL  HB ', ' A  77  GLY  HA3', -0.413, (131.319, 91.124, 157.264)), (' A 114  LEU  CD1', ' A 141  GLN  HG3', -0.409, (147.496, 92.507, 139.186)), (' A 100  MET  HE1', ' A 148  LEU  CD2', -0.408, (153.437, 101.212, 128.617)), (' A  21  ASN  ND2', ' A  81  PHE  HD1', -0.405, (143.081, 96.249, 156.738))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
