# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = []
data['omega'] = []
data['rota'] = []
data['cbeta'] = []
data['probe'] = [(' A 114  LEU  CD1', ' A 133  ILE HG23', -1.284, (145.108, 89.117, 141.856)), (' A 155  LEU  O  ', ' A 160  ALA  HB2', -1.218, (162.869, 103.404, 120.683)), (' A 115  LEU  HA ', ' A 118  HIS  CE1', -1.129, (149.145, 85.846, 142.143)), (' A 114  LEU HD11', ' A 133  ILE HG23', -1.083, (144.37, 89.195, 142.237)), (' A 114  LEU  HB2', ' A 137  TYR  OH ', -1.044, (148.024, 91.179, 141.227)), (' A  34  TYR  OH ', ' A 107  GLU  OE2', -1.033, (150.11, 100.214, 134.704)), (' A 101  GLU  OE2', ' A 156  ARG  NH1', -1.0, (164.681, 100.164, 126.961)), (' A  60  HIS  CE1', ' A  63  ARG HH11', -0.986, (136.849, 105.499, 135.608)), (' A  97  LEU HD22', ' A 160  ALA  CB ', -0.942, (163.714, 103.513, 122.805)), (' A 115  LEU  CA ', ' A 118  HIS  CE1', -0.941, (150.083, 85.62, 141.875)), (' A 114  LEU HD12', ' A 133  ILE HG23', -0.941, (145.952, 89.073, 143.219)), (' A 115  LEU  HA ', ' A 118  HIS  ND1', -0.932, (148.546, 85.093, 142.256)), (' A  26  LEU HD21', ' A 110  VAL  HA ', -0.866, (151.924, 95.66, 142.113)), (' A 158  MET  HG3', ' A 170  PHE  CZ ', -0.862, (159.477, 102.156, 115.201)), (' A 155  LEU  O  ', ' A 160  ALA  CB ', -0.817, (163.024, 104.398, 121.22)), (' A  97  LEU HD22', ' A 160  ALA  HB3', -0.813, (164.621, 103.496, 123.208)), (' A  20  ILE HG22', ' A  73  GLN HE21', -0.796, (142.18, 94.617, 150.654)), (' A 100  MET  HE1', ' A 148  LEU HD23', -0.795, (152.945, 100.779, 127.931)), (' A  13  HIS  CD2', ' A 124  LYS  HB3', -0.78, (142.083, 81.785, 153.946)), (' A 115  LEU  CA ', ' A 118  HIS  HE1', -0.764, (150.463, 84.754, 142.415)), (' A  20  ILE HD11', ' A 129  LEU HD11', -0.752, (141.724, 88.33, 149.251)), (' A 158  MET  HG3', ' A 170  PHE  HZ ', -0.75, (159.635, 102.179, 114.719)), (' A  20  ILE HG22', ' A  73  GLN  NE2', -0.741, (141.68, 94.161, 151.257)), (' A  43  ARG  O  ', ' A  47  ALA  HB2', -0.739, (156.407, 118.531, 127.181)), (' A 115  LEU  O  ', ' A 118  HIS  CE1', -0.725, (149.916, 84.64, 143.079)), (' A 104  LEU HD11', ' A 145  ILE HG23', -0.715, (155.423, 94.257, 130.691)), (' A  63  ARG  NH2', ' A  67  GLU  OE2', -0.697, (136.182, 104.895, 140.482)), (' A  20  ILE HD11', ' A 129  LEU  CD1', -0.69, (141.17, 88.657, 149.095)), (' A  20  ILE  CG2', ' A  73  GLN  NE2', -0.686, (142.028, 93.714, 150.802)), (' A  49  LYS  O  ', ' A 171  ASP  OD1', -0.684, (152.152, 111.209, 122.11)), (' A 114  LEU HD11', ' A 133  ILE  CG2', -0.68, (144.781, 88.226, 142.057)), (' A 160  ALA  HB3', ' A 161  PRO  HD3', -0.673, (165.32, 103.998, 123.509)), (' A  97  LEU HD22', ' A 160  ALA  HB1', -0.644, (163.034, 104.295, 123.45)), (' A 160  ALA  HB3', ' A 161  PRO  CD ', -0.642, (165.189, 104.009, 122.601)), (' A 115  LEU  CB ', ' A 118  HIS  HE1', -0.638, (150.513, 84.709, 141.663)), (' A 159  GLY  O  ', ' A 163  SER  HB3', -0.631, (165.253, 108.215, 118.499)), (' A 115  LEU  O  ', ' A 118  HIS  ND1', -0.617, (149.043, 84.842, 143.273)), (' A 114  LEU  CD1', ' A 133  ILE HD12', -0.617, (144.559, 89.793, 143.238)), (' A 158  MET  O  ', ' A 166  ALA  CB ', -0.606, (163.559, 106.259, 117.0)), (' A  24  ILE HG12', ' A  69  LEU  HB3', -0.6, (142.349, 97.554, 147.888)), (' A  27  GLU  HG3', ' A  69  LEU HD11', -0.596, (144.004, 96.801, 144.322)), (' A 115  LEU  CA ', ' A 118  HIS  ND1', -0.592, (149.017, 86.019, 142.928)), (' A   6  SER  CB ', ' A  77  GLY  O  ', -0.59, (132.738, 92.012, 159.35)), (' A 158  MET  HG3', ' A 170  PHE  CE1', -0.59, (159.829, 102.622, 115.96)), (' A 158  MET  O  ', ' A 166  ALA  HB2', -0.574, (163.967, 106.383, 116.923)), (' A 148  LEU  O  ', ' A 152  VAL HG23', -0.572, (156.805, 98.574, 126.676)), (' A  51  PHE  CD1', ' A 171  ASP  OD1', -0.568, (153.533, 109.444, 122.63)), (' A  26  LEU  CD2', ' A 110  VAL  HA ', -0.567, (151.391, 95.439, 143.088)), (' A  41  PHE  O  ', ' A  47  ALA  HA ', -0.563, (154.942, 115.576, 126.752)), (' A 100  MET  CE ', ' A 148  LEU HD23', -0.551, (153.626, 101.114, 127.709)), (' A 155  LEU  C  ', ' A 160  ALA  HB2', -0.546, (162.436, 102.776, 121.899)), (' A 114  LEU HD12', ' A 133  ILE HD12', -0.544, (145.175, 89.513, 143.603)), (' A 114  LEU HD12', ' A 133  ILE  CG2', -0.544, (145.633, 88.294, 143.428)), (' A 168  TYR  O  ', ' A 171  ASP  HB3', -0.542, (154.406, 110.122, 118.538)), (' A  40  TYR  CE2', ' A  93  TRP  O  ', -0.538, (160.622, 111.836, 131.059)), (' A   8  VAL  O  ', ' A  10  GLN  HG3', -0.536, (130.692, 85.627, 155.567)), (' A  42  ASP  OD1', ' A  49  LYS  NZ ', -0.535, (150.81, 118.972, 127.894)), (' A  34  TYR  CD1', ' A  62  GLU  HG3', -0.534, (148.016, 102.761, 137.559)), (' A 115  LEU  C  ', ' A 118  HIS  CE1', -0.522, (149.589, 85.385, 143.346)), (' A 114  LEU  HB2', ' A 137  TYR  HH ', -0.52, (147.874, 92.378, 142.033)), (' A  43  ARG  O  ', ' A  47  ALA  CB ', -0.507, (156.244, 118.191, 126.659)), (' A 100  MET  HE1', ' A 148  LEU  CD2', -0.505, (153.403, 101.217, 128.455)), (' A  48  LEU  CD1', ' A 167  GLU  HB3', -0.502, (158.531, 109.816, 122.333)), (' A 114  LEU  CD1', ' A 133  ILE  CG2', -0.49, (145.607, 88.163, 142.296)), (' A 115  LEU  HB3', ' A 118  HIS  HE1', -0.489, (151.097, 84.784, 142.177)), (' A  60  HIS  CE1', ' A  63  ARG  NH1', -0.487, (136.588, 104.889, 136.325)), (' A  60  HIS  HE1', ' A  63  ARG HH11', -0.486, (136.423, 106.037, 135.896)), (' A  43  ARG  H  ', ' A  47  ALA  HB2', -0.485, (154.88, 117.724, 128.133)), (' A  26  LEU  HG ', ' A 110  VAL HG22', -0.483, (150.734, 97.447, 142.925)), (' A 100  MET  CE ', ' A 148  LEU  CD2', -0.479, (153.607, 101.008, 128.4)), (' A  51  PHE  HD1', ' A 171  ASP  OD1', -0.478, (153.725, 110.224, 122.846)), (' A  78  GLY  HA2', ' A  79  ARG  HD3', -0.475, (136.67, 93.538, 159.371)), (' A 126  ASP  C  ', ' A 126  ASP  OD1', -0.474, (137.99, 82.107, 148.627)), (' A 158  MET  O  ', ' A 166  ALA  HB1', -0.473, (162.972, 106.083, 117.649)), (' A  87  LYS  HB3', ' A  88  PRO  HD2', -0.471, (156.029, 110.473, 144.512)), (' A 114  LEU  CB ', ' A 137  TYR  OH ', -0.471, (148.276, 91.228, 141.229)), (' A 104  LEU  CD1', ' A 145  ILE HG23', -0.465, (155.237, 94.372, 130.946)), (' A 137  TYR  O  ', ' A 138  LEU  HB3', -0.463, (144.095, 88.058, 136.604)), (' A  27  GLU  HG3', ' A  69  LEU  CD1', -0.462, (144.057, 97.158, 144.508)), (' A 100  MET  HG3', ' A 155  LEU  CD1', -0.461, (156.821, 103.63, 125.296)), (' A  17  GLU  HB2', ' A  76  ARG  CZ ', -0.454, (140.623, 90.205, 156.217)), (' A  23  GLN  HB2', ' A 117  LEU HD11', -0.446, (146.363, 92.607, 147.207)), (' A  24  ILE  HA ', ' A  69  LEU HD13', -0.442, (144.229, 97.806, 146.904)), (' A 117  LEU HD13', ' A 133  ILE HD11', -0.439, (143.896, 90.055, 146.063)), (' A  24  ILE  CG1', ' A  69  LEU  HB3', -0.438, (142.39, 97.12, 148.309)), (' A  50  ASN  HB2', ' A 171  ASP  OD2', -0.435, (151.458, 110.83, 120.984)), (' A  50  ASN  ND2', ' A 171  ASP  OD2', -0.433, (150.889, 111.656, 120.332)), (' A  37  MET  SD ', ' A  99  ALA  HB1', -0.433, (156.397, 106.939, 132.2)), (' A 114  LEU  CG ', ' A 133  ILE HG23', -0.431, (146.071, 88.657, 142.213)), (' A   6  SER  HB2', ' A  77  GLY  O  ', -0.429, (132.971, 91.933, 160.251)), (' A  24  ILE HG21', ' A  82  LEU  CD2', -0.428, (142.925, 100.935, 151.081)), (' A  49  LYS  O  ', ' A 171  ASP  CG ', -0.425, (152.632, 111.211, 121.718)), (' A 151  HIS  NE2', ' A 175  LEU HD21', -0.425, (151.195, 102.135, 123.364)), (' A 133  ILE  O  ', ' A 137  TYR  HD2', -0.423, (144.469, 89.064, 140.138)), (' A 168  TYR  CE2', ' A 172  LYS  HE3', -0.422, (154.065, 113.818, 115.395)), (' A  48  LEU HD11', ' A 167  GLU  HB3', -0.419, (158.705, 110.181, 122.853)), (' A 156  ARG  O  ', ' A 157  LYS  HB2', -0.417, (163.262, 99.602, 118.71)), (' A  54  TYR  HE2', ' A 148  LEU HD21', -0.417, (151.746, 101.895, 129.712)), (' A  20  ILE  HB ', ' A  73  GLN HE22', -0.415, (142.536, 92.976, 152.335)), (' A  41  PHE  HE1', ' A  55  PHE  CE1', -0.412, (154.271, 107.931, 130.043)), (' A  76  ARG  C  ', ' A  78  GLY  H  ', -0.411, (134.893, 91.559, 155.974)), (' A 115  LEU  CD2', ' A 118  HIS  CE1', -0.41, (149.972, 84.861, 140.784)), (' A  71  LYS  O  ', ' A  75  GLN  HG3', -0.409, (133.177, 94.778, 149.432)), (' A  12  TYR  CD2', ' A  76  ARG  HG2', -0.409, (136.939, 88.7, 152.649)), (' A 100  MET  HE2', ' A 151  HIS  CB ', -0.408, (154.564, 101.303, 125.221)), (' A  41  PHE  CE1', ' A  55  PHE  CE1', -0.408, (154.192, 107.978, 129.945)), (' A 160  ALA  CB ', ' A 161  PRO  CD ', -0.407, (164.738, 104.779, 122.877)), (' A  24  ILE HG12', ' A  69  LEU  CB ', -0.406, (141.966, 97.431, 147.5)), (' A  72  LEU HD22', ' A 132  PHE  CD2', -0.406, (139.288, 90.927, 146.279)), (' A 118  HIS  HB3', ' A 133  ILE  CG2', -0.404, (145.439, 85.831, 143.055)), (' A  97  LEU HD13', ' A 155  LEU  HB2', -0.402, (160.282, 102.491, 123.735)), (' A 117  LEU  HB3', ' A 133  ILE HG13', -0.402, (144.482, 87.699, 146.025)), (' A 137  TYR  O  ', ' A 139  ASN  N  ', -0.401, (143.796, 89.056, 135.327)), (' A 115  LEU  C  ', ' A 118  HIS  ND1', -0.4, (149.267, 85.42, 143.623))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
