# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', '  94 ', 'GLU', 0.0004976885225217091, (163.82100000000003, 111.01099999999997, 131.108)), ('A', ' 160 ', 'ALA', 0.0, (163.72100000000003, 105.68199999999997, 120.772)), ('A', ' 161 ', 'PRO', 0.004960390338552091, (165.634, 107.89099999999998, 123.088)), ('A', ' 162 ', 'GLU', 0.0011349934926385195, (168.40600000000006, 109.26899999999998, 120.66))]
data['omega'] = [('A', ' 161 ', 'PRO', None, (165.24000000000004, 106.58699999999997, 122.55300000000001))]
data['rota'] = [('A', '  20 ', 'ILE', 0.13861832625240625, (144.113, 92.85599999999997, 150.702)), ('A', '  49 ', 'LYS', 0.19262304793724533, (150.22100000000006, 114.70199999999996, 124.459)), ('A', '  63 ', 'ARG', 0.027917300338180923, (142.19500000000005, 103.865, 141.094)), ('A', ' 114 ', 'LEU', 0.0, (148.771, 89.471, 143.154)), ('A', ' 129 ', 'LEU', 0.07345865870261256, (139.12300000000002, 85.261, 147.104)), ('A', ' 141 ', 'GLN', 0.0, (147.933, 92.309, 134.514)), ('A', ' 162 ', 'GLU', 0.0, (168.40600000000006, 109.26899999999998, 120.66))]
data['cbeta'] = [('A', '  10 ', 'GLN', ' ', 0.487894455695157, (131.11900000000003, 83.156, 156.142)), ('A', '  11 ', 'ASN', ' ', 0.45170462208858153, (135.34300000000002, 80.54099999999998, 154.839)), ('A', '  39 ', 'TYR', ' ', 0.27905919562129394, (151.669, 115.814, 135.417)), ('A', '  98 ', 'ASN', ' ', 0.31887269107504074, (162.81300000000005, 106.42399999999998, 130.808))]
data['probe'] = [(' A 137  TYR  C  ', ' A 140  GLU  OE1', -1.255, (144.897, 89.933, 136.393)), (' A  58  GLN  CA ', ' A  61  GLU  CD ', -1.249, (145.772, 103.817, 132.97)), (' A  58  GLN  HA ', ' A  61  GLU  CD ', -1.147, (145.753, 102.842, 133.091)), (' A 137  TYR  O  ', ' A 140  GLU  CD ', -1.142, (144.12, 91.233, 135.504)), (' A  58  GLN  CA ', ' A  61  GLU  OE1', -1.018, (144.756, 103.76, 133.493)), (' A 137  TYR  O  ', ' A 140  GLU  OE1', -0.938, (145.015, 90.187, 136.163)), (' A 137  TYR  O  ', ' A 140  GLU  CG ', -0.935, (144.678, 91.745, 135.37)), (' A 137  TYR  O  ', ' A 140  GLU  HG2', -0.825, (145.403, 91.501, 135.762)), (' A 138  LEU  N  ', ' A 140  GLU  OE1', -0.806, (144.524, 89.45, 136.592)), (' A 161  PRO  HG2', ' A 162  GLU  OE2', -0.776, (167.659, 105.943, 122.663)), (' A  67  GLU  HA ', ' A  70  MET  HE3', -0.656, (138.353, 101.647, 145.929)), (' A  93  TRP  O  ', ' A  98  ASN  ND2', -0.624, (163.05, 107.703, 132.32)), (' A  72  LEU HD22', ' A 132  PHE  CD2', -0.606, (138.412, 90.84, 145.766)), (' A  58  GLN  HA ', ' A  61  GLU  OE1', -0.598, (144.808, 103.425, 133.048)), (' A 160  ALA  O  ', ' A 162  GLU  OE1', -0.597, (166.741, 106.724, 120.562)), (' A  20  ILE HD11', ' A 129  LEU HD21', -0.58, (141.55, 88.92, 148.688)), (' A 139  ASN  N  ', ' A 140  GLU  OE1', -0.575, (143.993, 88.915, 135.34)), (' A 131  ASP  O  ', ' A 135  THR HG23', -0.524, (137.898, 85.065, 139.228)), (' A 140  GLU  HG2', ' A 141  GLN  N  ', -0.524, (145.742, 92.614, 134.865)), (' A  67  GLU  HA ', ' A  70  MET  CE ', -0.519, (138.635, 101.993, 146.24)), (' A  58  GLN  HA ', ' A  61  GLU  CG ', -0.512, (145.342, 102.457, 133.744)), (' A  93  TRP  O  ', ' A  94  GLU  HB2', -0.5, (162.886, 108.684, 131.525)), (' A  72  LEU HD22', ' A 132  PHE  CE2', -0.479, (138.901, 91.114, 145.756)), (' A  50  ASN  HB2', ' A 171  ASP  OD1', -0.473, (151.062, 111.077, 121.802)), (' A 140  GLU  HG2', ' A 141  GLN  H  ', -0.472, (145.611, 91.888, 135.04)), (' A  23  GLN  OE1', ' A 114  LEU HD13', -0.462, (147.97, 93.361, 143.627)), (' A 106  LEU  O  ', ' A 110  VAL HG23', -0.445, (153.008, 96.933, 139.69)), (' A  23  GLN  CD ', ' A 114  LEU HD13', -0.441, (147.767, 93.016, 144.302)), (' A  97  LEU HD22', ' A 161  PRO  HD3', -0.438, (164.528, 104.017, 124.011)), (' A 160  ALA  O  ', ' A 162  GLU  CD ', -0.436, (167.288, 106.441, 120.98)), (' A   6  SER  OG ', ' A   8  VAL HG22', -0.43, (130.28, 91.756, 158.27)), (' A  97  LEU  CD2', ' A 161  PRO  HD3', -0.425, (164.832, 104.466, 124.312)), (' A 107  GLU  HA ', ' A 107  GLU  OE1', -0.421, (151.187, 96.833, 136.55)), (' A  19  ALA  HB1', ' A 117  LEU HD13', -0.419, (147.276, 89.62, 150.232)), (' A 140  GLU  N  ', ' A 140  GLU  OE1', -0.411, (144.106, 90.514, 134.487)), (' A  93  TRP  O  ', ' A  98  ASN  HB3', -0.41, (162.142, 108.069, 131.591)), (' A  12  TYR  OH ', ' A  73  GLN  NE2', -0.407, (139.344, 91.625, 153.597)), (' A  76  ARG HH11', ' A 128  HIS  HD2', -0.404, (135.743, 86.269, 149.373)), (' A 161  PRO  CG ', ' A 162  GLU  OE2', -0.402, (167.304, 106.124, 123.059))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
