# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', '  11 ', 'ASN', 0.004444607339893294, (135.997, 82.111, 155.579)), ('A', '  44 ', 'ASP', 0.0, (156.90300000000002, 121.948, 127.917)), ('A', '  45 ', 'ASP', 4.3022912571267525e-05, (160.426, 120.645, 127.494)), ('A', ' 110 ', 'VAL', 0.0015283109688817174, (152.016, 94.215, 141.127)), ('A', ' 160 ', 'ALA', 0.0, (164.406, 105.38199999999998, 121.229))]
data['omega'] = []
data['rota'] = [('A', '  79 ', 'ARG', 0.05494607823850261, (138.15000000000003, 96.987, 157.718)), ('A', ' 175 ', 'LEU', 7.62010507234839e-05, (149.65400000000002, 106.31799999999997, 120.926))]
data['cbeta'] = [('A', ' 148 ', 'LEU', ' ', 0.25937790150646073, (154.306, 97.95899999999997, 128.956)), ('A', ' 169 ', 'LEU', ' ', 0.25817052016638065, (157.18, 109.882, 114.565))]
data['probe'] = [(' A  32  TYR  CD2', ' A  88  PRO  HD3', -1.329, (153.382, 108.875, 142.5)), (' A 109  ASN  O  ', ' A 110  VAL HG23', -1.276, (153.858, 96.535, 140.155)), (' A 160  ALA  CB ', ' A 161  PRO  HD3', -1.26, (165.248, 104.132, 122.361)), (' A  34  TYR  CE1', ' A  62  GLU  HG3', -1.238, (147.492, 102.918, 136.822)), (' A 160  ALA  CB ', ' A 161  PRO  CD ', -1.18, (165.83, 104.882, 123.172)), (' A 160  ALA  HB3', ' A 161  PRO  CD ', -1.173, (166.478, 104.996, 122.306)), (' A  32  TYR  HE2', ' A  88  PRO  HD2', -1.137, (155.135, 110.494, 143.206)), (' A  32  TYR  CE2', ' A  88  PRO  CD ', -1.119, (154.993, 109.294, 144.026)), (' A   9  ARG  HD2', ' A  12  TYR  HD2', -1.095, (136.616, 87.04, 158.392)), (' A 160  ALA  HB1', ' A 161  PRO  HD3', -1.08, (164.517, 104.143, 122.866)), (' A  43  ARG  O  ', ' A  44  ASP  O  ', -1.078, (156.98, 119.623, 127.137)), (' A 109  ASN  O  ', ' A 110  VAL  CG2', -1.063, (152.683, 96.268, 140.122)), (' A  32  TYR  CE2', ' A  88  PRO  HD3', -1.058, (153.699, 109.874, 143.532)), (' A  34  TYR  HE1', ' A  62  GLU  HG3', -1.033, (147.338, 102.408, 138.198)), (' A   9  ARG  HD2', ' A  12  TYR  CD2', -1.031, (136.618, 87.849, 157.689)), (' A  34  TYR  HE1', ' A  62  GLU  CG ', -1.005, (147.527, 101.774, 137.447)), (' A  32  TYR  CE2', ' A  88  PRO  HD2', -0.982, (154.165, 110.639, 143.216)), (' A  32  TYR  HE2', ' A  88  PRO  CD ', -0.953, (154.959, 110.024, 143.186)), (' A  32  TYR  CD2', ' A  88  PRO  CD ', -0.929, (154.189, 109.692, 142.602)), (' A 159  GLY  O  ', ' A 160  ALA  HB2', -0.892, (164.506, 103.285, 121.42)), (' A  13  HIS  CD2', ' A 124  LYS  HD2', -0.872, (143.336, 81.564, 156.006)), (' A 159  GLY  O  ', ' A 160  ALA  CB ', -0.87, (165.383, 103.964, 121.294)), (' A 160  ALA  HB3', ' A 161  PRO  HD2', -0.865, (166.735, 104.572, 122.537)), (' A  32  TYR  CE2', ' A  87  LYS  HA ', -0.862, (154.537, 109.848, 144.509)), (' A  32  TYR  HD2', ' A  88  PRO  HD3', -0.842, (153.384, 108.502, 142.717)), (' A  44  ASP  O  ', ' A  46  VAL  N  ', -0.812, (158.809, 119.038, 127.082)), (' A 168  TYR  HD2', ' A 169  LEU  CD1', -0.802, (157.51, 113.162, 114.362)), (' A  50  ASN  HB3', ' A 175  LEU  HB3', -0.796, (150.466, 108.68, 121.581)), (' A 160  ALA  HB3', ' A 161  PRO  HD3', -0.791, (165.625, 103.652, 122.638)), (' A 103  ALA  HB3', ' A 148  LEU  CD2', -0.779, (154.939, 100.706, 130.581)), (' A  19  ALA  HA ', ' A  22  ARG HH11', -0.764, (148.14, 91.062, 151.235)), (' A  39  TYR  O  ', ' A  43  ARG  HG3', -0.754, (154.753, 117.325, 132.212)), (' A 168  TYR  CD2', ' A 169  LEU HD12', -0.754, (156.787, 112.95, 115.469)), (' A 103  ALA  CB ', ' A 148  LEU  CD2', -0.747, (154.327, 101.196, 130.801)), (' A 114  LEU HD11', ' A 133  ILE  HB ', -0.74, (144.256, 87.636, 141.375)), (' A  10  GLN  HB3', ' A  76  ARG  NH2', -0.726, (131.781, 84.402, 153.806)), (' A  34  TYR  CE1', ' A  62  GLU  CG ', -0.72, (147.261, 102.073, 137.094)), (' A 103  ALA  HB3', ' A 148  LEU HD23', -0.708, (155.116, 100.859, 130.46)), (' A  33  VAL HG22', ' A  88  PRO  HB3', -0.701, (155.343, 106.881, 140.728)), (' A 154  ASN  O  ', ' A 158  MET  HG3', -0.69, (160.523, 100.89, 117.632)), (' A 168  TYR  CD2', ' A 169  LEU  CD1', -0.683, (156.917, 113.272, 114.614)), (' A  20  ILE HG21', ' A  73  GLN  HB2', -0.645, (139.794, 94.446, 150.678)), (' A 168  TYR  HD2', ' A 169  LEU HD12', -0.644, (157.84, 113.083, 115.518)), (' A  31  SER  OG ', ' A  63  ARG  HD2', -0.643, (145.303, 107.477, 140.181)), (' A 165  LEU  O  ', ' A 169  LEU HD13', -0.637, (159.671, 110.875, 115.366)), (' A  65  HIS  O  ', ' A  68  LYS  HG2', -0.634, (139.834, 97.536, 142.7)), (' A 160  ALA  HB1', ' A 161  PRO  CD ', -0.606, (164.932, 105.176, 123.619)), (' A  12  TYR  OH ', ' A  17  GLU  HG3', -0.601, (140.57, 92.196, 157.366)), (' A  33  VAL HG12', ' A  37  MET  HE2', -0.579, (154.051, 105.437, 136.602)), (' A 103  ALA  HB1', ' A 148  LEU  CD2', -0.567, (153.789, 100.864, 131.81)), (' A  19  ALA  HA ', ' A  22  ARG  NH1', -0.564, (148.291, 90.677, 152.101)), (' A 154  ASN  HB3', ' A 158  MET  HE3', -0.559, (157.63, 100.573, 117.948)), (' A 168  TYR  HD2', ' A 169  LEU HD11', -0.553, (157.816, 113.362, 114.56)), (' A  10  GLN  O  ', ' A  12  TYR  N  ', -0.55, (135.757, 84.695, 155.104)), (' A 169  LEU  N  ', ' A 169  LEU HD12', -0.502, (157.158, 111.487, 116.143)), (' A  26  LEU HD21', ' A 110  VAL HG22', -0.502, (151.185, 95.946, 142.488)), (' A 133  ILE HG13', ' A 134  GLU  N  ', -0.5, (142.719, 85.924, 140.664)), (' A 103  ALA  CB ', ' A 148  LEU HD21', -0.5, (154.009, 101.289, 130.932)), (' A  94  GLU  O  ', ' A  95  SER  HB2', -0.492, (164.213, 110.497, 127.815)), (' A  44  ASP  CG ', ' A  45  ASP  N  ', -0.491, (158.914, 122.362, 128.236)), (' A 168  TYR  HB3', ' A 169  LEU HD12', -0.49, (157.897, 112.997, 116.586)), (' A  51  PHE  O  ', ' A  54  TYR  HB3', -0.478, (150.318, 108.579, 127.838)), (' A  13  HIS  CE1', ' A 124  LYS  HB3', -0.475, (141.461, 81.203, 154.56)), (' A  44  ASP  CG ', ' A  45  ASP  H  ', -0.474, (159.071, 122.707, 128.088)), (' A  21  ASN HD21', ' A  81  PHE  HD1', -0.471, (143.518, 96.877, 156.977)), (' A 175  LEU  HA ', ' A 175  LEU HD13', -0.471, (149.332, 104.942, 121.929)), (' A   6  SER  HB2', ' A   9  ARG  HB2', -0.47, (132.8, 89.254, 159.2)), (' A  28  LEU  HB3', ' A  85  ILE HD11', -0.47, (146.587, 106.121, 146.786)), (' A 118  HIS  ND1', ' A 133  ILE HD11', -0.469, (144.762, 83.836, 142.554)), (' A  12  TYR  OH ', ' A  17  GLU  CG ', -0.468, (140.63, 91.987, 157.116)), (' A 147  GLU  HG2', ' A 151  HIS  NE2', -0.468, (151.141, 99.61, 125.576)), (' A  19  ALA  HB1', ' A 117  LEU HD13', -0.467, (146.173, 90.032, 149.386)), (' A  73  GLN  OE1', ' A  80  ILE HG12', -0.464, (139.262, 97.346, 152.875)), (' A  54  TYR  CD1', ' A 175  LEU HD11', -0.461, (149.233, 104.796, 125.596)), (' A  44  ASP  O  ', ' A  45  ASP  C  ', -0.452, (159.057, 119.719, 126.871)), (' A  76  ARG  HB3', ' A  76  ARG  HE ', -0.449, (134.25, 87.12, 152.865)), (' A 109  ASN  O  ', ' A 110  VAL  CB ', -0.447, (152.598, 95.762, 140.32)), (' A  43  ARG  C  ', ' A  44  ASP  O  ', -0.447, (157.136, 120.144, 128.705)), (' A 103  ALA  HB1', ' A 148  LEU HD21', -0.444, (153.729, 100.893, 131.224)), (' A  26  LEU HD11', ' A 110  VAL HG22', -0.442, (151.809, 97.399, 142.183)), (' A 165  LEU HD21', ' A 169  LEU HD22', -0.442, (159.343, 110.443, 112.317)), (' A  75  GLN  HG2', ' A  76  ARG  HD2', -0.439, (131.869, 89.173, 149.574)), (' A 124  LYS  O  ', ' A 125  ASN  HB3', -0.428, (140.967, 77.625, 153.315)), (' A 129  LEU  O  ', ' A 132  PHE  HB3', -0.428, (139.774, 86.668, 144.519)), (' A  93  TRP  O  ', ' A  94  GLU  HB2', -0.423, (163.427, 109.231, 132.094)), (' A  41  PHE  O  ', ' A  47  ALA  HA ', -0.42, (154.749, 116.814, 126.685)), (' A  72  LEU HD22', ' A 132  PHE  CD2', -0.418, (139.178, 90.345, 145.645)), (' A  48  LEU HD22', ' A 171  ASP  OD2', -0.417, (155.446, 112.28, 121.661)), (' A  54  TYR  OH ', ' A 148  LEU HD11', -0.415, (151.015, 100.876, 128.7)), (' A   9  ARG  CD ', ' A  12  TYR  CD2', -0.413, (136.334, 88.338, 158.563)), (' A 168  TYR  CB ', ' A 169  LEU HD12', -0.409, (157.576, 112.704, 116.701)), (' A  18  ALA  O  ', ' A  22  ARG  HG3', -0.409, (148.049, 93.647, 152.632)), (' A 168  TYR  O  ', ' A 171  ASP  HB2', -0.406, (154.363, 110.851, 119.017)), (' A  19  ALA  CA ', ' A  22  ARG  NH1', -0.404, (147.712, 90.872, 152.152)), (' A  79  ARG  HB2', ' A  81  PHE  CZ ', -0.402, (140.507, 97.664, 159.87)), (' A  69  LEU HD11', ' A 137  TYR  OH ', -0.401, (143.826, 95.228, 144.509))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
