# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = []
data['omega'] = []
data['rota'] = []
data['cbeta'] = []
data['probe'] = [(' A 155  LEU  O  ', ' A 160  ALA  HB2', -1.286, (162.23, 103.557, 120.419)), (' A  43  ARG  O  ', ' A  47  ALA  HB2', -1.277, (155.65, 119.647, 126.899)), (' A 114  LEU HD11', ' A 133  ILE HG23', -1.129, (144.029, 89.297, 142.343)), (' A 114  LEU  CD1', ' A 133  ILE HG23', -1.114, (145.231, 89.212, 142.51)), (' A  43  ARG  O  ', ' A  47  ALA  CB ', -1.1, (155.933, 119.217, 125.95)), (' A 155  LEU  O  ', ' A 160  ALA  CB ', -1.013, (162.532, 104.655, 121.086)), (' A 117  LEU  HB3', ' A 133  ILE HD13', -1.004, (144.595, 88.251, 146.077)), (' A  24  ILE HD13', ' A  80  ILE HD11', -0.918, (141.557, 98.892, 150.187)), (' A  60  HIS  CE1', ' A  63  ARG HH11', -0.89, (136.853, 105.402, 135.296)), (' A   9  ARG  NH1', ' A  17  GLU  OE2', -0.87, (138.605, 89.943, 158.083)), (' A 114  LEU HD11', ' A 133  ILE  CG2', -0.867, (144.902, 88.202, 142.479)), (' A 115  LEU  HA ', ' A 118  HIS  CE1', -0.855, (149.626, 84.92, 141.772)), (' A 115  LEU  HA ', ' A 118  HIS  ND1', -0.852, (148.671, 85.789, 142.193)), (' A  37  MET  SD ', ' A  55  PHE  CZ ', -0.81, (154.996, 106.918, 131.726)), (' A  24  ILE HD13', ' A  80  ILE  CD1', -0.786, (140.615, 98.869, 150.582)), (' A 114  LEU  CD1', ' A 133  ILE  CG2', -0.772, (145.228, 88.2, 142.723)), (' A  24  ILE HG12', ' A  69  LEU  HB3', -0.758, (142.162, 97.286, 148.106)), (' A 155  LEU HD11', ' A 167  GLU  HG2', -0.732, (159.843, 106.446, 122.592)), (' A  20  ILE HG21', ' A  73  GLN  OE1', -0.73, (140.349, 92.999, 151.201)), (' A 114  LEU HD12', ' A 133  ILE HG23', -0.722, (145.569, 89.19, 143.454)), (' A 107  GLU  OE1', ' A 141  GLN  NE2', -0.719, (150.378, 96.064, 135.848)), (' A  41  PHE  CE1', ' A  55  PHE  HE1', -0.717, (154.542, 108.786, 129.315)), (' A 160  ALA  HB3', ' A 161  PRO  HD3', -0.702, (165.27, 104.129, 122.707)), (' A 104  LEU  CD1', ' A 145  ILE HG23', -0.701, (155.305, 94.909, 130.867)), (' A 158  MET  HE2', ' A 170  PHE  HZ ', -0.7, (159.16, 102.914, 112.329)), (' A  41  PHE  HE1', ' A  55  PHE  HE1', -0.697, (154.696, 108.156, 130.073)), (' A 158  MET  HE2', ' A 170  PHE  CZ ', -0.654, (158.724, 103.311, 113.011)), (' A 115  LEU  CA ', ' A 118  HIS  CE1', -0.653, (149.915, 85.33, 142.094)), (' A  27  GLU  OE2', ' A 137  TYR  OH ', -0.649, (147.048, 95.016, 140.86)), (' A 104  LEU HD11', ' A 145  ILE HG23', -0.646, (155.248, 93.995, 130.963)), (' A 167  GLU  O  ', ' A 171  ASP  HB2', -0.636, (156.154, 108.678, 119.701)), (' A 117  LEU  HB3', ' A 133  ILE  CD1', -0.631, (144.26, 87.826, 146.748)), (' A 168  TYR  O  ', ' A 171  ASP  HB3', -0.629, (154.613, 110.297, 118.22)), (' A  40  TYR  O  ', ' A  43  ARG  HB2', -0.626, (156.209, 117.183, 130.36)), (' A  30  ALA  HA ', ' A 106  LEU HD21', -0.622, (152.259, 102.546, 139.969)), (' A 160  ALA  HB3', ' A 161  PRO  CD ', -0.622, (164.898, 104.164, 122.197)), (' A  50  ASN  HB2', ' A 171  ASP  OD1', -0.616, (151.815, 109.986, 121.4)), (' A   9  ARG HH12', ' A  17  GLU  CD ', -0.615, (139.607, 90.018, 157.962)), (' A  54  TYR  HE2', ' A 148  LEU HD21', -0.608, (151.105, 101.993, 129.328)), (' A  54  TYR  HE2', ' A 148  LEU  CD2', -0.59, (152.097, 102.024, 129.17)), (' A  24  ILE  CG1', ' A  69  LEU  HB3', -0.581, (142.522, 96.903, 148.09)), (' A  17  GLU  HG2', ' A  76  ARG  CZ ', -0.575, (140.411, 91.067, 155.523)), (' A  24  ILE HG12', ' A  69  LEU  CB ', -0.567, (142.172, 97.235, 147.168)), (' A 158  MET  O  ', ' A 166  ALA  HB1', -0.558, (162.784, 106.82, 117.058)), (' A   6  SER  HB3', ' A   9  ARG  HB2', -0.557, (133.554, 88.468, 159.183)), (' A 115  LEU  CD2', ' A 118  HIS  CE1', -0.557, (149.41, 84.068, 140.906)), (' A  54  TYR  HB2', ' A 175  LEU HD22', -0.555, (149.461, 105.404, 124.801)), (' A 100  MET  HB3', ' A 152  VAL HG22', -0.552, (158.161, 101.193, 127.466)), (' A 117  LEU  CB ', ' A 133  ILE HD13', -0.547, (145.376, 88.061, 146.117)), (' A  51  PHE  CE2', ' A 151  HIS  NE2', -0.544, (155.226, 105.272, 124.057)), (' A 110  VAL  CG1', ' A 137  TYR  OH ', -0.543, (148.189, 94.942, 140.236)), (' A  27  GLU  OE2', ' A 137  TYR  CZ ', -0.543, (146.549, 95.268, 140.46)), (' A 114  LEU HD21', ' A 138  LEU  HB2', -0.538, (145.147, 89.234, 139.39)), (' A 148  LEU  O  ', ' A 152  VAL HG23', -0.53, (156.464, 99.368, 126.737)), (' A 160  ALA  O  ', ' A 167  GLU  HG3', -0.529, (162.776, 108.186, 121.786)), (' A   8  VAL  O  ', ' A  10  GLN  HG3', -0.528, (131.534, 84.997, 155.471)), (' A   6  SER  HB2', ' A  77  GLY  O  ', -0.525, (133.174, 91.395, 159.452)), (' A  49  LYS  O  ', ' A 171  ASP  OD2', -0.522, (152.712, 111.234, 122.077)), (' A  13  HIS  CD2', ' A 124  LYS  NZ ', -0.517, (145.39, 81.702, 157.707)), (' A  60  HIS  CE1', ' A  63  ARG  NH1', -0.516, (136.573, 104.781, 136.025)), (' A  43  ARG  C  ', ' A  47  ALA  HB2', -0.515, (155.921, 119.117, 127.991)), (' A  90  CYS  HB2', ' A  93  TRP  CE2', -0.511, (159.338, 108.532, 137.589)), (' A 115  LEU HD23', ' A 118  HIS  CE1', -0.511, (149.158, 84.464, 141.08)), (' A  17  GLU  OE2', ' A  76  ARG  NE ', -0.507, (139.336, 91.038, 157.072)), (' A 110  VAL HG12', ' A 137  TYR  OH ', -0.506, (148.638, 94.449, 140.596)), (' A  54  TYR  CE2', ' A 148  LEU  CD2', -0.502, (151.248, 101.712, 128.82)), (' A  48  LEU HD11', ' A 167  GLU  OE1', -0.502, (159.874, 110.391, 123.709)), (' A 159  GLY  O  ', ' A 166  ALA  HB3', -0.499, (163.872, 108.106, 118.588)), (' A 114  LEU HD22', ' A 137  TYR  CE2', -0.492, (145.771, 92.019, 140.415)), (' A 115  LEU  O  ', ' A 118  HIS  CE1', -0.481, (149.528, 84.608, 143.641)), (' A 100  MET  HE2', ' A 151  HIS  CD2', -0.48, (155.445, 102.166, 125.859)), (' A 159  GLY  O  ', ' A 166  ALA  CB ', -0.477, (164.103, 107.892, 118.168)), (' A  40  TYR  O  ', ' A  43  ARG  CB ', -0.475, (156.343, 117.087, 130.115)), (' A  50  ASN  ND2', ' A 172  LYS  HA ', -0.475, (150.487, 110.656, 118.488)), (' A  28  LEU  HB3', ' A  85  ILE HD13', -0.475, (146.884, 105.369, 147.171)), (' A  63  ARG  NH2', ' A  67  GLU  OE2', -0.474, (135.942, 104.551, 140.701)), (' A 169  LEU  C  ', ' A 171  ASP  H  ', -0.469, (155.438, 107.958, 117.413)), (' A  23  GLN  HB2', ' A 117  LEU HD11', -0.468, (146.615, 92.624, 147.093)), (' A  97  LEU  HA ', ' A 155  LEU  CD2', -0.466, (160.213, 104.459, 126.001)), (' A 155  LEU  CD1', ' A 167  GLU  HG2', -0.463, (159.85, 106.453, 122.337)), (' A 115  LEU  CD2', ' A 118  HIS  HE1', -0.462, (150.013, 84.43, 141.394)), (' A  36  SER  HG ', ' A  93  TRP  HH2', -0.458, (155.678, 110.442, 138.738)), (' A  54  TYR  CE2', ' A 148  LEU HD23', -0.457, (151.454, 101.761, 128.339)), (' A  51  PHE  HE2', ' A 151  HIS  HE2', -0.451, (155.853, 105.495, 124.867)), (' A  21  ASN  ND2', ' A  81  PHE  HB2', -0.447, (144.439, 97.191, 156.446)), (' A  80  ILE  CD1', ' A  82  LEU HD21', -0.447, (141.433, 100.726, 151.631)), (' A 132  PHE  O  ', ' A 135  THR  O  ', -0.446, (139.451, 89.005, 140.196)), (' A 115  LEU  O  ', ' A 118  HIS  ND1', -0.446, (148.907, 84.38, 143.505)), (' A  34  TYR  CD1', ' A  62  GLU  HG3', -0.444, (147.934, 103.031, 137.63)), (' A 107  GLU  O  ', ' A 141  GLN  NE2', -0.439, (151.489, 94.902, 137.554)), (' A  95  SER  H  ', ' A  98  ASN  HB2', -0.439, (163.306, 108.407, 130.58)), (' A   6  SER  OG ', ' A  77  GLY  HA3', -0.436, (132.089, 90.521, 158.209)), (' A 100  MET  HE2', ' A 151  HIS  HB3', -0.433, (154.868, 101.369, 125.891)), (' A 115  LEU HD22', ' A 118  HIS  CE1', -0.43, (149.994, 84.132, 140.726)), (' A 115  LEU  CB ', ' A 118  HIS  HE1', -0.427, (150.173, 84.719, 141.807)), (' A  72  LEU HD22', ' A 132  PHE  CD2', -0.425, (138.647, 90.892, 145.643)), (' A  68  LYS  HB3', ' A 132  PHE  HZ ', -0.425, (137.422, 94.456, 143.109)), (' A  97  LEU  HA ', ' A 155  LEU HD23', -0.413, (160.091, 104.229, 126.121)), (' A 115  LEU  CA ', ' A 118  HIS  HE1', -0.412, (150.001, 84.773, 142.131)), (' A 100  MET  HE1', ' A 148  LEU HD23', -0.409, (152.955, 101.283, 128.196)), (' A  13  HIS  CG ', ' A 124  LYS  HE3', -0.407, (145.525, 82.946, 156.545)), (' A 115  LEU  CA ', ' A 118  HIS  ND1', -0.407, (149.192, 85.444, 143.182)), (' A  13  HIS  CD2', ' A 124  LYS  HZ1', -0.406, (145.96, 82.117, 158.003)), (' A  20  ILE  CG2', ' A  73  GLN  OE1', -0.402, (141.4, 93.593, 151.31))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
