# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = []
data['omega'] = []
data['rota'] = []
data['cbeta'] = []
data['probe'] = [(' A 155  LEU  O  ', ' A 160  ALA  HB2', -1.256, (163.104, 103.705, 120.837)), (' A  34  TYR  OH ', ' A 107  GLU  OE2', -1.099, (150.273, 99.462, 134.734)), (' A 114  LEU HD22', ' A 137  TYR  CE2', -1.05, (146.366, 91.674, 139.996)), (' A 114  LEU HD11', ' A 133  ILE HG23', -1.022, (144.709, 88.88, 141.959)), (' A  27  GLU  OE2', ' A 137  TYR  OH ', -0.977, (146.508, 95.49, 140.495)), (' A  12  TYR  HE2', ' A 129  LEU HD22', -0.938, (139.597, 86.566, 149.934)), (' A  41  PHE  CE1', ' A  55  PHE  HE1', -0.913, (154.535, 108.769, 129.292)), (' A  42  ASP  HA ', ' A  49  LYS  HZ3', -0.9, (152.651, 117.46, 127.922)), (' A  42  ASP  HA ', ' A  49  LYS  NZ ', -0.89, (151.985, 117.578, 128.46)), (' A  12  TYR  CE2', ' A 129  LEU HD22', -0.855, (138.846, 86.542, 150.261)), (' A 114  LEU  CD1', ' A 133  ILE HG23', -0.836, (144.948, 88.873, 142.13)), (' A 104  LEU HD11', ' A 145  ILE HG23', -0.834, (155.179, 93.852, 130.637)), (' A  34  TYR  CE1', ' A  62  GLU  HG3', -0.81, (147.566, 102.496, 137.607)), (' A  12  TYR  CD2', ' A  76  ARG  NH2', -0.805, (139.668, 88.088, 152.715)), (' A  34  TYR  CE1', ' A  62  GLU  CG ', -0.799, (147.491, 102.69, 136.701)), (' A  34  TYR  HE1', ' A  62  GLU  CG ', -0.796, (147.35, 101.39, 137.191)), (' A 115  LEU  HA ', ' A 118  HIS  CE1', -0.78, (148.83, 85.334, 141.686)), (' A  41  PHE  HE1', ' A  55  PHE  HE1', -0.777, (155.301, 108.57, 130.087)), (' A  26  LEU HD21', ' A 110  VAL  HA ', -0.758, (151.548, 95.848, 142.877)), (' A  24  ILE HG12', ' A  69  LEU  HB3', -0.757, (142.193, 97.316, 148.224)), (' A  34  TYR  CD1', ' A  62  GLU  HG3', -0.75, (147.589, 103.085, 137.032)), (' A 114  LEU HD22', ' A 137  TYR  CD2', -0.704, (144.985, 91.43, 139.539)), (' A  48  LEU  CD1', ' A 167  GLU  HB3', -0.69, (158.084, 110.776, 122.095)), (' A  51  PHE  CD2', ' A 175  LEU HD11', -0.68, (152.872, 106.319, 124.526)), (' A 104  LEU  CD1', ' A 145  ILE HG23', -0.671, (155.214, 94.73, 130.736)), (' A 155  LEU  C  ', ' A 160  ALA  HB2', -0.665, (162.103, 103.297, 121.68)), (' A  43  ARG  O  ', ' A  47  ALA  HB2', -0.663, (155.828, 118.887, 127.039)), (' A 114  LEU HD22', ' A 137  TYR  HE2', -0.663, (146.091, 91.885, 140.987)), (' A  34  TYR  HE1', ' A  62  GLU  HG2', -0.654, (147.143, 101.782, 136.984)), (' A  41  PHE  CE1', ' A  55  PHE  CE1', -0.637, (154.528, 108.174, 129.648)), (' A  50  ASN  HB2', ' A 171  ASP  OD1', -0.636, (151.553, 110.085, 121.794)), (' A 158  MET  HG3', ' A 170  PHE  HZ ', -0.634, (159.431, 101.811, 115.86)), (' A   5  THR  HB ', ' A  77  GLY  HA2', -0.62, (132.73, 93.314, 157.305)), (' A 115  LEU  HA ', ' A 118  HIS  ND1', -0.618, (148.502, 85.956, 142.411)), (' A  21  ASN HD21', ' A  81  PHE  HD1', -0.608, (142.861, 96.185, 157.192)), (' A  37  MET  SD ', ' A  55  PHE  CZ ', -0.608, (154.679, 106.563, 131.394)), (' A 155  LEU  O  ', ' A 160  ALA  CB ', -0.607, (162.76, 104.76, 121.156)), (' A  23  GLN  HB2', ' A 117  LEU HD11', -0.605, (146.465, 92.89, 147.095)), (' A  22  ARG HH22', ' A 113  SER  CB ', -0.605, (152.004, 92.535, 146.823)), (' A 115  LEU HD23', ' A 118  HIS  CE1', -0.6, (148.807, 85.31, 140.862)), (' A  28  LEU HD13', ' A  85  ILE HD11', -0.594, (145.942, 104.886, 148.742)), (' A  49  LYS  O  ', ' A 171  ASP  OD2', -0.59, (152.281, 111.769, 121.493)), (' A  43  ARG  O  ', ' A  47  ALA  CB ', -0.589, (155.476, 118.826, 126.34)), (' A  24  ILE HG12', ' A  69  LEU  CB ', -0.588, (142.181, 97.291, 147.27)), (' A 114  LEU  CD2', ' A 137  TYR  CE2', -0.588, (145.436, 90.909, 140.472)), (' A  65  HIS  CE1', ' A 137  TYR  HD1', -0.588, (142.176, 94.983, 137.807)), (' A  24  ILE  CG1', ' A  69  LEU  HB3', -0.586, (142.553, 96.933, 148.208)), (' A 114  LEU HD21', ' A 138  LEU  HB2', -0.585, (145.183, 89.42, 139.213)), (' A  34  TYR  CE1', ' A  62  GLU  HG2', -0.581, (147.141, 102.132, 136.947)), (' A  12  TYR  HB3', ' A  76  ARG HH21', -0.577, (139.166, 87.801, 154.453)), (' A 114  LEU  CD2', ' A 137  TYR  CD2', -0.574, (145.166, 90.79, 139.752)), (' A  20  ILE HD13', ' A 117  LEU HD22', -0.572, (144.963, 90.374, 148.523)), (' A 168  TYR  O  ', ' A 171  ASP  HB3', -0.562, (153.976, 110.146, 118.289)), (' A  28  LEU  HB3', ' A  85  ILE HD13', -0.562, (146.95, 105.593, 147.455)), (' A  20  ILE HG13', ' A  76  ARG HH11', -0.561, (141.148, 90.591, 150.786)), (' A  41  PHE  HE1', ' A  55  PHE  CE1', -0.556, (154.845, 108.153, 130.555)), (' A  19  ALA  HB1', ' A 117  LEU HD23', -0.556, (147.214, 89.776, 150.11)), (' A 115  LEU  CD2', ' A 118  HIS  HE1', -0.555, (149.513, 84.434, 141.273)), (' A  78  GLY  HA2', ' A  79  ARG  HD3', -0.554, (137.342, 93.665, 159.339)), (' A  23  GLN  HG3', ' A  69  LEU HD11', -0.554, (144.824, 95.75, 145.072)), (' A  48  LEU HD13', ' A 167  GLU  HB3', -0.553, (157.634, 110.386, 121.828)), (' A 100  MET  HG3', ' A 155  LEU  CD1', -0.549, (156.804, 103.578, 125.831)), (' A  42  ASP  HA ', ' A  49  LYS  HZ2', -0.549, (151.193, 117.33, 128.005)), (' A 160  ALA  HB3', ' A 161  PRO  HD3', -0.546, (164.993, 105.112, 123.339)), (' A 118  HIS  HB3', ' A 133  ILE HG21', -0.545, (144.523, 86.389, 143.527)), (' A 118  HIS  HB3', ' A 133  ILE  CG2', -0.543, (144.249, 86.191, 143.013)), (' A  30  ALA  HA ', ' A 106  LEU HD21', -0.541, (151.925, 102.568, 139.805)), (' A 148  LEU  O  ', ' A 152  VAL HG23', -0.535, (156.713, 99.029, 126.586)), (' A  20  ILE HG22', ' A  73  GLN  NE2', -0.533, (141.864, 94.385, 151.674)), (' A  42  ASP  CA ', ' A  49  LYS  NZ ', -0.528, (151.457, 117.536, 128.598)), (' A   5  THR  O  ', ' A  77  GLY  HA3', -0.522, (131.93, 90.82, 158.035)), (' A 160  ALA  HB3', ' A 161  PRO  CD ', -0.522, (165.165, 105.152, 122.602)), (' A  61  GLU  HG2', ' A  65  HIS  CD2', -0.518, (143.977, 98.212, 136.761)), (' A  90  CYS  HB2', ' A  93  TRP  CE2', -0.517, (159.405, 108.35, 137.394)), (' A 117  LEU  HB3', ' A 133  ILE HD13', -0.513, (144.484, 87.79, 145.997)), (' A  13  HIS  ND1', ' A 124  LYS  HB3', -0.507, (141.505, 81.474, 155.168)), (' A  24  ILE HD11', ' A  73  GLN  HG2', -0.507, (140.683, 95.955, 150.848)), (' A  51  PHE  CD2', ' A 175  LEU  CD1', -0.5, (152.647, 106.996, 124.339)), (' A  50  ASN  HB2', ' A 171  ASP  CG ', -0.5, (151.391, 110.104, 121.311)), (' A  20  ILE HG22', ' A  73  GLN HE21', -0.497, (142.252, 95.003, 151.145)), (' A  51  PHE  CE2', ' A 175  LEU HD11', -0.494, (153.445, 106.213, 124.757)), (' A  46  VAL  O  ', ' A  48  LEU  HG ', -0.492, (157.671, 114.014, 123.854)), (' A 151  HIS  O  ', ' A 155  LEU  HG ', -0.49, (157.811, 101.628, 122.66)), (' A  93  TRP  HB3', ' A  99  ALA  HB2', -0.487, (159.452, 108.563, 132.344)), (' A  20  ILE HG13', ' A  76  ARG  NH1', -0.483, (141.474, 90.488, 150.925)), (' A 115  LEU  CD2', ' A 118  HIS  CE1', -0.479, (149.35, 84.662, 140.671)), (' A  65  HIS  CE1', ' A 137  TYR  CD1', -0.477, (143.039, 94.884, 138.17)), (' A  30  ALA  HB3', ' A  62  GLU  OE1', -0.475, (148.329, 100.821, 140.125)), (' A  13  HIS  CE1', ' A 124  LYS  HB3', -0.467, (141.505, 80.72, 155.135)), (' A 171  ASP  O  ', ' A 175  LEU  HB2', -0.459, (150.616, 107.153, 120.871)), (' A  49  LYS  O  ', ' A 171  ASP  CG ', -0.457, (151.823, 111.386, 122.133)), (' A  26  LEU  CD2', ' A 110  VAL  HA ', -0.457, (151.43, 95.365, 143.154)), (' A  48  LEU HD11', ' A 167  GLU  HB3', -0.454, (158.607, 110.674, 122.828)), (' A  54  TYR  HB2', ' A 175  LEU HD22', -0.45, (148.97, 105.676, 125.314)), (' A  34  TYR  CD1', ' A  62  GLU  CG ', -0.445, (147.291, 102.883, 137.395)), (' A  70  MET  HG2', ' A  80  ILE HD11', -0.443, (140.26, 100.333, 150.837)), (' A  12  TYR  HD2', ' A  76  ARG HH22', -0.441, (139.931, 86.803, 152.906)), (' A 154  ASN  HB3', ' A 170  PHE  CE2', -0.439, (157.46, 101.242, 117.611)), (' A 115  LEU HD23', ' A 118  HIS  HE1', -0.436, (149.354, 85.0, 141.518)), (' A 114  LEU HD13', ' A 137  TYR  CE2', -0.432, (145.038, 91.686, 141.623)), (' A  12  TYR  HE2', ' A 129  LEU  CD2', -0.431, (139.747, 87.052, 149.955)), (' A 107  GLU  HG3', ' A 148  LEU HD12', -0.429, (152.562, 97.97, 132.538)), (' A  78  GLY  CA ', ' A  79  ARG  HD3', -0.427, (137.395, 93.386, 158.95)), (' A 158  MET  HG3', ' A 170  PHE  CZ ', -0.426, (159.624, 102.299, 115.882)), (' A  20  ILE  CG2', ' A  73  GLN  NE2', -0.426, (142.105, 94.012, 151.349)), (' A  19  ALA  HB1', ' A 117  LEU  CD2', -0.421, (147.013, 89.759, 149.723)), (' A  23  GLN  CB ', ' A 117  LEU HD11', -0.42, (146.206, 92.933, 147.097)), (' A  21  ASN  ND2', ' A  81  PHE  HD1', -0.419, (143.601, 96.164, 157.008)), (' A 115  LEU  CA ', ' A 118  HIS  CE1', -0.419, (149.447, 85.4, 142.79)), (' A  42  ASP  OD1', ' A  49  LYS  NZ ', -0.418, (151.182, 119.115, 128.084)), (' A  37  MET  HG2', ' A  55  PHE  CE1', -0.417, (154.081, 108.158, 131.623)), (' A  20  ILE  CD1', ' A 117  LEU HD22', -0.415, (144.16, 90.307, 148.751)), (' A  26  LEU HD22', ' A 113  SER  OG ', -0.414, (152.371, 94.437, 145.331)), (' A  33  VAL HG22', ' A  88  PRO  HB3', -0.412, (155.433, 106.555, 140.684)), (' A  23  GLN  HG3', ' A  69  LEU  CD1', -0.411, (144.644, 95.729, 145.81)), (' A 114  LEU HD23', ' A 138  LEU HD13', -0.41, (147.097, 89.124, 139.223)), (' A  97  LEU HD22', ' A 160  ALA  HB3', -0.409, (164.133, 103.874, 123.662)), (' A 126  ASP  HA ', ' A 127  PRO  HD2', -0.409, (136.797, 80.099, 149.855)), (' A  49  LYS  O  ', ' A 171  ASP  OD1', -0.409, (152.092, 110.85, 122.515)), (' A  21  ASN  ND2', ' A  81  PHE  CD1', -0.406, (143.724, 96.282, 157.587)), (' A  78  GLY  C  ', ' A  79  ARG  HD3', -0.405, (137.372, 94.166, 159.189)), (' A  70  MET  HG2', ' A  80  ILE  CD1', -0.402, (139.953, 100.35, 150.917)), (' A  90  CYS  HB3', ' A  92  ASP  O  ', -0.4, (161.602, 109.781, 136.723)), (' A  61  GLU  HG2', ' A  65  HIS  NE2', -0.4, (143.459, 97.833, 136.367))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
