# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', '  94 ', 'GLU', 0.011211123135884082, (163.853, 111.41399999999997, 131.364))]
data['omega'] = []
data['rota'] = [('A', '  13 ', 'HIS', 0.16370386111754776, (141.201, 84.38200000000003, 157.872)), ('A', '  20 ', 'ILE', 0.00029037015553171866, (144.374, 92.63900000000002, 151.03600000000003)), ('A', '  23 ', 'GLN', 0.0005813561527711439, (147.138, 95.36200000000002, 147.489)), ('A', '  28 ', 'LEU', 0.0015426283104249558, (146.789, 103.60900000000002, 144.97)), ('A', '  33 ', 'VAL', 0.23596905904030127, (152.961, 107.32300000000001, 139.961)), ('A', '  43 ', 'ARG', 0.03754293407930246, (155.468, 120.048, 130.05700000000004)), ('A', '  46 ', 'VAL', 0.12641133766235704, (158.783, 117.21599999999998, 126.04)), ('A', '  69 ', 'LEU', 0.10895213051090613, (139.466, 95.655, 146.187)), ('A', '  72 ', 'LEU', 0.08387296404644741, (135.547, 93.14100000000003, 148.19000000000005)), ('A', '  86 ', 'LYS', 0.0, (154.686, 107.16000000000003, 149.108)), ('A', '  87 ', 'LYS', 0.0, (155.985, 109.78900000000003, 146.561)), ('A', '  89 ', 'ASP', 0.15463272085660815, (160.838, 107.52000000000001, 143.333)), ('A', '  98 ', 'ASN', 0.23978873099365114, (162.474, 105.199, 130.005)), ('A', ' 114 ', 'LEU', 0.06347841012238026, (148.853, 89.28500000000003, 143.112)), ('A', ' 115 ', 'LEU', 0.0820177620910306, (150.454, 85.80400000000002, 142.858)), ('A', ' 116 ', 'GLU', 0.04044944652200967, (151.491, 86.01600000000002, 146.55200000000005)), ('A', ' 117 ', 'LEU', 0.009721406654499828, (147.89, 87.11400000000003, 147.496)), ('A', ' 120 ', 'LEU', 0.027384729010076114, (148.194, 83.26200000000003, 150.662)), ('A', ' 124 ', 'LYS', 0.0, (143.656, 78.66300000000003, 153.56)), ('A', ' 130 ', 'CYS', 0.23648328922074782, (141.127, 83.01, 144.83000000000007)), ('A', ' 146 ', 'LYS', 0.0, (152.21, 92.085, 127.112)), ('A', ' 147 ', 'GLU', 0.14675319914889406, (150.887, 95.353, 125.645)), ('A', ' 153 ', 'THR', 0.07520993472469156, (160.448, 96.881, 121.888)), ('A', ' 157 ', 'LYS', 0.06883569716955786, (163.519, 99.24500000000002, 117.16100000000002)), ('A', ' 158 ', 'MET', 0.04004324195423486, (163.202, 102.91400000000003, 115.89800000000001))]
data['cbeta'] = []
data['probe'] = [(' A 131  ASP  O  ', ' A 135  THR HG23', -0.79, (138.322, 84.948, 139.198)), (' A  13  HIS  O  ', ' A  16  SER  OG ', -0.759, (142.388, 86.267, 155.425)), (' A  50  ASN  ND2', ' A 171  ASP  O  ', -0.696, (149.01, 109.601, 119.246)), (' A  38  SER  O  ', ' A  42  ASP  OD2', -0.683, (150.703, 115.269, 131.152)), (' A 160  ALA  HB3', ' A 161  PRO  HD3', -0.663, (164.572, 104.696, 122.224)), (' A   9  ARG  NH1', ' A  12  TYR  O  ', -0.614, (138.126, 87.039, 158.158)), (' A 114  LEU HD21', ' A 137  TYR  HB3', -0.602, (145.438, 91.166, 139.508)), (' A  37  MET  HE2', ' A  55  PHE  CZ ', -0.569, (154.519, 106.371, 131.24)), (' A  13  HIS  HB3', ' A 124  LYS  CE ', -0.555, (142.422, 83.217, 155.52)), (' A  15  ASP  OD1', ' A  16  SER  N  ', -0.552, (145.876, 86.161, 155.893)), (' A  90  CYS  SG ', ' A  93  TRP  CZ3', -0.54, (159.829, 107.325, 137.528)), (' A  12  TYR  CE2', ' A  17  GLU  HB2', -0.534, (139.692, 89.811, 155.261)), (' A  72  LEU  C  ', ' A  72  LEU HD13', -0.529, (136.549, 92.178, 149.453)), (' A  26  LEU HD22', ' A 110  VAL HG22', -0.515, (151.192, 97.409, 142.599)), (' A  90  CYS  SG ', ' A  93  TRP  CE3', -0.494, (160.167, 107.725, 136.933)), (' A  13  HIS  HB3', ' A 124  LYS  HE3', -0.468, (142.647, 83.506, 156.108)), (' A  17  GLU  OE1', ' A  78  GLY  HA2', -0.461, (138.322, 91.874, 157.723)), (' A 122  THR  OG1', ' A 130  CYS  SG ', -0.459, (143.475, 79.724, 145.287)), (' A  39  TYR  HA ', ' A  42  ASP  OD2', -0.457, (151.437, 116.132, 132.166)), (' A 107  GLU  OE1', ' A 141  GLN  NE2', -0.449, (149.626, 95.215, 136.397)), (' A 162  GLU  C  ', ' A 162  GLU  CD ', -0.447, (168.485, 109.253, 117.639)), (' A 106  LEU  C  ', ' A 106  LEU HD13', -0.446, (153.592, 98.452, 137.974)), (' A  73  GLN  HA ', ' A  73  GLN  OE1', -0.443, (138.173, 92.786, 152.737)), (' A  37  MET  HE2', ' A  55  PHE  CE1', -0.433, (154.117, 106.178, 131.978)), (' A  86  LYS  HD3', ' A  86  LYS  N  ', -0.429, (153.972, 106.381, 150.635)), (' A  24  ILE HD13', ' A  70  MET  CG ', -0.423, (140.151, 99.299, 149.442)), (' A  50  ASN  HB2', ' A 171  ASP  HB2', -0.421, (151.501, 110.713, 121.661)), (' A  23  GLN  HA ', ' A  23  GLN  OE1', -0.42, (148.407, 94.684, 146.634)), (' A  37  MET  HE3', ' A  99  ALA  HB1', -0.415, (156.61, 106.669, 132.153)), (' A  24  ILE HD13', ' A  70  MET  HG2', -0.414, (140.508, 99.199, 149.768)), (' A  65  HIS  O  ', ' A  68  LYS  HB3', -0.412, (139.519, 97.309, 142.728))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
