# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', '  14 ', 'GLN', 0.0, (142.64699999999996, 87.71800000000002, 159.484)), ('A', '  15 ', 'ASP', 0.0355432751635063, (145.783, 87.302, 157.284)), ('A', '  16 ', 'SER', 0.026762574158496116, (143.57, 87.64000000000001, 154.096)), ('A', '  24 ', 'ILE', 0.034689918917711456, (145.019, 98.726, 148.062)), ('A', '  45 ', 'ASP', 0.03868685985195617, (160.07899999999998, 120.481, 127.41599999999998)), ('A', '  54 ', 'TYR', 0.006815766839380831, (147.80399999999997, 107.292, 127.96300000000001)), ('A', '  57 ', 'HIS', 0.01388475148613871, (143.99799999999996, 106.617, 131.531)), ('A', '  61 ', 'GLU', 0.007640270561141142, (142.272, 102.40200000000002, 135.637)), ('A', '  87 ', 'LYS', 0.0276117, (155.88499999999993, 109.58, 146.464)), ('A', '  89 ', 'ASP', 0.041015807940085705, (160.85899999999998, 107.26200000000003, 143.118)), ('A', '  94 ', 'GLU', 0.0002838026822574321, (163.835, 111.213, 131.283)), ('A', ' 104 ', 'LEU', 0.02556262758262231, (156.87799999999993, 97.51, 132.995)), ('A', ' 105 ', 'HIS', 0.01955124278026717, (158.908, 97.3, 136.268)), ('A', ' 123 ', 'ASP', 0.005648172375793376, (146.87899999999993, 77.92100000000003, 151.679)), ('A', ' 134 ', 'GLU', 0.024081487789617165, (141.411, 85.25200000000002, 138.792)), ('A', ' 136 ', 'HIS', 0.023253022902971668, (139.657, 90.49, 137.791)), ('A', ' 139 ', 'ASN', 0.0002841663337408962, (144.135, 88.339, 133.302)), ('A', ' 140 ', 'GLU', 0.0005017818979752689, (144.47899999999998, 92.295, 133.007)), ('A', ' 152 ', 'VAL', 0.028480752665379847, (159.247, 99.219, 124.765)), ('A', ' 160 ', 'ALA', 0.0, (164.16399999999996, 105.5, 120.951)), ('A', ' 164 ', 'GLY', 0.0035312296805627788, (163.851, 112.374, 118.60200000000002)), ('A', ' 165 ', 'LEU', 0.00047587119352262625, (161.546, 111.71499999999997, 115.586))]
data['omega'] = []
data['rota'] = [('A', '   6 ', 'SER', 0.010497458742032877, (130.688, 91.22200000000002, 161.284)), ('A', '   9 ', 'ARG', 0.006502162258409356, (132.023, 86.96500000000003, 158.049)), ('A', '  14 ', 'GLN', 0.0, (142.64699999999996, 87.71800000000002, 159.484)), ('A', '  17 ', 'GLU', 0.0, (142.206, 90.962, 155.559)), ('A', '  23 ', 'GLN', 0.0, (146.992, 95.426, 147.742)), ('A', '  26 ', 'LEU', 0.0455471210204984, (150.045, 99.12, 146.062)), ('A', '  32 ', 'TYR', 0.0, (150.22999999999996, 108.20800000000001, 141.999)), ('A', '  42 ', 'ASP', 0.0036486866024963687, (152.5, 117.529, 129.207)), ('A', '  48 ', 'LEU', 0.04277863343287136, (153.95199999999997, 114.403, 123.995)), ('A', '  56 ', 'LEU', 0.051405459200644495, (146.089, 109.653, 132.669)), ('A', '  83 ', 'GLN', 0.005710514491691601, (148.591, 103.828, 154.762)), ('A', '  87 ', 'LYS', 0.0, (155.88499999999993, 109.58, 146.464)), ('A', '  89 ', 'ASP', 0.08484573409945959, (160.85899999999998, 107.26200000000003, 143.118)), ('A', '  91 ', 'ASP', 0.0, (160.177, 113.28600000000003, 139.581)), ('A', '  94 ', 'GLU', 0.0, (163.835, 111.213, 131.283)), ('A', '  98 ', 'ASN', 0.0791718762625446, (162.574, 105.397, 130.391)), ('A', ' 107 ', 'GLU', 0.094950143726621, (153.273, 95.945, 136.395)), ('A', ' 116 ', 'GLU', 0.0, (151.615, 86.069, 146.561)), ('A', ' 120 ', 'LEU', 0.0, (147.724, 83.023, 150.473)), ('A', ' 124 ', 'LYS', 0.0, (143.749, 78.97500000000001, 153.721)), ('A', ' 125 ', 'ASN', 0.0023038611645787087, (141.21199999999996, 77.406, 151.304)), ('A', ' 129 ', 'LEU', 0.279862482740312, (139.306, 85.134, 147.123)), ('A', ' 135 ', 'THR', 0.008159601566148922, (138.27399999999997, 86.91400000000002, 137.284)), ('A', ' 138 ', 'LEU', 0.0, (145.508, 87.90300000000002, 136.868)), ('A', ' 162 ', 'GLU', 0.0, (168.7, 108.88999999999997, 120.38)), ('A', ' 165 ', 'LEU', 0.0440239190897761, (161.546, 111.71499999999997, 115.586)), ('A', ' 171 ', 'ASP', 0.005367070287926016, (152.65799999999996, 109.089, 120.006))]
data['cbeta'] = [('A', '  46 ', 'VAL', ' ', 0.25254235937263997, (158.354, 116.015, 127.685)), ('A', '  47 ', 'ALA', ' ', 0.32974104731177334, (156.017, 118.82199999999999, 123.304)), ('A', '  55 ', 'PHE', ' ', 0.2559826909758004, (150.49199999999996, 108.279, 131.976)), ('A', '  86 ', 'LYS', ' ', 0.5580185392071733, (155.777, 105.52100000000003, 149.183)), ('A', ' 136 ', 'HIS', ' ', 0.2507984248439184, (138.963, 91.16300000000003, 139.019))]
data['probe'] = [(' A  15  ASP  OD1', ' A  16  SER  N  ', -1.316, (144.788, 85.956, 154.348)), (' A  82  LEU  O  ', ' A  83  GLN  OE1', -1.248, (146.608, 103.771, 156.21)), (' A  32  TYR  HD1', ' A  32  TYR  N  ', -1.218, (149.476, 106.101, 141.606)), (' A 120  LEU  HA ', ' A 123  ASP  OD2', -1.216, (148.172, 81.399, 150.759)), (' A  42  ASP  OD1', ' A  43  ARG  N  ', -1.075, (154.302, 119.14, 129.963)), (' A 147  GLU  HA ', ' A 150  ASP  OD2', -1.055, (150.66, 95.687, 123.6)), (' A  31  SER  OG ', ' A  62  GLU  CG ', -1.008, (145.025, 105.104, 140.866)), (' A 112  GLN  NE2', ' A 116  GLU  OE2', -1.001, (155.237, 86.526, 143.032)), (' A  81  PHE  O  ', ' A  83  GLN  NE2', -1.0, (146.084, 100.935, 155.216)), (' A  46  VAL  O  ', ' A  48  LEU HD13', -0.994, (157.136, 116.398, 123.851)), (' A 120  LEU  CA ', ' A 123  ASP  OD2', -0.993, (147.912, 81.879, 150.407)), (' A 107  GLU  HA ', ' A 107  GLU  OE1', -0.985, (152.276, 96.225, 136.4)), (' A  82  LEU  C  ', ' A  83  GLN  OE1', -0.963, (147.121, 103.238, 155.505)), (' A  42  ASP  C  ', ' A  42  ASP  OD1', -0.948, (153.3, 119.658, 129.428)), (' A 162  GLU  OE2', ' A 163  SER  OG ', -0.941, (167.419, 107.737, 115.662)), (' A  60  HIS  O  ', ' A  64  GLU  OE1', -0.938, (141.509, 103.079, 137.169)), (' A  37  MET  HE2', ' A  55  PHE  CZ ', -0.933, (154.005, 106.976, 131.826)), (' A  31  SER  OG ', ' A  62  GLU  HG3', -0.929, (145.21, 103.92, 140.75)), (' A   9  ARG  NH1', ' A  12  TYR  O  ', -0.924, (137.866, 86.47, 157.834)), (' A   9  ARG  NH1', ' A  12  TYR  HD2', -0.919, (138.387, 87.691, 157.194)), (' A  60  HIS  C  ', ' A  64  GLU  OE1', -0.919, (140.849, 103.521, 136.611)), (' A  50  ASN  ND2', ' A 171  ASP  O  ', -0.897, (149.085, 109.672, 119.271)), (' A  61  GLU  HG2', ' A  62  GLU  N  ', -0.885, (143.901, 102.776, 136.08)), (' A 124  LYS  C  ', ' A 125  ASN  OD1', -0.881, (142.158, 77.66, 152.819)), (' A  81  PHE  C  ', ' A  83  GLN HE22', -0.879, (144.968, 101.191, 156.036)), (' A  40  TYR  O  ', ' A  46  VAL HG21', -0.875, (156.08, 115.833, 129.916)), (' A  29  TYR  HD1', ' A  32  TYR  CE2', -0.874, (152.355, 105.425, 144.845)), (' A  29  TYR  CD1', ' A  32  TYR  CE2', -0.862, (152.46, 105.038, 145.359)), (' A 138  LEU  O  ', ' A 139  ASN  O  ', -0.83, (146.823, 88.934, 134.086)), (' A 104  LEU  CD1', ' A 148  LEU  HB3', -0.817, (155.387, 97.286, 128.906)), (' A 141  GLN  O  ', ' A 145  ILE HG13', -0.813, (150.658, 92.032, 132.658)), (' A  61  GLU  HG2', ' A  62  GLU  H  ', -0.802, (144.005, 103.365, 136.796)), (' A 135  THR  O  ', ' A 135  THR  OG1', -0.801, (136.32, 88.181, 137.131)), (' A  73  GLN  HA ', ' A  73  GLN  OE1', -0.785, (137.718, 92.719, 152.519)), (' A  37  MET  CE ', ' A  55  PHE  CZ ', -0.784, (155.035, 105.986, 131.488)), (' A  69  LEU  CD1', ' A 137  TYR  OH ', -0.776, (141.4, 95.196, 142.532)), (' A  82  LEU  C  ', ' A  83  GLN  CD ', -0.763, (147.162, 102.434, 155.457)), (' A  37  MET  HE2', ' A  55  PHE  CE2', -0.76, (154.46, 107.098, 130.855)), (' A  42  ASP  OD1', ' A  43  ARG  CA ', -0.74, (154.295, 120.142, 130.006)), (' A  32  TYR  CD1', ' A  32  TYR  N  ', -0.728, (150.092, 106.133, 141.691)), (' A 140  GLU  CG ', ' A 141  GLN  H  ', -0.728, (145.133, 91.623, 134.827)), (' A 171  ASP  OD1', ' A 172  LYS  N  ', -0.718, (151.939, 111.118, 117.938)), (' A  90  CYS  SG ', ' A  93  TRP  CZ3', -0.716, (159.305, 107.261, 137.301)), (' A   9  ARG  NH1', ' A  12  TYR  CD2', -0.714, (138.135, 87.26, 157.091)), (' A 163  SER  O  ', ' A 164  GLY  O  ', -0.711, (162.775, 110.706, 117.854)), (' A 135  THR  O  ', ' A 136  HIS  CG ', -0.702, (137.545, 89.891, 137.772)), (' A 160  ALA  HB3', ' A 161  PRO  HD3', -0.7, (165.606, 104.832, 122.486)), (' A  61  GLU  N  ', ' A  64  GLU  OE1', -0.697, (140.781, 103.332, 136.203)), (' A 114  LEU HD23', ' A 137  TYR  HB3', -0.697, (145.806, 90.404, 140.123)), (' A 140  GLU  HG3', ' A 141  GLN  H  ', -0.696, (145.888, 91.943, 135.057)), (' A  40  TYR  O  ', ' A  46  VAL  CG2', -0.695, (156.45, 116.133, 129.28)), (' A 104  LEU HD12', ' A 148  LEU  HB3', -0.694, (155.53, 97.106, 129.967)), (' A 128  HIS  O  ', ' A 131  ASP  CG ', -0.685, (137.379, 84.45, 143.839)), (' A  29  TYR  HD1', ' A  32  TYR  CD2', -0.668, (152.473, 105.555, 144.351)), (' A  69  LEU HD11', ' A 137  TYR  CZ ', -0.666, (142.152, 94.608, 142.418)), (' A 114  LEU  CD2', ' A 137  TYR  HB3', -0.658, (146.081, 90.89, 139.64)), (' A  69  LEU HD12', ' A 137  TYR  OH ', -0.654, (140.292, 95.392, 143.354)), (' A  23  GLN  HB3', ' A  69  LEU  CD2', -0.649, (144.726, 94.654, 146.555)), (' A  59  SER  O  ', ' A  62  GLU  HG2', -0.648, (144.536, 104.663, 138.349)), (' A  49  LYS  O  ', ' A  52  ALA  HB3', -0.646, (149.45, 113.737, 126.349)), (' A  83  GLN  CA ', ' A  83  GLN  OE1', -0.645, (148.365, 103.463, 155.786)), (' A  44  ASP  O  ', ' A  45  ASP  OD1', -0.644, (159.894, 122.961, 128.102)), (' A  42  ASP  OD1', ' A  43  ARG  HA ', -0.641, (154.428, 120.348, 130.476)), (' A  64  GLU  HG2', ' A  65  HIS  N  ', -0.64, (140.66, 99.787, 138.774)), (' A 140  GLU  CG ', ' A 141  GLN  N  ', -0.639, (145.101, 91.861, 134.686)), (' A 155  LEU  O  ', ' A 160  ALA  HB2', -0.635, (162.997, 103.836, 120.697)), (' A  41  PHE  HA ', ' A  46  VAL  CG2', -0.634, (156.191, 115.428, 128.031)), (' A  56  LEU  O  ', ' A  57  HIS  C  ', -0.634, (145.225, 106.778, 132.946)), (' A  41  PHE  HA ', ' A  46  VAL HG21', -0.634, (156.417, 115.424, 128.769)), (' A 140  GLU  HG3', ' A 141  GLN  N  ', -0.622, (145.979, 92.714, 135.09)), (' A  56  LEU  O  ', ' A  57  HIS  O  ', -0.621, (144.292, 107.265, 133.478)), (' A 110  VAL  O  ', ' A 114  LEU HD13', -0.616, (150.119, 91.85, 141.21)), (' A  69  LEU HD11', ' A 137  TYR  OH ', -0.609, (141.604, 94.769, 143.171)), (' A  20  ILE  O  ', ' A  24  ILE HD12', -0.603, (143.688, 96.072, 149.653)), (' A 131  ASP  O  ', ' A 134  GLU  HB2', -0.597, (139.628, 84.743, 139.457)), (' A  83  GLN  HA ', ' A  83  GLN  OE1', -0.596, (148.588, 103.67, 156.206)), (' A 107  GLU  CA ', ' A 107  GLU  OE1', -0.586, (152.458, 96.704, 136.421)), (' A 125  ASN  N  ', ' A 125  ASN  OD1', -0.586, (142.594, 77.505, 152.657)), (' A  83  GLN  CD ', ' A  83  GLN  N  ', -0.585, (147.333, 102.392, 155.334)), (' A  17  GLU  OE1', ' A  73  GLN  OE1', -0.577, (139.282, 91.494, 153.474)), (' A  57  HIS  O  ', ' A  60  HIS  N  ', -0.577, (143.289, 106.139, 135.004)), (' A 123  ASP  N  ', ' A 123  ASP  OD1', -0.573, (146.413, 79.331, 150.289)), (' A  32  TYR  CD2', ' A  85  ILE HG23', -0.567, (150.788, 107.108, 146.27)), (' A 124  LYS  C  ', ' A 125  ASN  CG ', -0.565, (141.848, 77.212, 153.244)), (' A  64  GLU  HG2', ' A  65  HIS  H  ', -0.562, (141.375, 100.127, 139.295)), (' A  81  PHE  C  ', ' A  83  GLN  NE2', -0.561, (145.066, 101.333, 155.87)), (' A  28  LEU  O  ', ' A  31  SER  N  ', -0.557, (148.499, 104.373, 142.126)), (' A   9  ARG HH12', ' A  12  TYR  HD2', -0.556, (138.778, 87.528, 157.853)), (' A  55  PHE  O  ', ' A  56  LEU  C  ', -0.552, (146.099, 107.768, 132.503)), (' A 126  ASP  O  ', ' A 126  ASP  OD1', -0.551, (138.821, 82.466, 148.587)), (' A  23  GLN  HB3', ' A  69  LEU HD23', -0.549, (143.945, 94.574, 146.984)), (' A  19  ALA  O  ', ' A  22  ARG  N  ', -0.548, (147.062, 94.285, 151.385)), (' A  37  MET  HE3', ' A  99  ALA  HB1', -0.546, (156.092, 106.358, 131.756)), (' A  37  MET  CE ', ' A  55  PHE  CE1', -0.546, (153.824, 105.73, 131.526)), (' A  29  TYR  O  ', ' A  32  TYR  CG ', -0.546, (151.576, 105.922, 142.646)), (' A 163  SER  O  ', ' A 164  GLY  C  ', -0.542, (162.935, 110.767, 117.603)), (' A  62  GLU  O  ', ' A  65  HIS  N  ', -0.538, (141.278, 100.642, 140.398)), (' A 139  ASN  C  ', ' A 140  GLU  HG2', -0.536, (144.268, 90.734, 134.331)), (' A 104  LEU  O  ', ' A 106  LEU  N  ', -0.534, (156.762, 97.709, 136.065)), (' A  28  LEU  O  ', ' A  31  SER  HB2', -0.53, (147.561, 105.464, 142.636)), (' A  19  ALA  HB1', ' A 117  LEU HD13', -0.53, (147.319, 89.496, 149.811)), (' A 147  GLU  HA ', ' A 150  ASP  CG ', -0.53, (151.836, 96.186, 124.206)), (' A  82  LEU  N  ', ' A  83  GLN HE22', -0.53, (145.158, 102.102, 156.547)), (' A 138  LEU  C  ', ' A 139  ASN  O  ', -0.53, (145.792, 88.893, 134.737)), (' A  62  GLU  CG ', ' A  63  ARG  N  ', -0.528, (144.254, 103.929, 139.79)), (' A  90  CYS  SG ', ' A  93  TRP  CH2', -0.526, (159.422, 107.941, 137.828)), (' A 133  ILE HG22', ' A 138  LEU HD22', -0.525, (144.282, 86.461, 140.006)), (' A 120  LEU  C  ', ' A 123  ASP  OD2', -0.524, (147.18, 81.957, 150.681)), (' A 160  ALA  O  ', ' A 161  PRO  C  ', -0.523, (165.968, 108.534, 121.239)), (' A  83  GLN  N  ', ' A  83  GLN  OE1', -0.523, (147.306, 103.423, 155.513)), (' A 100  MET  O  ', ' A 103  ALA  N  ', -0.519, (157.189, 101.454, 132.809)), (' A 112  GLN  O  ', ' A 116  GLU  CD ', -0.512, (153.463, 87.287, 144.113)), (' A 124  LYS  CA ', ' A 125  ASN  OD1', -0.509, (143.095, 77.979, 153.739)), (' A 130  CYS  O  ', ' A 131  ASP  C  ', -0.504, (140.032, 84.618, 141.895)), (' A 133  ILE HG22', ' A 138  LEU  CD2', -0.503, (144.857, 86.248, 140.124)), (' A  87  LYS  HB3', ' A  87  LYS  NZ ', -0.502, (158.3, 109.881, 148.329)), (' A 123  ASP  OD1', ' A 124  LYS  N  ', -0.501, (145.404, 79.313, 151.977)), (' A 126  ASP  CG ', ' A 129  LEU  HB2', -0.499, (139.511, 83.538, 149.541)), (' A  41  PHE  O  ', ' A  46  VAL HG23', -0.493, (155.626, 116.148, 127.349)), (' A 171  ASP  C  ', ' A 171  ASP  OD1', -0.492, (152.019, 110.223, 118.648)), (' A 139  ASN  O  ', ' A 141  GLN  N  ', -0.491, (146.199, 90.807, 133.636)), (' A  86  LYS  O  ', ' A  87  LYS  HB3', -0.489, (157.046, 109.214, 148.739)), (' A  15  ASP  O  ', ' A  16  SER  C  ', -0.487, (144.178, 89.021, 154.888)), (' A 150  ASP  N  ', ' A 150  ASP  OD1', -0.48, (154.1, 96.35, 124.145)), (' A 137  TYR  CD1', ' A 137  TYR  N  ', -0.479, (141.946, 90.978, 139.187)), (' A 140  GLU  HG2', ' A 141  GLN  H  ', -0.479, (145.324, 91.141, 134.806)), (' A  69  LEU  N  ', ' A  69  LEU HD12', -0.47, (139.523, 95.756, 144.421)), (' A 151  HIS  O  ', ' A 154  ASN  N  ', -0.47, (158.296, 98.915, 120.984)), (' A 126  ASP  C  ', ' A 126  ASP  OD1', -0.467, (138.231, 82.073, 149.291)), (' A  58  GLN  O  ', ' A  59  SER  C  ', -0.465, (144.742, 105.195, 136.208)), (' A  37  MET  HE1', ' A  55  PHE  CE1', -0.465, (154.244, 105.52, 131.894)), (' A 126  ASP  O  ', ' A 127  PRO  C  ', -0.459, (138.217, 81.395, 147.03)), (' A 104  LEU  C  ', ' A 106  LEU  H  ', -0.455, (156.675, 97.816, 135.269)), (' A  66  ALA  O  ', ' A  70  MET  HG2', -0.454, (139.677, 99.526, 146.689)), (' A  55  PHE  O  ', ' A  58  GLN  N  ', -0.449, (146.46, 106.036, 132.681)), (' A 164  GLY  O  ', ' A 166  ALA  N  ', -0.444, (161.513, 110.172, 117.274)), (' A  37  MET  HE1', ' A  55  PHE  CZ ', -0.442, (154.576, 105.544, 131.632)), (' A  62  GLU  O  ', ' A  63  ARG  C  ', -0.439, (141.517, 101.973, 140.71)), (' A 120  LEU  HA ', ' A 120  LEU HD22', -0.439, (148.519, 82.475, 151.882)), (' A 139  ASN  O  ', ' A 140  GLU  HG2', -0.438, (145.305, 90.406, 134.338)), (' A 147  GLU  N  ', ' A 147  GLU  OE1', -0.438, (150.685, 94.742, 127.409)), (' A 166  ALA  O  ', ' A 167  GLU  C  ', -0.437, (158.162, 109.482, 118.35)), (' A  23  GLN  HG3', ' A  69  LEU HD21', -0.436, (144.83, 94.088, 145.207)), (' A  29  TYR  O  ', ' A  32  TYR  CD2', -0.431, (151.747, 105.658, 143.832)), (' A 147  GLU  CA ', ' A 150  ASP  OD2', -0.43, (151.706, 95.539, 124.724)), (' A 150  ASP  O  ', ' A 154  ASN  OD1', -0.426, (155.919, 97.859, 120.041)), (' A  62  GLU  HG3', ' A  63  ARG  N  ', -0.423, (144.32, 103.651, 140.54)), (' A  54  TYR  O  ', ' A  55  PHE  C  ', -0.422, (147.519, 107.621, 131.174)), (' A 164  GLY  O  ', ' A 165  LEU  C  ', -0.421, (161.367, 110.689, 117.141)), (' A  37  MET  HE2', ' A  55  PHE  CE1', -0.421, (153.549, 106.344, 131.639)), (' A  24  ILE  O  ', ' A  27  GLU  N  ', -0.419, (147.144, 99.773, 145.983)), (' A 167  GLU  HA ', ' A 167  GLU  OE1', -0.418, (158.945, 108.512, 121.442)), (' A  31  SER  HG ', ' A  62  GLU  HG3', -0.417, (145.314, 103.962, 141.924)), (' A 117  LEU  O  ', ' A 120  LEU  N  ', -0.416, (147.586, 83.835, 148.349)), (' A  41  PHE  CA ', ' A  46  VAL HG21', -0.415, (155.912, 114.991, 129.19)), (' A  23  GLN  O  ', ' A  24  ILE  C  ', -0.414, (146.621, 98.625, 147.34)), (' A 103  ALA  O  ', ' A 104  LEU  C  ', -0.413, (156.497, 98.129, 134.547)), (' A 100  MET  O  ', ' A 101  GLU  C  ', -0.413, (159.111, 100.983, 132.222)), (' A  41  PHE  HA ', ' A  46  VAL HG23', -0.411, (155.95, 115.539, 128.036)), (' A  28  LEU  HB3', ' A  85  ILE  CD1', -0.41, (147.873, 105.452, 147.412)), (' A  72  LEU HD22', ' A 132  PHE  CD2', -0.409, (138.621, 90.431, 145.915)), (' A 175  LEU  N  ', ' A 175  LEU HD23', -0.407, (150.406, 104.777, 121.211)), (' A  99  ALA  O  ', ' A 100  MET  C  ', -0.406, (158.35, 102.608, 131.243)), (' A  62  GLU  HG2', ' A  63  ARG  H  ', -0.406, (143.76, 104.23, 139.574)), (' A  19  ALA  O  ', ' A  20  ILE  C  ', -0.406, (145.497, 93.919, 151.251)), (' A  79  ARG  HA ', ' A  79  ARG  HD3', -0.405, (136.428, 97.264, 157.985)), (' A  38  SER  OG ', ' A  56  LEU HD13', -0.405, (147.824, 112.717, 133.045)), (' A 151  HIS  O  ', ' A 152  VAL  C  ', -0.403, (158.799, 99.259, 122.607)), (' A  53  LYS  O  ', ' A  54  TYR  C  ', -0.402, (147.028, 108.083, 129.481)), (' A  97  LEU HD13', ' A 155  LEU  HB3', -0.4, (162.041, 103.123, 122.972))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
