# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', '  79 ', 'ARG', 0.045498292026665256, (137.613, 96.913, 157.466)), ('A', '  81 ', 'PHE', 0.039204723972179195, (142.267, 100.294, 155.935)), ('A', ' 125 ', 'ASN', 0.029009856088939454, (141.294, 77.92, 151.027)), ('A', ' 160 ', 'ALA', 0.021771276975951145, (163.792, 105.43799999999997, 121.44200000000001))]
data['omega'] = [('A', '  29 ', 'TYR', None, (149.827, 103.098, 143.889)), ('A', '  94 ', 'GLU', None, (162.949, 110.48499999999997, 132.27500000000003))]
data['rota'] = []
data['cbeta'] = []
data['probe'] = [(' A 114  LEU HD13', ' A 137  TYR  HB3', -1.135, (145.55, 91.396, 139.66)), (' A  41  PHE  HE1', ' A  55  PHE  CE1', -1.049, (154.832, 107.636, 129.599)), (' A  32  TYR  HB3', ' A  88  PRO  HD3', -1.046, (153.323, 109.006, 142.401)), (' A  41  PHE  CE1', ' A  55  PHE  HE1', -1.037, (154.251, 108.462, 128.707)), (' A  81  PHE  CZ ', ' A  83  GLN  NE2', -1.031, (147.698, 101.147, 156.933)), (' A  72  LEU HD22', ' A 132  PHE  CG ', -0.933, (137.532, 88.925, 144.923)), (' A  69  LEU  HB2', ' A 137  TYR  OH ', -0.905, (141.117, 95.178, 144.053)), (' A 141  GLN  O  ', ' A 145  ILE HG12', -0.856, (149.272, 92.922, 132.521)), (' A 114  LEU  CD1', ' A 137  TYR  HB3', -0.855, (146.23, 92.06, 140.015)), (' A  20  ILE HG21', ' A  73  GLN  HG3', -0.847, (140.876, 93.554, 150.835)), (' A 153  THR HG22', ' A 157  LYS  HE3', -0.795, (161.214, 95.343, 118.55)), (' A  41  PHE  CE1', ' A  55  PHE  CE1', -0.79, (153.755, 108.906, 129.182)), (' A  41  PHE  HD2', ' A  48  LEU HD12', -0.782, (156.067, 112.307, 125.785)), (' A  41  PHE  CD2', ' A  48  LEU HD12', -0.781, (156.044, 111.454, 126.205)), (' A 101  GLU  OE2', ' A 156  ARG  NH1', -0.776, (164.068, 99.217, 127.411)), (' A  15  ASP  HB2', ' A 124  LYS  HE3', -0.762, (146.006, 83.507, 155.971)), (' A  12  TYR  OH ', ' A  73  GLN  HG2', -0.762, (139.828, 90.948, 152.514)), (' A  33  VAL  CG1', ' A  37  MET  HE3', -0.755, (155.187, 104.852, 136.871)), (' A  41  PHE  HE1', ' A  55  PHE  HE1', -0.753, (154.802, 108.812, 129.78)), (' A  97  LEU HD22', ' A 160  ALA  HB3', -0.751, (164.038, 103.182, 123.686)), (' A  33  VAL HG12', ' A  37  MET  HE3', -0.749, (155.184, 105.474, 136.085)), (' A 153  THR  CG2', ' A 157  LYS  HE3', -0.742, (160.876, 94.349, 119.407)), (' A  50  ASN  HB2', ' A 171  ASP  O  ', -0.733, (150.205, 110.196, 120.627)), (' A  97  LEU HD11', ' A 152  VAL HG13', -0.725, (161.612, 100.166, 125.276)), (' A 155  LEU HD23', ' A 170  PHE  CD1', -0.718, (158.641, 104.65, 119.804)), (' A  95  SER  HB2', ' A 167  GLU  OE2', -0.712, (162.853, 109.341, 124.959)), (' A  63  ARG  O  ', ' A  66  ALA  HB3', -0.692, (141.392, 101.492, 142.739)), (' A  32  TYR  CB ', ' A  88  PRO  HD3', -0.661, (153.499, 108.605, 142.867)), (' A  81  PHE  HZ ', ' A  83  GLN  NE2', -0.65, (148.31, 99.962, 157.786)), (' A  24  ILE HG12', ' A  69  LEU HD23', -0.632, (142.79, 96.638, 147.066)), (' A  27  GLU  HB3', ' A  62  GLU  OE2', -0.632, (146.474, 98.84, 142.752)), (' A  48  LEU HD13', ' A  51  PHE  HD1', -0.63, (155.791, 110.916, 124.315)), (' A  17  GLU  OE1', ' A  73  GLN  NE2', -0.626, (140.345, 92.76, 155.506)), (' A 160  ALA  HB3', ' A 161  PRO  HD3', -0.615, (164.502, 104.702, 124.13)), (' A  12  TYR  OH ', ' A  20  ILE HD12', -0.615, (140.583, 90.395, 152.189)), (' A 118  HIS  HB2', ' A 133  ILE HG21', -0.614, (145.626, 86.106, 143.156)), (' A 160  ALA  HB3', ' A 161  PRO  CD ', -0.611, (165.101, 104.512, 123.511)), (' A 172  LYS  HD3', ' A 173  HIS  CE1', -0.607, (152.4, 111.503, 113.081)), (' A  17  GLU  OE2', ' A  78  GLY  O  ', -0.601, (139.534, 94.08, 156.852)), (' A  20  ILE  CG2', ' A  73  GLN  HG3', -0.601, (141.653, 92.848, 151.309)), (' A  72  LEU HD22', ' A 132  PHE  CB ', -0.601, (138.083, 88.7, 144.396)), (' A 166  ALA  O  ', ' A 170  PHE  HD1', -0.576, (158.46, 106.58, 118.181)), (' A 114  LEU HD12', ' A 141  GLN  HG3', -0.563, (148.181, 91.604, 139.423)), (' A  41  PHE  CE1', ' A  51  PHE  HB3', -0.562, (154.379, 109.378, 127.907)), (' A 155  LEU HD23', ' A 170  PHE  CE1', -0.555, (158.084, 104.267, 119.287)), (' A  74  ASN  O  ', ' A  77  GLY  N  ', -0.553, (133.091, 93.292, 154.434)), (' A  51  PHE  CE2', ' A 175  LEU HD12', -0.548, (152.87, 105.821, 123.635)), (' A 142  VAL  HA ', ' A 145  ILE  CG1', -0.54, (150.0, 91.945, 131.916)), (' A  34  TYR  OH ', ' A 107  GLU  HG2', -0.539, (152.241, 99.335, 135.064)), (' A  97  LEU HD22', ' A 160  ALA  CB ', -0.536, (163.485, 103.653, 123.288)), (' A  81  PHE  CE1', ' A  83  GLN  NE2', -0.536, (146.992, 101.102, 158.128)), (' A  74  ASN  O  ', ' A  77  GLY  HA2', -0.535, (132.704, 94.229, 155.042)), (' A  81  PHE  CE2', ' A  83  GLN  HG2', -0.532, (147.321, 100.864, 155.368)), (' A  38  SER  HB3', ' A  55  PHE  HB2', -0.53, (149.885, 110.052, 132.1)), (' A 158  MET  HG3', ' A 170  PHE  CE1', -0.528, (158.725, 103.728, 116.886)), (' A  41  PHE  CE2', ' A  51  PHE  CD1', -0.528, (155.74, 110.222, 126.001)), (' A  72  LEU HD22', ' A 132  PHE  CD1', -0.527, (137.326, 89.59, 144.307)), (' A  20  ILE HG21', ' A  73  GLN  CG ', -0.526, (140.432, 92.725, 151.17)), (' A 142  VAL  HA ', ' A 145  ILE HG12', -0.519, (149.845, 92.087, 132.427)), (' A  12  TYR  HD1', ' A  76  ARG  NH2', -0.515, (137.304, 86.43, 151.778)), (' A  74  ASN  O  ', ' A  77  GLY  CA ', -0.512, (133.302, 94.096, 154.632)), (' A  41  PHE  CZ ', ' A  96  GLY  HA2', -0.511, (157.505, 108.796, 127.349)), (' A  48  LEU  HB3', ' A 171  ASP  OD1', -0.511, (153.686, 112.694, 123.637)), (' A 155  LEU  CD2', ' A 170  PHE  CG ', -0.51, (157.559, 105.138, 119.963)), (' A  32  TYR  CE1', ' A  85  ILE HG22', -0.509, (150.346, 107.898, 146.363)), (' A  67  GLU  HA ', ' A  70  MET  HE3', -0.508, (137.545, 101.332, 146.302)), (' A 155  LEU HD23', ' A 170  PHE  CG ', -0.508, (157.529, 104.873, 119.818)), (' A  48  LEU HD22', ' A 171  ASP  HB2', -0.506, (155.384, 111.59, 121.801)), (' A  78  GLY  O  ', ' A  79  ARG  HB2', -0.497, (138.756, 95.547, 158.008)), (' A  23  GLN HE21', ' A  27  GLU  HG3', -0.492, (147.791, 96.051, 144.102)), (' A  32  TYR  HE1', ' A  85  ILE HG22', -0.491, (150.58, 107.529, 146.979)), (' A 114  LEU HD12', ' A 141  GLN  CG ', -0.49, (148.015, 92.167, 138.901)), (' A  48  LEU HD13', ' A  51  PHE  CD1', -0.482, (155.783, 110.334, 124.203)), (' A  97  LEU HD23', ' A 161  PRO  HD3', -0.481, (164.958, 104.039, 125.163)), (' A  34  TYR  HD2', ' A  55  PHE  HD2', -0.479, (151.534, 105.023, 133.333)), (' A  13  HIS  CD2', ' A 124  LYS  HB3', -0.478, (141.806, 81.25, 154.239)), (' A  24  ILE HG12', ' A  69  LEU  CD2', -0.478, (142.919, 96.224, 147.346)), (' A  97  LEU  CD1', ' A 152  VAL HG13', -0.476, (161.237, 100.992, 125.308)), (' A  41  PHE  CD1', ' A  51  PHE  HB3', -0.469, (153.841, 110.197, 127.943)), (' A 134  GLU  HA ', ' A 138  LEU HD12', -0.467, (144.277, 85.266, 138.728)), (' A  69  LEU  CB ', ' A 137  TYR  OH ', -0.464, (141.516, 96.02, 144.656)), (' A 155  LEU  CD2', ' A 170  PHE  CD1', -0.458, (158.144, 105.103, 120.214)), (' A   9  ARG  NE ', ' A  12  TYR  HD2', -0.446, (137.511, 87.928, 157.319)), (' A  37  MET  SD ', ' A  55  PHE  CE2', -0.442, (154.278, 106.037, 132.862)), (' A  33  VAL HG22', ' A  88  PRO  HB3', -0.441, (155.467, 107.063, 140.876)), (' A  48  LEU HD22', ' A 171  ASP  CB ', -0.433, (154.975, 111.912, 121.582)), (' A 132  PHE  C  ', ' A 132  PHE  CD2', -0.428, (139.951, 88.773, 142.558)), (' A  67  GLU  HA ', ' A  70  MET  CE ', -0.425, (137.799, 101.26, 146.299)), (' A  73  GLN  O  ', ' A  76  ARG  HB2', -0.423, (135.745, 91.378, 153.207)), (' A  50  ASN  ND2', ' A 171  ASP  O  ', -0.423, (149.72, 110.349, 120.339)), (' A  24  ILE  CG1', ' A  69  LEU  CD2', -0.422, (143.132, 95.992, 147.614)), (' A  34  TYR  HE2', ' A 103  ALA  HB1', -0.421, (152.753, 102.277, 133.468)), (' A 117  LEU  HG ', ' A 133  ILE  CD1', -0.42, (144.521, 87.478, 146.64)), (' A  41  PHE  CE2', ' A  48  LEU HD12', -0.409, (156.596, 111.361, 126.407)), (' A 155  LEU HD21', ' A 170  PHE  CG ', -0.406, (157.046, 105.073, 120.417)), (' A  41  PHE  HZ ', ' A  96  GLY  HA2', -0.406, (157.048, 108.44, 127.854)), (' A  24  ILE  CG1', ' A  69  LEU HD23', -0.404, (143.308, 96.498, 147.827)), (' A 104  LEU HD13', ' A 148  LEU  HB2', -0.403, (154.909, 96.411, 130.049)), (' A  29  TYR  O  ', ' A  33  VAL HG23', -0.402, (152.778, 105.235, 141.332)), (' A  32  TYR  HB3', ' A  88  PRO  CD ', -0.4, (154.079, 109.438, 141.864)), (' A  19  ALA  HB2', ' A 120  LEU HD13', -0.4, (148.147, 87.644, 152.118)), (' A  81  PHE  O  ', ' A  82  LEU HD23', -0.4, (142.949, 101.353, 152.535))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
