# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', '  18 ', 'ALA', 0.0004295741972219475, (146.264, 92.804, 156.05699999999993)), ('A', ' 125 ', 'ASN', 0.011157955690319818, (140.936, 78.14700000000002, 150.863))]
data['omega'] = []
data['rota'] = []
data['cbeta'] = []
data['probe'] = [(' A 114  LEU HD13', ' A 137  TYR  HB3', -1.145, (146.198, 91.568, 140.219)), (' A  34  TYR  OH ', ' A 107  GLU  OE2', -0.976, (149.904, 100.307, 134.876)), (' A 141  GLN  O  ', ' A 145  ILE HG12', -0.837, (149.627, 92.619, 132.762)), (' A  72  LEU HD22', ' A 132  PHE  CG ', -0.817, (137.7, 89.691, 144.309)), (' A 114  LEU HD12', ' A 141  GLN  HG3', -0.809, (147.951, 92.103, 138.842)), (' A  74  ASN  O  ', ' A  77  GLY  HA2', -0.794, (132.709, 94.151, 154.762)), (' A  97  LEU HD22', ' A 160  ALA  HB3', -0.781, (164.372, 103.949, 123.984)), (' A 114  LEU  CD1', ' A 137  TYR  HB3', -0.755, (146.03, 92.073, 139.991)), (' A  17  GLU  O  ', ' A  18  ALA  HB2', -0.753, (145.77, 92.095, 157.548)), (' A  69  LEU  HB2', ' A 137  TYR  OH ', -0.741, (140.795, 95.465, 143.835)), (' A  13  HIS  CD2', ' A 124  LYS  HD2', -0.717, (143.283, 81.654, 155.608)), (' A  15  ASP  HB2', ' A 124  LYS  HE2', -0.716, (145.577, 84.719, 155.772)), (' A  32  TYR  HB3', ' A  88  PRO  HG3', -0.702, (152.865, 109.148, 142.099)), (' A  51  PHE  CD2', ' A 175  LEU  CD1', -0.693, (153.153, 106.92, 123.849)), (' A  30  ALA  HA ', ' A  33  VAL HG12', -0.687, (151.599, 103.745, 139.394)), (' A  30  ALA  HB1', ' A  62  GLU  HG3', -0.66, (148.314, 102.066, 138.295)), (' A 160  ALA  HB3', ' A 161  PRO  HD3', -0.66, (164.431, 104.865, 123.976)), (' A  94  GLU  HB2', ' A  98  ASN HD22', -0.659, (165.257, 108.513, 130.791)), (' A  17  GLU  O  ', ' A  18  ALA  CB ', -0.657, (145.698, 91.361, 157.021)), (' A 161  PRO  HA ', ' A 167  GLU  OE2', -0.651, (163.776, 109.214, 123.711)), (' A  72  LEU HD22', ' A 132  PHE  CB ', -0.649, (137.282, 89.0, 144.151)), (' A  54  TYR  HA ', ' A  57  HIS  HE1', -0.644, (146.086, 105.554, 127.792)), (' A 155  LEU HD21', ' A 170  PHE  CD2', -0.643, (157.433, 104.826, 121.05)), (' A 149  GLY  O  ', ' A 153  THR HG23', -0.64, (159.143, 95.925, 124.421)), (' A  33  VAL HG21', ' A 106  LEU  CD1', -0.639, (155.54, 103.988, 138.106)), (' A  51  PHE  CD2', ' A 175  LEU HD12', -0.63, (152.41, 107.626, 123.927)), (' A 155  LEU HD21', ' A 170  PHE  CG ', -0.625, (156.879, 104.941, 120.571)), (' A 114  LEU HD12', ' A 141  GLN  CG ', -0.625, (147.697, 92.096, 138.815)), (' A  72  LEU HD22', ' A 132  PHE  CD1', -0.625, (136.9, 89.648, 144.1)), (' A 155  LEU  CD2', ' A 170  PHE  CD2', -0.622, (157.534, 104.087, 120.27)), (' A  54  TYR  HA ', ' A  57  HIS  CE1', -0.613, (145.927, 105.763, 127.801)), (' A  30  ALA  CB ', ' A  62  GLU  HG3', -0.612, (148.359, 102.695, 139.155)), (' A  13  HIS  CE1', ' A 124  LYS  HB3', -0.611, (141.58, 80.753, 154.172)), (' A  97  LEU  CD1', ' A 152  VAL HG13', -0.603, (160.819, 101.602, 125.515)), (' A 101  GLU  CD ', ' A 156  ARG HH11', -0.601, (163.489, 100.209, 128.46)), (' A 158  MET  HG3', ' A 170  PHE  HE1', -0.601, (159.167, 103.794, 116.496)), (' A  28  LEU  O  ', ' A  31  SER  HB2', -0.6, (148.466, 105.831, 143.526)), (' A  51  PHE  CD2', ' A 175  LEU HD11', -0.584, (153.001, 106.05, 124.344)), (' A  51  PHE  HZ ', ' A 170  PHE  HB3', -0.574, (155.694, 106.577, 121.715)), (' A  34  TYR  HB2', ' A  59  SER  HB3', -0.563, (148.224, 106.864, 136.521)), (' A 158  MET  HG3', ' A 170  PHE  CE1', -0.557, (158.734, 103.542, 117.123)), (' A  93  TRP  HZ3', ' A 102  CYS  HG ', -0.55, (160.468, 105.474, 136.173)), (' A  29  TYR  HE2', ' A 106  LEU HD13', -0.548, (155.163, 102.404, 140.383)), (' A  72  LEU  CD2', ' A 132  PHE  CG ', -0.548, (137.79, 89.111, 145.063)), (' A 142  VAL  O  ', ' A 145  ILE  O  ', -0.54, (149.661, 92.816, 129.318)), (' A  30  ALA  HB1', ' A  34  TYR  CE1', -0.53, (149.164, 102.72, 137.713)), (' A  33  VAL HG22', ' A  37  MET  HE3', -0.528, (155.095, 105.529, 136.668)), (' A  20  ILE HG21', ' A  73  GLN  HG3', -0.524, (140.721, 92.594, 150.951)), (' A  24  ILE HG12', ' A  69  LEU HD23', -0.521, (142.801, 96.92, 146.946)), (' A  51  PHE  HZ ', ' A 170  PHE  CB ', -0.521, (155.633, 107.027, 121.541)), (' A  51  PHE  CZ ', ' A 170  PHE  HB3', -0.516, (155.027, 106.997, 121.563)), (' A  97  LEU HD22', ' A 160  ALA  CB ', -0.514, (163.728, 104.234, 123.38)), (' A  97  LEU  CD2', ' A 160  ALA  HB3', -0.512, (164.181, 104.322, 124.611)), (' A  36  SER  OG ', ' A  88  PRO  HG2', -0.509, (154.671, 110.699, 140.291)), (' A 155  LEU  CD2', ' A 170  PHE  CG ', -0.508, (157.914, 104.823, 120.335)), (' A  33  VAL HG13', ' A  34  TYR  N  ', -0.508, (152.574, 105.644, 137.87)), (' A 118  HIS  HB2', ' A 133  ILE HG21', -0.504, (145.344, 85.902, 143.202)), (' A  97  LEU  HB2', ' A 160  ALA  CB ', -0.498, (162.375, 104.908, 124.373)), (' A  97  LEU HD11', ' A 152  VAL HG13', -0.491, (161.546, 101.088, 125.725)), (' A  74  ASN  O  ', ' A  77  GLY  CA ', -0.483, (133.446, 94.005, 154.755)), (' A  13  HIS  CG ', ' A 124  LYS  HD2', -0.481, (142.935, 82.149, 156.207)), (' A  13  HIS  O  ', ' A  16  SER  HB2', -0.481, (141.991, 87.016, 155.444)), (' A  43  ARG  C  ', ' A  45  ASP  N  ', -0.476, (157.697, 119.943, 128.536)), (' A  93  TRP  HZ3', ' A 102  CYS  SG ', -0.471, (160.455, 104.894, 135.863)), (' A  72  LEU  CD2', ' A 132  PHE  CB ', -0.471, (137.592, 88.922, 145.063)), (' A  70  MET  O  ', ' A  74  ASN  HB2', -0.47, (135.475, 96.522, 150.857)), (' A 132  PHE  HE2', ' A 137  TYR  CE1', -0.47, (140.747, 92.414, 143.338)), (' A  97  LEU HD23', ' A 161  PRO  HD3', -0.47, (164.892, 104.803, 124.857)), (' A 138  LEU  O  ', ' A 142  VAL HG23', -0.468, (147.173, 88.715, 134.602)), (' A  13  HIS  ND1', ' A 124  LYS  HB3', -0.467, (141.71, 81.98, 154.226)), (' A  34  TYR  CB ', ' A  59  SER  HB3', -0.465, (148.779, 107.033, 136.203)), (' A  21  ASN  ND2', ' A  81  PHE  CD1', -0.464, (142.845, 96.978, 156.843)), (' A  63  ARG  O  ', ' A  66  ALA  HB3', -0.461, (140.967, 101.808, 143.312)), (' A  97  LEU HD12', ' A 152  VAL HG13', -0.46, (160.826, 101.731, 126.258)), (' A 132  PHE  HE2', ' A 137  TYR  HE1', -0.45, (140.965, 92.958, 143.48)), (' A 165  LEU  O  ', ' A 169  LEU  HG ', -0.449, (159.126, 109.659, 115.048)), (' A 104  LEU HD22', ' A 149  GLY  HA2', -0.448, (157.808, 96.2, 128.205)), (' A  37  MET  HE1', ' A 103  ALA  CA ', -0.443, (155.895, 103.183, 134.494)), (' A  27  GLU  HG3', ' A  62  GLU  OE1', -0.443, (146.684, 99.702, 140.672)), (' A 132  PHE  CE2', ' A 137  TYR  HE1', -0.44, (140.472, 92.683, 143.363)), (' A  12  TYR  C  ', ' A  12  TYR  CD2', -0.438, (138.755, 86.197, 156.024)), (' A  33  VAL  CG1', ' A  34  TYR  N  ', -0.438, (152.671, 105.797, 138.119)), (' A 145  ILE HG13', ' A 146  LYS  HG2', -0.435, (151.378, 91.394, 130.187)), (' A 169  LEU  O  ', ' A 173  HIS  HB3', -0.421, (153.923, 107.214, 115.844)), (' A  97  LEU  HB2', ' A 160  ALA  HB1', -0.418, (162.238, 105.403, 124.359)), (' A  26  LEU  O  ', ' A  29  TYR  HB3', -0.418, (151.213, 100.999, 144.196)), (' A  50  ASN  ND2', ' A 171  ASP  O  ', -0.418, (149.431, 110.594, 119.849)), (' A  73  GLN  OE1', ' A  74  ASN  OD1', -0.416, (138.641, 95.536, 153.095)), (' A 132  PHE  CE2', ' A 137  TYR  CE1', -0.414, (140.944, 92.725, 143.101)), (' A  72  LEU HD22', ' A 132  PHE  HB2', -0.414, (136.905, 88.52, 144.428)), (' A  51  PHE  CE2', ' A 175  LEU HD11', -0.413, (153.367, 106.375, 124.168)), (' A  39  TYR  O  ', ' A  43  ARG  HG3', -0.412, (155.217, 116.803, 132.424)), (' A  66  ALA  O  ', ' A  70  MET  HG3', -0.41, (139.249, 99.169, 146.553)), (' A 100  MET  SD ', ' A 155  LEU HD11', -0.407, (157.086, 104.387, 124.443)), (' A 137  TYR  O  ', ' A 141  GLN  HG2', -0.4, (146.301, 92.091, 137.04))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
