# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = []
data['omega'] = [('A', ' 161 ', 'PRO', None, (165.965, 106.91499999999995, 122.63699999999999))]
data['rota'] = [('A', '   8 ', 'VAL', 0.060380362532388404, (128.445, 88.78499999999997, 157.081)), ('A', '  53 ', 'LYS', 0.07557097807223917, (147.05, 111.34299999999998, 127.879)), ('A', '  72 ', 'LEU', 0.04837861743198878, (135.54300000000003, 93.17799999999997, 148.24799999999993)), ('A', '  86 ', 'LYS', 0.027222906705090786, (154.481, 107.259, 148.95699999999997)), ('A', '  90 ', 'CYS', 0.2883542656137755, (161.49800000000002, 109.39099999999998, 139.59699999999995)), ('A', '  91 ', 'ASP', 0.07329840126813696, (160.66, 113.07599999999996, 139.749)), ('A', ' 116 ', 'GLU', 0.054863594339158495, (151.944, 85.938, 146.36799999999994)), ('A', ' 120 ', 'LEU', 0.15598505809390495, (148.29800000000003, 82.624, 150.11799999999997)), ('A', ' 122 ', 'THR', 0.054338742945869795, (144.591, 79.09, 147.98899999999995)), ('A', ' 133 ', 'ILE', 0.06284586122619765, (141.404, 87.84299999999998, 142.68399999999994)), ('A', ' 172 ', 'LYS', 0.09723205279422732, (151.164, 109.77999999999997, 116.88099999999997))]
data['cbeta'] = [('A', '  47 ', 'ALA', ' ', 0.2693139618491996, (156.209, 119.00099999999995, 123.46299999999997))]
data['probe'] = [(' A  50  ASN  HB2', ' A 171  ASP  OD2', -1.104, (151.421, 111.617, 120.926)), (' A  50  ASN  HB2', ' A 171  ASP  CG ', -1.071, (151.569, 110.877, 120.894)), (' A 112  GLN  OE1', ' A 116  GLU  OE2', -1.034, (154.73, 86.94, 143.683)), (' A  69  LEU HD21', ' A 137  TYR  CZ ', -0.95, (142.573, 93.856, 142.312)), (' A  69  LEU  CD2', ' A 137  TYR  CZ ', -0.924, (141.497, 94.064, 142.666)), (' A 112  GLN  O  ', ' A 116  GLU  HG2', -0.917, (153.281, 87.8, 143.879)), (' A  31  SER  OG ', ' A  62  GLU  HB3', -0.901, (145.791, 104.056, 139.429)), (' A  50  ASN  HB2', ' A 171  ASP  OD1', -0.891, (151.473, 110.024, 121.717)), (' A   9  ARG  NH1', ' A  12  TYR  HD2', -0.844, (138.105, 87.62, 157.547)), (' A  13  HIS  HB2', ' A 124  LYS  HD2', -0.836, (141.982, 82.936, 156.266)), (' A 141  GLN  O  ', ' A 145  ILE HG13', -0.772, (150.66, 91.825, 132.608)), (' A  27  GLU  HG3', ' A  69  LEU  CD1', -0.77, (144.002, 96.368, 144.072)), (' A 158  MET  HE1', ' A 170  PHE  HB2', -0.768, (158.084, 104.802, 117.991)), (' A  37  MET  CE ', ' A  55  PHE  CE1', -0.752, (153.564, 106.579, 131.931)), (' A  37  MET  HE1', ' A  55  PHE  CE1', -0.747, (153.823, 105.5, 131.623)), (' A  86  LYS  HA ', ' A  86  LYS  HE2', -0.74, (155.231, 107.618, 150.637)), (' A  26  LEU HD22', ' A 110  VAL HG22', -0.74, (150.951, 97.466, 142.349)), (' A  50  ASN  CB ', ' A 171  ASP  OD1', -0.717, (150.786, 110.055, 121.764)), (' A  13  HIS  CB ', ' A 124  LYS  HD2', -0.71, (142.489, 83.857, 155.929)), (' A  69  LEU  CD2', ' A 137  TYR  OH ', -0.702, (141.446, 94.836, 142.92)), (' A  24  ILE HD13', ' A  70  MET  HG2', -0.696, (140.748, 99.081, 149.612)), (' A  69  LEU  HG ', ' A 137  TYR  OH ', -0.672, (141.52, 95.571, 142.688)), (' A  27  GLU  HG3', ' A  69  LEU HD12', -0.666, (143.815, 97.078, 144.792)), (' A   9  ARG  NH1', ' A  12  TYR  CD2', -0.657, (137.958, 88.005, 156.965)), (' A  37  MET  CE ', ' A  55  PHE  CD1', -0.652, (153.089, 106.295, 131.665)), (' A 124  LYS  HG2', ' A 124  LYS  O  ', -0.652, (142.334, 80.222, 154.183)), (' A  20  ILE HG21', ' A  73  GLN  OE1', -0.647, (140.628, 93.128, 151.114)), (' A  27  GLU  HG3', ' A  69  LEU HD11', -0.645, (144.487, 96.175, 144.063)), (' A  80  ILE  O  ', ' A  81  PHE  CD1', -0.64, (140.926, 99.361, 158.186)), (' A  41  PHE  HD1', ' A  46  VAL HG11', -0.63, (157.291, 113.346, 127.999)), (' A 141  GLN  HA ', ' A 141  GLN  OE1', -0.626, (148.286, 93.722, 134.797)), (' A  37  MET  HE3', ' A  55  PHE  CZ ', -0.624, (154.219, 106.415, 131.187)), (' A  40  TYR  CZ ', ' A  93  TRP  O  ', -0.621, (160.863, 112.703, 131.093)), (' A  86  LYS  CA ', ' A  86  LYS  HE2', -0.62, (154.687, 107.368, 150.011)), (' A  50  ASN  CB ', ' A 171  ASP  OD2', -0.615, (150.712, 111.136, 121.186)), (' A 117  LEU  O  ', ' A 117  LEU HD23', -0.614, (146.027, 86.251, 147.685)), (' A  24  ILE HD13', ' A  70  MET  CG ', -0.604, (140.334, 99.102, 149.067)), (' A  69  LEU HD21', ' A 137  TYR  CE1', -0.6, (142.692, 94.079, 142.349)), (' A  69  LEU HD23', ' A 137  TYR  CZ ', -0.597, (141.15, 93.664, 143.458)), (' A   5  THR  O  ', ' A   5  THR HG23', -0.594, (130.819, 89.389, 164.432)), (' A  14  GLN  N  ', ' A  14  GLN  OE1', -0.586, (142.969, 85.669, 159.767)), (' A  20  ILE  CG2', ' A  73  GLN  OE1', -0.583, (140.931, 93.98, 150.995)), (' A  14  GLN  CD ', ' A  14  GLN  H  ', -0.574, (141.895, 85.656, 160.731)), (' A  51  PHE  HE2', ' A 171  ASP  HB2', -0.566, (155.096, 108.983, 121.752)), (' A 117  LEU  C  ', ' A 117  LEU HD23', -0.565, (146.221, 86.661, 147.471)), (' A  26  LEU  O  ', ' A  26  LEU HD23', -0.558, (150.878, 99.433, 143.799)), (' A  69  LEU HD23', ' A 137  TYR  OH ', -0.558, (140.865, 94.391, 143.703)), (' A  93  TRP  CD1', ' A  93  TRP  N  ', -0.548, (160.266, 111.544, 134.012)), (' A  69  LEU  CG ', ' A 137  TYR  OH ', -0.544, (141.763, 95.17, 143.466)), (' A  37  MET  HE3', ' A  55  PHE  CE2', -0.536, (154.467, 106.849, 131.1)), (' A  40  TYR  OH ', ' A  93  TRP  O  ', -0.527, (161.5, 113.099, 131.11)), (' A  26  LEU  CD2', ' A 110  VAL HG22', -0.526, (151.354, 97.684, 142.861)), (' A  44  ASP  OD1', ' A  45  ASP  N  ', -0.524, (158.929, 122.623, 128.596)), (' A  51  PHE  CE2', ' A 171  ASP  HB2', -0.514, (154.304, 109.259, 121.804)), (' A  50  ASN  CB ', ' A 171  ASP  CG ', -0.511, (150.886, 110.402, 121.651)), (' A  41  PHE  CD1', ' A  46  VAL HG11', -0.51, (157.49, 113.33, 128.248)), (' A 114  LEU HD13', ' A 137  TYR  HB3', -0.497, (146.0, 91.065, 139.653)), (' A  37  MET  CE ', ' A  55  PHE  CZ ', -0.494, (153.919, 106.214, 131.385)), (' A 131  ASP  O  ', ' A 131  ASP  OD1', -0.492, (138.248, 84.379, 140.36)), (' A  32  TYR  CE2', ' A  88  PRO  HD3', -0.492, (153.688, 110.218, 144.441)), (' A  69  LEU  CD2', ' A 137  TYR  CE2', -0.489, (141.677, 93.153, 142.846)), (' A 139  ASN  O  ', ' A 143  LYS  HG3', -0.487, (145.151, 90.292, 130.605)), (' A 124  LYS  HB3', ' A 124  LYS  HE2', -0.481, (144.484, 81.544, 152.353)), (' A  56  LEU  O  ', ' A  60  HIS  CD2', -0.477, (143.429, 108.872, 133.491)), (' A  80  ILE  O  ', ' A  81  PHE  HD1', -0.467, (140.983, 100.321, 158.825)), (' A   8  VAL  O  ', ' A   8  VAL HG23', -0.465, (130.133, 89.121, 155.381)), (' A  68  LYS  HB2', ' A  68  LYS  HE2', -0.463, (136.327, 97.679, 140.417)), (' A  23  GLN  HA ', ' A  23  GLN  NE2', -0.461, (148.075, 94.55, 146.992)), (' A 117  LEU  C  ', ' A 117  LEU  CD2', -0.448, (146.258, 86.762, 147.225)), (' A  37  MET  HE2', ' A  55  PHE  CD1', -0.445, (152.806, 106.585, 132.696)), (' A  32  TYR  CD2', ' A  88  PRO  HD3', -0.442, (153.485, 109.779, 144.422)), (' A  69  LEU HD23', ' A 137  TYR  CE2', -0.441, (141.086, 93.299, 142.937)), (' A  42  ASP  O  ', ' A  42  ASP  OD1', -0.437, (151.436, 119.655, 129.531)), (' A  79  ARG  HA ', ' A  79  ARG  HD3', -0.433, (136.153, 97.027, 158.125)), (' A 155  LEU  HA ', ' A 155  LEU HD23', -0.431, (160.057, 103.644, 120.012)), (' A 118  HIS  C  ', ' A 118  HIS  ND1', -0.416, (146.788, 82.699, 144.882)), (' A  86  LYS  CA ', ' A  86  LYS  CE ', -0.411, (154.739, 106.759, 150.561)), (' A  86  LYS  H  ', ' A  86  LYS  HG2', -0.409, (153.43, 105.009, 149.638)), (' A 112  GLN  CD ', ' A 116  GLU  OE2', -0.407, (155.863, 87.105, 143.205))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
