# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', ' 106 ', 'PRO', 0.08643151006928139, (133.255, 149.89400000000003, 156.986)), ('A', ' 107 ', 'GLU', 0.023250365451837878, (135.723, 150.407, 154.096)), ('A', ' 108 ', 'GLY', 0.01372205902530184, (134.81, 152.395, 150.92)), ('A', ' 174 ', 'CYS', 0.024863073922399545, (143.829, 165.875, 146.159)), ('A', ' 286 ', 'TYR', 0.04915099869900217, (151.64199999999994, 137.758, 148.064)), ('B', '  67 ', 'HIS', 0.0019685166710218553, (146.404, 115.82000000000001, 142.049)), ('B', '  97 ', 'CYS', 0.030901113784333578, (159.125, 124.76300000000002, 151.545)), ('B', '  98 ', 'GLY', 0.047146706862214435, (160.695, 126.08600000000003, 154.752)), ('B', '  99 ', 'LYS', 0.037899896449309474, (162.785, 128.001, 153.268)), ('B', ' 123 ', 'MET', 0.04053136746726765, (160.45899999999997, 115.678, 140.74700000000004))]
data['omega'] = [('A', '  62 ', 'PRO', None, (131.488, 173.344, 127.343)), ('B', '  62 ', 'PRO', None, (154.638, 112.65999999999998, 127.342)), ('B', '  99 ', 'LYS', None, (162.09999999999994, 128.162, 154.543))]
data['rota'] = [('A', '  18 ', 'LYS', 0.026420534692495237, (143.366, 170.901, 123.549)), ('A', ' 150 ', 'THR', 0.026835309837649632, (132.506, 178.848, 143.01)), ('A', ' 274 ', 'THR', 0.12180945377178688, (152.471, 150.668, 133.075)), ('B', '  56 ', 'THR', 0.015514971995999915, (144.067, 124.55699999999997, 127.87600000000002)), ('B', ' 100 ', 'CYS', 0.07325586696117964, (161.90999999999994, 130.368, 150.402)), ('B', ' 239 ', 'GLU', 0.18375798866232787, (119.13999999999997, 131.652, 144.80700000000002)), ('B', ' 274 ', 'THR', 0.07620750907187553, (133.608, 135.44600000000003, 133.096))]
data['cbeta'] = [('A', '  18 ', 'LYS', ' ', 0.34521219805314196, (143.962, 170.155, 122.34)), ('A', ' 274 ', 'THR', ' ', 0.2835323223684811, (152.94, 152.051, 133.513)), ('B', '  18 ', 'LYS', ' ', 0.2984840964810726, (142.405, 116.162, 122.176)), ('B', '  34 ', 'HIS', ' ', 0.2615416845159762, (164.094, 114.91000000000001, 150.657)), ('B', '  99 ', 'LYS', ' ', 0.34622422334500824, (163.394, 126.61700000000002, 152.92900000000003)), ('B', ' 100 ', 'CYS', ' ', 0.30592094522052127, (161.187, 129.57400000000004, 149.248)), ('B', ' 274 ', 'THR', ' ', 0.2504223759894332, (133.129, 134.092, 133.565))]
data['probe'] = [(' B 174  CYS  SG ', ' B 401  NAD  H5N', -0.599, (141.725, 121.938, 142.316)), (' A 174  CYS  SG ', ' A 401  NAD  H5N', -0.532, (143.78, 164.418, 142.263)), (' A  46  CYS  HB3', ' A  67  HIS  HE1', -0.444, (144.286, 168.118, 139.287)), (' A 166  LEU  H  ', ' A 166  LEU HD22', -0.427, (145.987, 179.572, 154.162)), (' B  46  CYS  HB3', ' B  67  HIS  HE1', -0.417, (141.555, 117.898, 139.324)), (' A  83  VAL HG12', ' A 159  LYS  HB2', -0.411, (133.21, 173.766, 157.2))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
