# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = []
data['omega'] = [('A', '  62 ', 'PRO', None, (131.741, 173.548, 127.53199999999998)), ('B', '  62 ', 'PRO', None, (154.192, 112.4, 127.51899999999999))]
data['rota'] = []
data['cbeta'] = []
data['probe'] = [(' A  26  VAL HG12', ' A 132  CYS  HB2', -0.659, (132.442, 182.376, 131.725)), (' B 108  GLY  O  ', ' B 323  LYS  NZ ', -0.659, (152.725, 130.667, 153.002)), (' B  26  VAL HG12', ' B 132  CYS  HB2', -0.657, (153.501, 103.253, 131.658)), (' A 147  SER  OG ', ' A 149  TYR  O  ', -0.653, (134.941, 179.917, 140.589)), (' A 259  ASN  O  ', ' B 101  ARG  NH1', -0.645, (161.146, 138.259, 146.055)), (' A 108  GLY  O  ', ' A 323  LYS  NZ ', -0.643, (133.108, 155.341, 152.878)), (' B 147  SER  OG ', ' B 149  TYR  O  ', -0.639, (150.928, 106.005, 140.64)), (' A 101  ARG  NH1', ' B 259  ASN  O  ', -0.637, (124.805, 147.686, 146.035)), (' A 282  CYS  HB3', ' A 287  GLY  HA3', -0.626, (152.655, 141.712, 144.239)), (' B  97  CYS  SG ', ' B 100  CYS  N  ', -0.62, (160.983, 128.111, 150.871)), (' B 282  CYS  HB3', ' B 287  GLY  HA3', -0.618, (133.078, 144.782, 144.558)), (' A  68  GLU  OE1', ' A 369  ARG  NH1', -0.614, (147.376, 168.278, 142.336)), (' B  68  GLU  OE1', ' B 369  ARG  NH1', -0.614, (139.269, 117.895, 142.507)), (' A 360  ASP  OD1', ' A 361  LEU  N  ', -0.608, (154.913, 174.565, 131.649)), (' B 360  ASP  OD1', ' B 361  LEU  N  ', -0.606, (131.473, 110.841, 131.345)), (' B   1  SER  OG ', ' B   2  THR  N  ', -0.601, (158.057, 94.345, 149.483)), (' B 369  ARG  NH2', ' B 401  NAD  O1N', -0.594, (136.722, 120.394, 140.216)), (' B 267  GLU  HG3', ' B 275  MET  HA ', -0.592, (135.773, 135.867, 135.923)), (' A 369  ARG  NH2', ' A 401  NAD  O1N', -0.588, (149.122, 165.402, 140.29)), (' A 267  GLU  HG3', ' A 275  MET  HA ', -0.584, (150.037, 150.155, 135.836)), (' A   1  SER  OG ', ' A   2  THR  N  ', -0.583, (127.77, 191.667, 149.382)), (' A  97  CYS  SG ', ' A 100  CYS  N  ', -0.569, (125.161, 157.833, 151.795)), (' A  97  CYS  HB3', ' A 111  CYS  SG ', -0.555, (127.392, 160.489, 148.557)), (' A 223  ASP  OD1', ' A 224  ILE  N  ', -0.554, (160.257, 158.764, 134.137)), (' B  97  CYS  HB3', ' B 111  CYS  SG ', -0.554, (158.527, 125.425, 148.551)), (' B 166  LEU  HA ', ' B 169  VAL HG22', -0.549, (140.138, 110.47, 152.779)), (' A  97  CYS  SG ', ' A  99  LYS  N  ', -0.547, (125.303, 158.362, 152.432)), (' B 223  ASP  OD1', ' B 224  ILE  N  ', -0.547, (125.584, 127.176, 134.218)), (' A 101  ARG  NH2', ' B 286  TYR  OH ', -0.544, (127.452, 147.743, 149.205)), (' A  97  CYS  SG ', ' A  98  GLY  N  ', -0.54, (127.035, 159.749, 151.99)), (' A 166  LEU  HA ', ' A 169  VAL HG22', -0.539, (145.754, 175.929, 152.642)), (' B  97  CYS  SG ', ' B  98  GLY  N  ', -0.533, (159.054, 126.04, 151.916)), (' A 286  TYR  OH ', ' B 101  ARG  NH2', -0.527, (158.411, 138.841, 148.861)), (' B   9  CYS  HB2', ' B 148  GLN  HB2', -0.52, (149.209, 100.614, 140.626)), (' A 305  PRO  HG2', ' B 295  PRO  HG3', -0.519, (144.118, 133.594, 132.959)), (' A   9  CYS  HB2', ' A 148  GLN  HB2', -0.518, (136.363, 185.585, 140.438)), (' A 301  LEU HD11', ' B 303  MET  HE3', -0.517, (142.737, 144.722, 133.564)), (' A  53  VAL HG11', ' A 363  ARG HH21', -0.51, (145.983, 170.955, 128.989)), (' A 267  GLU  OE2', ' A 274  THR  OG1', -0.508, (151.387, 153.339, 134.47)), (' B 267  GLU  OE2', ' B 274  THR  OG1', -0.507, (134.79, 132.687, 134.352)), (' A 348  HIS  HB2', ' A 370  THR HG23', -0.502, (154.566, 176.3, 139.553)), (' B 348  HIS  HB2', ' B 370  THR HG23', -0.501, (131.829, 109.648, 139.465)), (' A 295  PRO  HG3', ' B 305  PRO  HG2', -0.5, (142.026, 152.263, 133.092)), (' B  53  VAL HG11', ' B 363  ARG HH21', -0.498, (139.546, 114.819, 128.902)), (' A 303  MET  HE3', ' B 301  LEU HD11', -0.497, (142.935, 140.79, 133.276)), (' B  90  ILE HG13', ' B 160  ILE HD13', -0.493, (144.848, 112.484, 153.854)), (' A  83  VAL HG12', ' A 159  LYS  HB2', -0.487, (133.082, 173.622, 157.067)), (' A  43  THR HG23', ' A  69  ALA  HB2', -0.485, (142.009, 174.484, 143.479)), (' B  43  THR HG23', ' B  69  ALA  HB2', -0.484, (143.902, 110.992, 143.472)), (' B  83  VAL HG12', ' B 159  LYS  HB2', -0.481, (152.326, 112.102, 157.178)), (' B  97  CYS  SG ', ' B  99  LYS  N  ', -0.48, (160.58, 127.581, 152.466)), (' B  56  THR  OG1', ' B 296  PRO  HA ', -0.477, (142.704, 126.999, 128.768)), (' B  50  ASP  HA ', ' B  53  VAL HG12', -0.477, (140.504, 116.795, 130.7)), (' B 117  SER  OG ', ' B 118  MET  N  ', -0.474, (156.304, 128.332, 136.995)), (' A 117  SER  OG ', ' A 118  MET  N  ', -0.474, (129.708, 157.858, 136.673)), (' A  50  ASP  HA ', ' A  53  VAL HG12', -0.472, (145.035, 169.043, 130.363)), (' A  90  ILE HG13', ' A 160  ILE HD13', -0.472, (141.243, 173.009, 153.55)), (' B 187  ALA  HB2', ' B 290  VAL HG21', -0.47, (137.601, 136.098, 147.466)), (' A 250  ILE HD12', ' A 253  VAL  HB ', -0.468, (163.64, 147.077, 135.376)), (' A 187  ALA  HB2', ' A 290  VAL HG21', -0.467, (148.435, 149.751, 147.934)), (' B 176  PHE  HA ', ' B 206  SER  OG ', -0.463, (135.498, 122.086, 147.763)), (' B  68  GLU  OE2', ' B 175  GLY  N  ', -0.458, (139.51, 119.206, 144.986)), (' B 250  ILE HD12', ' B 253  VAL  HB ', -0.458, (122.666, 138.573, 135.397)), (' A  56  THR  OG1', ' A 296  PRO  HA ', -0.457, (143.092, 158.564, 128.969)), (' B  67  HIS  NE2', ' B 174  CYS  SG ', -0.457, (143.166, 119.824, 141.861)), (' A 128  SER  O  ', ' A 129  ARG  NH1', -0.454, (123.13, 175.939, 138.864)), (' B 327  SER  O  ', ' B 330  LYS  HG2', -0.453, (144.226, 122.63, 158.181)), (' A 128  SER  OG ', ' A 129  ARG  N  ', -0.452, (126.415, 176.634, 136.859)), (' B 116  LEU HD23', ' B 318  ILE HD13', -0.45, (148.817, 127.471, 141.119)), (' B  81  THR  O  ', ' B  84  ARG  NH1', -0.45, (158.829, 110.769, 160.06)), (' A 176  PHE  HA ', ' A 206  SER  OG ', -0.449, (150.908, 163.845, 147.677)), (' B 128  SER  OG ', ' B 129  ARG  N  ', -0.449, (159.407, 109.497, 136.448)), (' B  68  GLU  CD ', ' B 174  CYS  HB3', -0.449, (140.777, 117.896, 144.057)), (' A 327  SER  O  ', ' A 330  LYS  HG2', -0.448, (141.779, 163.481, 158.277)), (' B 271  ARG  NH2', ' B 273  ASP  OD2', -0.447, (132.901, 133.615, 127.591)), (' B 128  SER  O  ', ' B 129  ARG  NH1', -0.446, (162.724, 110.016, 138.902)), (' A  48  SER  HB2', ' A  67  HIS  CE1', -0.444, (142.919, 166.41, 138.499)), (' A 116  LEU HD23', ' A 318  ILE HD13', -0.443, (136.988, 158.727, 140.752)), (' B  48  SER  HB2', ' B  67  HIS  CE1', -0.441, (143.431, 119.223, 138.667)), (' B 251  GLN  O  ', ' B 255  THR  OG1', -0.439, (125.659, 144.112, 137.898)), (' A 161  ASP  OD1', ' A 163  ALA  N  ', -0.438, (143.893, 176.981, 161.442)), (' A  68  GLU  CD ', ' A 174  CYS  HB3', -0.437, (144.816, 167.808, 143.905)), (' A  56  THR  HG1', ' A 296  PRO  HA ', -0.435, (142.793, 159.126, 129.379)), (' B 107  GLU  HG2', ' B 107  GLU  O  ', -0.432, (150.176, 136.532, 152.199)), (' A 143  THR  O  ', ' A 145  THR HG23', -0.431, (137.286, 172.833, 142.407)), (' B  33  ALA  HA ', ' B  78  GLU  H  ', -0.43, (165.626, 109.722, 150.692)), (' A 170  CYS  SG ', ' A 371  ILE HD12', -0.429, (148.355, 174.447, 146.114)), (' B 170  CYS  SG ', ' B 371  ILE HD12', -0.429, (137.569, 111.586, 146.136)), (' A 271  ARG  NH2', ' A 273  ASP  OD2', -0.425, (153.044, 152.283, 127.462)), (' B 143  THR  O  ', ' B 145  THR HG23', -0.425, (148.578, 113.186, 142.321)), (' A 107  GLU  HG2', ' A 107  GLU  O  ', -0.423, (135.91, 149.514, 152.307)), (' A  50  ASP  OD1', ' A 363  ARG  NE ', -0.423, (148.822, 169.75, 129.496)), (' A  33  ALA  HA ', ' A  78  GLU  H  ', -0.421, (120.383, 176.662, 150.869)), (' B 200  LEU HD13', ' B 232  ALA  HB2', -0.42, (124.58, 125.808, 142.734)), (' B 251  GLN  NE2', ' B 277  THR  OG1', -0.418, (130.501, 139.712, 132.526)), (' A 194  THR HG23', ' A 218  ARG  HB2', -0.417, (162.75, 147.578, 148.989)), (' B 292  VAL  O  ', ' B 401  NAD  H2N', -0.416, (140.836, 128.011, 140.16)), (' A 372  LEU  HA ', ' A 372  LEU HD23', -0.416, (149.048, 179.471, 140.414)), (' A 251  GLN HE21', ' A 277  THR  HA ', -0.415, (155.105, 145.155, 133.383)), (' A 200  LEU HD13', ' A 232  ALA  HB2', -0.414, (161.445, 160.262, 142.643)), (' A 272  LEU  HA ', ' A 272  LEU HD23', -0.414, (146.401, 151.413, 131.595)), (' A  67  HIS  NE2', ' A 174  CYS  SG ', -0.412, (142.866, 166.31, 141.952)), (' B 252  GLU  O  ', ' B 256  GLU  HG3', -0.412, (121.254, 144.688, 137.31)), (' B 194  THR HG23', ' B 218  ARG  HB2', -0.411, (123.585, 138.575, 148.888)), (' A 252  GLU  O  ', ' A 256  GLU  HG3', -0.411, (164.69, 141.297, 137.384)), (' A  94  THR  O  ', ' A  94  THR HG23', -0.411, (135.739, 162.585, 148.224)), (' B  94  THR  O  ', ' B  94  THR HG23', -0.411, (150.214, 123.382, 148.274)), (' A 185  LYS  HB3', ' A 185  LYS  HE3', -0.407, (142.369, 153.515, 153.236)), (' B 171  LEU  HA ', ' B 171  LEU HD23', -0.407, (138.455, 115.658, 145.992)), (' B 185  LYS  HB3', ' B 185  LYS  HE3', -0.407, (143.987, 132.083, 153.251)), (' A  93  PHE  HA ', ' A 143  THR HG21', -0.406, (135.92, 167.735, 143.533)), (' B  56  THR  HG1', ' B 296  PRO  HA ', -0.406, (143.162, 127.23, 129.348)), (' A  81  THR  O  ', ' A  84  ARG  NH1', -0.405, (127.386, 175.155, 160.196)), (' A 265  SER  HB3', ' A 282  CYS  SG ', -0.403, (152.82, 145.854, 142.722)), (' A 292  VAL  O  ', ' A 401  NAD  H2N', -0.401, (145.111, 158.351, 140.276)), (' B 251  GLN HE21', ' B 277  THR  HA ', -0.401, (130.835, 140.867, 133.404)), (' A  48  SER  HB2', ' A  67  HIS  HE1', -0.401, (142.982, 166.457, 138.461)), (' A 105  HIS  CG ', ' A 106  PRO  HD2', -0.401, (131.648, 148.83, 154.894)), (' B  67  HIS  CD2', ' B 174  CYS  HB2', -0.4, (143.304, 118.952, 142.803)), (' B 312  ARG  HD2', ' B 312  ARG HH11', -0.4, (135.701, 146.596, 139.204))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
