# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = []
data['omega'] = [('A', '  62 ', 'PRO', None, (131.715, 173.52800000000002, 127.575)), ('B', '  62 ', 'PRO', None, (154.236, 112.42399999999999, 127.574))]
data['rota'] = [('A', '   8 ', 'LYS', 0.21615863547985878, (131.067, 188.723, 138.631)), ('A', ' 268 ', 'VAL', 0.2760263131335405, (150.766, 156.52, 139.34400000000002)), ('A', ' 314 ', 'TRP', 0.2835028979601328, (145.18, 144.181, 142.20600000000002)), ('B', '   8 ', 'LYS', 0.21642648301048495, (154.883, 97.22800000000001, 138.62900000000002)), ('B', ' 268 ', 'VAL', 0.27588553766833535, (135.185, 129.43200000000002, 139.343)), ('B', ' 314 ', 'TRP', 0.2836367636580823, (140.772, 141.77100000000002, 142.20600000000002))]
data['cbeta'] = []
data['probe'] = [(' A 166  LEU  HA ', ' A 169  VAL HG22', -0.858, (145.552, 175.456, 152.556)), (' A  26  VAL HG12', ' A 132  CYS  HB2', -0.854, (132.765, 182.759, 131.845)), (' B 166  LEU  HA ', ' B 169  VAL HG22', -0.852, (140.014, 110.401, 152.658)), (' B  26  VAL HG12', ' B 132  CYS  HB2', -0.839, (153.627, 103.581, 131.472)), (' A 269  ILE HD12', ' A 274  THR HG21', -0.732, (153.702, 153.561, 134.653)), (' B 269  ILE HD12', ' B 274  THR HG21', -0.715, (131.883, 132.835, 134.805)), (' B 218  ARG HH12', ' B 258  SER  HA ', -0.695, (121.426, 141.552, 146.334)), (' A 218  ARG HH12', ' A 258  SER  HA ', -0.692, (164.583, 144.461, 146.199)), (' A  68  GLU  HG2', ' A 174  CYS  HB3', -0.632, (143.512, 167.895, 143.645)), (' B  68  GLU  HG2', ' B 174  CYS  HB3', -0.63, (142.308, 118.166, 143.583)), (' B 153  ASP  OD1', ' B 154  GLU  N  ', -0.613, (159.251, 115.105, 149.301)), (' A 153  ASP  OD1', ' A 154  GLU  N  ', -0.611, (126.509, 170.439, 148.932)), (' B 254  LEU HD13', ' B 281  CYS  SG ', -0.606, (127.162, 139.325, 139.693)), (' A 254  LEU HD13', ' A 281  CYS  SG ', -0.6, (158.917, 147.149, 139.565)), (' A 166  LEU  HA ', ' A 169  VAL  CG2', -0.594, (145.29, 175.47, 152.556)), (' A 269  ILE  CD1', ' A 274  THR HG21', -0.591, (154.217, 153.664, 134.658)), (' B 166  LEU  HA ', ' B 169  VAL  CG2', -0.589, (140.78, 110.456, 152.405)), (' B 269  ILE  CD1', ' B 274  THR HG21', -0.588, (131.792, 132.226, 134.794)), (' B  12  ALA  HB1', ' B  21  PHE  HB3', -0.581, (144.42, 107.358, 132.428)), (' A 335  PHE  HE1', ' A 342  LEU  H  ', -0.573, (153.42, 169.953, 154.071)), (' B  26  VAL HG12', ' B 132  CYS  CB ', -0.573, (153.451, 103.346, 131.383)), (' A  12  ALA  HB1', ' A  21  PHE  HB3', -0.565, (141.843, 178.567, 131.932)), (' B 335  PHE  HE1', ' B 342  LEU  H  ', -0.557, (132.353, 115.902, 154.097)), (' A  26  VAL HG12', ' A 132  CYS  CB ', -0.553, (132.497, 182.711, 131.384)), (' B 200  LEU  CD2', ' B 208  ILE HD11', -0.552, (127.147, 127.965, 143.45)), (' A 200  LEU  CD2', ' A 208  ILE HD11', -0.55, (158.974, 157.816, 143.934)), (' A 255  THR  HA ', ' A 261  GLY  HA2', -0.542, (160.718, 141.968, 141.712)), (' B 194  THR HG21', ' B 258  SER  HB2', -0.538, (123.858, 140.688, 146.225)), (' A 194  THR HG21', ' A 258  SER  HB2', -0.536, (162.599, 145.071, 145.972)), (' B 255  THR  HA ', ' B 261  GLY  HA2', -0.533, (125.145, 144.061, 141.867)), (' B  83  VAL HG21', ' B 157  VAL HG13', -0.531, (154.2, 112.792, 153.548)), (' A  83  VAL HG21', ' A 157  VAL HG13', -0.529, (131.367, 173.008, 153.637)), (' A 186  VAL HG21', ' A 317  ALA  HB2', -0.528, (143.414, 153.583, 146.997)), (' A 254  LEU  HA ', ' A 257  MET  HE3', -0.525, (163.923, 146.027, 139.86)), (' B 254  LEU  HA ', ' B 257  MET  HE3', -0.519, (121.662, 139.64, 139.844)), (' B 186  VAL HG21', ' B 317  ALA  HB2', -0.515, (142.296, 132.511, 147.422)), (' B  12  ALA  HB2', ' B  23  ILE HD13', -0.507, (144.046, 105.147, 133.927)), (' A 186  VAL HG21', ' A 317  ALA  CB ', -0.504, (143.534, 153.806, 147.007)), (' B 186  VAL HG21', ' B 317  ALA  CB ', -0.503, (142.261, 132.141, 147.43)), (' A  90  ILE HD12', ' A 160  ILE HG21', -0.502, (141.246, 171.289, 154.027)), (' A 268  VAL  O  ', ' A 401  NAD  H4D', -0.494, (149.871, 158.953, 137.621)), (' A  12  ALA  HB2', ' A  23  ILE HD13', -0.491, (141.594, 181.254, 134.105)), (' B 268  VAL  O  ', ' B 401  NAD  H4D', -0.49, (136.463, 126.79, 137.601)), (' B  90  ILE HD12', ' B 160  ILE HG21', -0.49, (144.706, 114.76, 154.047)), (' A 172  ILE HG13', ' A 342  LEU HD11', -0.486, (148.507, 169.655, 152.831)), (' B 172  ILE HG13', ' B 342  LEU HD11', -0.486, (137.512, 116.285, 152.999)), (' B 341  ALA  O  ', ' B 344  PRO  HD2', -0.484, (129.995, 117.87, 151.637)), (' B 254  LEU  CD1', ' B 281  CYS  SG ', -0.479, (126.87, 139.123, 139.223)), (' A 341  ALA  O  ', ' A 344  PRO  HD2', -0.478, (156.339, 168.385, 151.567)), (' A 208  ILE HG23', ' A 219  ILE HG21', -0.476, (159.515, 155.985, 148.336)), (' B 241  VAL HG21', ' B 257  MET  HE1', -0.475, (120.954, 136.945, 139.539)), (' A 301  LEU HD21', ' A 314  TRP  HH2', -0.473, (145.966, 146.153, 134.086)), (' A 254  LEU  CD1', ' A 281  CYS  SG ', -0.471, (158.975, 146.986, 139.332)), (' A  48  SER  HB2', ' A  67  HIS  CE1', -0.469, (142.901, 166.436, 138.748)), (' A 260  GLY  O  ', ' A 283  GLN  NE2', -0.468, (158.522, 137.765, 144.338)), (' B 260  GLY  O  ', ' B 283  GLN  NE2', -0.468, (127.306, 148.189, 144.45)), (' B 208  ILE HG23', ' B 219  ILE HG21', -0.467, (126.495, 129.905, 148.199)), (' A 241  VAL HG21', ' A 257  MET  HE1', -0.463, (164.526, 149.279, 139.422)), (' B 205  LEU  HB2', ' B 345  LEU HD21', -0.462, (130.396, 121.864, 146.183)), (' B 205  LEU  HB2', ' B 345  LEU  CD2', -0.462, (130.233, 121.673, 145.975)), (' B 301  LEU HD21', ' B 314  TRP  HH2', -0.46, (139.851, 140.225, 134.266)), (' A 205  LEU  HB2', ' A 345  LEU  CD2', -0.459, (155.365, 164.649, 145.92)), (' B  48  SER  HB2', ' B  67  HIS  CE1', -0.458, (143.106, 119.622, 138.896)), (' A 205  LEU  HB2', ' A 345  LEU HD21', -0.454, (155.338, 164.019, 146.116)), (' B 268  VAL HG12', ' B 401  NAD H52N', -0.451, (135.833, 125.886, 139.783)), (' B  83  VAL HG21', ' B 157  VAL  CG1', -0.449, (154.439, 113.021, 153.151)), (' A 216  ALA  HB3', ' A 219  ILE HD11', -0.449, (159.22, 152.316, 152.28)), (' A   1  SER  O  ', ' A   2  THR  OG1', -0.448, (129.47, 189.615, 149.241)), (' B 192  GLY  HA2', ' B 217  ALA  HB2', -0.445, (124.177, 138.601, 155.431)), (' A 192  GLY  HA2', ' A 217  ALA  HB2', -0.443, (161.414, 147.39, 155.697)), (' A  83  VAL HG21', ' A 157  VAL  CG1', -0.441, (131.465, 173.179, 153.525)), (' B 194  THR HG21', ' B 258  SER  CB ', -0.438, (123.684, 141.178, 146.023)), (' A 268  VAL HG12', ' A 401  NAD H52N', -0.437, (150.164, 160.016, 139.637)), (' A 275  MET  HE1', ' A 295  PRO  HB3', -0.437, (144.439, 153.472, 133.409)), (' B 216  ALA  HB3', ' B 219  ILE HD11', -0.436, (126.804, 133.638, 152.122)), (' A 194  THR HG21', ' A 258  SER  CB ', -0.436, (162.44, 144.716, 146.127)), (' A 268  VAL HG13', ' A 292  VAL HG13', -0.432, (149.446, 157.581, 141.47)), (' B 275  MET  HE1', ' B 295  PRO  HB3', -0.43, (141.21, 132.604, 133.704)), (' A  97  CYS  HA ', ' A 155  ILE  CG2', -0.426, (126.966, 164.261, 151.71)), (' B 268  VAL HG13', ' B 292  VAL HG13', -0.424, (136.728, 128.753, 141.506)), (' B 174  CYS  SG ', ' B 175  GLY  N  ', -0.42, (141.034, 121.105, 144.862)), (' B  97  CYS  HA ', ' B 155  ILE  CG2', -0.418, (158.925, 121.713, 151.606)), (' A 174  CYS  SG ', ' A 175  GLY  N  ', -0.416, (144.539, 164.931, 144.683)), (' B 343  ASP  N  ', ' B 344  PRO  CD ', -0.414, (129.589, 115.699, 151.478)), (' B 267  GLU  OE2', ' B 270  GLY  N  ', -0.414, (136.622, 130.388, 135.425)), (' B 190  THR HG22', ' B 191  GLN  N  ', -0.41, (130.715, 139.904, 157.494)), (' A 190  THR HG22', ' A 191  GLN  N  ', -0.409, (155.365, 146.008, 157.596)), (' A 267  GLU  OE2', ' A 270  GLY  N  ', -0.409, (149.33, 155.575, 135.533)), (' B 255  THR  HA ', ' B 261  GLY  CA ', -0.407, (125.285, 144.552, 141.889)), (' A  61  LEU HD23', ' A  63  VAL HG12', -0.407, (135.385, 171.283, 129.895)), (' A 343  ASP  N  ', ' A 344  PRO  CD ', -0.406, (156.68, 169.983, 151.475)), (' B  40  MET  HE1', ' B  91  PRO  CG ', -0.404, (148.9, 111.144, 147.052)), (' B 303  MET  HB2', ' B 303  MET  HE2', -0.404, (139.05, 145.132, 133.82)), (' B 171  LEU HD21', ' B 371  ILE HD11', -0.404, (135.717, 113.487, 145.404)), (' A 255  THR  HA ', ' A 261  GLY  CA ', -0.404, (160.666, 141.33, 141.89)), (' B  61  LEU HD23', ' B  63  VAL HG12', -0.403, (150.566, 114.598, 129.821)), (' A 187  ALA  HB2', ' A 290  VAL HG21', -0.402, (148.603, 150.034, 147.924)), (' B 187  ALA  HB2', ' B 290  VAL HG21', -0.402, (137.359, 135.966, 147.93)), (' A  40  MET  HE1', ' A  91  PRO  CG ', -0.402, (137.183, 174.796, 146.948)), (' B 171  LEU  HB2', ' B 342  LEU HD22', -0.4, (135.75, 116.905, 149.607)), (' A 171  LEU HD21', ' A 371  ILE HD11', -0.4, (150.35, 172.073, 144.901))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
