# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = []
data['omega'] = [('A', '  62 ', 'PRO', None, (131.76399999999995, 173.543, 127.55300000000004)), ('B', '  62 ', 'PRO', None, (154.188, 112.408, 127.55300000000004))]
data['rota'] = [('A', ' 370 ', 'THR', 0.22531432971979243, (152.552, 174.54100000000003, 140.69400000000005)), ('B', ' 370 ', 'THR', 0.22531432971968574, (133.39999999999995, 111.41, 140.69400000000005))]
data['cbeta'] = []
data['probe'] = [(' B  68  GLU  HG2', ' B 174  CYS  HB3', -0.826, (142.485, 117.967, 143.409)), (' A  68  GLU  HG2', ' A 174  CYS  HB3', -0.81, (143.93, 167.305, 143.602)), (' A  16  GLU  HG3', ' A  19  LYS  HG3', -0.658, (139.938, 174.689, 121.638)), (' B  16  GLU  HG3', ' B  19  LYS  HG3', -0.656, (146.369, 111.749, 121.453)), (' A 267  GLU  HG3', ' A 275  MET  HA ', -0.653, (149.87, 150.213, 135.68)), (' B 267  GLU  HG3', ' B 275  MET  HA ', -0.649, (135.834, 135.882, 135.756)), (' B  56  THR HG23', ' B 296  PRO  HA ', -0.648, (142.918, 127.454, 129.254)), (' A 147  SER  OG ', ' A 149  TYR  O  ', -0.633, (135.203, 180.196, 140.865)), (' A  56  THR HG23', ' A 296  PRO  HA ', -0.63, (142.902, 158.566, 129.162)), (' A  92  LEU HD13', ' A 324  SER  HB3', -0.625, (135.716, 165.222, 150.868)), (' B 190  THR  OG1', ' B 193  SER  OG ', -0.621, (131.327, 140.891, 154.199)), (' B  92  LEU HD13', ' B 324  SER  HB3', -0.617, (150.54, 120.368, 150.985)), (' B 108  GLY  O  ', ' B 323  LYS  NZ ', -0.607, (152.816, 130.724, 152.953)), (' B 343  ASP  N  ', ' B 343  ASP  OD1', -0.602, (129.345, 115.075, 152.196)), (' B  48  SER  HB2', ' B  67  HIS  CE1', -0.598, (143.559, 119.138, 138.488)), (' B 147  SER  OG ', ' B 149  TYR  O  ', -0.594, (151.169, 105.928, 140.502)), (' A  48  SER  HB2', ' A  67  HIS  CE1', -0.591, (142.174, 166.642, 138.573)), (' B  50  ASP  HA ', ' B  53  VAL HG12', -0.589, (140.807, 116.834, 130.275)), (' A 343  ASP  N  ', ' A 343  ASP  OD1', -0.587, (156.681, 170.861, 152.148)), (' A  50  ASP  HA ', ' A  53  VAL HG12', -0.586, (145.473, 169.01, 130.679)), (' A 108  GLY  O  ', ' A 323  LYS  NZ ', -0.586, (133.084, 155.035, 152.992)), (' A 105  HIS  CD2', ' A 107  GLU  H  ', -0.579, (133.993, 149.593, 153.595)), (' A  38  ILE HG22', ' A  73  VAL  HA ', -0.568, (133.606, 179.122, 150.919)), (' B 105  HIS  CD2', ' B 107  GLU  H  ', -0.565, (152.02, 136.186, 153.499)), (' A  83  VAL HG12', ' A 159  LYS  HB2', -0.563, (133.242, 173.743, 156.907)), (' B  83  VAL HG12', ' B 159  LYS  HB2', -0.562, (152.27, 112.181, 157.228)), (' A 190  THR  OG1', ' A 193  SER  OG ', -0.558, (154.997, 144.749, 154.364)), (' A 128  SER  O  ', ' A 129  ARG  NH1', -0.558, (122.952, 176.028, 138.857)), (' B 128  SER  O  ', ' B 129  ARG  NH1', -0.556, (162.734, 110.131, 138.923)), (' B  38  ILE HG22', ' B  73  VAL  HA ', -0.553, (152.519, 106.771, 150.815)), (' B 123  MET  HE2', ' B 139  HIS  CE1', -0.537, (157.928, 111.762, 141.049)), (' A 123  MET  HE2', ' A 139  HIS  CE1', -0.537, (128.024, 174.063, 141.006)), (' A 199  GLY  HA3', ' A 269  ILE HG22', -0.51, (154.35, 157.571, 136.917)), (' B 228  LYS  NZ ', ' B 401  NAD  O3B', -0.5, (128.576, 123.066, 136.131)), (' B 199  GLY  HA3', ' B 269  ILE HG22', -0.498, (131.375, 128.153, 137.304)), (' B  26  VAL HG12', ' B 132  CYS  HB2', -0.497, (153.333, 103.301, 132.031)), (' A 228  LYS  NZ ', ' A 401  NAD  O3B', -0.497, (157.449, 163.33, 136.21)), (' A  26  VAL HG12', ' A 132  CYS  HB2', -0.494, (132.354, 182.501, 131.71)), (' B 371  ILE  O  ', ' B 371  ILE HG13', -0.491, (134.929, 108.01, 143.575)), (' A  16  GLU  HA ', ' A  61  LEU HD23', -0.485, (135.988, 171.351, 124.804)), (' A 343  ASP  OD1', ' A 344  PRO  HD3', -0.485, (157.686, 170.789, 152.52)), (' B  16  GLU  HA ', ' B  61  LEU HD23', -0.48, (149.896, 114.172, 124.56)), (' A 371  ILE  O  ', ' A 371  ILE HG13', -0.478, (151.023, 177.828, 143.554)), (' A 223  ASP  OD1', ' A 224  ILE  N  ', -0.475, (160.329, 158.767, 134.353)), (' B 223  ASP  OD1', ' B 224  ILE  N  ', -0.472, (125.92, 127.303, 134.215)), (' B 343  ASP  OD1', ' B 344  PRO  HD3', -0.471, (128.211, 115.644, 152.412)), (' B  48  SER  HB2', ' B  67  HIS  HE1', -0.469, (143.056, 119.019, 138.483)), (' A 117  SER  OG ', ' A 118  MET  N  ', -0.468, (129.688, 157.974, 136.662)), (' B 267  GLU  OE2', ' B 269  ILE HG12', -0.467, (134.594, 131.402, 134.852)), (' A 267  GLU  OE2', ' A 269  ILE HG12', -0.466, (151.355, 154.487, 134.709)), (' B 117  SER  OG ', ' B 118  MET  N  ', -0.466, (156.254, 128.082, 137.14)), (' B 283  GLN  HG2', ' B 286  TYR  CZ ', -0.458, (129.651, 147.959, 148.554)), (' A 187  ALA  O  ', ' A 189  VAL  N  ', -0.457, (149.724, 149.532, 152.558)), (' A 200  LEU HD13', ' A 232  ALA  HB2', -0.457, (161.518, 160.262, 142.556)), (' A 176  PHE  HA ', ' A 206  SER  OG ', -0.456, (150.459, 163.917, 147.917)), (' B 176  PHE  HA ', ' B 206  SER  OG ', -0.456, (135.073, 122.201, 147.823)), (' B 200  LEU HD13', ' B 232  ALA  HB2', -0.456, (124.322, 125.672, 142.503)), (' B 187  ALA  O  ', ' B 189  VAL  N  ', -0.452, (135.893, 136.671, 152.775)), (' A 231  LYS  O  ', ' A 234  GLU  HB3', -0.452, (163.132, 164.577, 147.293)), (' B 231  LYS  O  ', ' B 234  GLU  HB3', -0.451, (122.866, 121.784, 147.041)), (' A 283  GLN  HG2', ' A 286  TYR  CZ ', -0.449, (156.301, 137.888, 148.573)), (' B 172  ILE HD11', ' B 342  LEU HD11', -0.444, (136.725, 117.146, 153.495)), (' A  88  LYS  HD3', ' A 166  LEU HD21', -0.441, (142.625, 178.094, 155.607)), (' B 401  NAD  H2B', ' B 401  NAD  H8A', -0.44, (130.557, 124.847, 132.839)), (' B 196  ALA  HB2', ' B 262  VAL HG11', -0.438, (126.662, 138.455, 143.659)), (' B 180  TYR  O  ', ' B 184  VAL HG22', -0.436, (137.471, 129.452, 153.463)), (' A 172  ILE HD11', ' A 342  LEU HD11', -0.435, (148.855, 168.538, 153.455)), (' A 303  MET  C  ', ' B 300  ASN HD22', -0.434, (146.859, 139.296, 130.099)), (' A 196  ALA  HB2', ' A 262  VAL HG11', -0.432, (159.29, 147.464, 143.568)), (' A 180  TYR  O  ', ' A 184  VAL HG22', -0.432, (148.336, 156.85, 153.062)), (' B 275  MET  HE1', ' B 295  PRO  HB3', -0.431, (141.493, 132.819, 134.046)), (' A 300  ASN HD22', ' B 303  MET  C  ', -0.43, (138.938, 146.94, 129.798)), (' A  56  THR  O  ', ' A 297  ASP  HB2', -0.427, (139.298, 159.484, 128.971)), (' B  90  ILE HG13', ' B 160  ILE HD13', -0.427, (144.973, 112.805, 153.586)), (' A  89  VAL HG12', ' A 159  LYS  HA ', -0.427, (135.466, 174.176, 155.703)), (' A 105  HIS  CG ', ' A 106  PRO  HD2', -0.427, (131.739, 148.842, 154.479)), (' B  56  THR  O  ', ' B 297  ASP  HB2', -0.426, (146.377, 126.255, 129.227)), (' B 336  MET  HB3', ' B 336  MET  HE2', -0.426, (137.454, 112.752, 163.102)), (' A  45  ILE HD11', ' A 372  LEU HD11', -0.426, (146.992, 176.707, 137.533)), (' B  88  LYS  HD3', ' B 166  LEU HD21', -0.424, (143.212, 107.96, 155.182)), (' A 401  NAD  H2B', ' A 401  NAD  H8A', -0.424, (155.662, 161.017, 132.687)), (' A 335  PHE  HB2', ' A 340  PHE  CE1', -0.424, (149.82, 167.356, 156.205)), (' A  92  LEU HD11', ' A 158  ALA  HB2', -0.422, (135.639, 167.94, 153.228)), (' A 275  MET  HE1', ' A 295  PRO  HB3', -0.422, (144.518, 153.164, 134.018)), (' A  48  SER  HB2', ' A  67  HIS  HE1', -0.421, (142.896, 166.9, 138.584)), (' A   9  CYS  HB2', ' A 148  GLN  HB2', -0.421, (136.258, 185.6, 140.613)), (' B 105  HIS  CG ', ' B 106  PRO  HD2', -0.42, (154.073, 137.177, 154.887)), (' B  89  VAL HG12', ' B 159  LYS  HA ', -0.42, (150.486, 111.846, 155.644)), (' B 335  PHE  HB2', ' B 340  PHE  CE1', -0.42, (136.01, 118.598, 156.29)), (' B  92  LEU HD11', ' B 158  ALA  HB2', -0.42, (150.233, 118.033, 153.192)), (' B  45  ILE HD11', ' B 372  LEU HD11', -0.418, (139.054, 108.84, 137.317)), (' A 305  PRO  HG2', ' B 295  PRO  HG3', -0.417, (144.128, 133.345, 133.63)), (' A 290  VAL  HA ', ' A 315  LYS  O  ', -0.417, (145.484, 148.936, 143.288)), (' A 124  GLN  HG2', ' A 153  ASP  OD2', -0.416, (126.071, 168.288, 144.548)), (' A  90  ILE HG13', ' A 160  ILE HD13', -0.415, (141.078, 173.144, 153.54)), (' B 290  VAL  HA ', ' B 315  LYS  O  ', -0.414, (140.467, 137.05, 143.311)), (' B  36  VAL HG12', ' B  38  ILE HG23', -0.414, (154.124, 108.464, 149.835)), (' A 252  GLU  O  ', ' A 256  GLU  HG3', -0.413, (164.98, 141.012, 137.302)), (' B 124  GLN  HG2', ' B 153  ASP  OD2', -0.412, (159.881, 117.674, 144.67)), (' B 252  GLU  O  ', ' B 256  GLU  HG3', -0.411, (121.065, 144.995, 137.387)), (' A  36  VAL HG12', ' A  38  ILE HG23', -0.411, (131.828, 177.521, 149.858)), (' A 292  VAL  O  ', ' A 401  NAD  H2N', -0.409, (144.993, 157.96, 140.09)), (' A 295  PRO  HG3', ' B 305  PRO  HG2', -0.408, (141.911, 152.277, 133.376)), (' B   9  CYS  HB2', ' B 148  GLN  HB2', -0.408, (149.334, 100.491, 140.817)), (' B 301  LEU  HA ', ' B 301  LEU HD23', -0.406, (140.858, 138.262, 129.454)), (' A  24  GLU  OE1', ' A 133  ARG  NH2', -0.403, (135.577, 184.95, 126.626)), (' A  70  ALA  HB1', ' A 166  LEU HD22', -0.403, (142.811, 176.532, 152.429))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
