# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', '   2 ', 'THR', 0.020427659055826428, (127.48900000000006, 189.82700000000006, 147.87000000000003)), ('A', '   3 ', 'ALA', 0.01568746845053922, (125.692, 187.47900000000004, 150.442)), ('A', '  78 ', 'GLU', 0.022821417954923717, (119.407, 177.98200000000006, 153.09400000000002)), ('A', '  97 ', 'CYS', 0.022794040042711367, (126.72900000000006, 161.36500000000007, 151.293)), ('A', ' 100 ', 'CYS', 0.017378848054797603, (124.513, 155.97300000000004, 151.16600000000003)), ('B', '  97 ', 'CYS', 0.011566681581728015, (159.29900000000006, 124.24600000000002, 151.406))]
data['omega'] = [('A', '  61 ', 'LEU', None, (131.704, 169.89400000000006, 127.85000000000001)), ('A', ' 100 ', 'CYS', None, (123.66400000000003, 156.45500000000007, 152.292)), ('B', '  61 ', 'LEU', None, (154.24500000000006, 116.06899999999999, 127.866))]
data['rota'] = [('A', '   2 ', 'THR', 0.015824327713205525, (127.48900000000006, 189.82700000000006, 147.87000000000003)), ('A', '  27 ', 'GLU', 0.0, (129.185, 185.23700000000002, 136.616)), ('A', '  39 ', 'LYS', 0.0, (136.43100000000007, 182.41900000000007, 147.298)), ('A', '  48 ', 'SER', 0.009085347132989946, (143.743, 165.164, 136.281)), ('A', '  58 ', 'VAL', 0.076958248400828, (135.598, 162.96000000000004, 129.214)), ('A', '  59 ', 'THR', 0.23037597482073505, (133.376, 165.78900000000002, 130.648)), ('A', '  61 ', 'LEU', 0.02969725589689814, (133.031, 170.45500000000007, 127.51)), ('A', '  74 ', 'GLU', 0.015921356238906764, (131.864, 183.61000000000007, 151.303)), ('A', '  76 ', 'ILE', 0.0, (126.20400000000002, 179.73300000000006, 152.957)), ('A', '  78 ', 'GLU', 0.19158911524665742, (119.407, 177.98200000000006, 153.09400000000002)), ('A', '  81 ', 'THR', 0.2183804035985122, (124.98100000000001, 173.419, 159.02600000000004)), ('A', '  84 ', 'ARG', 0.20647632200731675, (129.736, 179.17800000000003, 158.177)), ('A', '  92 ', 'LEU', 0.017259206073176856, (136.68000000000006, 167.389, 147.535)), ('A', '  94 ', 'THR', 0.0, (134.93500000000006, 162.56200000000007, 146.19000000000003)), ('A', '  99 ', 'LYS', 0.0, (123.111, 158.39000000000004, 153.705)), ('A', ' 109 ', 'ASN', 0.018497100788678774, (134.74300000000005, 156.246, 150.077)), ('A', ' 111 ', 'CYS', 0.24445736533417378, (130.01800000000006, 158.04400000000007, 147.26)), ('A', ' 112 ', 'LEU', 0.013408102605651307, (127.34500000000006, 157.31900000000005, 144.561)), ('A', ' 113 ', 'LYS', 0.00010916770213105805, (126.70300000000006, 161.13800000000003, 144.597)), ('A', ' 117 ', 'SER', 0.057492004781263095, (131.682, 157.54000000000005, 137.18400000000003)), ('A', ' 123 ', 'MET', 0.0, (125.64000000000003, 170.264, 140.828)), ('A', ' 127 ', 'THR', 0.003604640490683762, (121.803, 172.67500000000007, 137.082)), ('A', ' 135 ', 'LYS', 0.24533581212798755, (125.987, 180.35000000000005, 127.627)), ('A', ' 145 ', 'THR', 0.03102981335175414, (138.067, 175.335, 141.513)), ('A', ' 153 ', 'ASP', 0.039362915418970384, (127.46400000000006, 171.08900000000006, 147.937)), ('A', ' 157 ', 'VAL', 0.11509112578269917, (133.327, 170.68000000000006, 151.274)), ('A', ' 159 ', 'LYS', 0.0, (135.966, 172.50400000000005, 157.306)), ('A', ' 167 ', 'GLU', 0.1110951836115158, (148.839, 178.13700000000006, 149.94)), ('A', ' 171 ', 'LEU', 0.00883835333880677, (147.524, 169.714, 148.149)), ('A', ' 200 ', 'LEU', 0.0, (157.42, 160.437, 140.557)), ('A', ' 205 ', 'LEU', 0.12704553534836271, (156.028, 161.569, 145.742)), ('A', ' 212 ', 'LYS', 0.0, (158.17, 155.79500000000004, 154.341)), ('A', ' 250 ', 'ILE', 0.018063173271373575, (161.20400000000006, 146.77500000000003, 133.653)), ('A', ' 256 ', 'GLU', 0.015141367511175351, (166.214, 141.13900000000004, 139.956)), ('A', ' 257 ', 'MET', 0.11160323480480937, (166.56300000000005, 144.22600000000006, 142.28)), ('A', ' 258 ', 'SER', 0.17534381114906525, (164.22100000000006, 142.64000000000004, 144.931)), ('A', ' 267 ', 'GLU', 0.1968815564017627, (151.136, 152.777, 139.456)), ('A', ' 268 ', 'VAL', 0.08383856786665593, (150.758, 156.623, 139.39)), ('A', ' 272 ', 'LEU', 0.002659657995145356, (147.62, 150.79400000000004, 130.384)), ('A', ' 273 ', 'ASP', 0.0, (151.127, 149.42900000000003, 129.464)), ('A', ' 279 ', 'LEU', 0.0, (151.488, 144.16400000000004, 138.696)), ('A', ' 280 ', 'SER', 0.08985766022936062, (154.10500000000005, 141.68500000000006, 137.215)), ('A', ' 294 ', 'VAL', 0.1810762885608469, (143.31300000000005, 157.40100000000004, 135.99600000000004)), ('A', ' 300 ', 'ASN', 0.08657699924826479, (141.112, 148.49400000000006, 127.715)), ('A', ' 302 ', 'SER', 0.040888113204188295, (145.501, 143.08700000000002, 128.30200000000002)), ('A', ' 303 ', 'MET', 0.0, (146.82300000000006, 141.13500000000005, 131.355)), ('A', ' 307 ', 'LEU', 0.0, (149.679, 136.542, 137.06000000000003)), ('A', ' 309 ', 'LEU', 0.0046739165215865216, (145.914, 133.54100000000003, 140.309)), ('A', ' 310 ', 'SER', 0.2791184447212337, (149.329, 132.886, 141.997)), ('A', ' 315 ', 'LYS', 0.21807237951710529, (143.446, 147.35500000000005, 144.009)), ('A', ' 328 ', 'VAL', 0.2042118445402462, (140.759, 165.87200000000007, 155.04700000000003)), ('A', ' 330 ', 'LYS', 0.0, (142.301, 165.06000000000006, 160.20400000000004)), ('A', ' 350 ', 'LEU', 9.982509138888983e-06, (152.27600000000007, 181.50800000000007, 139.968)), ('B', '   5 ', 'LYS', 0.0, (162.335, 97.25200000000002, 145.199)), ('B', '  18 ', 'LYS', 0.04920221621393006, (142.298, 115.531, 123.28500000000001)), ('B', '  27 ', 'GLU', 0.055778287029499475, (156.79500000000004, 100.68300000000004, 136.654)), ('B', '  39 ', 'LYS', 0.0, (149.533, 103.53100000000003, 147.30200000000002)), ('B', '  48 ', 'SER', 0.009338989741545848, (142.20600000000005, 120.78000000000004, 136.284)), ('B', '  58 ', 'VAL', 0.08330612424918082, (150.35200000000006, 122.982, 129.198)), ('B', '  59 ', 'THR', 0.27962248317771765, (152.58200000000005, 120.17299999999999, 130.651)), ('B', '  74 ', 'GLU', 0.04916132601007993, (154.088, 102.34400000000002, 151.314)), ('B', '  78 ', 'GLU', 0.10263278795148753, (166.57200000000006, 108.32800000000002, 152.80700000000002)), ('B', '  81 ', 'THR', 0.1928534221019271, (160.938, 112.55000000000003, 159.051)), ('B', '  84 ', 'ARG', 0.0, (156.18900000000005, 106.76500000000003, 158.222)), ('B', '  92 ', 'LEU', 0.01768422521603576, (149.283, 118.57000000000002, 147.539)), ('B', '  94 ', 'THR', 0.0, (151.03400000000005, 123.39300000000006, 146.192)), ('B', '  96 ', 'GLN', 0.0005491404859328604, (155.46800000000002, 123.70200000000003, 151.601)), ('B', '  97 ', 'CYS', 0.02261897939337318, (159.29900000000006, 124.24600000000002, 151.406)), ('B', '  99 ', 'LYS', 0.0, (162.51000000000005, 127.91600000000004, 153.437)), ('B', ' 101 ', 'ARG', 0.034785222445776164, (160.55900000000005, 133.36700000000005, 151.12)), ('B', ' 113 ', 'LYS', 0.09811874721465293, (159.24900000000005, 124.90200000000003, 144.446)), ('B', ' 117 ', 'SER', 0.05695048861518783, (154.244, 128.412, 137.17600000000002)), ('B', ' 118 ', 'MET', 0.02783810741676357, (156.801, 126.80000000000004, 134.72800000000004)), ('B', ' 123 ', 'MET', 0.0, (160.3, 115.69000000000001, 140.833)), ('B', ' 124 ', 'GLN', 0.09078889633411023, (162.16500000000005, 118.44200000000004, 142.822)), ('B', ' 127 ', 'THR', 0.0036269783535192385, (164.135, 113.27700000000004, 137.094)), ('B', ' 135 ', 'LYS', 2.8037265397727347e-05, (160.021, 105.582, 127.651)), ('B', ' 145 ', 'THR', 0.031154278674089892, (147.885, 110.60700000000004, 141.50800000000004)), ('B', ' 153 ', 'ASP', 0.04509914641712891, (158.495, 114.87000000000005, 147.951)), ('B', ' 157 ', 'VAL', 0.11562666968538195, (152.625, 115.27300000000002, 151.284)), ('B', ' 159 ', 'LYS', 0.0, (149.946, 113.41700000000004, 157.293)), ('B', ' 166 ', 'LEU', 0.029289811561070647, (139.97800000000007, 108.30200000000002, 152.567)), ('B', ' 171 ', 'LEU', 0.008642543345679701, (138.43200000000004, 116.232, 148.14)), ('B', ' 200 ', 'LEU', 0.0, (128.541, 125.52600000000001, 140.56)), ('B', ' 205 ', 'LEU', 0.18634740655758916, (129.92400000000006, 124.381, 145.75200000000004)), ('B', ' 212 ', 'LYS', 0.0, (127.7930000000001, 130.16000000000005, 154.344)), ('B', ' 250 ', 'ILE', 0.018194977385386467, (124.74600000000002, 139.179, 133.665)), ('B', ' 258 ', 'SER', 0.17733929368567536, (121.75200000000002, 143.33700000000002, 144.94500000000002)), ('B', ' 267 ', 'GLU', 0.20211683861056187, (134.818, 133.184, 139.457)), ('B', ' 268 ', 'VAL', 0.09224448847448356, (135.194, 129.339, 139.394)), ('B', ' 271 ', 'ARG', 0.0010953842964068962, (137.111, 131.6, 131.228)), ('B', ' 273 ', 'ASP', 0.0, (134.847, 136.561, 129.466)), ('B', ' 279 ', 'LEU', 0.0, (134.482, 141.77800000000005, 138.693)), ('B', ' 280 ', 'SER', 0.0907168000011222, (131.863, 144.266, 137.22500000000002)), ('B', ' 284 ', 'GLU', 0.024880335112708648, (132.133, 149.731, 142.68800000000002)), ('B', ' 294 ', 'VAL', 0.17768165244864254, (142.632, 128.555, 135.988)), ('B', ' 300 ', 'ASN', 0.0965810214660076, (144.91800000000006, 137.41700000000003, 127.654)), ('B', ' 301 ', 'LEU', 0.05401571048476709, (141.761, 139.148, 128.944)), ('B', ' 302 ', 'SER', 0.03845963709187378, (140.506, 142.73400000000007, 128.35)), ('B', ' 303 ', 'MET', 0.0, (139.16400000000004, 144.78300000000002, 131.323)), ('B', ' 308 ', 'LEU', 0.0, (139.504, 148.69800000000006, 139.627)), ('B', ' 309 ', 'LEU', 0.003207511875945276, (140.023, 152.42700000000002, 140.30600000000004)), ('B', ' 310 ', 'SER', 0.03590206271584236, (136.627, 153.05500000000004, 142.02100000000002)), ('B', ' 328 ', 'VAL', 0.2019391712050519, (145.192, 120.08200000000004, 155.043)), ('B', ' 330 ', 'LYS', 0.0, (143.648, 120.89700000000005, 160.199)), ('B', ' 350 ', 'LEU', 3.777921403260831e-06, (133.67, 104.44600000000003, 139.964)), ('B', ' 357 ', 'GLU', 2.0399848909795258e-05, (133.686, 106.96, 131.864)), ('B', ' 374 ', 'PHE', 0.0019291178167539667, (141.706, 100.97600000000003, 143.985))]
data['cbeta'] = [('A', '   2 ', 'THR', ' ', 0.3323276591585138, (128.86300000000006, 189.13600000000005, 147.68000000000004)), ('B', ' 100 ', 'CYS', ' ', 0.2686481305296334, (160.16, 128.882, 149.28700000000003))]
data['probe'] = [(' A  27  GLU  O  ', ' A  27  GLU  OE1', -0.792, (127.788, 182.785, 135.675)), (' A  65  ALA  O  ', ' A 146  PHE  CD2', -0.747, (140.831, 174.334, 135.879)), (' B  65  ALA  O  ', ' B 146  PHE  CD2', -0.743, (145.004, 111.739, 135.789)), (' B  92  LEU HD13', ' B 324  SER  HB3', -0.694, (150.714, 120.536, 150.864)), (' A  92  LEU HD13', ' A 324  SER  HB3', -0.692, (135.91, 165.117, 150.815)), (' B  16  GLU  HA ', ' B  61  LEU HD11', -0.691, (149.635, 113.488, 123.923)), (' A  56  THR HG23', ' A 296  PRO  HA ', -0.674, (142.967, 158.446, 129.146)), (' B  56  THR HG23', ' B 296  PRO  HA ', -0.671, (143.303, 126.852, 129.484)), (' A 174  CYS  SG ', ' A 401  NAD  H5N', -0.63, (144.322, 164.412, 142.183)), (' B 186  VAL HG21', ' B 317  ALA  CB ', -0.617, (142.183, 132.456, 147.491)), (' A  40  MET  HA ', ' A  40  MET  HE3', -0.613, (139.26, 179.434, 146.72)), (' A 186  VAL HG21', ' A 317  ALA  CB ', -0.612, (143.571, 153.356, 146.997)), (' B 347  THR HG22', ' B 348  HIS  CD2', -0.602, (127.66, 112.136, 139.485)), (' B 301  LEU  C  ', ' B 301  LEU HD12', -0.599, (141.421, 141.24, 130.24)), (' B  15  TRP  O  ', ' B  61  LEU  CD1', -0.583, (150.691, 113.143, 124.499)), (' B 174  CYS  SG ', ' B 401  NAD  H5N', -0.583, (141.389, 121.493, 142.152)), (' A  69  ALA  HB2', ' A 145  THR HG21', -0.581, (141.404, 174.843, 143.906)), (' A 283  GLN  HG2', ' A 286  TYR  CE2', -0.57, (156.523, 137.185, 148.458)), (' B 187  ALA  HB2', ' B 290  VAL HG21', -0.567, (137.435, 136.123, 147.416)), (' B 269  ILE HD12', ' B 274  THR HG21', -0.567, (132.219, 131.87, 134.511)), (' B  69  ALA  HB2', ' B 145  THR HG21', -0.567, (144.371, 111.217, 143.842)), (' B  67  HIS  HE1', ' B 174  CYS  SG ', -0.565, (142.499, 120.026, 141.633)), (' A  88  LYS  HD3', ' A 166  LEU HD11', -0.563, (141.84, 180.535, 154.966)), (' A 269  ILE HD12', ' A 274  THR HG21', -0.562, (154.08, 153.797, 134.253)), (' B 170  CYS  SG ', ' B 371  ILE HD12', -0.562, (137.549, 111.317, 145.921)), (' A 170  CYS  SG ', ' A 371  ILE HD12', -0.557, (148.198, 174.166, 146.337)), (' A  67  HIS  HE1', ' A 174  CYS  SG ', -0.556, (143.913, 165.836, 141.958)), (' A  36  VAL HG22', ' A  76  ILE HD12', -0.554, (127.207, 176.681, 152.848)), (' B  70  ALA  HB1', ' B 166  LEU  HG ', -0.548, (143.235, 108.631, 152.008)), (' A 347  THR HG22', ' A 348  HIS  CE1', -0.547, (159.218, 173.905, 139.759)), (' A 139  HIS  HA ', ' A 144  SER  OG ', -0.546, (132.673, 173.041, 136.947)), (' B 139  HIS  HA ', ' B 144  SER  OG ', -0.543, (153.316, 112.88, 136.967)), (' A 187  ALA  HB2', ' A 290  VAL HG21', -0.542, (148.611, 149.624, 147.893)), (' B 186  VAL HG21', ' B 317  ALA  HB2', -0.539, (142.635, 133.13, 147.111)), (' A 128  SER  O  ', ' A 129  ARG  NH1', -0.539, (123.135, 176.646, 138.362)), (' A 186  VAL HG21', ' A 317  ALA  HB2', -0.536, (143.666, 153.136, 147.445)), (' A  88  LYS  HE3', ' A 162  ALA  O  ', -0.534, (142.209, 179.868, 158.836)), (' A  65  ALA  O  ', ' A 146  PHE  CE2', -0.534, (141.223, 173.418, 136.282)), (' A 316  GLY  HA3', ' B 308  LEU  O  ', -0.532, (140.9, 150.61, 141.808)), (' B 348  HIS  HB2', ' B 370  THR HG23', -0.531, (131.746, 109.576, 139.372)), (' B 128  SER  O  ', ' B 129  ARG  NH1', -0.531, (162.998, 109.241, 138.343)), (' B  65  ALA  O  ', ' B 146  PHE  CE2', -0.528, (144.265, 112.303, 136.274)), (' A 255  THR  O  ', ' A 258  SER  O  ', -0.526, (164.79, 140.919, 142.72)), (' B  40  MET  HE1', ' B 150  THR HG22', -0.52, (149.972, 108.082, 144.79)), (' A 301  LEU  O  ', ' B 302  SER  HA ', -0.518, (142.273, 143.876, 128.201)), (' B 255  THR  O  ', ' B 258  SER  O  ', -0.516, (121.069, 145.316, 142.71)), (' A  40  MET  HE2', ' A  69  ALA  HB1', -0.505, (140.881, 176.378, 145.788)), (' A 122  THR HG23', ' A 123  MET  O  ', -0.502, (124.419, 168.267, 138.733)), (' B  69  ALA  HB2', ' B 145  THR  CG2', -0.497, (144.718, 111.15, 143.451)), (' B  16  GLU  CA ', ' B  61  LEU HD11', -0.496, (149.477, 113.375, 124.089)), (' A  69  ALA  HB2', ' A 145  THR  CG2', -0.492, (141.0, 174.891, 143.538)), (' A 303  MET  HE1', ' B 301  LEU HD11', -0.487, (142.341, 140.829, 132.916)), (' A  36  VAL HG13', ' A  73  VAL HG13', -0.487, (130.537, 177.832, 151.65)), (' A   6  VAL HG22', ' A  30  PRO  HD3', -0.485, (123.174, 184.403, 141.739)), (' B   6  VAL HG22', ' B  30  PRO  HD3', -0.481, (162.641, 101.506, 141.854)), (' B  36  VAL HG13', ' B  73  VAL HG13', -0.48, (155.293, 108.246, 151.738)), (' A  97  CYS  N  ', ' A 111  CYS  SG ', -0.469, (128.358, 160.618, 150.688)), (' B 164  SER  HA ', ' B 336  MET  HE1', -0.467, (138.541, 109.79, 160.077)), (' A  42  ALA  CB ', ' A 167  GLU  HA ', -0.459, (147.391, 178.15, 148.319)), (' A 305  PRO  HG3', ' B 301  LEU HD23', -0.457, (141.967, 137.089, 132.489)), (' A  36  VAL HG22', ' A  76  ILE  CD1', -0.456, (127.743, 176.754, 153.058)), (' A 348  HIS  HB2', ' A 370  THR HG23', -0.455, (154.217, 176.348, 139.654)), (' B 265  SER  O  ', ' B 289  SER  HA ', -0.449, (135.193, 138.466, 143.575)), (' B  42  ALA  CB ', ' B 167  GLU  HA ', -0.446, (138.209, 107.553, 148.626)), (' A 353  GLU  HA ', ' A 353  GLU  OE1', -0.445, (144.523, 185.658, 135.473)), (' A  88  LYS  CD ', ' A 166  LEU HD11', -0.444, (142.278, 180.009, 155.321)), (' B  32  LYS  HE2', ' B 129  ARG  NH2', -0.442, (164.87, 110.416, 141.484)), (' B 353  GLU  HA ', ' B 353  GLU  OE1', -0.44, (141.319, 100.185, 135.687)), (' A 368  ILE  N  ', ' A 368  ILE HD12', -0.438, (157.536, 168.76, 139.611)), (' B 105  HIS  O  ', ' B 323  LYS  NZ ', -0.434, (153.444, 132.446, 154.538)), (' B 192  GLY  HA2', ' B 217  ALA  HB2', -0.434, (124.464, 138.637, 156.149)), (' A 265  SER  O  ', ' A 289  SER  HA ', -0.433, (150.922, 147.908, 143.455)), (' A  76  ILE  HA ', ' A  76  ILE HD12', -0.433, (127.064, 178.303, 152.371)), (' A  96  GLN HE22', ' A 323  LYS  HB3', -0.433, (134.274, 159.784, 155.099)), (' A 100  CYS  HB3', ' A 103  CYS  HB2', -0.431, (126.77, 156.93, 152.321)), (' A 192  GLY  HA2', ' A 217  ALA  HB2', -0.428, (161.468, 147.377, 156.122)), (' A 185  LYS  HD3', ' A 321  GLY  O  ', -0.428, (141.067, 155.742, 153.241)), (' B 171  LEU  HA ', ' B 171  LEU HD12', -0.427, (138.496, 116.451, 146.453)), (' A 373  THR  O  ', ' A 373  THR HG22', -0.426, (146.875, 183.997, 145.918)), (' A 308  LEU  O  ', ' B 316  GLY  HA3', -0.423, (145.556, 135.667, 141.924)), (' A 273  ASP  N  ', ' A 273  ASP  OD1', -0.423, (150.255, 150.74, 128.747)), (' A  43  THR HG21', ' A 146  PHE  HD1', -0.42, (142.464, 176.113, 140.268)), (' A  27  GLU  C  ', ' A  27  GLU  OE1', -0.42, (127.915, 183.594, 136.745)), (' A 303  MET  CE ', ' B 301  LEU HD11', -0.419, (142.854, 141.077, 132.899)), (' A 364  SER  HB2', ' A 366  GLU  OE1', -0.418, (158.913, 172.141, 131.531)), (' B 153  ASP  O  ', ' B 155  ILE  N  ', -0.418, (157.195, 116.501, 150.01)), (' B  15  TRP  O  ', ' B  61  LEU HD12', -0.417, (151.442, 113.035, 124.494)), (' A 171  LEU HD11', ' A 369  ARG  HD2', -0.417, (149.736, 170.158, 143.744)), (' B  10  LYS  HB3', ' B  23  ILE HG23', -0.416, (146.195, 100.071, 134.791)), (' B 171  LEU HD11', ' B 369  ARG  HD2', -0.415, (136.354, 115.681, 143.717)), (' B  43  THR HG21', ' B 146  PHE  HD1', -0.415, (143.493, 109.74, 140.265)), (' B 186  VAL HG21', ' B 317  ALA  HB1', -0.413, (142.981, 132.003, 147.361)), (' A 251  GLN  HG2', ' A 280  SER  HB2', -0.413, (155.689, 142.381, 134.948)), (' A 254  LEU  HA ', ' A 254  LEU HD23', -0.412, (163.266, 146.471, 140.211)), (' A 153  ASP  O  ', ' A 155  ILE  N  ', -0.411, (128.554, 169.253, 150.302)), (' B 125  ASP  OD1', ' B 127  THR  OG1', -0.411, (165.83, 113.689, 138.991)), (' B 284  GLU  O  ', ' B 310  SER  HB2', -0.41, (134.824, 151.186, 142.508)), (' A 328  VAL  N  ', ' A 329  PRO  CD ', -0.41, (139.228, 165.634, 156.361)), (' A 122  THR  OG1', ' A 127  THR  O  ', -0.409, (123.975, 171.13, 137.235)), (' A  67  HIS  CE1', ' A 174  CYS  SG ', -0.408, (143.141, 166.272, 142.045)), (' A 171  LEU  HA ', ' A 171  LEU HD12', -0.408, (147.35, 169.661, 146.428)), (' B 328  VAL  N  ', ' B 329  PRO  CD ', -0.407, (146.541, 120.543, 156.055)), (' B 251  GLN  HG2', ' B 280  SER  HB2', -0.406, (130.265, 143.507, 134.992)), (' B  88  LYS  HD3', ' B 166  LEU  CD1', -0.405, (143.147, 107.374, 155.498)), (' A 368  ILE  CD1', ' A 368  ILE  N  ', -0.404, (157.533, 168.798, 140.215)), (' B 273  ASP  N  ', ' B 273  ASP  OD1', -0.404, (135.718, 135.187, 128.772)), (' A 186  VAL HG21', ' A 317  ALA  HB1', -0.404, (142.977, 154.023, 147.43)), (' A  88  LYS  HB3', ' A 166  LEU HD21', -0.402, (141.213, 177.85, 154.95)), (' A  77  GLY  O  ', ' A  80  VAL HG23', -0.4, (122.883, 176.546, 153.292))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
