# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', '  56 ', 'THR', 0.021919492186358757, (141.881, 161.202, 128.693)), ('A', '  61 ', 'LEU', 0.014399066293867458, (132.278, 170.81600000000003, 127.319)), ('A', '  62 ', 'PRO', 0.0, (132.639, 174.5, 128.156)), ('A', '  75 ', 'SER', 0.016617876526258773, (127.97500000000007, 182.634, 152.016)), ('A', '  78 ', 'GLU', 0.01715613489377182, (119.146, 177.41600000000003, 153.165)), ('A', '  85 ', 'PRO', 0.0, (130.996, 182.074, 156.35100000000003)), ('A', ' 106 ', 'PRO', 0.0, (133.684, 151.015, 156.82300000000004)), ('A', ' 136 ', 'PRO', 0.0, (126.044, 178.104, 130.794)), ('A', ' 146 ', 'PHE', 0.04109447143465212, (139.833, 177.547, 138.403)), ('A', ' 154 ', 'GLU', 0.00038889843980347645, (127.64200000000004, 170.79900000000004, 151.406)), ('A', ' 162 ', 'ALA', 0.007064342507857198, (141.475, 178.41100000000003, 161.214)), ('A', ' 167 ', 'GLU', 0.00039159508323870863, (148.956, 178.142, 149.823)), ('A', ' 193 ', 'SER', 0.0, (158.403, 145.748, 153.244)), ('A', ' 250 ', 'ILE', 0.07190217100619592, (161.439, 146.848, 133.85600000000002)), ('A', ' 297 ', 'ASP', 0.00028258199999999997, (138.757, 157.23600000000002, 128.483)), ('A', ' 323 ', 'LYS', 0.023964533853609474, (136.137, 159.262, 153.562)), ('A', ' 324 ', 'SER', 0.0011318833875495894, (136.291, 162.93, 152.276)), ('A', ' 348 ', 'HIS', 0.0028520200122573677, (156.357, 176.92000000000004, 141.535)), ('B', '  18 ', 'LYS', 0.04688998657546132, (142.433, 115.386, 123.179)), ('B', '  56 ', 'THR', 0.019568269420362452, (144.062, 124.716, 128.667)), ('B', '  61 ', 'LEU', 0.0032484399999999996, (153.237, 115.19699999999999, 127.77900000000001)), ('B', '  62 ', 'PRO', 0.0, (153.325, 111.45899999999999, 128.165)), ('B', '  75 ', 'SER', 0.018147665351499767, (157.93800000000005, 103.30500000000002, 152.078)), ('B', '  78 ', 'GLU', 0.016904246118657, (166.76, 108.51500000000001, 153.217)), ('B', ' 106 ', 'PRO', 0.0, (152.348, 134.96600000000007, 156.89400000000003)), ('B', ' 126 ', 'GLY', 0.099526864181123, (164.433, 117.19000000000001, 137.47700000000003)), ('B', ' 136 ', 'PRO', 0.0, (159.882, 107.815, 130.779)), ('B', ' 146 ', 'PHE', 0.033110473740053326, (146.108, 108.409, 138.39)), ('B', ' 154 ', 'GLU', 0.00039117290243691883, (158.309, 115.18500000000002, 151.417)), ('B', ' 162 ', 'ALA', 0.006561875501023332, (144.514, 107.54700000000003, 161.217)), ('B', ' 167 ', 'GLU', 0.008170372089063436, (137.01, 107.80200000000002, 149.84700000000004)), ('B', ' 193 ', 'SER', 0.0, (127.57900000000004, 140.20100000000002, 153.238)), ('B', ' 249 ', 'PRO', 0.0, (124.376, 140.98000000000005, 130.561)), ('B', ' 297 ', 'ASP', 0.0002931261161852527, (147.172, 128.702, 128.508)), ('B', ' 323 ', 'LYS', 0.04048807245413361, (149.777, 126.689, 153.497)), ('B', ' 324 ', 'SER', 0.001184444627230721, (149.62600000000006, 123.02300000000004, 152.243)), ('B', ' 348 ', 'HIS', 0.0033083158476754967, (129.589, 109.009, 141.552))]
data['omega'] = [('A', ' 315 ', 'LYS', None, (145.023, 146.25600000000003, 143.62500000000003)), ('B', '  62 ', 'PRO', None, (153.53700000000006, 112.714, 127.44300000000003))]
data['rota'] = [('A', '  18 ', 'LYS', 0.0, (143.452, 170.481, 123.051)), ('A', '  61 ', 'LEU', 0.07919481421173144, (132.278, 170.81600000000003, 127.319)), ('A', '  92 ', 'LEU', 0.05248329802765804, (136.66100000000006, 167.435, 147.637)), ('A', '  97 ', 'CYS', 0.012204796803416684, (126.92600000000006, 161.46400000000003, 151.344)), ('A', ' 112 ', 'LEU', 0.0, (127.35700000000006, 157.304, 144.729)), ('A', ' 122 ', 'THR', 0.08175017554310673, (126.448, 169.91700000000003, 137.175)), ('A', ' 127 ', 'THR', 0.0027198671887163073, (121.914, 172.627, 137.067)), ('A', ' 164 ', 'SER', 0.0955682919650679, (146.021, 176.56000000000006, 158.186)), ('A', ' 167 ', 'GLU', 0.0, (148.956, 178.142, 149.823)), ('A', ' 171 ', 'LEU', 0.0015214512105755868, (147.592, 169.61, 148.162)), ('A', ' 239 ', 'GLU', 0.0, (166.848, 153.866, 144.77100000000002)), ('A', ' 251 ', 'GLN', 5.477532990033579e-05, (159.31400000000005, 144.19700000000006, 135.644)), ('A', ' 256 ', 'GLU', 0.0, (165.94, 140.922, 140.053)), ('A', ' 263 ', 'ASP', 0.07619620700410559, (155.674, 143.631, 148.533)), ('A', ' 272 ', 'LEU', 0.04136818449012765, (147.695, 150.66200000000006, 130.476)), ('A', ' 273 ', 'ASP', 0.003444359464695701, (151.24, 149.286, 129.715)), ('A', ' 303 ', 'MET', 4.697474662482132e-05, (146.769, 140.88400000000004, 131.111)), ('A', ' 309 ', 'LEU', 0.09167043521235982, (145.936, 133.27200000000005, 140.36300000000003)), ('A', ' 318 ', 'ILE', 0.08419886197318903, (140.379, 156.945, 144.624)), ('A', ' 330 ', 'LYS', 0.0012840559238944324, (142.319, 165.15400000000005, 160.22)), ('A', ' 350 ', 'LEU', 0.011603161641138735, (152.592, 182.007, 140.193)), ('A', ' 357 ', 'GLU', 0.0, (152.346, 178.859, 131.88100000000003)), ('A', ' 366 ', 'GLU', 0.0, (159.80000000000007, 170.983, 135.132)), ('A', ' 370 ', 'THR', 0.18411955473306346, (152.329, 174.73000000000005, 140.64900000000003)), ('B', '  24 ', 'GLU', 0.0, (148.793, 100.375, 131.063)), ('B', '  74 ', 'GLU', 0.0, (154.244, 102.30600000000001, 151.13400000000001)), ('B', '  97 ', 'CYS', 0.012204796803416684, (158.985, 124.48600000000002, 151.348)), ('B', '  99 ', 'LYS', 0.0, (162.437, 127.517, 153.809)), ('B', ' 112 ', 'LEU', 0.0, (158.58, 128.65900000000002, 144.74)), ('B', ' 122 ', 'THR', 0.02713393152629452, (159.452, 116.04200000000003, 137.17000000000002)), ('B', ' 164 ', 'SER', 0.09749152292276578, (139.962, 109.37000000000002, 158.194)), ('B', ' 171 ', 'LEU', 0.0028798821106289585, (138.331, 116.31300000000002, 148.18)), ('B', ' 174 ', 'CYS', 0.15654010980423327, (142.035, 120.206, 145.84500000000003)), ('B', ' 231 ', 'LYS', 0.19195923161156636, (122.817, 121.01000000000003, 144.595)), ('B', ' 239 ', 'GLU', 0.0, (119.108, 132.10200000000006, 144.779)), ('B', ' 251 ', 'GLN', 0.1360925537485367, (126.633, 141.672, 135.615)), ('B', ' 256 ', 'GLU', 0.0, (120.05, 145.037, 140.053)), ('B', ' 263 ', 'ASP', 0.07593880859044354, (130.312, 142.31200000000004, 148.525)), ('B', ' 272 ', 'LEU', 0.03980134580594415, (138.31900000000002, 135.297, 130.471)), ('B', ' 280 ', 'SER', 0.1568825489251819, (131.721, 144.057, 137.10900000000004)), ('B', ' 303 ', 'MET', 0.00021950377431953003, (139.223, 145.044, 131.145)), ('B', ' 312 ', 'ARG', 0.0493567337494724, (137.206, 147.38800000000003, 143.661)), ('B', ' 314 ', 'TRP', 0.0, (140.201, 141.521, 142.11200000000002)), ('B', ' 350 ', 'LEU', 0.006973745429494149, (133.341, 103.90400000000002, 140.271)), ('B', ' 357 ', 'GLU', 0.0, (133.583, 107.11199999999998, 131.793)), ('B', ' 366 ', 'GLU', 0.0, (126.13900000000002, 114.96600000000001, 135.12400000000002)), ('B', ' 369 ', 'ARG', 0.11777341666394735, (132.981, 114.83200000000001, 141.834)), ('B', ' 370 ', 'THR', 0.1712904041287828, (133.599, 111.20900000000002, 140.628))]
data['cbeta'] = [('A', '  61 ', 'LEU', ' ', 1.90218513483466, (133.594, 170.665, 126.55700000000002)), ('A', ' 100 ', 'CYS', ' ', 0.32473457089380453, (125.502, 156.961, 149.822)), ('A', ' 238 ', 'THR', ' ', 0.27507643731429576, (166.01, 153.297, 149.515)), ('A', ' 313 ', 'THR', ' ', 0.3459710523942159, (146.305, 142.033, 146.128)), ('B', ' 100 ', 'CYS', ' ', 0.31668708739201784, (160.439, 128.972, 149.823)), ('B', ' 133 ', 'ARG', ' ', 0.28733989893805095, (155.957, 100.507, 127.074)), ('B', ' 238 ', 'THR', ' ', 0.2751700738939614, (119.951, 132.668, 149.522)), ('B', ' 314 ', 'TRP', ' ', 0.320287834521102, (140.727, 142.09400000000002, 140.778)), ('B', ' 315 ', 'LYS', ' ', 0.3627770842405335, (142.376, 138.672, 145.51800000000003))]
data['probe'] = [(' A  33  ALA  HA ', ' A  78  GLU  CD ', -1.365, (120.428, 175.337, 150.537)), (' B  24  GLU  CD ', ' B  25  GLU  N  ', -1.363, (150.814, 99.616, 130.834)), (' A 357  GLU  C  ', ' A 357  GLU  OE1', -1.321, (153.422, 177.903, 132.65)), (' B  24  GLU  OE1', ' B  25  GLU  C  ', -1.292, (151.811, 100.395, 132.295)), (' B  33  ALA  CA ', ' B  78  GLU  OE1', -1.292, (165.283, 111.018, 149.146)), (' B  24  GLU  OE2', ' B  25  GLU  N  ', -1.284, (150.268, 98.92, 131.375)), (' B  33  ALA  HA ', ' B  78  GLU  CD ', -1.273, (165.443, 110.661, 150.545)), (' A  33  ALA  CA ', ' A  78  GLU  OE1', -1.26, (119.552, 175.003, 149.033)), (' B  74  GLU  OE2', ' B  75  SER  OG ', -1.216, (158.775, 102.553, 150.077)), (' B  33  ALA  HA ', ' B  78  GLU  OE1', -1.207, (165.752, 110.236, 150.527)), (' A  33  ALA  HA ', ' A  78  GLU  OE1', -1.205, (119.568, 175.882, 150.56)), (' B 347  THR  O  ', ' B 348  HIS  CD2', -1.169, (127.086, 110.499, 140.486)), (' B  24  GLU  OE1', ' B  25  GLU  CA ', -1.1, (151.343, 99.088, 132.827)), (' A  33  ALA  CA ', ' A  78  GLU  CD ', -1.095, (119.598, 174.39, 149.701)), (' B  24  GLU  HG2', ' B 132  CYS  SG ', -1.085, (152.615, 101.688, 129.091)), (' A 347  THR  O  ', ' A 348  HIS  ND1', -1.07, (157.827, 174.422, 139.873)), (' B  33  ALA  CA ', ' B  78  GLU  CD ', -1.049, (166.401, 111.552, 149.793)), (' A 308  LEU HD22', ' A 314  TRP  HE3', -1.008, (144.438, 140.959, 140.783)), (' B  24  GLU  OE1', ' B  25  GLU  N  ', -0.984, (151.028, 100.34, 132.358)), (' A 255  THR  O  ', ' A 258  SER  O  ', -0.957, (163.892, 141.336, 142.79)), (' B  24  GLU  CD ', ' B  25  GLU  C  ', -0.956, (152.006, 99.506, 131.769)), (' B 357  GLU  OE2', ' B 361  LEU  HG ', -0.951, (131.29, 108.868, 133.594)), (' A  38  ILE  CA ', ' A  74  GLU  OE1', -0.946, (132.86, 181.29, 148.171)), (' B 255  THR  O  ', ' B 258  SER  O  ', -0.946, (122.017, 145.325, 142.104)), (' A 357  GLU  OE1', ' A 358  GLY  N  ', -0.939, (152.513, 177.137, 133.865)), (' B  24  GLU  CD ', ' B  25  GLU  CA ', -0.93, (151.985, 98.986, 132.418)), (' A 316  GLY  HA3', ' B 308  LEU  O  ', -0.925, (141.531, 150.03, 142.026)), (' B 133  ARG  O  ', ' B 135  LYS  NZ ', -0.921, (158.42, 102.472, 126.235)), (' B  24  GLU  C  ', ' B  24  GLU  CD ', -0.919, (150.042, 99.697, 132.002)), (' B  74  GLU  OE2', ' B  75  SER  CB ', -0.915, (158.394, 102.141, 150.3)), (' A 336  MET  HA ', ' A 336  MET  HE2', -0.91, (149.939, 172.65, 160.075)), (' B  24  GLU  CD ', ' B  25  GLU  O  ', -0.892, (152.477, 99.807, 131.115)), (' A  69  ALA  HB2', ' A 145  THR HG21', -0.886, (141.673, 174.961, 143.281)), (' B  69  ALA  HB2', ' B 145  THR HG21', -0.88, (144.164, 110.864, 143.281)), (' A 357  GLU  O  ', ' A 357  GLU  OE1', -0.864, (153.978, 176.923, 133.36)), (' A  69  ALA  O  ', ' A  91  PRO  HD2', -0.847, (139.943, 173.604, 147.464)), (' B  69  ALA  O  ', ' B  91  PRO  HD2', -0.839, (145.916, 112.554, 147.405)), (' B  24  GLU  CG ', ' B 132  CYS  SG ', -0.838, (151.5, 102.079, 129.806)), (' B  24  GLU  OE2', ' B  25  GLU  CA ', -0.835, (151.552, 98.079, 131.991)), (' B  32  LYS  O  ', ' B  78  GLU  OE1', -0.823, (165.229, 110.309, 149.609)), (' A  32  LYS  O  ', ' A  78  GLU  OE1', -0.819, (120.807, 175.51, 149.469)), (' B  92  LEU HD13', ' B 324  SER  HB3', -0.802, (150.956, 120.435, 150.978)), (' B 364  SER  C  ', ' B 366  GLU  OE1', -0.801, (127.171, 115.915, 131.096)), (' B 205  LEU HD21', ' B 231  LYS  HG2', -0.8, (126.22, 120.269, 143.907)), (' B 366  GLU  N  ', ' B 366  GLU  OE1', -0.799, (127.523, 115.59, 132.829)), (' A 357  GLU  C  ', ' A 357  GLU  CD ', -0.799, (153.911, 178.38, 132.832)), (' A 364  SER  C  ', ' A 366  GLU  OE1', -0.793, (158.767, 170.158, 131.037)), (' A 308  LEU HD22', ' A 314  TRP  CE3', -0.792, (144.164, 140.083, 140.511)), (' B  24  GLU  C  ', ' B  24  GLU  OE1', -0.786, (150.123, 100.362, 132.37)), (' A 366  GLU  N  ', ' A 366  GLU  OE1', -0.786, (158.347, 170.244, 132.842)), (' A  66  GLY  O  ', ' A 143  THR  O  ', -0.785, (137.418, 172.185, 140.181)), (' B  66  GLY  O  ', ' B 143  THR  O  ', -0.782, (148.492, 113.981, 140.153)), (' B 255  THR HG23', ' B 260  GLY  O  ', -0.767, (125.432, 147.108, 140.47)), (' A 255  THR HG23', ' A 260  GLY  O  ', -0.76, (160.3, 138.684, 140.98)), (' B 105  HIS  CG ', ' B 105  HIS  O  ', -0.755, (153.935, 136.073, 153.294)), (' B 347  THR  O  ', ' B 348  HIS  CG ', -0.747, (128.4, 110.382, 140.25)), (' B  69  ALA  CB ', ' B 145  THR HG21', -0.747, (144.779, 111.423, 144.305)), (' A  37  ARG  HD2', ' A  74  GLU  HG3', -0.745, (130.311, 182.937, 147.353)), (' A  69  ALA  CB ', ' A 145  THR HG21', -0.745, (141.327, 174.451, 144.2)), (' A 347  THR  O  ', ' A 348  HIS  CG ', -0.743, (157.816, 175.369, 139.914)), (' A 105  HIS  CG ', ' A 105  HIS  O  ', -0.741, (132.15, 149.507, 153.577)), (' A 152  VAL HG21', ' A 157  VAL  CG1', -0.74, (132.783, 172.77, 148.703)), (' A 166  LEU  N  ', ' A 167  GLU  OE2', -0.738, (147.131, 178.62, 152.923)), (' B 357  GLU  OE2', ' B 361  LEU  CG ', -0.733, (130.194, 109.022, 134.538)), (' A 249  PRO  HD2', ' A 252  GLU  HG3', -0.727, (162.969, 141.277, 131.076)), (' A  92  LEU HD22', ' A 324  SER  HB3', -0.723, (136.188, 165.076, 150.845)), (' B  33  ALA  N  ', ' B  78  GLU  OE1', -0.709, (165.574, 110.698, 148.861)), (' A  33  ALA  N  ', ' A  78  GLU  OE1', -0.708, (120.096, 175.28, 148.774)), (' A 186  VAL HG21', ' A 317  ALA  CB ', -0.705, (143.426, 153.174, 146.934)), (' B 269  ILE HD12', ' B 274  THR HG21', -0.699, (131.69, 132.268, 134.238)), (' A 186  VAL HG21', ' A 317  ALA  HB2', -0.699, (143.086, 152.774, 147.559)), (' A 269  ILE HD12', ' A 274  THR HG21', -0.698, (154.011, 154.159, 133.982)), (' B  37  ARG  HD2', ' B  74  GLU  HG3', -0.696, (155.909, 102.385, 146.961)), (' B  32  LYS  C  ', ' B  78  GLU  OE1', -0.695, (165.706, 110.036, 148.761)), (' B  61  LEU  O  ', ' B 138  HIS  HD2', -0.695, (155.762, 113.252, 129.737)), (' A 125  ASP  OD1', ' A 127  THR  OG1', -0.695, (120.866, 172.842, 139.202)), (' A  32  LYS  C  ', ' A  78  GLU  OE1', -0.689, (119.929, 175.976, 149.341)), (' A  61  LEU  O  ', ' A 138  HIS  HD2', -0.685, (130.294, 172.267, 128.867)), (' B 105  HIS  CD2', ' B 105  HIS  O  ', -0.682, (153.316, 135.619, 153.343)), (' A 166  LEU  N  ', ' A 167  GLU  OE1', -0.675, (147.945, 177.69, 152.539)), (' A 105  HIS  CD2', ' A 105  HIS  O  ', -0.672, (132.582, 149.929, 153.029)), (' B  24  GLU  OE1', ' B  26  VAL  N  ', -0.67, (152.55, 100.702, 133.613)), (' B 186  VAL HG21', ' B 317  ALA  CB ', -0.668, (142.845, 132.448, 147.049)), (' A  27  GLU  OE1', ' A 131  THR  O  ', -0.668, (127.755, 185.139, 132.704)), (' A  38  ILE  HA ', ' A  74  GLU  OE1', -0.666, (133.532, 180.814, 148.998)), (' B  27  GLU  OE1', ' B 131  THR  O  ', -0.666, (157.574, 101.128, 132.603)), (' B  74  GLU  OE2', ' B  75  SER  CA ', -0.653, (157.893, 103.656, 150.933)), (' A 314  TRP  CD2', ' B 314  TRP  HB3', -0.649, (142.498, 142.097, 140.89)), (' A 314  TRP  NE1', ' B 314  TRP  N  ', -0.646, (141.602, 143.016, 143.331)), (' A 283  GLN  HG2', ' A 286  TYR  CZ ', -0.645, (156.75, 138.127, 148.542)), (' B  96  GLN  HG2', ' B 325  LYS  HB2', -0.645, (153.477, 121.92, 154.558)), (' A 243  PRO  HA ', ' A 250  ILE HD11', -0.645, (163.068, 150.913, 132.626)), (' A 185  LYS  HD3', ' A 321  GLY  O  ', -0.644, (140.325, 154.882, 152.621)), (' A 153  ASP  O  ', ' A 156  SER  N  ', -0.642, (129.435, 168.578, 149.561)), (' B 283  GLN  HG2', ' B 286  TYR  CZ ', -0.641, (129.331, 147.915, 148.633)), (' B 153  ASP  O  ', ' B 156  SER  N  ', -0.64, (156.535, 117.455, 149.43)), (' B  24  GLU  OE1', ' B  26  VAL HG13', -0.637, (152.244, 101.56, 133.19)), (' B  24  GLU  HG2', ' B 132  CYS  HG ', -0.631, (152.932, 101.15, 129.757)), (' B 133  ARG  HG2', ' B 135  LYS  HZ1', -0.63, (156.66, 100.972, 125.255)), (' B  74  GLU  CD ', ' B  75  SER  CB ', -0.629, (157.449, 102.031, 150.252)), (' A 166  LEU  N  ', ' A 167  GLU  CD ', -0.626, (147.507, 178.864, 152.59)), (' B 357  GLU  OE2', ' B 361  LEU  CD1', -0.621, (130.663, 108.585, 134.735)), (' B 192  GLY  O  ', ' B 193  SER  O  ', -0.621, (124.941, 139.194, 153.416)), (' A 192  GLY  O  ', ' A 193  SER  O  ', -0.62, (160.512, 146.665, 153.078)), (' A  61  LEU  O  ', ' A 138  HIS  CD2', -0.618, (130.333, 171.787, 129.022)), (' B 120  ARG  HB3', ' B 122  THR HG23', -0.617, (160.503, 118.706, 135.126)), (' B  61  LEU  O  ', ' B 138  HIS  CD2', -0.616, (156.014, 114.273, 129.321)), (' B 365  GLY  N  ', ' B 366  GLU  OE1', -0.604, (127.77, 115.621, 132.286)), (' B 250  ILE  O  ', ' B 253  VAL  N  ', -0.603, (122.759, 141.416, 135.664)), (' B 288  VAL HG22', ' B 313  THR  CG2', -0.602, (138.173, 143.306, 147.299)), (' A 250  ILE  O  ', ' A 253  VAL  N  ', -0.599, (163.019, 144.274, 135.58)), (' A 365  GLY  N  ', ' A 366  GLU  OE1', -0.598, (158.266, 169.592, 132.075)), (' A 250  ILE HG23', ' A 254  LEU HD13', -0.598, (161.3, 147.915, 136.477)), (' A  16  GLU  OE1', ' A  19  LYS  NZ ', -0.596, (139.026, 173.832, 119.054)), (' A 359  PHE  HB3', ' A 363  ARG  NH1', -0.595, (148.794, 173.33, 130.299)), (' A 166  LEU  HA ', ' A 169  VAL HG22', -0.593, (146.079, 175.717, 152.589)), (' A  58  VAL  O  ', ' A  58  VAL HG23', -0.592, (133.691, 162.007, 129.17)), (' B 166  LEU  HA ', ' B 169  VAL HG22', -0.592, (139.971, 110.258, 152.719)), (' A 357  GLU  OE2', ' A 361  LEU  HG ', -0.588, (155.674, 177.318, 133.249)), (' B 359  PHE  HB3', ' B 363  ARG  NH1', -0.587, (136.881, 112.825, 129.79)), (' B  58  VAL  O  ', ' B  58  VAL HG23', -0.586, (152.843, 123.644, 129.555)), (' A  93  PHE  HB2', ' A 141  LEU HD13', -0.582, (136.968, 165.017, 141.268)), (' A 357  GLU  CD ', ' A 357  GLU  O  ', -0.581, (154.239, 177.955, 132.723)), (' A 314  TRP  CE2', ' B 314  TRP  N  ', -0.58, (141.583, 142.263, 142.789)), (' A  56  THR HG23', ' A 296  PRO  HA ', -0.58, (143.208, 158.38, 129.062)), (' B  24  GLU  OE2', ' B  25  GLU  O  ', -0.58, (152.218, 99.027, 131.733)), (' A  41  VAL HG11', ' A 166  LEU HD12', -0.58, (143.453, 180.897, 151.636)), (' B  93  PHE  HB2', ' B 141  LEU HD13', -0.58, (149.418, 120.88, 141.71)), (' A  96  GLN  HG2', ' A 325  LYS  HB2', -0.58, (132.162, 163.422, 154.748)), (' B  21  PHE  H  ', ' B 356  ASN HD21', -0.579, (140.907, 107.798, 128.654)), (' B 304  ASN  ND2', ' B 306  MET  HB2', -0.577, (136.797, 151.759, 133.115)), (' B  56  THR HG23', ' B 296  PRO  HA ', -0.574, (142.838, 127.525, 129.097)), (' A 366  GLU  CD ', ' A 366  GLU  N  ', -0.573, (159.41, 170.719, 132.966)), (' A  96  GLN HE22', ' A 323  LYS  HB3', -0.573, (133.603, 159.849, 155.128)), (' B 283  GLN  HG2', ' B 286  TYR  CE2', -0.572, (129.794, 148.853, 148.055)), (' A 268  VAL  O  ', ' A 268  VAL HG12', -0.572, (151.682, 159.277, 138.732)), (' B 268  VAL  O  ', ' B 268  VAL HG12', -0.572, (134.662, 126.556, 139.184)), (' B 174  CYS  O  ', ' B 178  THR  OG1', -0.571, (140.808, 123.505, 145.842)), (' B 366  GLU  CD ', ' B 366  GLU  N  ', -0.569, (126.397, 115.577, 132.932)), (' B  41  VAL HG11', ' B 166  LEU HD12', -0.568, (142.411, 105.108, 151.71)), (' A 186  VAL HG23', ' A 320  GLY  O  ', -0.566, (143.138, 154.484, 149.632)), (' A 152  VAL HG21', ' A 157  VAL HG11', -0.566, (131.963, 173.636, 149.324)), (' B 192  GLY  O  ', ' B 217  ALA  HB3', -0.562, (123.595, 139.097, 154.243)), (' A 185  LYS  CD ', ' A 321  GLY  O  ', -0.562, (141.16, 155.14, 152.762)), (' B 161  ASP  O  ', ' B 164  SER  OG ', -0.561, (142.406, 110.345, 159.008)), (' B 254  LEU HD23', ' B 257  MET  CE ', -0.561, (122.319, 137.751, 140.153)), (' A 229  PHE  CD1', ' A 240  CYS  HB3', -0.56, (165.287, 157.523, 139.913)), (' A 161  ASP  O  ', ' A 164  SER  OG ', -0.559, (143.324, 175.627, 158.925)), (' A 192  GLY  O  ', ' A 217  ALA  HB3', -0.558, (161.886, 146.699, 153.926)), (' B 288  VAL HG22', ' B 313  THR HG22', -0.557, (137.819, 143.684, 147.315)), (' A 283  GLN  HG2', ' A 286  TYR  CE2', -0.556, (156.496, 136.773, 148.483)), (' B  40  MET  HE3', ' B 150  THR HG22', -0.556, (150.299, 107.788, 144.784)), (' A 347  THR  O  ', ' A 348  HIS  CE1', -0.556, (158.824, 174.654, 139.768)), (' A 304  ASN  ND2', ' A 306  MET  HB2', -0.555, (149.289, 134.004, 133.094)), (' B 229  PHE  CD1', ' B 240  CYS  HB3', -0.551, (121.018, 128.155, 139.63)), (' B  94  THR  O  ', ' B 324  SER  OG ', -0.548, (150.355, 122.525, 149.081)), (' B 105  HIS  O  ', ' B 107  GLU  N  ', -0.547, (151.922, 135.069, 154.416)), (' A 267  GLU  OE1', ' A 274  THR  C  ', -0.547, (151.652, 150.953, 134.795)), (' B  78  GLU  HG2', ' B  79  GLY  N  ', -0.547, (166.338, 110.675, 153.584)), (' B 273  ASP  OD1', ' B 274  THR  N  ', -0.543, (133.636, 134.805, 130.588)), (' A 105  HIS  O  ', ' A 107  GLU  N  ', -0.542, (134.071, 150.862, 154.391)), (' B 267  GLU  OE1', ' B 274  THR  C  ', -0.542, (134.8, 134.779, 135.142)), (' B 290  VAL  HA ', ' B 315  LYS  O  ', -0.541, (140.104, 136.822, 143.037)), (' A 152  VAL  CG2', ' A 157  VAL  CG1', -0.54, (131.74, 173.067, 148.583)), (' A  78  GLU  HG2', ' A  79  GLY  N  ', -0.537, (119.753, 175.572, 153.505)), (' B 296  PRO  HB2', ' B 299  GLN  HG3', -0.536, (143.056, 130.258, 126.483)), (' A 296  PRO  HB2', ' A 299  GLN  HG3', -0.536, (142.779, 155.714, 126.532)), (' A 308  LEU  O  ', ' B 316  GLY  HA3', -0.527, (144.836, 135.5, 141.643)), (' A 314  TRP  C  ', ' A 314  TRP  CD1', -0.527, (143.696, 144.899, 142.583)), (' B 364  SER  CB ', ' B 366  GLU  OE1', -0.525, (127.746, 114.945, 131.053)), (' B 267  GLU  OE1', ' B 274  THR HG22', -0.522, (133.455, 134.097, 135.228)), (' B  68  GLU  OE2', ' B 175  GLY  N  ', -0.521, (139.155, 119.485, 144.821)), (' A 153  ASP  O  ', ' A 155  ILE  N  ', -0.521, (128.433, 168.773, 149.79)), (' A 254  LEU  O  ', ' A 258  SER  OG ', -0.521, (162.438, 142.999, 142.454)), (' A  93  PHE  HB2', ' A 141  LEU  CD1', -0.521, (136.66, 165.413, 141.631)), (' B 364  SER  HB2', ' B 366  GLU  OE1', -0.52, (127.418, 114.516, 131.689)), (' A 200  LEU HD13', ' A 232  ALA  HB2', -0.519, (161.588, 160.023, 142.21)), (' A 186  VAL HG11', ' A 317  ALA  HB2', -0.518, (144.15, 151.754, 146.527)), (' A 108  GLY  O  ', ' A 323  LYS  CE ', -0.516, (133.82, 155.085, 153.265)), (' A 364  SER  HB2', ' A 366  GLU  OE1', -0.514, (158.525, 171.394, 131.656)), (' B 153  ASP  O  ', ' B 155  ILE  N  ', -0.514, (157.418, 117.188, 149.88)), (' B  26  VAL HG12', ' B 132  CYS  HB2', -0.514, (153.697, 103.083, 132.031)), (' A 364  SER  CB ', ' A 366  GLU  OE1', -0.513, (158.192, 171.129, 131.079)), (' B  35  GLU  OE2', ' B 129  ARG  NH2', -0.512, (163.858, 111.565, 143.272)), (' B  93  PHE  HB2', ' B 141  LEU  CD1', -0.512, (149.2, 120.589, 141.195)), (' B 200  LEU HD13', ' B 232  ALA  HB2', -0.512, (124.303, 125.684, 142.568)), (' A 267  GLU  OE1', ' A 274  THR HG22', -0.507, (152.113, 151.548, 135.555)), (' B  92  LEU  CD2', ' B 328  VAL HG21', -0.506, (147.001, 118.716, 151.627)), (' B  68  GLU  CG ', ' B 174  CYS  HB3', -0.503, (141.895, 118.468, 144.199)), (' B 180  TYR  O  ', ' B 184  VAL HG22', -0.501, (137.547, 129.015, 153.202)), (' B  24  GLU  OE2', ' B  25  GLU  C  ', -0.5, (152.05, 99.258, 131.758)), (' B 241  VAL  CG1', ' B 250  ILE HD11', -0.499, (122.006, 135.623, 135.849)), (' B 186  VAL HG21', ' B 317  ALA  HB2', -0.499, (143.178, 133.172, 147.379)), (' A 165  PRO  C  ', ' A 167  GLU  OE1', -0.498, (148.124, 177.242, 152.985)), (' A  48  SER  HB2', ' A  67  HIS  CE1', -0.496, (142.785, 166.449, 138.425)), (' A 180  TYR  O  ', ' A 184  VAL HG22', -0.494, (148.326, 157.055, 153.28)), (' B  48  SER  HB2', ' B  67  HIS  CE1', -0.493, (142.911, 119.525, 138.524)), (' A 208  ILE  CG2', ' A 235  VAL HG23', -0.492, (159.33, 159.584, 148.271)), (' B 304  ASN  O  ', ' B 306  MET  N  ', -0.492, (138.653, 150.758, 134.49)), (' A 328  VAL  HB ', ' A 329  PRO  HD3', -0.49, (138.611, 166.695, 155.536)), (' A 105  HIS  CE1', ' A 106  PRO  HG2', -0.49, (132.523, 148.225, 155.615)), (' A  31  PRO  HB3', ' A  35  GLU  O  ', -0.489, (125.525, 177.277, 148.879)), (' B 241  VAL HG21', ' B 257  MET  HE1', -0.488, (121.115, 136.254, 139.815)), (' B 254  LEU  O  ', ' B 258  SER  OG ', -0.488, (123.426, 142.919, 142.526)), (' A 105  HIS  ND1', ' A 106  PRO  HG2', -0.488, (131.926, 148.026, 155.402)), (' B  88  LYS  NZ ', ' B 162  ALA  O  ', -0.486, (142.891, 105.915, 158.429)), (' B 105  HIS  ND1', ' B 106  PRO  HG2', -0.486, (153.716, 137.681, 155.696)), (' A 304  ASN  O  ', ' A 306  MET  N  ', -0.486, (147.14, 135.774, 134.533)), (' A 357  GLU  OE1', ' A 358  GLY  CA ', -0.485, (152.661, 177.037, 134.373)), (' A  16  GLU  HG3', ' A  19  LYS  HG3', -0.485, (139.328, 174.813, 121.76)), (' B 105  HIS  CE1', ' B 106  PRO  HG2', -0.485, (153.238, 138.09, 155.325)), (' A 192  GLY  O  ', ' A 217  ALA  CB ', -0.484, (162.043, 147.547, 154.552)), (' B  31  PRO  HB3', ' B  35  GLU  O  ', -0.484, (160.591, 108.751, 148.792)), (' B 272  LEU HD21', ' B 299  GLN  HB3', -0.483, (142.374, 134.361, 127.123)), (' B 109  ASN  ND2', ' B 318  ILE  O  ', -0.483, (147.042, 128.25, 147.842)), (' B 133  ARG  HB3', ' B 135  LYS  NZ ', -0.482, (156.237, 101.693, 126.426)), (' A 186  VAL HG21', ' A 317  ALA  HB1', -0.482, (143.049, 153.981, 147.373)), (' B 125  ASP  O  ', ' B 127  THR  N  ', -0.481, (164.734, 115.238, 138.316)), (' B  92  LEU HD11', ' B 158  ALA  HB2', -0.479, (150.151, 118.279, 152.8)), (' A  35  GLU  OE2', ' A 129  ARG  NH2', -0.478, (122.084, 174.494, 143.264)), (' B 192  GLY  O  ', ' B 217  ALA  CB ', -0.477, (123.94, 138.397, 154.471)), (' B 125  ASP  O  ', ' B 125  ASP  OD2', -0.477, (166.286, 114.277, 139.963)), (' A 109  ASN  ND2', ' A 318  ILE  O  ', -0.476, (138.926, 157.722, 147.871)), (' A 263  ASP  N  ', ' A 263  ASP  OD1', -0.476, (157.343, 143.032, 148.329)), (' B  68  GLU  HG3', ' B 174  CYS  HB3', -0.476, (142.093, 118.013, 143.658)), (' B  64  ILE HG13', ' B 137  ILE HG21', -0.473, (152.466, 108.401, 133.494)), (' B 208  ILE  CG2', ' B 235  VAL HG23', -0.472, (126.63, 125.881, 148.438)), (' A 116  LEU  CD2', ' A 318  ILE HD11', -0.472, (137.649, 159.079, 140.304)), (' B 348  HIS  HB2', ' B 370  THR HG23', -0.47, (131.093, 109.945, 139.672)), (' A  40  MET  HE1', ' A 150  THR HG22', -0.469, (136.052, 178.049, 145.058)), (' A  88  LYS  HD2', ' A 166  LEU HD21', -0.468, (142.664, 178.65, 154.934)), (' B  32  LYS  HG3', ' B 129  ARG  NH2', -0.467, (165.146, 109.97, 143.093)), (' A 125  ASP  C  ', ' A 125  ASP  OD1', -0.467, (120.755, 170.375, 139.555)), (' B  88  LYS  HD2', ' B 166  LEU HD21', -0.467, (143.495, 107.343, 154.798)), (' B 282  CYS  O  ', ' B 284  GLU  OE2', -0.466, (131.605, 146.976, 141.328)), (' B 328  VAL  HB ', ' B 329  PRO  HD3', -0.463, (147.356, 119.133, 155.556)), (' B 271  ARG  NH2', ' B 273  ASP  OD2', -0.462, (133.346, 132.745, 127.855)), (' A 147  SER  OG ', ' A 149  TYR  O  ', -0.462, (134.88, 181.187, 140.506)), (' A 129  ARG  H  ', ' A 139  HIS  HE1', -0.462, (127.321, 175.752, 137.722)), (' A 282  CYS  O  ', ' A 284  GLU  OE2', -0.461, (154.356, 139.593, 141.371)), (' B 263  ASP  N  ', ' B 263  ASP  OD1', -0.46, (128.508, 142.641, 148.42)), (' B 350  LEU HD11', ' B 370  THR HG22', -0.46, (133.605, 108.006, 138.371)), (' A 167  GLU  OE1', ' A 168  LYS  N  ', -0.46, (148.582, 177.175, 151.49)), (' B 129  ARG  H  ', ' B 139  HIS  HE1', -0.46, (158.937, 109.867, 137.629)), (' B  17  GLU  HG3', ' B  61  LEU HD11', -0.46, (149.054, 117.356, 124.459)), (' B  43  THR HG23', ' B 145  THR HG21', -0.459, (144.32, 110.845, 142.907)), (' A 116  LEU HD23', ' A 318  ILE HD11', -0.458, (137.602, 158.686, 140.839)), (' B 250  ILE  O  ', ' B 251  GLN  C  ', -0.457, (124.783, 141.806, 135.681)), (' A 241  VAL HG21', ' A 257  MET  HE1', -0.456, (164.698, 149.401, 140.131)), (' A  64  ILE HG13', ' A 137  ILE HG21', -0.456, (133.455, 177.231, 133.462)), (' B 350  LEU HD11', ' B 370  THR  CG2', -0.455, (133.158, 108.436, 138.202)), (' B  69  ALA  CB ', ' B 145  THR  CG2', -0.454, (145.095, 110.349, 143.927)), (' A 193  SER  HA ', ' A 263  ASP  OD2', -0.454, (158.097, 144.274, 152.027)), (' B 108  GLY  O  ', ' B 323  LYS  NZ ', -0.454, (152.151, 131.301, 153.451)), (' A 350  LEU HD11', ' A 370  THR HG22', -0.453, (152.358, 177.649, 138.763)), (' A 348  HIS  CB ', ' A 370  THR HG23', -0.453, (154.647, 176.25, 139.22)), (' A 336  MET  CE ', ' A 336  MET  HA ', -0.452, (149.327, 172.812, 160.587)), (' A 250  ILE  O  ', ' A 251  GLN  C  ', -0.451, (161.149, 144.09, 135.572)), (' B  60  PRO  HG2', ' B 120  ARG  O  ', -0.451, (157.681, 118.724, 132.298)), (' A 271  ARG  NH2', ' A 273  ASP  OD2', -0.449, (152.694, 152.981, 127.659)), (' A  32  LYS  HG3', ' A 129  ARG  NH2', -0.449, (120.795, 175.906, 143.096)), (' A  69  ALA  CB ', ' A 145  THR  CG2', -0.449, (140.631, 175.401, 143.961)), (' B 179  GLY  HA3', ' B 206  SER  HB2', -0.448, (135.154, 125.371, 147.323)), (' B 204  GLY  N  ', ' B 268  VAL HG11', -0.448, (133.334, 125.976, 142.199)), (' A 271  ARG  NH1', ' A 273  ASP  OD2', -0.448, (153.084, 152.959, 128.67)), (' B 250  ILE  CG2', ' B 251  GLN  N  ', -0.448, (126.414, 139.101, 134.554)), (' B 357  GLU  O  ', ' B 357  GLU  OE2', -0.447, (131.943, 108.832, 133.209)), (' B 193  SER  HA ', ' B 263  ASP  OD2', -0.447, (127.838, 141.524, 152.453)), (' A 348  HIS  HB2', ' A 370  THR HG23', -0.447, (154.586, 176.037, 139.289)), (' A 208  ILE HG21', ' A 235  VAL HG23', -0.446, (159.598, 160.029, 148.267)), (' A 204  GLY  N  ', ' A 268  VAL HG11', -0.445, (152.392, 160.011, 142.28)), (' A  60  PRO  HG2', ' A 120  ARG  O  ', -0.441, (128.213, 167.145, 132.18)), (' B 254  LEU HD23', ' B 257  MET  HE3', -0.44, (122.418, 138.246, 140.913)), (' A  68  GLU  HG3', ' A 174  CYS  HB3', -0.44, (143.625, 167.569, 143.897)), (' B 135  LYS  O  ', ' B 136  PRO  O  ', -0.439, (158.575, 108.871, 129.181)), (' A 359  PHE  O  ', ' A 362  LEU  HB3', -0.438, (151.722, 171.193, 132.871)), (' A 273  ASP  N  ', ' A 273  ASP  OD1', -0.438, (150.333, 150.785, 129.199)), (' B 348  HIS  CB ', ' B 370  THR HG23', -0.437, (130.915, 109.558, 139.422)), (' A 301  LEU HD23', ' B 305  PRO  HG3', -0.434, (143.945, 149.032, 132.873)), (' B 133  ARG  CG ', ' B 135  LYS  HZ1', -0.434, (156.341, 101.042, 125.758)), (' B 369  ARG  HA ', ' B 369  ARG  HD3', -0.434, (134.863, 115.379, 141.103)), (' B 133  ARG  CB ', ' B 135  LYS  HZ1', -0.433, (156.451, 101.606, 125.875)), (' A 350  LEU HD11', ' A 370  THR  CG2', -0.433, (152.366, 177.847, 138.234)), (' A 294  VAL  HA ', ' B 309  LEU HD11', -0.433, (142.369, 155.831, 136.619)), (' B 133  ARG  HB3', ' B 135  LYS  HZ1', -0.432, (156.219, 101.958, 125.94)), (' A 152  VAL  CG2', ' A 157  VAL HG11', -0.432, (131.851, 173.83, 148.891)), (' A 335  PHE  CE1', ' A 342  LEU  HG ', -0.431, (152.028, 170.175, 154.28)), (' A 279  LEU  O  ', ' A 282  CYS  SG ', -0.431, (152.812, 142.062, 140.875)), (' B  21  PHE  H  ', ' B 356  ASN  ND2', -0.43, (140.599, 108.214, 128.672)), (' B 332  VAL  O  ', ' B 336  MET  HG2', -0.43, (138.824, 114.719, 160.109)), (' A 179  GLY  HA3', ' A 206  SER  HB2', -0.429, (150.576, 160.188, 147.177)), (' A  88  LYS  NZ ', ' A 162  ALA  O  ', -0.428, (143.098, 180.145, 158.486)), (' A 135  LYS  O  ', ' A 136  PRO  O  ', -0.427, (127.374, 177.409, 128.846)), (' A 272  LEU HD21', ' A 299  GLN  HB3', -0.425, (143.616, 151.706, 127.252)), (' B  40  MET  HE3', ' B 150  THR  CG2', -0.425, (150.213, 108.548, 144.817)), (' A  76  ILE HG23', ' A  85  PRO  CD ', -0.425, (128.589, 179.929, 155.29)), (' A  92  LEU HD12', ' A 156  SER  HA ', -0.424, (132.986, 167.229, 148.859)), (' A  93  PHE  CE2', ' A 174  CYS  HB2', -0.423, (141.395, 165.058, 144.648)), (' B 208  ILE HG21', ' B 235  VAL HG23', -0.423, (126.424, 126.338, 148.132)), (' B 248  LYS  HA ', ' B 249  PRO  HD2', -0.422, (122.201, 142.365, 127.727)), (' B 105  HIS  HA ', ' B 106  PRO  HD2', -0.422, (155.856, 136.404, 156.577)), (' B 250  ILE HG23', ' B 251  GLN  N  ', -0.422, (126.458, 139.565, 134.98)), (' B 250  ILE  HA ', ' B 250  ILE HD12', -0.422, (122.845, 138.36, 134.156)), (' A 335  PHE  HD2', ' A 336  MET  HE3', -0.422, (149.044, 172.604, 158.439)), (' A 243  PRO  HG3', ' A 250  ILE HG13', -0.421, (160.771, 150.909, 133.546)), (' B  21  PHE  CE2', ' B 359  PHE  CE2', -0.419, (141.244, 111.77, 132.127)), (' B  84  ARG  O  ', ' B  87  ASP  OD2', -0.419, (153.701, 106.478, 158.226)), (' A 145  THR  O  ', ' A 147  SER  N  ', -0.418, (138.82, 178.698, 140.165)), (' A  21  PHE  CE2', ' A 359  PHE  CE2', -0.418, (144.808, 174.015, 132.554)), (' B 205  LEU  CD2', ' B 231  LYS  HG2', -0.418, (126.786, 120.541, 144.841)), (' A 271  ARG  CZ ', ' A 273  ASP  OD2', -0.417, (152.728, 153.204, 128.357)), (' B 265  SER  O  ', ' B 289  SER  HA ', -0.417, (135.157, 138.252, 143.523)), (' B 114  ASN HD22', ' B 116  LEU  H  ', -0.417, (153.699, 125.555, 139.922)), (' B 359  PHE  O  ', ' B 362  LEU  HB3', -0.416, (134.2, 114.338, 132.724)), (' A 265  SER  O  ', ' A 289  SER  HA ', -0.416, (150.802, 147.701, 143.435)), (' B 348  HIS  CD2', ' B 367  SER  HB3', -0.415, (128.9, 112.329, 138.19)), (' B 178  THR HG22', ' B 292  VAL  CG1', -0.415, (139.252, 127.496, 143.81)), (' B 306  MET  HA ', ' B 306  MET  HE3', -0.415, (137.865, 153.93, 136.678)), (' A 108  GLY  O  ', ' A 323  LYS  HE2', -0.414, (133.689, 154.865, 153.256)), (' B 145  THR  O  ', ' B 147  SER  N  ', -0.414, (146.989, 107.317, 140.06)), (' A  68  GLU  CG ', ' A 174  CYS  HB3', -0.41, (143.84, 168.046, 144.17)), (' B  92  LEU HD21', ' B 328  VAL HG21', -0.41, (147.268, 118.829, 152.045)), (' A 348  HIS  CD2', ' A 361  LEU HD13', -0.41, (157.226, 176.526, 137.521)), (' B  78  GLU  CG ', ' B  79  GLY  N  ', -0.409, (166.675, 110.411, 153.916)), (' A  78  GLU  CG ', ' A  79  GLY  N  ', -0.408, (119.246, 175.378, 153.907)), (' B 161  ASP  O  ', ' B 162  ALA  C  ', -0.408, (143.099, 108.336, 160.496)), (' A 189  VAL  O  ', ' A 214  ALA  HB1', -0.408, (153.064, 150.693, 156.017)), (' A 332  VAL  O  ', ' A 336  MET  HG2', -0.407, (147.116, 170.808, 160.026)), (' A 161  ASP  O  ', ' A 162  ALA  C  ', -0.407, (143.051, 177.679, 160.336)), (' A  37  ARG  CD ', ' A  74  GLU  HG3', -0.407, (130.12, 182.884, 146.904)), (' B 275  MET  HE1', ' B 295  PRO  HG3', -0.407, (142.567, 132.915, 134.044)), (' A 165  PRO  C  ', ' A 167  GLU  CD ', -0.407, (148.286, 178.207, 153.038)), (' B  30  PRO  HA ', ' B  37  ARG  NH2', -0.406, (160.321, 102.343, 144.982)), (' A 354  LYS  O  ', ' A 357  GLU  HB3', -0.405, (151.369, 180.482, 133.208)), (' B 124  GLN  HG2', ' B 153  ASP  CG ', -0.404, (160.265, 117.44, 145.034)), (' A 124  GLN  HG2', ' A 153  ASP  CG ', -0.403, (125.964, 168.816, 145.19)), (' B  43  THR  CG2', ' B 145  THR  CG2', -0.403, (144.062, 110.411, 142.195)), (' B 140  PHE  O  ', ' B 141  LEU  C  ', -0.403, (152.637, 117.614, 139.917)), (' A  92  LEU HD13', ' A 324  SER  HB3', -0.403, (134.842, 164.947, 150.229)), (' A  92  LEU  CD2', ' A 324  SER  HB3', -0.403, (135.606, 165.499, 151.368)), (' B  10  LYS  HA ', ' B  24  GLU  O  ', -0.403, (148.744, 100.041, 134.779)), (' A 336  MET  CA ', ' A 336  MET  HE2', -0.402, (149.423, 172.269, 160.748)), (' B  43  THR  CG2', ' B 145  THR HG22', -0.402, (144.423, 109.957, 142.102)), (' A  30  PRO  HA ', ' A  37  ARG  NH2', -0.401, (125.604, 183.638, 145.038)), (' A 284  GLU  HA ', ' A 284  GLU  OE2', -0.401, (153.038, 137.694, 141.94)), (' B  48  SER  HB2', ' B  67  HIS  HE1', -0.401, (142.917, 119.209, 138.806)), (' A 140  PHE  O  ', ' A 141  LEU  C  ', -0.4, (133.058, 168.475, 139.571)), (' A 178  THR HG22', ' A 292  VAL  CG1', -0.4, (146.527, 158.982, 143.502))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
