# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', '  17 ', 'GLU', 0.0031697241633601276, (139.31299999999993, 170.035, 124.133)), ('A', '  24 ', 'GLU', 0.011055811666673855, (136.80899999999994, 184.91600000000003, 131.018)), ('A', '  26 ', 'VAL', 0.0028424223769425603, (131.965, 184.66400000000002, 134.207)), ('A', '  78 ', 'GLU', 0.002877889879723907, (120.23999999999997, 177.635, 153.017)), ('A', ' 118 ', 'MET', 0.016731461554476298, (132.06599999999995, 158.619, 135.7)), ('A', ' 123 ', 'MET', 0.0005049466411387947, (125.71900000000005, 169.954, 140.702)), ('A', ' 160 ', 'ILE', 0.0, (137.324, 172.703, 158.934)), ('A', ' 191 ', 'GLN', 0.04220745683673861, (159.537, 146.529, 157.115)), ('A', ' 203 ', 'VAL', 0.004985125858309898, (154.106, 164.959, 142.865)), ('A', ' 224 ', 'ILE', 0.004716156388017596, (160.297, 155.127, 136.726)), ('A', ' 262 ', 'VAL', 0.012901779628079764, (159.96399999999994, 140.578, 143.314)), ('A', ' 314 ', 'TRP', 0.004459755364565749, (145.141, 143.937, 142.21)), ('A', ' 319 ', 'PHE', 0.009800079132830517, (139.54799999999994, 159.24600000000004, 144.742)), ('A', ' 337 ', 'ALA', 0.005732033505932251, (152.117, 169.32700000000003, 164.139)), ('B', '  24 ', 'GLU', 0.010344399211639398, (148.80099999999993, 101.061, 130.991)), ('B', '  33 ', 'ALA', 0.039099154149120026, (166.073, 110.98800000000001, 149.17)), ('B', '  78 ', 'GLU', 0.005770028701444026, (165.77899999999994, 108.5, 153.107)), ('B', '  99 ', 'LYS', 0.019012926490131938, (158.507, 123.77800000000002, 153.698)), ('B', ' 122 ', 'THR', 0.005265737268144859, (158.764, 122.03, 133.91)), ('B', ' 125 ', 'ASP', 0.021227113921694185, (160.01, 116.10700000000001, 140.706)), ('B', ' 135 ', 'LYS', 0.005346481044660936, (160.97699999999995, 103.19999999999999, 128.794)), ('B', ' 160 ', 'ILE', 0.0, (148.72199999999995, 113.582, 159.152)), ('B', ' 180 ', 'TYR', 0.00029094691363778347, (136.64399999999995, 127.143, 151.797)), ('B', ' 189 ', 'VAL', 0.026398376066824873, (132.67499999999995, 139.9, 156.731)), ('B', ' 190 ', 'THR', 0.010514761997884557, (131.573, 138.528, 160.114)), ('B', ' 203 ', 'VAL', 0.005163434319558258, (131.083, 122.71700000000003, 140.206)), ('B', ' 220 ', 'ILE', 0.024168024565570375, (125.33000000000006, 133.34, 147.864)), ('B', ' 224 ', 'ILE', 0.005199303962593628, (127.01800000000004, 130.746, 135.523)), ('B', ' 262 ', 'VAL', 0.0904904178466507, (125.706, 145.203, 143.814)), ('B', ' 273 ', 'ASP', 0.02451205763329059, (135.604, 136.556, 130.209)), ('B', ' 298 ', 'SER', 0.027378290960113807, (146.09599999999995, 129.166, 128.99)), ('B', ' 327 ', 'SER', 0.0011873269447938675, (146.68999999999994, 123.54100000000001, 157.028)), ('B', ' 332 ', 'VAL', 0.05151583726046414, (141.705, 117.165, 158.181)), ('B', ' 333 ', 'ALA', 0.04075037053766379, (138.335, 118.648, 157.247)), ('B', ' 346 ', 'ILE', 0.07798087899923165, (130.825, 112.995, 145.658)), ('B', ' 368 ', 'ILE', 0.03730994455786349, (130.132, 117.47800000000002, 140.459)), ('B', ' 369 ', 'ARG', 0.04445419029169883, (133.06599999999995, 115.22300000000001, 141.471))]
data['omega'] = [('A', '   7 ', 'ILE', None, (130.928, 190.702, 137.915)), ('A', '  99 ', 'LYS', None, (128.019, 162.723, 151.445)), ('A', ' 141 ', 'LEU', None, (134.335, 168.308, 140.474)), ('A', ' 180 ', 'TYR', None, (149.83199999999994, 159.986, 151.893)), ('A', ' 255 ', 'THR', None, (165.95, 145.515, 135.222)), ('A', ' 257 ', 'MET', None, (162.992, 146.53700000000003, 140.414)), ('A', ' 306 ', 'MET', None, (147.644, 134.298, 134.263)), ('A', ' 321 ', 'GLY', None, (140.28999999999994, 161.93300000000002, 149.397)), ('A', ' 335 ', 'PHE', None, (150.69199999999995, 169.802, 158.024)), ('A', ' 346 ', 'ILE', None, (154.303, 172.02100000000002, 146.93)), ('A', ' 366 ', 'GLU', None, (159.93999999999994, 171.958, 134.947)), ('A', ' 374 ', 'PHE', None, (145.25, 177.97300000000004, 139.508)), ('B', '   7 ', 'ILE', None, (155.03599999999994, 95.19700000000003, 138.01)), ('B', ' 102 ', 'VAL', None, (160.41699999999994, 129.341, 149.515)), ('B', ' 180 ', 'TYR', None, (135.784, 126.94400000000003, 150.615)), ('B', ' 201 ', 'GLY', None, (125.71700000000006, 127.218, 140.642)), ('B', ' 227 ', 'ASP', None, (125.86400000000005, 127.935, 130.761)), ('B', ' 249 ', 'PRO', None, (118.67499999999997, 135.79700000000003, 127.984)), ('B', ' 255 ', 'THR', None, (120.398, 139.121, 134.437)), ('B', ' 306 ', 'MET', None, (138.133, 151.609, 134.387)), ('B', ' 328 ', 'VAL', None, (145.01599999999993, 123.72800000000002, 155.193)), ('B', ' 346 ', 'ILE', None, (131.394, 113.873, 146.649)), ('B', ' 366 ', 'GLU', None, (125.38100000000001, 114.88900000000001, 134.325)), ('B', ' 374 ', 'PHE', None, (139.87099999999995, 103.94100000000003, 144.323))]
data['rota'] = [('A', ' 303 ', 'MET', 0.2956626186536843, (146.429, 142.509, 131.349)), ('A', ' 314 ', 'TRP', 0.0037528041035479313, (145.141, 143.937, 142.21)), ('B', ' 113 ', 'LYS', 0.049597998074972345, (155.482, 128.059, 147.02))]
data['cbeta'] = [('A', ' 194 ', 'THR', ' ', 0.26589735210694065, (158.42899999999995, 146.777, 147.408)), ('A', ' 314 ', 'TRP', ' ', 0.39732850877716563, (144.42699999999994, 143.71, 140.858)), ('A', ' 322 ', 'PHE', ' ', 0.314889112652418, (143.791, 157.98, 148.228)), ('B', ' 115 ', 'ASP', ' ', 0.270507679539369, (160.65799999999993, 123.68600000000002, 146.064)), ('B', ' 180 ', 'TYR', ' ', 0.4294004029214207, (136.972, 125.856, 152.453)), ('B', ' 262 ', 'VAL', ' ', 0.2566576726011534, (126.445, 146.22500000000002, 142.99))]
data['probe'] = [(' A 219  ILE HG13', ' A 220  ILE HG12', -0.705, (160.967, 152.246, 150.358)), (' A 127  THR  OG1', ' A 129  ARG  NH1', -0.659, (122.204, 174.73, 139.087)), (' A 198  PHE  H  ', ' A 224  ILE HG21', -0.6, (157.137, 156.234, 138.028)), (' A 204  GLY  O  ', ' A 205  LEU  HB2', -0.59, (151.454, 161.646, 142.005)), (' A 122  THR  OG1', ' A 123  MET  N  ', -0.581, (127.365, 170.803, 138.922)), (' A 198  PHE  N  ', ' A 224  ILE HG21', -0.572, (157.097, 156.286, 138.134)), (' B 203  VAL HG12', ' B 205  LEU  H  ', -0.557, (133.333, 123.529, 141.975)), (' A 318  ILE  O  ', ' A 319  PHE  CB ', -0.55, (138.494, 157.291, 144.724)), (' A 326  ASP  N  ', ' A 326  ASP  OD1', -0.538, (134.864, 161.662, 152.901)), (' B   8  LYS  HD2', ' B 149  TYR  H  ', -0.533, (150.468, 103.371, 140.604)), (' B 166  LEU  O  ', ' B 167  GLU  HB2', -0.528, (137.24, 107.49, 151.15)), (' A 269  ILE  O  ', ' A 269  ILE HG22', -0.521, (151.374, 158.512, 137.964)), (' A 318  ILE  O  ', ' A 319  PHE  HB3', -0.506, (138.568, 157.129, 145.471)), (' B  91  PRO  HB3', ' B 159  LYS  CE ', -0.504, (151.677, 110.619, 152.677)), (' A 208  ILE  C  ', ' A 210  GLY  H  ', -0.501, (154.823, 157.328, 150.109)), (' B  68  GLU  HG2', ' B 174  CYS  HB3', -0.499, (142.414, 117.871, 144.271)), (' A 215  GLY  HA3', ' A 219  ILE HD13', -0.498, (159.667, 151.054, 153.958)), (' A 364  SER  OG ', ' A 365  GLY  N  ', -0.498, (158.232, 170.953, 131.095)), (' B   8  LYS  NZ ', ' B 149  TYR  O  ', -0.49, (152.119, 105.311, 140.175)), (' B 139  HIS  CD2', ' B 140  PHE  H  ', -0.488, (154.182, 115.2, 137.16)), (' B 202  GLY  O  ', ' B 203  VAL  HB ', -0.486, (129.95, 124.578, 140.955)), (' A 122  THR  HG1', ' A 138  HIS  CE1', -0.478, (129.474, 172.036, 138.611)), (' B 105  HIS  N  ', ' B 106  PRO  CD ', -0.477, (157.571, 133.118, 153.263)), (' A 210  GLY  C  ', ' A 212  LYS  H  ', -0.476, (155.328, 156.308, 154.394)), (' B 189  VAL  O  ', ' B 191  GLN  N  ', -0.476, (130.039, 138.22, 158.39)), (' B 328  VAL  O  ', ' B 331  LEU  N  ', -0.475, (144.215, 120.112, 158.199)), (' A 294  VAL  N  ', ' A 295  PRO  CD ', -0.473, (144.813, 157.23, 136.691)), (' A 204  GLY  O  ', ' A 206  SER  N  ', -0.473, (153.038, 161.844, 143.483)), (' B 101  ARG  N  ', ' B 102  VAL  HA ', -0.472, (160.491, 127.684, 150.562)), (' B 139  HIS  CG ', ' B 140  PHE  H  ', -0.472, (154.285, 114.441, 137.126)), (' B 256  GLU  C  ', ' B 258  SER  H  ', -0.47, (122.873, 142.997, 139.167)), (' B 272  LEU  O  ', ' B 273  ASP  HB3', -0.47, (135.442, 134.339, 129.614)), (' B  48  SER  O  ', ' B  51  HIS  ND1', -0.468, (144.198, 117.259, 133.121)), (' B 159  LYS  O  ', ' B 160  ILE  HB ', -0.468, (150.458, 114.743, 159.053)), (' B 179  GLY  HA2', ' B 181  GLY  N  ', -0.466, (138.274, 128.025, 149.674)), (' A   9  CYS  O  ', ' A   9  CYS  SG ', -0.465, (138.762, 189.001, 135.766)), (' A 334  ASP  N  ', ' A 335  PHE  HA ', -0.459, (148.628, 169.181, 158.336)), (' B 122  THR  OG1', ' B 123  MET  N  ', -0.457, (159.55, 120.211, 134.169)), (' B 139  HIS  CG ', ' B 140  PHE  N  ', -0.456, (153.974, 114.662, 136.563)), (' A  48  SER  O  ', ' A  51  HIS  ND1', -0.455, (141.294, 168.18, 132.557)), (' A 226  LYS  HB2', ' A 245  ASP  HA ', -0.454, (166.07, 156.075, 134.628)), (' B 326  ASP  O  ', ' B 327  SER  CB ', -0.454, (147.664, 124.343, 158.201)), (' B 167  GLU  HB3', ' B 372  LEU  CD2', -0.452, (135.442, 107.699, 148.72)), (' A 159  LYS  O  ', ' A 160  ILE  HB ', -0.45, (135.52, 171.738, 159.053)), (' B 223  ASP  O  ', ' B 225  ASN  N  ', -0.446, (125.667, 129.414, 136.376)), (' B 208  ILE  O  ', ' B 208  ILE HG22', -0.444, (131.525, 130.519, 147.024)), (' A 286  TYR  CD2', ' B 109  ASN  HB3', -0.438, (154.098, 136.098, 150.765)), (' A 343  ASP  N  ', ' A 344  PRO  CD ', -0.437, (157.248, 169.911, 151.569)), (' B 294  VAL  O  ', ' B 296  PRO  HD3', -0.436, (144.561, 130.286, 135.309)), (' A 109  ASN  N  ', ' A 109  ASN  OD1', -0.436, (135.778, 154.921, 149.014)), (' B 160  ILE  O  ', ' B 160  ILE HG12', -0.435, (147.152, 115.042, 160.18)), (' A 272  LEU  O  ', ' A 273  ASP  HB2', -0.434, (150.891, 151.214, 129.39)), (' B 157  VAL  HB ', ' B 159  LYS  CD ', -0.433, (153.255, 112.403, 153.109)), (' B  93  PHE  CD1', ' B  93  PHE  N  ', -0.433, (147.648, 113.376, 148.491)), (' A  93  PHE  CD2', ' A  93  PHE  N  ', -0.432, (138.254, 173.016, 148.517)), (' A 203  VAL  C  ', ' A 204  GLY  O  ', -0.432, (152.614, 163.267, 143.197)), (' B 333  ALA  O  ', ' B 334  ASP  CB ', -0.431, (136.503, 115.886, 156.62)), (' B 332  VAL  O  ', ' B 333  ALA  HB3', -0.429, (139.609, 118.061, 155.598)), (' B 185  LYS  HD3', ' B 317  ALA  HB3', -0.428, (142.606, 131.882, 146.538)), (' A 139  HIS  CG ', ' A 140  PHE  H  ', -0.428, (133.491, 168.288, 136.088)), (' B 189  VAL  O  ', ' B 190  THR  C  ', -0.427, (130.675, 138.178, 158.261)), (' B 238  THR  O  ', ' B 239  GLU  C  ', -0.427, (123.379, 126.486, 149.737)), (' A 198  PHE  N  ', ' A 224  ILE HD13', -0.426, (155.786, 155.339, 137.206)), (' A 355  ILE  O  ', ' A 356  ASN  HB2', -0.426, (148.14, 179.903, 130.986)), (' B 135  LYS  H  ', ' B 136  PRO  CD ', -0.425, (159.129, 103.837, 127.89)), (' B 367  SER  OG ', ' B 368  ILE  N  ', -0.425, (129.709, 116.577, 138.174)), (' B  98  GLY  O  ', ' B 100  CYS  N  ', -0.422, (158.519, 123.731, 151.338)), (' A 317  ALA  O  ', ' A 322  PHE  CD1', -0.421, (142.709, 155.769, 145.815)), (' B  49  ASP  C  ', ' B  49  ASP  OD1', -0.421, (140.025, 119.004, 131.633)), (' B 272  LEU  O  ', ' B 273  ASP  CB ', -0.421, (135.359, 134.829, 129.379)), (' B  28  VAL  O  ', ' B  29  ALA  C  ', -0.42, (159.883, 103.449, 141.935)), (' A  30  PRO  HA ', ' A  31  PRO  HD3', -0.42, (125.431, 182.73, 145.667)), (' B 118  MET  N  ', ' B 119  PRO  CD ', -0.418, (152.722, 124.424, 139.899)), (' A 205  LEU  O  ', ' A 208  ILE HG12', -0.415, (153.24, 158.306, 145.049)), (' A 185  LYS  CE ', ' A 290  VAL HG11', -0.413, (146.668, 151.746, 145.946)), (' B 167  GLU  HB3', ' B 372  LEU HD22', -0.412, (135.772, 107.331, 149.023)), (' A 354  LYS  C  ', ' A 355  ILE  O  ', -0.412, (148.705, 180.772, 133.522)), (' B 262  VAL  CG1', ' B 283  GLN  HG2', -0.411, (127.762, 147.743, 144.662)), (' B 253  VAL  O  ', ' B 256  GLU  HA ', -0.41, (121.556, 143.516, 135.697)), (' A 367  SER  OG ', ' A 368  ILE  N  ', -0.409, (155.272, 169.517, 138.158)), (' B 157  VAL  HB ', ' B 159  LYS  HD3', -0.409, (153.383, 112.784, 153.425)), (' B 219  ILE  O  ', ' B 220  ILE  HB ', -0.407, (124.156, 132.762, 149.712)), (' B 200  LEU  HB3', ' B 201  GLY  HA2', -0.407, (126.875, 126.57, 142.449)), (' B 345  LEU  HG ', ' B 345  LEU  O  ', -0.406, (132.133, 116.493, 147.47)), (' A 171  LEU HD13', ' A 176  PHE  HB2', -0.406, (148.542, 165.772, 151.884)), (' A 294  VAL  O  ', ' A 296  PRO  HD3', -0.403, (141.885, 155.475, 134.601)), (' A 157  VAL  O  ', ' A 158  ALA  C  ', -0.403, (135.109, 170.955, 153.466)), (' B 111  CYS  HA ', ' B 113  LYS  HE2', -0.403, (150.677, 127.629, 149.318)), (' B  91  PRO  HB3', ' B 159  LYS  HE3', -0.403, (151.618, 110.088, 153.159)), (' B  32  LYS  O  ', ' B  33  ALA  HB3', -0.401, (166.782, 111.358, 147.106))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
