# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', '  67 ', 'HIS', 0.008141348249599029, (139.78200000000007, 170.435, 142.162)), ('A', ' 189 ', 'VAL', 0.04581016019360594, (152.34800000000007, 148.699, 153.878)), ('A', ' 310 ', 'SER', 0.0003997131684140382, (149.01000000000005, 133.308, 141.816)), ('A', ' 371 ', 'ILE', 0.010364505129417459, (149.577, 177.046, 144.638)), ('B', '   3 ', 'ALA', 0.010641567523882435, (163.577, 97.088, 145.811)), ('B', '  17 ', 'GLU', 0.003492529437421091, (146.69500000000005, 115.82999999999996, 123.377)), ('B', '  86 ', 'GLY', 0.023268642843861608, (156.15300000000005, 102.047, 160.529)), ('B', ' 174 ', 'CYS', 0.04012632476036725, (141.94700000000006, 120.333, 145.805)), ('B', ' 231 ', 'LYS', 0.0050220278264393806, (121.23700000000002, 119.47499999999998, 139.46)), ('B', ' 269 ', 'ILE', 0.0015378100000000001, (135.052, 130.258, 136.86))]
data['omega'] = [('A', '  62 ', 'PRO', None, (131.81700000000004, 173.637, 127.566)), ('A', '  88 ', 'LYS', None, (137.48700000000005, 183.196, 160.071)), ('A', ' 104 ', 'LYS', None, (128.85900000000007, 154.49, 153.962)), ('A', ' 130 ', 'PHE', None, (127.32900000000006, 178.805, 136.761)), ('A', ' 141 ', 'LEU', None, (134.695, 169.096, 139.281)), ('A', ' 209 ', 'MET', None, (156.68000000000006, 158.601, 150.449)), ('A', ' 273 ', 'ASP', None, (150.117, 151.022, 129.597)), ('A', ' 310 ', 'SER', None, (147.765, 132.583, 141.988)), ('A', ' 321 ', 'GLY', None, (141.66300000000007, 161.69, 150.067)), ('A', ' 374 ', 'PHE', None, (143.97900000000007, 178.641, 140.186)), ('B', '   5 ', 'LYS', None, (160.332, 99.397, 141.687)), ('B', '  62 ', 'PRO', None, (154.015, 112.347, 127.70199999999998)), ('B', '  97 ', 'CYS', None, (152.92100000000005, 123.84600000000002, 147.739)), ('B', '  99 ', 'LYS', None, (157.754, 121.918, 152.554)), ('B', ' 100 ', 'CYS', None, (159.11200000000005, 123.985, 154.174)), ('B', ' 143 ', 'THR', None, (151.97800000000007, 115.635, 141.741)), ('B', ' 144 ', 'SER', None, (150.57300000000006, 113.06599999999999, 139.406)), ('B', ' 192 ', 'GLY', None, (126.33100000000003, 138.732, 156.956)), ('B', ' 269 ', 'ILE', None, (135.92100000000005, 130.665, 138.018)), ('B', ' 296 ', 'PRO', None, (142.425, 130.621, 130.981)), ('B', ' 324 ', 'SER', None, (150.28600000000006, 125.152, 153.21))]
data['rota'] = [('B', ' 314 ', 'TRP', 0.056514916004228026, (141.118, 141.506, 142.351))]
data['cbeta'] = [('A', '  93 ', 'PHE', ' ', 0.266300268162809, (137.345, 171.786, 147.066)), ('A', ' 209 ', 'MET', ' ', 0.27797166090844333, (155.586, 160.575, 151.687)), ('A', ' 314 ', 'TRP', ' ', 0.37479070255644215, (144.259, 144.442, 141.057)), ('A', ' 367 ', 'SER', ' ', 0.25367317621726854, (156.571, 172.538, 137.694)), ('B', ' 102 ', 'VAL', ' ', 0.26216118625422924, (156.34800000000007, 129.093, 152.43))]
data['probe'] = [(' B  96  GLN  HB2', ' B  97  CYS  HA ', -0.723, (153.034, 121.255, 147.894)), (' A 200  LEU  HB2', ' A 222  VAL HG11', -0.647, (158.337, 157.587, 140.863)), (' A 200  LEU  HB3', ' A 224  ILE HD11', -0.634, (159.946, 159.72, 138.981)), (' B  96  GLN  CB ', ' B  97  CYS  HA ', -0.62, (152.607, 121.752, 148.421)), (' B 110  PHE  CG ', ' B 111  CYS  N  ', -0.589, (150.239, 129.378, 148.579)), (' A  92  LEU  HB2', ' A 160  ILE HD11', -0.58, (140.331, 172.793, 153.052)), (' B 100  CYS  SG ', ' B 101  ARG  N  ', -0.567, (158.15, 125.688, 150.601)), (' B  99  LYS  N  ', ' B 100  CYS  HA ', -0.564, (158.429, 122.623, 152.102)), (' A 350  LEU  H  ', ' A 371  ILE HD12', -0.537, (151.636, 179.896, 141.247)), (' B 268  VAL  HB ', ' B 269  ILE HG22', -0.536, (135.381, 133.333, 136.777)), (' B 100  CYS  HB3', ' B 102  VAL HG22', -0.515, (156.605, 126.534, 153.107)), (' B 225  ASN  ND2', ' B 401  NAD  O6 ', -0.512, (127.606, 123.986, 133.628)), (' B 211  CYS  O  ', ' B 211  CYS  SG ', -0.496, (129.432, 132.031, 152.29)), (' A 200  LEU  HB2', ' A 222  VAL  CG1', -0.494, (158.802, 157.363, 140.853)), (' B 135  LYS  N  ', ' B 136  PRO  CD ', -0.49, (159.09, 103.198, 127.666)), (' B 269  ILE HG23', ' B 271  ARG  H  ', -0.486, (136.696, 131.53, 133.84)), (' A 319  PHE  HB2', ' A 321  GLY  O  ', -0.47, (140.897, 158.898, 148.69)), (' B  68  GLU  HG2', ' B 174  CYS  HB3', -0.467, (141.832, 117.981, 144.285)), (' A 186  VAL HG22', ' A 290  VAL HG21', -0.454, (147.874, 149.965, 146.801)), (' A 319  PHE  O  ', ' A 401  NAD  N7 ', -0.454, (142.548, 160.642, 144.504)), (' B  93  PHE  CD1', ' B  93  PHE  N  ', -0.453, (147.601, 113.314, 148.535)), (' B  99  LYS  N  ', ' B 100  CYS  CA ', -0.451, (158.322, 123.359, 152.489)), (' A 123  MET  O  ', ' A 124  GLN  C  ', -0.45, (123.169, 168.633, 140.974)), (' B 268  VAL  HB ', ' B 269  ILE  CG2', -0.443, (135.311, 132.943, 136.389)), (' A 227  ASP  N  ', ' A 227  ASP  OD1', -0.437, (162.997, 161.173, 129.72)), (' A 208  ILE  HA ', ' A 210  GLY  H  ', -0.436, (153.809, 158.236, 150.352)), (' B 107  GLU  O  ', ' B 323  LYS  NZ ', -0.435, (150.167, 132.88, 157.354)), (' A 178  THR HG23', ' A 319  PHE  CE1', -0.433, (145.493, 158.813, 145.014)), (' A 263  ASP  HB2', ' A 266  PHE  CE1', -0.432, (156.773, 145.157, 143.912)), (' A 109  ASN  N  ', ' A 109  ASN  OD1', -0.432, (136.324, 155.086, 149.25)), (' A 173  GLY  O  ', ' A 174  CYS  C  ', -0.429, (144.786, 165.372, 144.752)), (' A  93  PHE  CD1', ' A  93  PHE  N  ', -0.429, (138.074, 172.482, 148.501)), (' A 123  MET  HB2', ' A 127  THR  OG1', -0.428, (124.042, 172.01, 141.121)), (' A  68  GLU  HA ', ' A 173  GLY  HA3', -0.426, (142.906, 169.533, 144.99)), (' A   8  LYS  O  ', ' A  10  LYS  N  ', -0.424, (137.203, 186.906, 137.244)), (' A 328  VAL  N  ', ' A 329  PRO  CD ', -0.423, (138.745, 165.477, 156.885)), (' B 273  ASP  OD1', ' B 274  THR  N  ', -0.421, (133.91, 134.926, 130.953)), (' B  12  ALA  O  ', ' B  13  VAL  HB ', -0.418, (146.106, 107.166, 131.057)), (' A 207  VAL  O  ', ' A 209  MET  HB2', -0.415, (154.138, 160.468, 150.692)), (' B 297  ASP  N  ', ' B 297  ASP  OD1', -0.414, (144.393, 129.16, 127.366)), (' A 224  ILE HG22', ' A 225  ASN  N  ', -0.413, (160.59, 158.994, 133.728)), (' A 370  THR  C  ', ' A 371  ILE HG23', -0.41, (151.278, 175.49, 144.29)), (' A 371  ILE HG13', ' A 372  LEU  N  ', -0.409, (148.967, 178.299, 143.045)), (' B  38  ILE HG21', ' B  93  PHE  CZ ', -0.408, (149.621, 109.359, 148.623)), (' B 221  GLY  O  ', ' B 243  PRO  HA ', -0.407, (122.425, 131.417, 141.452)), (' A 348  HIS  O  ', ' A 371  ILE HG21', -0.406, (153.683, 177.039, 142.957)), (' A 250  ILE  O  ', ' A 251  GLN  HB2', -0.404, (162.913, 143.093, 130.767)), (' A 122  THR  OG1', ' A 123  MET  N  ', -0.404, (125.86, 170.413, 138.402)), (' A  43  THR  N  ', ' A 371  ILE  O  ', -0.402, (146.336, 177.418, 144.953)), (' A 196  ALA  HB3', ' A 266  PHE  CE2', -0.402, (156.879, 147.67, 142.509)), (' B 343  ASP  N  ', ' B 344  PRO  CD ', -0.4, (128.803, 115.995, 151.307))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
