# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = []
data['omega'] = [('A', '  62 ', 'PRO', None, (131.832, 173.4, 127.69800000000001)), ('B', '  62 ', 'PRO', None, (154.156, 112.64399999999996, 127.53099999999999))]
data['rota'] = [('A', '  25 ', 'GLU', 0.0, (134.514, 187.076, 132.959)), ('A', '  59 ', 'THR', 0.016319203132297844, (133.428, 165.66899999999998, 130.681)), ('A', ' 128 ', 'SER', 0.05379610800303527, (125.165, 174.91, 136.733)), ('A', ' 177 ', 'SER', 0.07183374930810764, (146.144, 162.681, 150.238)), ('A', ' 222 ', 'VAL', 0.10398412814929475, (160.741, 154.41399999999996, 138.743)), ('A', ' 268 ', 'VAL', 0.26698152614519743, (150.937, 156.551, 139.622)), ('A', ' 324 ', 'SER', 0.0, (136.977, 162.888, 152.338)), ('A', ' 357 ', 'GLU', 0.001908622446881465, (152.041, 179.02299999999997, 131.919)), ('A', ' 366 ', 'GLU', 0.11079587675420918, (159.717, 171.244, 135.181)), ('B', '  25 ', 'GLU', 0.0, (151.568, 98.962, 132.82)), ('B', '  59 ', 'THR', 0.016319203132297844, (152.565, 120.37199999999996, 130.528)), ('B', ' 128 ', 'SER', 0.05383488077829688, (160.916, 111.158, 136.5)), ('B', ' 177 ', 'SER', 0.07197595761274303, (140.031, 123.324, 150.207)), ('B', ' 222 ', 'VAL', 0.10876190230813669, (125.297, 131.542, 138.853)), ('B', ' 268 ', 'VAL', 0.2677730022691768, (135.116, 129.436, 139.637)), ('B', ' 324 ', 'SER', 0.0, (149.218, 123.146, 152.217)), ('B', ' 357 ', 'GLU', 0.0018769972080061976, (134.007, 106.95899999999996, 131.949)), ('B', ' 366 ', 'GLU', 0.11121601251408916, (126.339, 114.715, 135.284))]
data['cbeta'] = []
data['probe'] = [(' A 174  CYS  SG ', ' A 401  NAD  H5N', -1.208, (144.66, 164.481, 141.073)), (' B 174  CYS  SG ', ' B 401  NAD  H5N', -1.2, (140.974, 121.469, 141.197)), (' B 174  CYS  SG ', ' B 401  NAD  C5N', -0.96, (141.216, 122.497, 140.598)), (' A 174  CYS  SG ', ' A 401  NAD  C5N', -0.909, (144.83, 163.473, 140.751)), (' A 269  ILE HD13', ' A 401  NAD  C4A', -0.777, (155.048, 156.206, 133.471)), (' B 269  ILE HD13', ' B 401  NAD  C4A', -0.704, (130.782, 129.33, 133.172)), (' A 165  PRO  HD2', ' A 336  MET  HE1', -0.628, (148.333, 175.111, 157.571)), (' B 165  PRO  HD2', ' B 336  MET  HE1', -0.627, (137.9, 111.494, 157.627)), (' A 269  ILE HD13', ' A 401  NAD  N3A', -0.622, (155.922, 156.384, 133.766)), (' A 111  CYS  O  ', ' A 114  ASN  ND2', -0.591, (130.346, 158.512, 143.642)), (' B 111  CYS  O  ', ' B 114  ASN  ND2', -0.584, (155.764, 127.662, 143.453)), (' B 174  CYS  HA ', ' B 401  NAD  H5N', -0.583, (141.85, 122.112, 142.951)), (' A 154  GLU  O  ', ' A 325  LYS  NZ ', -0.572, (129.536, 168.597, 153.481)), (' B 269  ILE HD13', ' B 401  NAD  N3A', -0.556, (130.076, 129.623, 133.795)), (' B  83  VAL HG12', ' B 159  LYS  HB2', -0.549, (153.054, 112.634, 156.938)), (' B 154  GLU  O  ', ' B 325  LYS  NZ ', -0.546, (156.552, 117.368, 153.372)), (' B 173  GLY  HA2', ' B 319  PHE  HE1', -0.544, (144.068, 121.262, 147.613)), (' A 173  GLY  HA2', ' A 319  PHE  HE1', -0.54, (142.215, 165.221, 147.438)), (' A  83  VAL HG12', ' A 159  LYS  HB2', -0.539, (133.776, 173.601, 157.406)), (' B 369  ARG  NH1', ' B 401  NAD  O1N', -0.534, (135.834, 119.71, 140.032)), (' B  50  ASP  OD1', ' B 363  ARG  NH1', -0.533, (138.52, 115.625, 129.611)), (' A  50  ASP  OD1', ' A 363  ARG  NH1', -0.53, (147.598, 170.312, 129.509)), (' A 269  ILE  CD1', ' A 401  NAD  N3A', -0.529, (155.593, 156.0, 134.467)), (' A 313  THR HG23', ' B 315  LYS  HG2', -0.524, (143.407, 141.325, 146.248)), (' A  48  SER  OG ', ' A 174  CYS  SG ', -0.521, (143.813, 165.234, 139.355)), (' A 203  VAL HG23', ' A 401  NAD  O2N', -0.521, (150.165, 162.965, 140.724)), (' A 315  LYS  HG2', ' B 313  THR HG23', -0.52, (142.741, 145.22, 146.047)), (' B  47  ARG  HB3', ' B 401  NAD  H3D', -0.517, (137.718, 122.984, 136.854)), (' A 174  CYS  HA ', ' A 401  NAD  H5N', -0.504, (144.718, 163.856, 142.496)), (' B 198  PHE  HA ', ' B 222  VAL HG13', -0.503, (128.224, 132.526, 138.588)), (' B  48  SER  OG ', ' B 174  CYS  SG ', -0.502, (142.217, 120.671, 139.297)), (' A 198  PHE  HA ', ' A 222  VAL HG13', -0.498, (157.292, 153.388, 138.653)), (' A 267  GLU  HG3', ' A 275  MET  HA ', -0.496, (149.966, 150.685, 135.996)), (' B 100  CYS  HB2', ' B 112  LEU HD12', -0.489, (161.119, 130.772, 147.328)), (' A 269  ILE  CD1', ' A 401  NAD  C2A', -0.488, (155.669, 155.502, 134.307)), (' A 100  CYS  HB2', ' A 112  LEU HD12', -0.486, (125.138, 155.127, 147.613)), (' B 254  LEU  O  ', ' B 258  SER  OG ', -0.486, (123.838, 142.816, 142.724)), (' B 267  GLU  HG3', ' B 275  MET  HA ', -0.484, (136.1, 135.32, 136.146)), (' A  47  ARG  HB3', ' A 401  NAD  H3D', -0.482, (148.051, 163.478, 136.919)), (' B 174  CYS  CA ', ' B 401  NAD  H5N', -0.48, (141.482, 121.645, 142.803)), (' A 369  ARG  NH1', ' A 401  NAD  O1N', -0.477, (150.232, 166.161, 140.143)), (' B  26  VAL HG12', ' B 132  CYS  HB2', -0.477, (153.852, 103.751, 131.812)), (' A  31  PRO  HG3', ' A  37  ARG  HB2', -0.475, (127.392, 180.205, 147.303)), (' B 174  CYS  O  ', ' B 369  ARG  NH2', -0.473, (138.072, 120.431, 142.346)), (' A  26  VAL HG12', ' A 132  CYS  HB2', -0.471, (132.276, 182.259, 131.939)), (' B  31  PRO  HG3', ' B  37  ARG  HB2', -0.471, (158.421, 105.447, 147.021)), (' B 194  THR HG23', ' B 218  ARG  HB2', -0.466, (123.565, 138.575, 148.637)), (' B 269  ILE  CD1', ' B 401  NAD  N3A', -0.46, (130.357, 129.919, 134.547)), (' B 174  CYS  CB ', ' B 401  NAD  H5N', -0.458, (141.742, 121.371, 142.414)), (' A 194  THR HG23', ' A 218  ARG  HB2', -0.456, (162.556, 147.447, 148.461)), (' B 267  GLU  OE2', ' B 274  THR  OG1', -0.45, (134.58, 132.843, 134.585)), (' A 269  ILE HD11', ' A 401  NAD  C2A', -0.449, (155.856, 155.486, 134.778)), (' B 208  ILE HG23', ' B 219  ILE HG21', -0.446, (126.589, 129.774, 148.443)), (' B  64  ILE HG13', ' B 144  SER  HB3', -0.445, (151.521, 110.834, 137.169)), (' A 267  GLU  OE2', ' A 274  THR  OG1', -0.443, (151.487, 153.331, 134.527)), (' A 174  CYS  O  ', ' A 369  ARG  NH2', -0.442, (148.022, 165.514, 142.352)), (' A  64  ILE HG13', ' A 144  SER  HB3', -0.44, (134.576, 175.308, 137.331)), (' A   6  VAL HG22', ' A  30  PRO  HD3', -0.439, (123.513, 185.162, 141.373)), (' A 208  ILE HG23', ' A 219  ILE HG21', -0.436, (159.637, 155.755, 148.237)), (' B 115  ASP  HB3', ' B 141  LEU  HA ', -0.43, (153.543, 120.328, 139.216)), (' A  97  CYS  SG ', ' A  98  GLY  N  ', -0.43, (126.649, 160.204, 152.01)), (' B   6  VAL HG22', ' B  30  PRO  HD3', -0.425, (162.582, 101.247, 141.407)), (' A 200  LEU  HG ', ' A 223  ASP  HB2', -0.425, (159.627, 158.351, 138.629)), (' B 200  LEU  HG ', ' B 223  ASP  HB2', -0.423, (126.726, 127.347, 139.049)), (' A 283  GLN  HG2', ' A 286  TYR  CZ ', -0.423, (156.392, 137.679, 148.447)), (' B 203  VAL HG23', ' B 401  NAD  O2N', -0.421, (135.693, 122.857, 140.907)), (' A 105  HIS  ND1', ' A 107  GLU  O  ', -0.421, (133.421, 149.967, 152.931)), (' A 115  ASP  HB3', ' A 141  LEU  HA ', -0.421, (132.53, 165.686, 139.452)), (' B 122  THR  OG1', ' B 123  MET  N  ', -0.42, (160.576, 115.414, 138.115)), (' B  97  CYS  SG ', ' B  98  GLY  N  ', -0.419, (159.327, 125.83, 152.17)), (' B 283  GLN  HG2', ' B 286  TYR  CZ ', -0.419, (129.677, 148.189, 148.509)), (' B 223  ASP  OD1', ' B 224  ILE  N  ', -0.419, (126.264, 127.417, 134.575)), (' B 269  ILE  CD1', ' B 401  NAD  C2A', -0.418, (129.859, 130.319, 134.319)), (' A 174  CYS  CA ', ' A 401  NAD  H5N', -0.416, (144.597, 164.219, 142.866)), (' B  70  ALA  HB1', ' B 166  LEU HD22', -0.415, (143.298, 109.577, 152.18)), (' A 223  ASP  OD1', ' A 224  ILE  N  ', -0.414, (159.665, 158.507, 134.408)), (' B 113  LYS  HB3', ' B 124  GLN HE22', -0.414, (159.939, 122.624, 144.983)), (' A 269  ILE HG23', ' A 401  NAD  O4B', -0.41, (153.426, 158.732, 134.316)), (' A 251  GLN  HG2', ' A 277  THR HG23', -0.41, (156.622, 145.629, 133.762)), (' A 224  ILE HD12', ' A 244  GLN HE21', -0.409, (160.752, 156.052, 129.716)), (' A  70  ALA  HB1', ' A 166  LEU HD22', -0.408, (142.951, 176.536, 152.196)), (' B 105  HIS  O  ', ' B 323  LYS  NZ ', -0.407, (153.236, 132.28, 155.71)), (' A 122  THR  OG1', ' A 123  MET  N  ', -0.407, (125.496, 170.55, 138.33)), (' B 275  MET  HE1', ' B 295  PRO  HB3', -0.405, (141.783, 132.646, 133.565)), (' B 105  HIS  ND1', ' B 107  GLU  O  ', -0.404, (152.848, 135.973, 152.879)), (' A 113  LYS  HB3', ' A 124  GLN HE22', -0.404, (126.294, 163.842, 145.172)), (' A 275  MET  HE1', ' A 295  PRO  HB3', -0.4, (144.176, 153.318, 133.626)), (' B 251  GLN  HG2', ' B 277  THR HG23', -0.4, (129.315, 140.741, 133.939))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
