# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = []
data['omega'] = [('A', '  62 ', 'PRO', None, (131.334, 173.105, 127.55)), ('B', '  62 ', 'PRO', None, (154.409, 113.02199999999995, 127.47300000000001))]
data['rota'] = []
data['cbeta'] = []
data['probe'] = [(' B  68  GLU  HG2', ' B 174  CYS  HB3', -0.747, (142.235, 118.642, 143.599)), (' A 101  ARG HH21', ' B 283  GLN HE22', -0.62, (127.242, 150.34, 144.689)), (' B 115  ASP  HB3', ' B 141  LEU  HA ', -0.618, (154.366, 120.896, 138.861)), (' B  11  ALA  O  ', ' B  23  ILE  HA ', -0.604, (147.077, 103.146, 132.813)), (' A  35  GLU  OE2', ' A 129  ARG  NH2', -0.566, (122.937, 174.35, 143.166)), (' A 283  GLN HE22', ' B 101  ARG HH21', -0.565, (159.201, 135.653, 144.744)), (' B 354  LYS  O  ', ' B 357  GLU  HB3', -0.561, (134.978, 105.25, 133.541)), (' A  50  ASP  HA ', ' A  53  VAL HG12', -0.551, (145.163, 168.945, 130.491)), (' B 282  CYS  HB3', ' B 287  GLY  HA3', -0.544, (133.231, 144.684, 144.348)), (' B  92  LEU HD22', ' B 324  SER  HB3', -0.543, (149.397, 120.396, 150.726)), (' A 354  LYS  O  ', ' A 357  GLU  HB3', -0.542, (150.466, 180.272, 133.624)), (' A  47  ARG  HD3', ' A  50  ASP  HB3', -0.537, (147.887, 166.259, 132.93)), (' A  26  VAL HG12', ' A 132  CYS  HB2', -0.537, (131.924, 182.323, 132.28)), (' B  50  ASP  HA ', ' B  53  VAL HG12', -0.535, (141.184, 116.989, 130.136)), (' A 124  GLN HE22', ' A 155  ILE HD11', -0.532, (126.294, 164.849, 146.9)), (' A  92  LEU HD22', ' A 324  SER  HB3', -0.53, (136.506, 165.135, 150.749)), (' A 105  HIS  ND1', ' A 107  GLU  O  ', -0.529, (133.525, 149.301, 152.608)), (' A 282  CYS  HB3', ' A 287  GLY  HA3', -0.525, (152.736, 141.877, 144.129)), (' B 105  HIS  ND1', ' B 107  GLU  O  ', -0.521, (152.586, 136.594, 152.472)), (' A 140  PHE  H  ', ' A 144  SER  HB2', -0.519, (133.048, 172.127, 138.008)), (' B 140  PHE  H  ', ' B 144  SER  HB2', -0.518, (152.597, 114.381, 138.157)), (' B 116  LEU HD13', ' B 141  LEU HD21', -0.516, (150.19, 123.294, 138.558)), (' B 109  ASN  ND2', ' B 318  ILE  O  ', -0.508, (147.423, 128.64, 147.705)), (' A  16  GLU  HA ', ' A  61  LEU HD13', -0.506, (136.054, 170.838, 124.946)), (' B  26  VAL HG12', ' B 132  CYS  HB2', -0.501, (154.139, 104.137, 131.868)), (' A  37  ARG  NE ', ' A  74  GLU  OE2', -0.499, (129.071, 183.358, 146.673)), (' A  11  ALA  O  ', ' A  23  ILE  HA ', -0.491, (138.928, 182.436, 132.818)), (' A  43  THR HG23', ' A  69  ALA  HB2', -0.486, (141.464, 174.284, 143.518)), (' B  88  LYS  HD3', ' B 166  LEU HD21', -0.482, (143.657, 107.746, 155.209)), (' A   8  LYS  HG2', ' A  27  GLU  HG3', -0.481, (128.068, 188.601, 136.118)), (' B   1  SER  OG ', ' B   5  LYS  NZ ', -0.477, (157.423, 96.65, 148.452)), (' A 109  ASN  ND2', ' A 318  ILE  O  ', -0.474, (138.51, 157.4, 147.748)), (' B  48  SER  HB2', ' B  67  HIS  HE1', -0.472, (143.743, 119.213, 138.287)), (' B  15  TRP  HZ3', ' B 135  LYS  HD2', -0.469, (155.682, 107.21, 125.889)), (' B  44  GLY  N  ', ' B  68  GLU  O  ', -0.467, (141.533, 112.056, 143.541)), (' B  37  ARG  NE ', ' B  74  GLU  OE2', -0.464, (156.795, 102.026, 146.988)), (' A  40  MET  HE2', ' A 145  THR  HB ', -0.461, (138.427, 176.534, 143.775)), (' A  15  TRP  HZ3', ' A 135  LYS  HD2', -0.46, (130.385, 178.814, 125.712)), (' A 293  GLY  HA2', ' A 401  NAD  H1D', -0.46, (145.921, 158.702, 138.218)), (' A  88  LYS  HD3', ' A 166  LEU HD21', -0.453, (142.4, 177.781, 154.927)), (' A  44  GLY  N  ', ' A  68  GLU  O  ', -0.445, (144.409, 173.733, 143.52)), (' B  47  ARG  HG2', ' B 401  NAD H52N', -0.443, (137.037, 122.974, 135.748)), (' A 288  VAL HG22', ' A 313  THR  HB ', -0.443, (147.355, 142.68, 146.962)), (' B 293  GLY  HA2', ' B 401  NAD  H1D', -0.441, (140.359, 126.902, 138.304)), (' B  83  VAL HG12', ' B 159  LYS  HB2', -0.436, (153.134, 112.533, 157.204)), (' B  70  ALA  HB1', ' B 166  LEU HD22', -0.435, (143.552, 109.679, 152.32)), (' B 288  VAL HG22', ' B 313  THR  HB ', -0.434, (138.369, 143.142, 147.305)), (' A  67  HIS  HD1', ' A 140  PHE  HE2', -0.433, (139.572, 168.487, 138.255)), (' A 115  ASP  HB3', ' A 141  LEU  HA ', -0.431, (132.221, 165.522, 139.345)), (' B  89  VAL HG12', ' B 159  LYS  HA ', -0.43, (150.709, 112.364, 156.115)), (' B  47  ARG  NH2', ' B 362  LEU  O  ', -0.42, (133.14, 118.701, 133.4)), (' A  83  VAL HG12', ' A 159  LYS  HB2', -0.417, (133.208, 173.286, 157.466)), (' A 274  THR  HA ', ' A 277  THR  HB ', -0.417, (153.781, 148.886, 133.853)), (' B 164  SER  HB2', ' B 169  VAL HG21', -0.412, (139.938, 111.455, 156.155)), (' A  95  PRO  HB3', ' A 156  SER  HB3', -0.41, (130.604, 166.103, 147.227)), (' A  48  SER  HB2', ' A  67  HIS  CE1', -0.409, (142.201, 166.475, 138.57)), (' B  76  ILE HD11', ' B  80  VAL HG11', -0.408, (159.044, 110.1, 154.365)), (' A  40  MET  HB3', ' A  40  MET  HE3', -0.403, (139.521, 179.047, 144.773)), (' B  48  SER  HB2', ' B  67  HIS  CE1', -0.4, (144.017, 119.528, 138.507))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
