# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = []
data['omega'] = [('A', '  62 ', 'PRO', None, (131.97499999999994, 173.497, 127.74499999999996)), ('A', ' 215 ', 'GLY', None, (156.447, 152.587, 156.88099999999994)), ('A', ' 319 ', 'PHE', None, (141.272, 159.426, 146.28499999999997)), ('B', '  62 ', 'PRO', None, (153.984, 112.465, 127.74299999999997)), ('B', ' 215 ', 'GLY', None, (129.50799999999995, 133.368, 156.87999999999994)), ('B', ' 319 ', 'PHE', None, (144.68400000000005, 126.533, 146.283))]
data['rota'] = []
data['cbeta'] = []
data['probe'] = [(' A 309  LEU  CD1', ' B 295  PRO  CD ', -1.56, (145.026, 131.978, 135.552)), (' A 309  LEU  CD1', ' B 295  PRO  HD2', -1.547, (145.137, 131.835, 135.732)), (' A 295  PRO  CD ', ' B 309  LEU  CD1', -1.514, (140.97, 153.967, 135.718)), (' A 314  TRP  CZ3', ' B 303  MET  HE1', -1.5, (142.894, 143.666, 136.678)), (' A 303  MET  HE1', ' B 314  TRP  CZ3', -1.494, (143.255, 142.295, 136.548)), (' A 295  PRO  HD2', ' B 309  LEU  CD1', -1.489, (140.89, 154.125, 135.89)), (' A 303  MET  CE ', ' B 314  TRP  CZ3', -1.469, (143.385, 141.228, 135.38)), (' A 314  TRP  CZ3', ' B 303  MET  CE ', -1.461, (141.761, 145.43, 136.448)), (' A 303  MET  HE3', ' B 314  TRP  CH2', -1.447, (143.049, 139.2, 135.586)), (' A 314  TRP  CH2', ' B 303  MET  CE ', -1.447, (143.092, 145.719, 134.957)), (' A 295  PRO  CD ', ' B 309  LEU HD11', -1.439, (141.939, 154.539, 134.926)), (' A 309  LEU HD11', ' B 295  PRO  CD ', -1.437, (144.011, 131.525, 134.926)), (' A 314  TRP  CH2', ' B 303  MET  HE3', -1.43, (142.657, 146.81, 135.681)), (' A 303  MET  CE ', ' B 314  TRP  CH2', -1.424, (142.503, 139.795, 135.734)), (' A 352  PHE  HA ', ' A 372  LEU  CD1', -1.369, (147.222, 181.102, 138.041)), (' B 352  PHE  HA ', ' B 372  LEU  CD1', -1.358, (138.739, 104.927, 138.098)), (' A  69  ALA  O  ', ' A  91  PRO  HD2', -1.275, (140.725, 173.144, 147.201)), (' B  69  ALA  O  ', ' B  91  PRO  HD2', -1.252, (145.057, 112.992, 147.387)), (' A  40  MET  CE ', ' A 145  THR HG23', -1.219, (139.478, 176.741, 143.021)), (' B  40  MET  CE ', ' B 145  THR HG23', -1.212, (146.297, 109.067, 142.948)), (' A 316  GLY  O  ', ' B 311  GLY  HA2', -1.19, (140.431, 151.739, 144.114)), (' A 311  GLY  HA2', ' B 316  GLY  O  ', -1.177, (145.424, 134.319, 144.038)), (' A 272  LEU HD21', ' B 305  PRO  HG3', -1.163, (142.943, 150.856, 131.084)), (' A  73  VAL  CG1', ' A  76  ILE HG23', -1.152, (130.02, 179.502, 152.519)), (' A 303  MET  SD ', ' B 314  TRP  HZ3', -1.145, (143.815, 141.97, 135.635)), (' A 314  TRP  HZ3', ' B 303  MET  SD ', -1.138, (141.886, 144.07, 135.617)), (' B  73  VAL  CG1', ' B  76  ILE HG23', -1.131, (156.69, 106.524, 152.999)), (' A 305  PRO  HG3', ' B 272  LEU HD21', -1.126, (143.008, 135.2, 131.106)), (' A 295  PRO  CG ', ' B 309  LEU HD11', -1.123, (142.068, 153.625, 135.29)), (' B 284  GLU  HG2', ' B 312  ARG  NH1', -1.113, (132.339, 149.51, 139.976)), (' A 269  ILE HD11', ' A 274  THR HG21', -1.111, (152.685, 154.046, 132.892)), (' A 260  GLY  CA ', ' B 101  ARG  NH1', -1.104, (161.45, 137.398, 144.551)), (' A 301  LEU  N  ', ' B 303  MET  O  ', -1.103, (141.087, 147.359, 129.798)), (' A 309  LEU HD11', ' B 295  PRO  CG ', -1.102, (143.763, 131.95, 135.05)), (' B 352  PHE  CA ', ' B 372  LEU HD11', -1.102, (140.012, 103.99, 138.035)), (' A  73  VAL HG11', ' A  76  ILE  CG2', -1.099, (129.749, 177.829, 153.345)), (' A 352  PHE  CA ', ' A 372  LEU HD11', -1.097, (146.247, 182.001, 137.895)), (' A 303  MET  O  ', ' B 301  LEU  N  ', -1.096, (144.92, 138.483, 129.881)), (' A  69  ALA  O  ', ' A  91  PRO  CD ', -1.096, (139.812, 173.297, 147.339)), (' B  69  ALA  O  ', ' B  91  PRO  CD ', -1.096, (146.125, 112.607, 147.321)), (' A 284  GLU  HG2', ' A 312  ARG  NH1', -1.095, (153.687, 136.321, 139.902)), (' A 101  ARG  NH1', ' B 260  GLY  CA ', -1.094, (124.644, 148.517, 144.641)), (' B  73  VAL HG11', ' B  76  ILE  CG2', -1.092, (156.138, 108.059, 153.202)), (' B 186  VAL HG21', ' B 317  ALA  HB2', -1.088, (143.424, 132.899, 146.772)), (' B 284  GLU  CG ', ' B 312  ARG HH11', -1.084, (131.69, 150.224, 140.574)), (' B  66  GLY  O  ', ' B 145  THR  HB ', -1.083, (145.09, 112.008, 140.933)), (' A  40  MET  HE1', ' A 145  THR HG23', -1.083, (139.252, 176.235, 143.754)), (' A 186  VAL HG21', ' A 317  ALA  HB2', -1.077, (144.025, 153.125, 147.493)), (' A 260  GLY  HA3', ' B 101  ARG  NH1', -1.074, (161.596, 136.888, 145.685)), (' A 284  GLU  CG ', ' A 312  ARG HH11', -1.069, (154.363, 135.828, 140.762)), (' B  40  MET  HE1', ' B 145  THR HG23', -1.064, (146.446, 109.674, 144.169)), (' A  66  GLY  O  ', ' A 145  THR  HB ', -1.063, (140.356, 173.183, 140.517)), (' A 275  MET  SD ', ' A 291  ILE HD13', -1.062, (145.53, 150.863, 136.256)), (' A 303  MET  HE1', ' B 314  TRP  CH2', -1.053, (142.193, 140.366, 136.231)), (' A   8  LYS  HG2', ' A  27  GLU  HG2', -1.052, (129.552, 188.789, 135.742)), (' B 275  MET  SD ', ' B 291  ILE HD13', -1.051, (140.347, 135.573, 137.14)), (' B 269  ILE HD11', ' B 274  THR HG21', -1.05, (132.608, 130.904, 133.199)), (' A 101  ARG  NH1', ' B 260  GLY  HA3', -1.044, (124.231, 149.013, 145.785)), (' A 301  LEU  O  ', ' B 303  MET  N  ', -1.044, (141.224, 144.223, 129.172)), (' B 241  VAL HG13', ' B 246  TYR  HE1', -1.042, (120.954, 134.998, 136.421)), (' A 241  VAL HG13', ' A 246  TYR  HE1', -1.036, (165.179, 151.24, 136.232)), (' B 205  LEU HD12', ' B 368  ILE HG21', -1.027, (129.409, 120.339, 143.659)), (' A 303  MET  N  ', ' B 301  LEU  O  ', -1.027, (144.708, 142.151, 129.178)), (' A  73  VAL  CG1', ' A  76  ILE  CG2', -1.027, (130.218, 178.875, 152.808)), (' A   6  VAL HG22', ' A  30  PRO  HD3', -1.024, (123.803, 184.917, 140.877)), (' B  73  VAL  CG1', ' B  76  ILE  CG2', -1.022, (156.323, 107.538, 152.571)), (' B  95  PRO  O  ', ' B 111  CYS  SG ', -1.022, (154.217, 125.87, 148.353)), (' A 205  LEU HD12', ' A 368  ILE HG21', -1.021, (156.632, 166.396, 143.502)), (' B   8  LYS  HG2', ' B  27  GLU  HG2', -1.019, (156.286, 97.225, 135.637)), (' A  95  PRO  O  ', ' A 111  CYS  SG ', -1.015, (131.116, 160.858, 148.317)), (' A 314  TRP  CH2', ' B 303  MET  HE1', -1.014, (143.759, 145.561, 136.321)), (' A 272  LEU  CD2', ' B 305  PRO  HG3', -1.012, (143.383, 150.835, 131.381)), (' A 223  ASP  O  ', ' A 243  PRO  CD ', -1.011, (161.99, 155.145, 133.763)), (' B   6  VAL HG22', ' B  30  PRO  HD3', -1.008, (162.712, 101.417, 141.475)), (' A 305  PRO  HG3', ' B 272  LEU  CD2', -1.005, (142.568, 134.684, 131.382)), (' B  70  ALA  HB1', ' B 166  LEU HD22', -1.001, (143.608, 108.857, 151.787)), (' B 223  ASP  O  ', ' B 243  PRO  CD ', -0.999, (124.525, 130.363, 134.335)), (' B  66  GLY  O  ', ' B 145  THR  CB ', -0.986, (146.363, 112.159, 141.193)), (' A  66  GLY  O  ', ' A 145  THR  CB ', -0.986, (139.406, 173.638, 141.285)), (' B 284  GLU  HG2', ' B 312  ARG HH11', -0.983, (132.6, 150.382, 140.334)), (' A  70  ALA  HB1', ' A 166  LEU HD22', -0.97, (142.811, 176.723, 151.142)), (' A 284  GLU  HG2', ' A 312  ARG HH11', -0.969, (153.851, 135.576, 140.997)), (' A 314  TRP  HE3', ' B 314  TRP  HE3', -0.967, (143.004, 142.461, 138.45)), (' A 200  LEU HD13', ' A 232  ALA  HB2', -0.957, (161.478, 161.31, 142.617)), (' A 303  MET  O  ', ' B 301  LEU  HB3', -0.951, (144.333, 140.035, 130.724)), (' A 223  ASP  O  ', ' A 243  PRO  HD2', -0.949, (161.493, 155.772, 134.075)), (' B 200  LEU HD13', ' B 232  ALA  HB2', -0.948, (124.086, 124.559, 142.556)), (' A 301  LEU  HB3', ' B 303  MET  O  ', -0.947, (141.62, 145.995, 130.701)), (' A 189  VAL  O  ', ' A 214  ALA  HB1', -0.943, (152.584, 151.246, 155.732)), (' B  14  LEU  HB2', ' B  21  PHE  CE2', -0.938, (145.422, 111.779, 130.772)), (' B  92  LEU HD13', ' B 324  SER  HB3', -0.936, (149.009, 121.29, 151.445)), (' A  92  LEU HD13', ' A 324  SER  HB3', -0.934, (137.033, 165.549, 151.607)), (' B 189  VAL  O  ', ' B 214  ALA  HB1', -0.934, (133.157, 135.393, 155.507)), (' A  14  LEU  HB2', ' A  21  PHE  CE2', -0.932, (140.541, 173.633, 130.775)), (' B 205  LEU HD22', ' B 235  VAL HG21', -0.931, (127.207, 122.728, 146.206)), (' A 295  PRO  HD3', ' B 309  LEU HD11', -0.929, (143.037, 155.008, 136.04)), (' B 208  ILE HG22', ' B 235  VAL HG12', -0.925, (127.106, 126.953, 149.08)), (' A 309  LEU HD11', ' B 295  PRO  HD3', -0.924, (142.806, 131.338, 136.012)), (' B 223  ASP  O  ', ' B 243  PRO  HD2', -0.923, (124.377, 130.028, 134.015)), (' B 352  PHE  HA ', ' B 372  LEU HD11', -0.922, (139.462, 105.139, 138.108)), (' A 205  LEU HD22', ' A 235  VAL HG21', -0.922, (158.362, 163.538, 146.217)), (' A 352  PHE  HA ', ' A 372  LEU HD11', -0.917, (146.37, 180.637, 138.46)), (' B 168  LYS  HD3', ' B 335  PHE  HZ ', -0.917, (133.053, 112.2, 154.076)), (' A  73  VAL HG11', ' A  76  ILE HG21', -0.908, (129.266, 178.228, 154.101)), (' A 284  GLU  CG ', ' A 312  ARG  NH1', -0.906, (154.492, 135.857, 140.47)), (' A 168  LYS  HD3', ' A 335  PHE  HZ ', -0.906, (152.796, 173.891, 154.13)), (' A 295  PRO  HD2', ' B 309  LEU HD13', -0.903, (141.452, 155.859, 136.576)), (' B 186  VAL HG21', ' B 317  ALA  CB ', -0.902, (142.683, 132.258, 146.744)), (' B  69  ALA  HB2', ' B 145  THR HG21', -0.902, (143.997, 111.695, 143.798)), (' A 208  ILE HG22', ' A 235  VAL HG12', -0.899, (158.329, 159.784, 149.058)), (' A 303  MET  SD ', ' B 314  TRP  CZ3', -0.898, (144.557, 141.007, 136.551)), (' B  40  MET  HE3', ' B 145  THR HG23', -0.897, (145.386, 108.765, 143.184)), (' A 186  VAL HG21', ' A 317  ALA  CB ', -0.895, (143.024, 153.699, 146.82)), (' A 309  LEU HD12', ' B 295  PRO  HD2', -0.895, (145.53, 131.516, 135.463)), (' A 316  GLY  O  ', ' B 311  GLY  CA ', -0.894, (139.505, 151.286, 144.266)), (' A 311  GLY  CA ', ' B 316  GLY  O  ', -0.893, (146.291, 134.361, 144.04)), (' A  69  ALA  HB2', ' A 145  THR HG21', -0.892, (142.247, 174.747, 143.924)), (' B  93  PHE  CZ ', ' B 141  LEU HD13', -0.892, (149.487, 122.606, 139.234)), (' A  40  MET  HE3', ' A 145  THR HG23', -0.892, (140.702, 177.178, 143.29)), (' A 303  MET  O  ', ' B 301  LEU  CB ', -0.89, (143.791, 138.771, 130.546)), (' A 301  LEU  CB ', ' B 303  MET  O  ', -0.889, (141.59, 146.189, 130.619)), (' B  73  VAL HG11', ' B  76  ILE HG21', -0.888, (156.51, 108.067, 154.147)), (' A 208  ILE  CG2', ' A 235  VAL HG12', -0.888, (159.283, 159.429, 148.303)), (' B 208  ILE  CG2', ' B 235  VAL HG12', -0.888, (126.845, 126.467, 148.199)), (' B  26  VAL HG12', ' B 130  PHE  HD2', -0.882, (154.254, 104.416, 136.192)), (' A 295  PRO  HD2', ' B 309  LEU HD12', -0.88, (140.257, 154.907, 135.924)), (' A 260  GLY  HA2', ' B 101  ARG  NH1', -0.879, (162.419, 137.196, 144.542)), (' A  11  ALA  HB3', ' A  26  VAL HG21', -0.879, (135.941, 181.161, 134.175)), (' A 241  VAL HG13', ' A 246  TYR  CE1', -0.875, (165.308, 150.776, 135.708)), (' A  93  PHE  CZ ', ' A 141  LEU HD13', -0.874, (137.059, 163.191, 139.872)), (' A 309  LEU HD13', ' B 295  PRO  HD2', -0.872, (145.003, 130.481, 136.661)), (' B  11  ALA  HB3', ' B  26  VAL HG21', -0.871, (150.642, 105.174, 133.784)), (' B 284  GLU  CG ', ' B 312  ARG  NH1', -0.871, (131.395, 149.504, 140.329)), (' A 303  MET  HE3', ' B 314  TRP  HH2', -0.871, (143.507, 139.635, 134.799)), (' B  93  PHE  CE1', ' B 141  LEU HD13', -0.87, (150.051, 122.505, 140.145)), (' A  93  PHE  CE1', ' A 141  LEU HD13', -0.868, (135.906, 163.383, 140.086)), (' B 241  VAL HG13', ' B 246  TYR  CE1', -0.866, (120.526, 135.057, 135.716)), (' A 305  PRO  CG ', ' B 272  LEU HD21', -0.865, (143.95, 134.769, 131.554)), (' A 314  TRP  CZ3', ' B 303  MET  SD ', -0.865, (141.569, 144.988, 136.477)), (' A 314  TRP  HE3', ' B 314  TRP  CE3', -0.864, (143.201, 142.566, 138.209)), (' A  26  VAL HG12', ' A 130  PHE  HD2', -0.863, (131.598, 181.35, 136.063)), (' A 223  ASP  O  ', ' A 243  PRO  HD3', -0.859, (162.144, 155.513, 134.921)), (' B 223  ASP  O  ', ' B 243  PRO  HD3', -0.857, (123.061, 131.032, 134.756)), (' A 246  TYR  CZ ', ' A 253  VAL HG11', -0.855, (166.214, 148.572, 135.571)), (' A 272  LEU HD21', ' B 305  PRO  CG ', -0.853, (141.924, 150.396, 131.565)), (' B 246  TYR  CZ ', ' B 253  VAL HG11', -0.852, (119.968, 138.118, 136.084)), (' A 314  TRP  CE3', ' B 314  TRP  HE3', -0.851, (143.077, 143.351, 138.063)), (' A 295  PRO  HD3', ' B 309  LEU  CD1', -0.839, (142.175, 154.196, 137.026)), (' A  26  VAL  CG1', ' A 130  PHE  HD2', -0.837, (131.891, 181.024, 135.815)), (' B  26  VAL  CG1', ' B 130  PHE  HD2', -0.834, (154.071, 105.025, 135.795)), (' B  14  LEU  CD2', ' B  52  VAL HG12', -0.833, (146.631, 116.365, 129.879)), (' A 101  ARG  NH1', ' B 260  GLY  HA2', -0.832, (124.379, 148.636, 144.472)), (' A 269  ILE HD11', ' A 274  THR  CG2', -0.83, (153.481, 153.977, 132.682)), (' A 101  ARG HH11', ' B 260  GLY  HA3', -0.829, (124.997, 149.068, 145.532)), (' B  40  MET  CE ', ' B 145  THR  CG2', -0.828, (145.89, 109.7, 142.829)), (' B 187  ALA  HA ', ' B 288  VAL HG11', -0.823, (137.381, 138.41, 149.046)), (' A 309  LEU  CD1', ' B 295  PRO  HD3', -0.821, (143.759, 131.902, 136.888)), (' A 195  CYS  SG ', ' A 211  CYS  SG ', -0.821, (154.489, 152.286, 147.842)), (' B 269  ILE HD11', ' B 274  THR  CG2', -0.82, (132.474, 132.05, 132.76)), (' A  14  LEU  CD2', ' A  52  VAL HG12', -0.819, (139.301, 170.135, 129.619)), (' B  40  MET  HE3', ' B 145  THR  CG2', -0.818, (145.246, 109.21, 142.322)), (' A 260  GLY  HA3', ' B 101  ARG HH11', -0.811, (160.822, 136.93, 145.687)), (' A  40  MET  HE3', ' A 145  THR  CG2', -0.811, (140.496, 176.681, 142.258)), (' A 205  LEU HD22', ' A 235  VAL  CG2', -0.811, (159.608, 163.112, 146.968)), (' A 187  ALA  HA ', ' A 288  VAL HG11', -0.809, (148.228, 147.406, 148.968)), (' B 205  LEU HD22', ' B 235  VAL  CG2', -0.805, (126.407, 122.121, 146.962)), (' B 246  TYR  CE1', ' B 253  VAL HG11', -0.802, (120.315, 137.258, 135.348)), (' A 314  TRP  HH2', ' B 303  MET  HE3', -0.796, (142.578, 146.201, 134.822)), (' A 246  TYR  CG ', ' A 253  VAL HG21', -0.796, (165.522, 147.378, 133.328)), (' A 352  PHE  HA ', ' A 372  LEU HD12', -0.796, (147.729, 181.236, 138.991)), (' B   6  VAL  CG2', ' B  30  PRO  HD3', -0.792, (162.734, 100.93, 140.955)), (' A 198  PHE  CE2', ' A 274  THR  HB ', -0.792, (153.067, 152.834, 134.045)), (' B 246  TYR  CG ', ' B 253  VAL HG21', -0.792, (120.184, 137.709, 133.622)), (' A 246  TYR  CE1', ' A 253  VAL HG11', -0.791, (165.509, 148.804, 135.41)), (' B  53  VAL HG11', ' B 359  PHE  CZ ', -0.791, (139.158, 114.701, 128.199)), (' B 198  PHE  CE2', ' B 274  THR  HB ', -0.791, (132.402, 132.808, 134.103)), (' A  40  MET  CE ', ' A 145  THR  CG2', -0.789, (139.812, 176.337, 142.732)), (' B 352  PHE  HA ', ' B 372  LEU HD12', -0.787, (138.183, 104.588, 139.028)), (' A  53  VAL HG11', ' A 359  PHE  CZ ', -0.785, (146.779, 170.855, 128.195)), (' A 303  MET  HE2', ' B 301  LEU HD23', -0.782, (142.647, 140.683, 133.31)), (' A   6  VAL  CG2', ' A  30  PRO  HD3', -0.779, (123.307, 184.917, 140.877)), (' A  89  VAL  HB ', ' A 157  VAL  CG2', -0.778, (135.153, 173.405, 151.439)), (' A  96  GLN  NE2', ' A 324  SER  H  ', -0.773, (135.734, 160.703, 151.562)), (' A 269  ILE  CD1', ' A 274  THR HG21', -0.77, (152.999, 155.374, 132.804)), (' B 269  ILE  CD1', ' B 274  THR HG21', -0.77, (132.832, 130.612, 132.703)), (' B  96  GLN  NE2', ' B 324  SER  H  ', -0.769, (149.96, 124.801, 151.926)), (' A 352  PHE  CA ', ' A 372  LEU  CD1', -0.767, (146.454, 181.809, 139.357)), (' B  89  VAL  HB ', ' B 157  VAL  CG2', -0.766, (150.693, 112.708, 151.49)), (' A 301  LEU HD23', ' B 303  MET  HE2', -0.764, (143.761, 144.643, 133.964)), (' B 275  MET  HE2', ' B 291  ILE HG21', -0.761, (140.707, 132.769, 137.151)), (' B 195  CYS  SG ', ' B 211  CYS  SG ', -0.761, (131.182, 133.05, 148.179)), (' A  92  LEU  CD2', ' A 328  VAL HG21', -0.761, (139.668, 166.62, 151.891)), (' B  92  LEU  CD2', ' B 328  VAL HG21', -0.76, (146.99, 119.034, 151.413)), (' A 174  CYS  HA ', ' A 319  PHE  HE2', -0.758, (143.082, 165.093, 145.681)), (' A  48  SER  HB2', ' A  67  HIS  HE1', -0.758, (142.696, 166.724, 138.31)), (' B 275  MET  HE1', ' B 295  PRO  HG3', -0.756, (141.92, 132.708, 134.836)), (' A 275  MET  HE2', ' A 291  ILE HG21', -0.755, (145.43, 152.609, 137.16)), (' B  48  SER  HB2', ' B  67  HIS  HE1', -0.754, (143.262, 119.327, 138.308)), (' A  93  PHE  HB3', ' A 319  PHE  CZ ', -0.752, (139.47, 164.058, 145.544)), (' A 275  MET  HE1', ' A 295  PRO  HG3', -0.745, (144.398, 153.466, 135.228)), (' A  26  VAL  CG1', ' A 130  PHE  CD2', -0.745, (132.249, 180.198, 136.148)), (' B   9  CYS  HB2', ' B 148  GLN  HB2', -0.743, (148.696, 100.876, 140.218)), (' B  73  VAL HG12', ' B  76  ILE HG23', -0.743, (156.094, 105.821, 153.658)), (' B  93  PHE  HB3', ' B 319  PHE  CZ ', -0.741, (146.273, 121.745, 145.374)), (' B  26  VAL  CG1', ' B 130  PHE  CD2', -0.739, (153.965, 105.757, 136.054)), (' A   9  CYS  HB2', ' A 148  GLN  HB2', -0.737, (137.266, 185.05, 140.198)), (' A 303  MET  C  ', ' B 301  LEU  H  ', -0.733, (145.727, 140.073, 130.141)), (' B  66  GLY  O  ', ' B 145  THR  OG1', -0.732, (146.61, 112.971, 142.203)), (' B 174  CYS  HA ', ' B 319  PHE  HE2', -0.731, (142.875, 120.899, 145.634)), (' A  69  ALA  HB2', ' A 145  THR  CG2', -0.729, (140.944, 174.756, 143.414)), (' B 103  CYS  SG ', ' B 111  CYS  SG ', -0.728, (155.644, 127.626, 149.672)), (' A  66  GLY  O  ', ' A 145  THR  OG1', -0.727, (139.336, 173.267, 142.023)), (' A  73  VAL HG12', ' A  76  ILE HG23', -0.726, (130.116, 179.939, 153.482)), (' A 301  LEU  H  ', ' B 303  MET  C  ', -0.724, (140.07, 146.057, 130.09)), (' A 302  SER  HA ', ' B 301  LEU  O  ', -0.723, (143.768, 141.853, 128.65)), (' A 301  LEU  CA ', ' B 303  MET  O  ', -0.721, (141.875, 146.372, 129.91)), (' B 186  VAL  CG2', ' B 317  ALA  HB2', -0.721, (143.332, 132.99, 147.694)), (' B  69  ALA  HB2', ' B 145  THR  CG2', -0.718, (144.981, 111.161, 143.396)), (' A 303  MET  O  ', ' B 301  LEU  CA ', -0.717, (144.05, 139.551, 129.928)), (' A 301  LEU  O  ', ' B 302  SER  HA ', -0.715, (142.052, 144.07, 128.74)), (' A 170  CYS  SG ', ' A 371  ILE HD12', -0.713, (148.241, 174.141, 145.521)), (' B 170  CYS  SG ', ' B 371  ILE HD12', -0.712, (137.718, 111.959, 145.497)), (' B 348  HIS  HD2', ' B 367  SER  HB2', -0.708, (128.802, 112.613, 138.354)), (' A 200  LEU HD13', ' A 232  ALA  CB ', -0.707, (162.343, 160.362, 142.576)), (' B  68  GLU  HB2', ' B 174  CYS  SG ', -0.707, (140.855, 117.316, 142.904)), (' B 129  ARG  HG3', ' B 151  VAL  HB ', -0.704, (157.301, 109.143, 142.057)), (' A 129  ARG  HG3', ' A 151  VAL  HB ', -0.704, (128.194, 176.488, 141.641)), (' A 348  HIS  HD2', ' A 367  SER  HB2', -0.702, (156.795, 172.762, 138.103)), (' A 103  CYS  SG ', ' A 111  CYS  SG ', -0.702, (130.441, 158.252, 149.706)), (' B 180  TYR  CE1', ' B 340  PHE  HE2', -0.699, (133.844, 125.063, 155.715)), (' A 186  VAL  CG2', ' A 317  ALA  HB2', -0.698, (142.912, 152.926, 147.783)), (' A  68  GLU  HB2', ' A 174  CYS  SG ', -0.697, (144.368, 169.02, 142.896)), (' B 352  PHE  CA ', ' B 372  LEU  CD1', -0.696, (139.901, 104.382, 139.472)), (' A 267  GLU  HG2', ' A 275  MET  HG2', -0.692, (148.454, 152.178, 136.784)), (' A 314  TRP  CE3', ' B 308  LEU HD21', -0.691, (142.072, 144.868, 138.6)), (' B  93  PHE  CD1', ' B  93  PHE  O  ', -0.691, (150.616, 121.085, 143.653)), (' A 180  TYR  CE1', ' A 340  PHE  HE2', -0.689, (152.119, 160.402, 155.423)), (' A 308  LEU HD21', ' B 314  TRP  CE3', -0.689, (144.439, 141.333, 138.937)), (' B 267  GLU  HG2', ' B 275  MET  HG2', -0.688, (137.568, 133.77, 136.952)), (' A  90  ILE HG12', ' A 160  ILE HG21', -0.685, (140.941, 171.976, 154.223)), (' A  93  PHE  CD1', ' A  93  PHE  O  ', -0.684, (135.32, 164.636, 143.672)), (' B  92  LEU HD21', ' B 328  VAL HG21', -0.683, (146.817, 118.389, 151.89)), (' A  92  LEU HD21', ' A 328  VAL HG21', -0.683, (139.637, 167.093, 152.307)), (' B  90  ILE HG12', ' B 160  ILE HG21', -0.681, (144.982, 114.287, 154.216)), (' A  43  THR  HB ', ' A 372  LEU  HB3', -0.68, (145.19, 177.276, 141.259)), (' A 205  LEU HD12', ' A 368  ILE  CG2', -0.68, (156.144, 165.935, 143.354)), (' A 200  LEU  CD2', ' A 208  ILE HD11', -0.68, (159.345, 158.301, 144.106)), (' B  43  THR  HB ', ' B 372  LEU  HB3', -0.679, (140.696, 108.779, 141.317)), (' A 282  CYS  HB3', ' A 287  GLY  HA3', -0.677, (152.186, 142.349, 143.471)), (' B 282  CYS  HB3', ' B 287  GLY  HA3', -0.674, (133.74, 144.201, 144.191)), (' B 200  LEU  CD2', ' B 208  ILE HD11', -0.674, (127.019, 127.537, 144.025)), (' B   6  VAL HG22', ' B  30  PRO  CD ', -0.674, (162.036, 102.05, 141.269)), (' A 316  GLY  HA3', ' B 308  LEU  O  ', -0.67, (141.072, 150.706, 141.389)), (' A 308  LEU  O  ', ' B 316  GLY  HA3', -0.67, (144.513, 134.99, 141.841)), (' A  46  CYS  SG ', ' A 174  CYS  SG ', -0.67, (145.256, 168.152, 141.967)), (' B 200  LEU HD13', ' B 232  ALA  CB ', -0.666, (123.672, 124.871, 142.57)), (' B  28  VAL HG22', ' B 130  PHE  CE2', -0.666, (153.812, 105.048, 138.55)), (' B  26  VAL HG11', ' B 130  PHE  CD2', -0.665, (153.738, 105.92, 135.979)), (' B  36  VAL HG13', ' B  73  VAL HG13', -0.664, (155.289, 107.276, 151.711)), (' A 200  LEU  CD1', ' A 232  ALA  HB2', -0.66, (161.657, 160.238, 142.035)), (' A  28  VAL HG22', ' A 130  PHE  CE2', -0.655, (131.686, 181.043, 138.835)), (' B  46  CYS  SG ', ' B 174  CYS  SG ', -0.655, (141.068, 117.729, 142.704)), (' A 345  LEU  O  ', ' A 369  ARG  HB3', -0.653, (154.074, 170.241, 143.453)), (' B 345  LEU  O  ', ' B 369  ARG  HB3', -0.652, (131.864, 115.4, 143.446)), (' A 314  TRP  CE3', ' B 314  TRP  CE3', -0.652, (143.398, 143.231, 137.99)), (' A  36  VAL HG13', ' A  73  VAL HG13', -0.651, (130.412, 178.62, 151.813)), (' A 241  VAL  CG1', ' A 246  TYR  HE1', -0.65, (164.815, 150.565, 136.203)), (' A 167  GLU  HG3', ' A 371  ILE HG21', -0.649, (149.736, 178.117, 146.941)), (' B 241  VAL  CG1', ' B 246  TYR  HE1', -0.648, (121.116, 135.249, 136.185)), (' A  26  VAL HG11', ' A 130  PHE  CD2', -0.647, (132.732, 180.289, 135.712)), (' B 275  MET  SD ', ' B 291  ILE  CD1', -0.647, (139.919, 135.702, 136.992)), (' B 251  GLN  HG3', ' B 280  SER  HB2', -0.644, (131.017, 143.168, 135.09)), (' B 167  GLU  HG3', ' B 371  ILE HG21', -0.643, (136.223, 107.768, 146.86)), (' A  56  THR HG23', ' A 296  PRO  HA ', -0.643, (142.965, 158.655, 129.612)), (' A 198  PHE  HE2', ' A 269  ILE HD11', -0.642, (153.531, 154.467, 133.942)), (' A 251  GLN  HG3', ' A 280  SER  HB2', -0.641, (155.44, 142.605, 134.766)), (' A 309  LEU HD13', ' B 295  PRO  CD ', -0.641, (144.304, 130.247, 136.755)), (' A 295  PRO  CG ', ' B 309  LEU  CD1', -0.641, (141.568, 153.71, 135.236)), (' B 198  PHE  HE2', ' B 269  ILE HD11', -0.641, (132.309, 131.485, 133.873)), (' B 180  TYR  CE1', ' B 340  PHE  CE2', -0.641, (134.391, 124.804, 155.444)), (' A   6  VAL HG22', ' A  30  PRO  CD ', -0.64, (123.925, 183.88, 141.173)), (' B 178  THR  CG2', ' B 292  VAL  HB ', -0.64, (140.131, 127.314, 143.363)), (' B 205  LEU  CD1', ' B 368  ILE HG21', -0.64, (128.826, 119.829, 143.892)), (' B 205  LEU HD12', ' B 368  ILE  CG2', -0.639, (129.814, 120.118, 143.331)), (' A 348  HIS  CD2', ' A 367  SER  HB2', -0.638, (157.263, 173.437, 137.695)), (' A 203  VAL HG12', ' A 268  VAL  CG1', -0.638, (150.862, 158.31, 142.045)), (' B 203  VAL HG12', ' B 268  VAL  CG1', -0.638, (134.877, 127.578, 142.11)), (' A 276  VAL  CG2', ' A 301  LEU HD11', -0.636, (147.691, 146.497, 131.298)), (' A 180  TYR  CE1', ' A 340  PHE  CE2', -0.636, (151.307, 161.178, 155.596)), (' B 276  VAL HG23', ' B 301  LEU HD11', -0.636, (138.399, 139.301, 131.795)), (' B  56  THR HG23', ' B 296  PRO  HA ', -0.635, (143.414, 127.645, 129.507)), (' A 327  SER  O  ', ' A 331  LEU  HG ', -0.634, (142.328, 163.549, 156.717)), (' B 246  TYR  CD2', ' B 253  VAL HG21', -0.633, (119.708, 138.367, 133.417)), (' A 276  VAL HG23', ' A 301  LEU HD11', -0.633, (147.245, 146.759, 131.238)), (' B 182  SER  HB3', ' B 292  VAL HG11', -0.629, (138.574, 130.18, 146.002)), (' B 222  VAL HG13', ' B 250  ILE  CD1', -0.629, (125.97, 133.612, 135.914)), (' A 205  LEU  CD1', ' A 368  ILE HG21', -0.628, (157.058, 166.006, 143.834)), (' B 348  HIS  CD2', ' B 367  SER  HB2', -0.627, (129.026, 112.321, 137.858)), (' A 182  SER  HB3', ' A 292  VAL HG11', -0.626, (147.381, 155.706, 145.96)), (' B 276  VAL  CG2', ' B 301  LEU HD11', -0.626, (138.774, 139.579, 131.017)), (' A 178  THR  CG2', ' A 292  VAL  HB ', -0.626, (145.694, 158.618, 143.469)), (' A 222  VAL HG13', ' A 250  ILE  CD1', -0.626, (160.487, 151.978, 135.704)), (' A 246  TYR  CD2', ' A 253  VAL HG21', -0.626, (166.286, 147.513, 133.446)), (' A 174  CYS  HA ', ' A 319  PHE  CE2', -0.626, (142.849, 164.317, 146.343)), (' B  72  ILE HG22', ' B  88  LYS  HG2', -0.625, (147.127, 105.62, 154.536)), (' A 275  MET  HE2', ' A 291  ILE  CG2', -0.625, (145.379, 153.381, 137.998)), (' B 246  TYR  CZ ', ' B 253  VAL  CG1', -0.622, (119.776, 138.295, 136.091)), (' A  92  LEU  CD1', ' A 324  SER  HB3', -0.621, (136.272, 165.635, 151.611)), (' B 243  PRO  HG3', ' B 250  ILE HD12', -0.621, (124.815, 134.247, 134.32)), (' B 327  SER  O  ', ' B 331  LEU  HG ', -0.62, (143.061, 122.266, 156.553)), (' A  35  GLU  OE1', ' A 123  MET  HE2', -0.62, (127.167, 173.773, 144.484)), (' B 200  LEU  CD1', ' B 232  ALA  HB2', -0.62, (124.17, 125.777, 142.095)), (' B 168  LYS  HD3', ' B 335  PHE  CZ ', -0.617, (133.314, 113.071, 154.195)), (' A 309  LEU  CD1', ' B 295  PRO  CG ', -0.617, (144.314, 132.552, 135.476)), (' B 174  CYS  HA ', ' B 319  PHE  CE2', -0.616, (143.207, 121.567, 146.17)), (' B  37  ARG  HB3', ' B  75  SER  HB3', -0.615, (157.698, 103.708, 148.547)), (' A 246  TYR  CZ ', ' A 253  VAL  CG1', -0.615, (166.178, 147.647, 135.973)), (' B 275  MET  HE2', ' B 291  ILE  CG2', -0.614, (140.576, 132.48, 137.976)), (' A 168  LYS  HD3', ' A 335  PHE  CZ ', -0.613, (152.717, 172.884, 154.354)), (' A 171  LEU HD12', ' A 342  LEU  HB3', -0.613, (152.519, 170.167, 150.777)), (' B 168  LYS  CD ', ' B 335  PHE  HZ ', -0.613, (133.538, 112.068, 154.071)), (' A  72  ILE HG22', ' A  88  LYS  HG2', -0.613, (139.157, 180.494, 154.414)), (' B  35  GLU  OE1', ' B 123  MET  HE2', -0.613, (159.185, 112.523, 144.592)), (' A  44  GLY  HA3', ' A  68  GLU  OE1', -0.612, (146.534, 171.908, 142.932)), (' B  44  GLY  HA3', ' B  68  GLU  CD ', -0.612, (139.478, 113.995, 143.446)), (' B  46  CYS  O  ', ' B  49  ASP  HB2', -0.61, (139.702, 116.519, 135.84)), (' B 171  LEU HD12', ' B 342  LEU  HB3', -0.61, (133.853, 115.699, 150.416)), (' A 120  ARG HH12', ' A 124  GLN  HA ', -0.61, (124.939, 166.279, 141.37)), (' B 120  ARG HH12', ' B 124  GLN  HA ', -0.61, (160.941, 119.663, 141.405)), (' A 171  LEU HD13', ' A 345  LEU HD12', -0.609, (152.124, 168.558, 148.972)), (' A  37  ARG  HB3', ' A  75  SER  HB3', -0.609, (128.264, 182.219, 148.612)), (' B  94  THR  H  ', ' B 319  PHE  HE1', -0.609, (148.02, 121.763, 146.58)), (' A  94  THR  H  ', ' A 319  PHE  HE1', -0.609, (137.396, 163.939, 146.452)), (' A  44  GLY  HA3', ' A  68  GLU  CD ', -0.607, (147.107, 171.514, 143.559)), (' A  29  ALA  HB1', ' A  30  PRO  HD2', -0.605, (122.973, 182.614, 140.85)), (' B  44  GLY  HA3', ' B  68  GLU  OE1', -0.605, (139.424, 114.06, 142.822)), (' A  46  CYS  O  ', ' A  49  ASP  HB2', -0.604, (146.207, 169.306, 135.803)), (' A 275  MET  SD ', ' A 291  ILE  CD1', -0.603, (145.914, 150.097, 136.896)), (' A 129  ARG  HG3', ' A 151  VAL  CB ', -0.6, (128.299, 177.233, 142.335)), (' B 129  ARG  HG3', ' B 151  VAL  CB ', -0.599, (157.575, 108.778, 142.274)), (' A 260  GLY  HA2', ' B 101  ARG HH12', -0.599, (162.016, 136.478, 144.623)), (' A 243  PRO  HG3', ' A 250  ILE HD12', -0.599, (160.664, 152.051, 133.958)), (' B  29  ALA  HB1', ' B  30  PRO  HD2', -0.598, (162.769, 103.177, 140.763)), (' B 171  LEU HD13', ' B 345  LEU HD12', -0.595, (133.337, 117.614, 148.783)), (' A   7  ILE  CD1', ' A  37  ARG  NH2', -0.593, (130.651, 185.77, 145.861)), (' B  47  ARG  HA ', ' B 362  LEU HD21', -0.593, (137.501, 118.623, 134.982)), (' A  47  ARG  HA ', ' A 362  LEU HD21', -0.592, (148.333, 167.436, 135.07)), (' B  96  GLN  HG3', ' B 325  LYS  H  ', -0.591, (151.438, 123.222, 153.518)), (' A  96  GLN  HG3', ' A 325  LYS  H  ', -0.591, (134.275, 162.883, 153.481)), (' A 109  ASN  ND2', ' A 318  ILE  O  ', -0.589, (139.296, 157.15, 147.646)), (' A  48  SER  HB2', ' A  67  HIS  CE1', -0.589, (142.148, 166.612, 138.807)), (' B 187  ALA  HA ', ' B 288  VAL  CG1', -0.589, (137.622, 138.185, 148.659)), (' A 168  LYS  CD ', ' A 335  PHE  HZ ', -0.588, (152.549, 173.958, 154.133)), (' A 260  GLY  CA ', ' B 101  ARG HH11', -0.587, (161.064, 136.911, 145.197)), (' A 185  LYS  HB2', ' A 320  GLY  O  ', -0.587, (144.18, 154.435, 151.481)), (' B   7  ILE  CD1', ' B  37  ARG  NH2', -0.586, (154.937, 100.202, 146.341)), (' B 185  LYS  HB2', ' B 320  GLY  O  ', -0.584, (142.227, 131.553, 150.984)), (' B 238  THR HG22', ' B 239  GLU  HG3', -0.584, (118.27, 133.999, 146.639)), (' B 109  ASN  ND2', ' B 318  ILE  O  ', -0.583, (147.17, 128.295, 147.292)), (' A  50  ASP  HA ', ' A 359  PHE  HE1', -0.581, (146.397, 169.01, 131.107)), (' A  93  PHE  HB3', ' A 319  PHE  CE1', -0.581, (139.233, 164.05, 145.715)), (' A 238  THR HG22', ' A 239  GLU  HG3', -0.58, (167.685, 152.057, 146.621)), (' A 280  SER  OG ', ' A 307  LEU HD11', -0.58, (152.048, 141.318, 134.641)), (' B  69  ALA  HB3', ' B  91  PRO  HG2', -0.579, (146.637, 112.197, 145.654)), (' A 284  GLU  HG3', ' A 312  ARG  NH1', -0.579, (154.816, 136.324, 141.211)), (' A 181  GLY  HA3', ' A 320  GLY  HA3', -0.579, (145.265, 157.748, 150.03)), (' B 280  SER  OG ', ' B 307  LEU HD11', -0.579, (133.836, 145.351, 134.874)), (' B 153  ASP  O  ', ' B 157  VAL HG12', -0.578, (155.274, 114.29, 149.883)), (' A 229  PHE  CE1', ' A 240  CYS  HB3', -0.578, (165.082, 157.363, 139.925)), (' B 181  GLY  HA3', ' B 320  GLY  HA3', -0.578, (140.69, 128.178, 150.006)), (' B 200  LEU  O  ', ' B 368  ILE HD12', -0.576, (128.457, 121.852, 141.02)), (' B  90  ILE HG22', ' B  92  LEU HD23', -0.574, (146.693, 116.685, 149.525)), (' A 205  LEU  CD2', ' A 235  VAL HG21', -0.574, (158.377, 163.099, 146.198)), (' B  93  PHE  HB3', ' B 319  PHE  CE1', -0.574, (146.871, 122.168, 145.599)), (' A 200  LEU  O  ', ' A 368  ILE HD12', -0.573, (157.5, 164.564, 141.257)), (' A 187  ALA  HA ', ' A 288  VAL  CG1', -0.571, (148.22, 147.787, 148.607)), (' A  69  ALA  HB3', ' A  91  PRO  HG2', -0.571, (139.605, 174.433, 145.471)), (' A 153  ASP  O  ', ' A 157  VAL HG12', -0.57, (130.775, 171.707, 149.741)), (' A 101  ARG HH12', ' B 260  GLY  HA2', -0.57, (123.492, 149.228, 144.947)), (' A 102  VAL HG13', ' B 285  ALA  HB2', -0.569, (132.103, 152.211, 148.702)), (' B  50  ASP  HA ', ' B 359  PHE  HE1', -0.568, (139.696, 116.914, 130.94)), (' B 229  PHE  CE1', ' B 240  CYS  HB3', -0.567, (121.229, 128.266, 139.604)), (' B  92  LEU  CD1', ' B 324  SER  HB3', -0.567, (149.428, 120.328, 151.509)), (' B 177  SER  OG ', ' B 319  PHE  HB3', -0.567, (143.45, 124.577, 149.169)), (' A 207  VAL HG11', ' A 266  PHE  CB ', -0.566, (152.781, 153.948, 144.766)), (' A 302  SER  CA ', ' B 301  LEU  O  ', -0.566, (144.047, 142.809, 128.745)), (' A 260  GLY  HA3', ' B 101  ARG  CZ ', -0.564, (162.038, 137.544, 146.403)), (' A 311  GLY  HA2', ' B 316  GLY  C  ', -0.564, (145.392, 134.447, 143.794)), (' A 153  ASP  OD1', ' A 155  ILE  N  ', -0.563, (128.02, 168.257, 149.762)), (' A 301  LEU  O  ', ' B 302  SER  CA ', -0.562, (141.636, 143.504, 128.68)), (' A 177  SER  OG ', ' A 319  PHE  HB3', -0.561, (142.584, 161.964, 149.317)), (' A 347  THR HG22', ' A 348  HIS  CD2', -0.56, (158.836, 173.69, 139.916)), (' A  90  ILE HG22', ' A  92  LEU HD23', -0.56, (139.441, 168.737, 149.458)), (' A 275  MET  CE ', ' A 291  ILE HG21', -0.559, (145.0, 152.861, 137.065)), (' A 307  LEU  O  ', ' A 312  ARG  HG2', -0.559, (149.164, 137.656, 140.463)), (' B 207  VAL HG11', ' B 266  PHE  CB ', -0.557, (133.314, 131.412, 144.845)), (' B 168  LYS  HE2', ' B 343  ASP  OD1', -0.556, (130.077, 111.566, 152.373)), (' B 347  THR HG22', ' B 348  HIS  CD2', -0.555, (127.454, 112.268, 139.491)), (' B 307  LEU  O  ', ' B 312  ARG  HG2', -0.554, (136.657, 148.409, 140.523)), (' A 285  ALA  HB2', ' B 102  VAL HG13', -0.553, (153.741, 133.614, 148.629)), (' B 140  PHE  O  ', ' B 141  LEU HD23', -0.552, (152.17, 119.59, 136.927)), (' B  48  SER  HB2', ' B  67  HIS  CE1', -0.552, (143.809, 119.276, 138.762)), (' A 168  LYS  HE2', ' A 343  ASP  OD1', -0.552, (155.412, 174.523, 152.629)), (' B  11  ALA  HB3', ' B  26  VAL  CG2', -0.552, (150.549, 104.004, 134.11)), (' B  46  CYS  SG ', ' B  68  GLU  HB2', -0.551, (141.104, 116.299, 142.042)), (' A  69  ALA  C  ', ' A  91  PRO  HD2', -0.551, (140.619, 173.608, 147.427)), (' B  40  MET  HG2', ' B 374  PHE  CE1', -0.551, (144.042, 105.666, 142.604)), (' A 303  MET  H  ', ' B 301  LEU  C  ', -0.549, (143.857, 140.89, 129.398)), (' A 346  ILE  O  ', ' A 346  ILE HG22', -0.548, (155.485, 175.023, 145.234)), (' A  46  CYS  SG ', ' A  68  GLU  HB2', -0.548, (144.734, 169.54, 142.034)), (' B 205  LEU  CD2', ' B 235  VAL HG21', -0.548, (127.58, 122.96, 146.217)), (' A  40  MET  HG2', ' A 374  PHE  CE1', -0.548, (141.629, 179.89, 142.838)), (' B 275  MET  CE ', ' B 291  ILE HG21', -0.547, (140.955, 133.203, 137.064)), (' A 140  PHE  O  ', ' A 141  LEU HD23', -0.546, (133.494, 166.082, 137.415)), (' B  69  ALA  C  ', ' B  91  PRO  HD2', -0.545, (145.437, 112.314, 147.358)), (' A  73  VAL HG13', ' A  76  ILE  CG2', -0.544, (130.098, 178.895, 152.58)), (' A 301  LEU  C  ', ' B 303  MET  H  ', -0.544, (142.121, 144.899, 129.225)), (' B 176  PHE  HA ', ' B 206  SER  OG ', -0.543, (135.79, 122.387, 148.332)), (' A 101  ARG  CZ ', ' B 260  GLY  HA3', -0.543, (124.08, 148.536, 146.453)), (' B  96  GLN  HG2', ' B 324  SER  HB2', -0.543, (151.587, 123.071, 151.434)), (' B 284  GLU  HG3', ' B 312  ARG  NH1', -0.543, (131.082, 149.241, 141.48)), (' B 180  TYR  CZ ', ' B 340  PHE  CZ ', -0.542, (135.94, 124.876, 156.524)), (' A 176  PHE  HA ', ' A 206  SER  OG ', -0.542, (150.601, 163.537, 148.039)), (' A  43  THR HG23', ' A 145  THR HG21', -0.542, (141.917, 175.022, 142.268)), (' A 314  TRP  CE3', ' B 308  LEU  CD2', -0.541, (141.965, 145.469, 138.999)), (' A 198  PHE  HE2', ' A 269  ILE  CD1', -0.54, (154.028, 154.58, 133.947)), (' A 314  TRP  CD2', ' B 308  LEU  CD2', -0.54, (142.806, 145.529, 139.226)), (' A 180  TYR  CZ ', ' A 340  PHE  CZ ', -0.538, (150.203, 161.093, 156.417)), (' A  43  THR HG23', ' A 145  THR  CG2', -0.538, (142.326, 175.09, 141.979)), (' B 346  ILE  O  ', ' B 346  ILE HG22', -0.537, (130.359, 110.713, 145.178)), (' A 308  LEU  CD2', ' B 314  TRP  CD2', -0.536, (143.109, 140.36, 139.265)), (' B 207  VAL HG11', ' B 266  PHE  HB2', -0.536, (132.925, 131.488, 144.833)), (' A 352  PHE  CD2', ' A 374  PHE  HA ', -0.535, (144.772, 184.802, 142.285)), (' A  90  ILE  CG2', ' A  92  LEU HD23', -0.535, (139.826, 169.211, 149.874)), (' B 251  GLN  HG3', ' B 280  SER  CB ', -0.534, (130.411, 143.624, 134.966)), (' A  96  GLN  HG2', ' A 324  SER  HB2', -0.534, (134.661, 163.353, 151.614)), (' A  12  ALA  HB3', ' A 146  PHE  HB3', -0.534, (140.897, 177.856, 135.385)), (' B 352  PHE  CD2', ' B 374  PHE  HA ', -0.531, (141.191, 101.263, 142.283)), (' B  43  THR HG23', ' B 145  THR HG21', -0.53, (144.017, 111.013, 142.283)), (' A 251  GLN  HG3', ' A 280  SER  CB ', -0.53, (155.108, 142.151, 135.064)), (' B  64  ILE HG13', ' B 137  ILE HG21', -0.529, (152.551, 108.864, 133.088)), (' A 309  LEU  CD2', ' B 293  GLY  O  ', -0.529, (142.597, 131.191, 138.324)), (' A 145  THR  O  ', ' A 147  SER  N  ', -0.527, (138.99, 178.393, 139.878)), (' A  64  ILE HG13', ' A 137  ILE HG21', -0.527, (133.571, 177.042, 132.936)), (' B  43  THR HG23', ' B 145  THR  CG2', -0.527, (144.179, 110.511, 141.778)), (' A 308  LEU  CD2', ' B 314  TRP  CE3', -0.527, (144.152, 140.629, 138.906)), (' A 181  GLY  CA ', ' A 322  PHE  CE1', -0.527, (145.834, 158.349, 151.543)), (' A 207  VAL HG11', ' A 266  PHE  HB2', -0.527, (153.306, 153.985, 144.768)), (' A  93  PHE  C  ', ' A  93  PHE  CD1', -0.526, (135.921, 164.982, 143.981)), (' B  12  ALA  HB3', ' B 146  PHE  HB3', -0.526, (145.03, 108.102, 135.899)), (' A 200  LEU  CD2', ' A 208  ILE  CD1', -0.525, (158.965, 158.948, 144.261)), (' B  73  VAL HG13', ' B  76  ILE  CG2', -0.525, (155.795, 107.387, 152.544)), (' A  69  ALA  CB ', ' A 145  THR  CG2', -0.525, (140.953, 174.771, 144.12)), (' B  90  ILE  CG2', ' B  92  LEU HD23', -0.524, (146.019, 116.826, 149.781)), (' A  37  ARG HH22', ' A  74  GLU  HG2', -0.524, (131.913, 185.776, 147.954)), (' A 301  LEU HD23', ' B 303  MET  CE ', -0.523, (143.091, 145.407, 134.204)), (' A  11  ALA  HB3', ' A  26  VAL  CG2', -0.523, (135.391, 181.816, 133.974)), (' A 140  PHE  CE2', ' A 141  LEU HD12', -0.523, (137.786, 166.228, 138.234)), (' A 293  GLY  O  ', ' B 309  LEU  CD2', -0.523, (143.358, 154.778, 138.217)), (' B 180  TYR  CZ ', ' B 340  PHE  HZ ', -0.522, (135.861, 125.518, 156.797)), (' B 181  GLY  CA ', ' B 322  PHE  CE1', -0.522, (140.637, 127.473, 151.638)), (' A 282  CYS  HB3', ' A 287  GLY  CA ', -0.521, (152.372, 142.031, 144.521)), (' B 140  PHE  CE2', ' B 141  LEU HD12', -0.521, (148.12, 120.248, 138.49)), (' B 140  PHE  O  ', ' B 141  LEU  HG ', -0.521, (150.721, 119.063, 137.478)), (' B  14  LEU HD21', ' B  52  VAL HG12', -0.52, (146.265, 115.906, 129.557)), (' B 200  LEU  CD2', ' B 208  ILE  CD1', -0.519, (127.112, 127.131, 144.166)), (' A 180  TYR  CZ ', ' A 340  PHE  HZ ', -0.518, (150.073, 160.96, 156.92)), (' B  37  ARG HH22', ' B  74  GLU  HG2', -0.518, (153.886, 99.915, 148.438)), (' B 200  LEU HD22', ' B 232  ALA  HB2', -0.518, (124.998, 125.331, 143.428)), (' B 198  PHE  HE2', ' B 269  ILE  CD1', -0.517, (132.001, 131.298, 134.089)), (' B  14  LEU  HB2', ' B  21  PHE  HE2', -0.517, (146.424, 112.228, 131.609)), (' A 176  PHE  HZ ', ' A 340  PHE  CE2', -0.516, (151.275, 162.74, 155.429)), (' A 140  PHE  O  ', ' A 141  LEU  HG ', -0.513, (135.194, 166.723, 137.443)), (' B 282  CYS  HB3', ' B 287  GLY  CA ', -0.513, (133.5, 143.945, 144.557)), (' A 200  LEU HD22', ' A 232  ALA  HB2', -0.512, (160.547, 160.28, 142.897)), (' B 250  ILE  CG2', ' B 277  THR HG21', -0.511, (128.674, 137.84, 133.613)), (' B 145  THR  O  ', ' B 147  SER  N  ', -0.511, (146.786, 107.374, 139.964)), (' A 309  LEU  CD1', ' B 295  PRO  HG2', -0.51, (144.558, 132.639, 135.48)), (' A 235  VAL  O  ', ' A 235  VAL HG12', -0.51, (159.221, 160.053, 149.796)), (' B  69  ALA  CB ', ' B 145  THR  CG2', -0.51, (145.06, 111.288, 144.064)), (' A  12  ALA  HB1', ' A  21  PHE  HB3', -0.51, (141.564, 177.826, 132.123)), (' B  93  PHE  C  ', ' B  93  PHE  CD1', -0.508, (149.896, 121.589, 144.065)), (' A  45  ILE  HB ', ' A 370  THR  HB ', -0.508, (150.326, 173.298, 138.473)), (' B  65  ALA  HA ', ' B 140  PHE  HB2', -0.507, (149.075, 114.966, 136.001)), (' A 303  MET  CE ', ' B 301  LEU HD23', -0.507, (142.861, 140.48, 134.226)), (' A 309  LEU HD22', ' B 293  GLY  O  ', -0.506, (142.866, 130.241, 138.647)), (' B  11  ALA  O  ', ' B  23  ILE  HA ', -0.506, (146.541, 104.05, 132.58)), (' B  93  PHE  CE1', ' B 141  LEU  HB3', -0.506, (150.896, 121.067, 140.393)), (' A  11  ALA  O  ', ' A  23  ILE  HA ', -0.506, (139.651, 182.208, 132.32)), (' B 186  VAL HG23', ' B 320  GLY  O  ', -0.506, (142.276, 131.983, 149.318)), (' B 176  PHE  HZ ', ' B 340  PHE  CE2', -0.505, (134.892, 123.647, 155.281)), (' A  65  ALA  HA ', ' A 140  PHE  HB2', -0.505, (137.155, 171.373, 136.073)), (' A 171  LEU  CD1', ' A 342  LEU  HB3', -0.504, (152.523, 170.092, 150.222)), (' A 295  PRO  HG2', ' B 309  LEU  CD1', -0.504, (141.322, 153.623, 135.232)), (' B  45  ILE  HB ', ' B 370  THR  HB ', -0.502, (135.657, 112.034, 138.717)), (' B 171  LEU  CD1', ' B 342  LEU  HB3', -0.5, (133.435, 115.967, 150.221)), (' A 293  GLY  O  ', ' B 309  LEU HD22', -0.5, (143.125, 155.583, 138.484)), (' A 250  ILE  CG2', ' A 277  THR HG21', -0.498, (157.66, 148.449, 133.72)), (' B  90  ILE HD11', ' B 169  VAL  CG1', -0.498, (142.43, 113.403, 152.749)), (' B 235  VAL  O  ', ' B 235  VAL HG12', -0.498, (126.496, 125.626, 149.634)), (' B 203  VAL HG12', ' B 268  VAL HG12', -0.498, (135.729, 128.005, 142.569)), (' A  40  MET  HG3', ' A 374  PHE  CD1', -0.498, (142.313, 180.912, 143.797)), (' B 283  GLN  HG2', ' B 286  TYR  HD1', -0.496, (130.387, 147.578, 148.217)), (' A 283  GLN  HG2', ' A 286  TYR  HD1', -0.496, (155.564, 138.458, 148.239)), (' A 129  ARG  HG3', ' A 151  VAL  CG1', -0.496, (127.735, 176.27, 142.403)), (' A 282  CYS  O  ', ' A 312  ARG  NH2', -0.496, (154.52, 140.232, 141.107)), (' A  31  PRO  HG3', ' A  75  SER  OG ', -0.495, (126.085, 181.964, 149.005)), (' A  14  LEU  HB2', ' A  21  PHE  HE2', -0.495, (139.535, 173.627, 131.592)), (' A  93  PHE  CE1', ' A 141  LEU  HB3', -0.494, (135.625, 164.862, 140.661)), (' A  90  ILE HD11', ' A 169  VAL  CG1', -0.494, (143.508, 172.414, 152.734)), (' A  14  LEU HD21', ' A  52  VAL HG12', -0.494, (139.753, 169.883, 129.48)), (' A 200  LEU HD22', ' A 232  ALA  CB ', -0.494, (161.101, 160.268, 143.213)), (' A 313  THR HG23', ' B 315  LYS  HG2', -0.493, (144.033, 141.21, 146.078)), (' B 282  CYS  O  ', ' B 312  ARG  NH2', -0.493, (131.233, 145.976, 141.057)), (' A  92  LEU  CD1', ' A 328  VAL HG21', -0.493, (138.167, 166.695, 151.943)), (' B 113  LYS  HD3', ' B 124  GLN  OE1', -0.493, (160.773, 121.997, 145.683)), (' B  12  ALA  HB1', ' B  21  PHE  HB3', -0.493, (144.277, 108.014, 132.138)), (' B 153  ASP  OD1', ' B 155  ILE  N  ', -0.492, (157.915, 117.245, 149.765)), (' B 200  LEU HD22', ' B 232  ALA  CB ', -0.492, (124.888, 125.568, 143.439)), (' B  40  MET  HG3', ' B 374  PHE  CD1', -0.49, (143.578, 104.93, 143.915)), (' B 187  ALA  HB2', ' B 266  PHE  CZ ', -0.489, (136.175, 135.191, 148.902)), (' A 305  PRO  CG ', ' B 272  LEU  CD2', -0.488, (143.287, 135.822, 132.263)), (' B  92  LEU  CD1', ' B 328  VAL HG21', -0.488, (147.767, 119.187, 151.924)), (' A 203  VAL HG12', ' A 268  VAL HG12', -0.487, (150.559, 157.894, 142.717)), (' A 186  VAL HG23', ' A 320  GLY  O  ', -0.487, (143.719, 154.375, 149.526)), (' B 139  HIS  HA ', ' B 144  SER  OG ', -0.486, (152.903, 112.862, 137.655)), (' B 129  ARG  HG3', ' B 151  VAL  CG1', -0.486, (157.996, 109.617, 142.816)), (' B  14  LEU  HB2', ' B  21  PHE  CD2', -0.485, (145.834, 111.133, 130.744)), (' B  31  PRO  HG3', ' B  75  SER  OG ', -0.485, (159.844, 103.697, 149.336)), (' A 305  PRO  HB2', ' B 295  PRO  HG2', -0.485, (144.014, 133.601, 134.775)), (' A 315  LYS  HE3', ' B 313  THR  OG1', -0.484, (140.601, 146.157, 147.271)), (' A 316  GLY  C  ', ' B 311  GLY  HA2', -0.484, (140.559, 151.543, 143.856)), (' A  26  VAL HG12', ' A 130  PHE  CD2', -0.483, (131.539, 180.827, 136.496)), (' A 209  MET  HG3', ' A 235  VAL HG13', -0.483, (157.426, 161.654, 149.658)), (' B 181  GLY  HA2', ' B 322  PHE  CE1', -0.483, (140.643, 128.021, 152.354)), (' A 139  HIS  HA ', ' A 144  SER  OG ', -0.483, (132.973, 173.146, 137.716)), (' A 313  THR  OG1', ' B 315  LYS  HE3', -0.483, (145.437, 139.312, 147.521)), (' B 153  ASP  OD1', ' B 155  ILE  HB ', -0.483, (158.911, 118.352, 148.996)), (' B 209  MET  HG3', ' B 235  VAL HG13', -0.483, (128.956, 124.197, 149.874)), (' A 295  PRO  HG2', ' B 305  PRO  HB2', -0.482, (142.052, 151.892, 134.69)), (' A 352  PHE  HD2', ' A 374  PHE  HA ', -0.482, (144.849, 184.402, 142.797)), (' A 164  SER  HB2', ' A 169  VAL HG21', -0.482, (146.005, 174.495, 156.259)), (' A 181  GLY  HA2', ' A 322  PHE  CE1', -0.481, (145.918, 157.881, 152.225)), (' A 101  ARG HH11', ' B 260  GLY  CA ', -0.481, (124.938, 149.037, 145.074)), (' A 355  ILE HG12', ' A 372  LEU HD22', -0.481, (145.033, 178.534, 137.342)), (' B  53  VAL HG21', ' B 359  PHE  CE1', -0.481, (140.136, 114.854, 130.23)), (' A  12  ALA  HB2', ' A 355  ILE HD13', -0.48, (142.752, 178.844, 135.085)), (' B  64  ILE HD12', ' B 130  PHE  CG ', -0.48, (153.276, 107.45, 135.965)), (' B 173  GLY  O  ', ' B 319  PHE  CE2', -0.48, (144.193, 120.193, 146.724)), (' B   3  ALA  O  ', ' B  31  PRO  HD2', -0.48, (161.551, 102.14, 147.097)), (' A 187  ALA  HB2', ' A 266  PHE  CZ ', -0.48, (149.86, 150.73, 149.087)), (' A 173  GLY  O  ', ' A 319  PHE  CE2', -0.48, (141.935, 165.322, 146.593)), (' B  90  ILE HD11', ' B 169  VAL HG12', -0.48, (142.916, 113.452, 152.317)), (' A 272  LEU  HB3', ' A 301  LEU HD13', -0.479, (145.68, 148.455, 130.506)), (' B 246  TYR  CD2', ' B 253  VAL  CG2', -0.479, (119.817, 139.068, 133.891)), (' A 153  ASP  OD1', ' A 155  ILE  HB ', -0.479, (127.12, 167.608, 148.841)), (' A 246  TYR  CD2', ' A 253  VAL  CG2', -0.478, (166.276, 146.782, 134.042)), (' A 208  ILE  HB ', ' A 235  VAL HG11', -0.478, (157.5, 160.396, 147.988)), (' A  90  ILE HD11', ' A 169  VAL HG12', -0.478, (143.51, 172.433, 152.48)), (' A 315  LYS  HG2', ' B 313  THR HG23', -0.477, (141.723, 145.212, 146.237)), (' A   3  ALA  O  ', ' A  31  PRO  HD2', -0.477, (124.691, 183.403, 147.02)), (' A  14  LEU HD23', ' A  52  VAL HG12', -0.477, (138.817, 170.409, 130.491)), (' A 284  GLU  OE1', ' B 110  PHE  CD2', -0.476, (154.365, 132.166, 142.137)), (' A 113  LYS  HD3', ' A 124  GLN  OE1', -0.475, (125.245, 164.129, 145.294)), (' B 164  SER  HB2', ' B 169  VAL HG21', -0.475, (139.998, 111.678, 155.821)), (' B  12  ALA  HB2', ' B 355  ILE HD13', -0.475, (143.519, 107.19, 134.792)), (' A 176  PHE  HZ ', ' A 340  PHE  CD2', -0.474, (151.084, 163.13, 154.989)), (' A 335  PHE  CE1', ' A 342  LEU HD12', -0.474, (151.954, 170.934, 154.465)), (' A  53  VAL HG21', ' A 359  PHE  CE1', -0.473, (145.857, 171.243, 130.205)), (' B 352  PHE  HD2', ' B 374  PHE  HA ', -0.472, (141.057, 101.477, 142.319)), (' A 110  PHE  CD2', ' B 284  GLU  OE1', -0.471, (131.574, 154.201, 142.339)), (' B 335  PHE  CE1', ' B 342  LEU HD12', -0.471, (134.355, 115.394, 154.348)), (' A  64  ILE HD12', ' A 130  PHE  CG ', -0.47, (132.084, 178.196, 136.096)), (' A 200  LEU HD23', ' A 208  ILE HD11', -0.469, (158.824, 158.864, 143.605)), (' B 263  ASP  O  ', ' B 287  GLY  HA2', -0.469, (133.132, 142.76, 145.953)), (' B 197  VAL HG22', ' B 207  VAL HG12', -0.469, (131.143, 131.308, 146.036)), (' B 355  ILE HG12', ' B 372  LEU HD22', -0.469, (140.674, 107.519, 137.321)), (' B 272  LEU  HB3', ' B 301  LEU HD13', -0.469, (140.305, 137.097, 130.263)), (' B 176  PHE  HZ ', ' B 340  PHE  CD2', -0.468, (134.478, 122.767, 155.243)), (' B  80  VAL  HA ', ' B 154  GLU  OE1', -0.468, (161.013, 113.623, 154.596)), (' B  68  GLU  O  ', ' B  69  ALA  HB2', -0.467, (143.847, 111.901, 144.129)), (' A 105  HIS  HD1', ' A 107  GLU  H  ', -0.467, (134.122, 149.5, 153.919)), (' A 229  PHE  CD1', ' A 240  CYS  HB3', -0.467, (164.924, 158.025, 139.843)), (' A  80  VAL  HA ', ' A 154  GLU  OE1', -0.466, (124.449, 172.509, 154.652)), (' A  68  GLU  O  ', ' A  69  ALA  HB2', -0.466, (142.051, 174.039, 143.959)), (' B 200  LEU HD23', ' B 208  ILE HD11', -0.465, (127.254, 127.227, 143.546)), (' B 105  HIS  HD1', ' B 107  GLU  H  ', -0.465, (151.84, 136.537, 153.923)), (' B 208  ILE  HB ', ' B 235  VAL HG11', -0.464, (128.455, 125.526, 147.886)), (' B 140  PHE  O  ', ' B 141  LEU  CD2', -0.464, (151.479, 119.978, 137.277)), (' A 272  LEU HD22', ' A 301  LEU  HB2', -0.463, (143.629, 148.713, 131.155)), (' A 284  GLU  HB3', ' A 310  SER  HB2', -0.463, (152.091, 134.309, 142.097)), (' A 200  LEU  CD1', ' A 232  ALA  CB ', -0.463, (161.846, 160.069, 142.187)), (' A 263  ASP  O  ', ' A 287  GLY  HA2', -0.462, (152.703, 143.144, 146.066)), (' A  14  LEU  HB2', ' A  21  PHE  CD2', -0.462, (140.125, 174.794, 130.825)), (' A 140  PHE  O  ', ' A 141  LEU  CD2', -0.462, (134.356, 165.913, 137.167)), (' B  93  PHE  CE1', ' B 141  LEU  CD1', -0.462, (149.634, 121.272, 139.831)), (' B 200  LEU  O  ', ' B 368  ILE  CD1', -0.462, (128.198, 121.402, 141.135)), (' A 284  GLU  O  ', ' A 312  ARG  HB3', -0.461, (150.693, 137.649, 143.706)), (' B 241  VAL  CG1', ' B 246  TYR  CE1', -0.46, (121.139, 135.561, 136.329)), (' B  56  THR  CG2', ' B 296  PRO  HA ', -0.46, (143.448, 126.911, 130.034)), (' A 183  ALA  HA ', ' A 266  PHE  CE2', -0.459, (150.136, 152.726, 149.648)), (' B  57  LEU HD11', ' B 116  LEU  CD1', -0.459, (149.124, 125.227, 135.499)), (' A 200  LEU  O  ', ' A 368  ILE  CD1', -0.459, (157.685, 164.533, 141.002)), (' B 284  GLU  O  ', ' B 312  ARG  HB3', -0.459, (134.931, 148.616, 143.998)), (' A 316  GLY  CA ', ' B 308  LEU  O  ', -0.458, (141.328, 150.556, 142.338)), (' A  90  ILE HD11', ' A 160  ILE HD13', -0.458, (141.723, 173.324, 153.463)), (' B  14  LEU HD23', ' B  52  VAL HG12', -0.458, (147.176, 115.664, 130.157)), (' A 197  VAL HG22', ' A 207  VAL HG12', -0.457, (154.447, 154.928, 146.146)), (' B 229  PHE  CD1', ' B 240  CYS  HB3', -0.457, (121.237, 127.885, 139.965)), (' B 183  ALA  HA ', ' B 266  PHE  CE2', -0.457, (135.796, 133.014, 149.175)), (' B 284  GLU  HB3', ' B 310  SER  HB2', -0.456, (133.576, 151.421, 142.383)), (' A  47  ARG HH12', ' A 228  LYS  NZ ', -0.456, (155.776, 163.951, 136.146)), (' B 199  GLY  HA2', ' B 222  VAL  O  ', -0.455, (128.098, 128.94, 138.423)), (' B  51  HIS  HB3', ' B  56  THR  HB ', -0.454, (143.044, 123.251, 131.316)), (' A  12  ALA  HB3', ' A 146  PHE  CB ', -0.453, (140.93, 177.313, 135.901)), (' A 140  PHE  O  ', ' A 141  LEU  CG ', -0.453, (134.523, 166.634, 137.387)), (' A 284  GLU  OE1', ' B 110  PHE  CE2', -0.453, (154.321, 132.145, 141.881)), (' B  47  ARG HH12', ' B 228  LYS  NZ ', -0.452, (130.189, 121.886, 136.138)), (' A  37  ARG HH11', ' A  75  SER  HB2', -0.452, (128.32, 184.985, 149.472)), (' A  38  ILE  HB ', ' A 150  THR  OG1', -0.452, (134.609, 177.676, 145.828)), (' A 308  LEU  O  ', ' B 316  GLY  CA ', -0.451, (144.6, 135.457, 142.322)), (' B  93  PHE  HE1', ' B 141  LEU  HB3', -0.451, (150.979, 121.477, 140.74)), (' A  57  LEU HD11', ' A 116  LEU  CD1', -0.451, (136.956, 160.599, 135.443)), (' B  90  ILE HD11', ' B 160  ILE HD13', -0.451, (144.236, 112.563, 153.402)), (' B 272  LEU HD22', ' B 301  LEU  HB2', -0.45, (142.542, 137.651, 131.09)), (' B 235  VAL  CG1', ' B 235  VAL  O  ', -0.45, (126.607, 125.374, 149.779)), (' B 140  PHE  O  ', ' B 141  LEU  CG ', -0.45, (151.146, 119.681, 137.505)), (' A  73  VAL HG13', ' A  76  ILE HG23', -0.449, (130.02, 178.991, 152.496)), (' A 235  VAL  CG1', ' A 235  VAL  O  ', -0.449, (159.29, 160.557, 149.818)), (' B  92  LEU HD22', ' B 328  VAL HG21', -0.448, (146.742, 119.468, 151.326)), (' A   7  ILE HD12', ' A  37  ARG  NH2', -0.447, (130.467, 185.586, 145.853)), (' B 200  LEU  CD1', ' B 232  ALA  CB ', -0.446, (123.999, 125.814, 142.14)), (' B  37  ARG HH11', ' B  75  SER  HB2', -0.446, (157.718, 101.403, 149.615)), (' B  38  ILE  HB ', ' B 150  THR  OG1', -0.446, (151.231, 108.166, 145.835)), (' A  40  MET  HE3', ' A 145  THR HG22', -0.445, (140.713, 176.82, 142.265)), (' A 110  PHE  CE2', ' B 284  GLU  OE1', -0.445, (131.376, 153.865, 141.732)), (' B  12  ALA  HB3', ' B 146  PHE  CB ', -0.445, (145.149, 108.821, 135.851)), (' A 152  VAL  CG1', ' A 156  SER  OG ', -0.444, (131.795, 170.757, 146.666)), (' A  26  VAL HG11', ' A  64  ILE HD11', -0.444, (133.496, 179.708, 134.918)), (' A  51  HIS  HB3', ' A  56  THR  HB ', -0.444, (142.848, 162.809, 131.211)), (' A  56  THR  CG2', ' A 296  PRO  HA ', -0.443, (142.554, 158.948, 130.379)), (' A 199  GLY  HA2', ' A 222  VAL  O  ', -0.443, (157.857, 157.026, 138.488)), (' B   7  ILE HD12', ' B  37  ARG  NH2', -0.442, (155.437, 100.492, 146.281)), (' B  10  LYS  O  ', ' B 147  SER  HA ', -0.442, (147.691, 104.115, 138.307)), (' A  10  LYS  O  ', ' A 147  SER  HA ', -0.442, (138.395, 181.835, 138.194)), (' A 272  LEU  CD2', ' B 305  PRO  CG ', -0.442, (142.813, 150.304, 132.438)), (' A 195  CYS  HA ', ' A 264  PHE  O  ', -0.442, (155.964, 148.236, 146.495)), (' A 304  ASN  OD1', ' B 300  ASN  HA ', -0.441, (147.308, 137.303, 129.396)), (' A  93  PHE  HE1', ' A 141  LEU  HB3', -0.441, (135.039, 164.565, 140.882)), (' B 152  VAL  CG1', ' B 156  SER  OG ', -0.439, (154.334, 115.113, 146.805)), (' B 187  ALA  CB ', ' B 266  PHE  CZ ', -0.439, (135.514, 135.216, 149.096)), (' A 187  ALA  CB ', ' A 266  PHE  CZ ', -0.439, (150.44, 150.814, 149.18)), (' A 302  SER  HA ', ' B 302  SER  HA ', -0.438, (142.759, 143.044, 127.964)), (' B  90  ILE HG12', ' B 160  ILE  CG2', -0.438, (145.941, 114.146, 154.416)), (' A 182  SER  HB2', ' A 290  VAL HG11', -0.438, (147.399, 152.916, 146.563)), (' A 315  LYS  CG ', ' B 313  THR HG23', -0.437, (142.171, 144.753, 146.173)), (' A  93  PHE  CE1', ' A 141  LEU  CD1', -0.437, (136.561, 164.716, 139.912)), (' B  80  VAL HG13', ' B 154  GLU  CD ', -0.437, (159.396, 113.622, 154.608)), (' A 313  THR HG23', ' B 315  LYS  CG ', -0.436, (143.583, 140.805, 146.136)), (' B  64  ILE HG13', ' B 137  ILE  CG2', -0.436, (152.551, 109.375, 133.111)), (' A  90  ILE HG12', ' A 160  ILE  CG2', -0.436, (140.018, 171.708, 154.418)), (' B  90  ILE  CD1', ' B 160  ILE HD13', -0.436, (144.47, 112.522, 153.281)), (' B 195  CYS  HA ', ' B 264  PHE  O  ', -0.435, (129.82, 137.415, 146.8)), (' B  26  VAL HG11', ' B  64  ILE HD11', -0.434, (152.511, 106.202, 134.77)), (' A 295  PRO  CG ', ' B 305  PRO  HB2', -0.434, (142.319, 152.401, 134.624)), (' A 300  ASN  HA ', ' B 304  ASN  OD1', -0.434, (138.217, 148.3, 129.46)), (' A 208  ILE  CG2', ' A 235  VAL  CG1', -0.434, (158.561, 159.93, 148.483)), (' A  80  VAL HG13', ' A 154  GLU  CD ', -0.434, (126.431, 172.363, 154.505)), (' B 129  ARG  HG3', ' B 151  VAL HG11', -0.433, (158.684, 109.373, 142.884)), (' A  90  ILE  CD1', ' A 160  ILE HD13', -0.433, (141.377, 173.188, 152.931)), (' B  14  LEU  O  ', ' B  62  PRO  HA ', -0.432, (150.884, 111.786, 128.372)), (' A  64  ILE HG13', ' A 137  ILE  CG2', -0.43, (133.407, 176.656, 133.09)), (' A  14  LEU  O  ', ' A  62  PRO  HA ', -0.428, (134.689, 173.943, 128.399)), (' A 348  HIS  HD2', ' A 367  SER  CB ', -0.428, (156.783, 172.547, 138.564)), (' B 182  SER  HB2', ' B 290  VAL HG11', -0.426, (138.407, 132.603, 146.445)), (' A 198  PHE  CE2', ' A 269  ILE  CD1', -0.425, (153.976, 154.327, 134.645)), (' A 241  VAL  CG1', ' A 246  TYR  CE1', -0.425, (164.789, 150.553, 136.149)), (' A  92  LEU HD22', ' A 328  VAL HG21', -0.425, (139.47, 166.605, 151.355)), (' A 231  LYS  O  ', ' A 234  GLU  HB2', -0.425, (162.723, 164.739, 146.941)), (' B  35  GLU  OE1', ' B 123  MET  CE ', -0.424, (158.514, 113.224, 144.463)), (' B 231  LYS  O  ', ' B 234  GLU  HB2', -0.424, (123.079, 121.072, 147.311)), (' B 207  VAL HG21', ' B 268  VAL  CG1', -0.424, (134.598, 129.273, 143.831)), (' B 208  ILE  CG2', ' B 235  VAL  CG1', -0.424, (127.526, 126.067, 148.595)), (' A 207  VAL HG21', ' A 268  VAL  CG1', -0.424, (151.476, 156.82, 143.857)), (' A 301  LEU  O  ', ' B 301  LEU  O  ', -0.424, (143.194, 142.838, 129.625)), (' A 305  PRO  HB2', ' B 295  PRO  CG ', -0.423, (143.586, 133.995, 134.575)), (' A 309  LEU HD21', ' B 291  ILE  CG2', -0.423, (141.617, 132.5, 138.532)), (' A 285  ALA  CB ', ' B 102  VAL HG13', -0.422, (153.336, 134.367, 148.829)), (' A 229  PHE  O  ', ' A 233  LYS  HG3', -0.421, (166.159, 161.418, 143.842)), (' A 264  PHE  HB3', ' A 266  PHE  HE1', -0.42, (153.129, 149.22, 148.151)), (' B  96  GLN HE21', ' B 324  SER  H  ', -0.42, (150.229, 124.927, 151.489)), (' A 129  ARG  HG3', ' A 151  VAL HG11', -0.419, (127.275, 176.485, 142.886)), (' B 176  PHE  CZ ', ' B 340  PHE  CD2', -0.418, (134.446, 122.629, 155.142)), (' A 176  PHE  CZ ', ' A 340  PHE  CD2', -0.418, (151.518, 163.344, 155.139)), (' B 113  LYS  NZ ', ' B 155  ILE  CD1', -0.418, (161.738, 121.516, 149.131)), (' A  53  VAL  CG1', ' A 359  PHE  CZ ', -0.417, (145.874, 170.447, 128.426)), (' A 291  ILE  CG2', ' B 309  LEU HD21', -0.417, (143.945, 153.719, 138.534)), (' A 305  PRO  CD ', ' B 272  LEU HD21', -0.416, (143.943, 135.775, 131.598)), (' A 309  LEU  CD2', ' B 291  ILE HG22', -0.416, (141.88, 132.11, 139.319)), (' B  26  VAL  CG1', ' B 130  PHE  HB3', -0.416, (154.682, 105.592, 135.068)), (' B 229  PHE  O  ', ' B 233  LYS  HG3', -0.416, (119.797, 124.605, 143.798)), (' A  96  GLN HE21', ' A 324  SER  H  ', -0.415, (135.727, 161.121, 151.49)), (' B 157  VAL HG22', ' B 158  ALA  N  ', -0.415, (151.738, 114.005, 152.472)), (' A 172  ILE HG21', ' A 328  VAL HG13', -0.414, (142.247, 167.795, 153.653)), (' A 101  ARG  CZ ', ' B 260  GLY  CA ', -0.413, (123.633, 148.537, 146.172)), (' B 172  ILE HG21', ' B 328  VAL HG13', -0.413, (143.268, 118.141, 153.738)), (' A 113  LYS  NZ ', ' A 155  ILE  CD1', -0.411, (124.22, 164.52, 149.05)), (' B 200  LEU HD21', ' B 208  ILE HD11', -0.411, (126.224, 127.724, 143.568)), (' B 264  PHE  HB3', ' B 266  PHE  HE1', -0.409, (132.952, 136.348, 148.003)), (' A 313  THR  OG1', ' B 315  LYS  HG2', -0.408, (145.105, 140.244, 146.541)), (' B  13  VAL HG21', ' B 137  ILE HD13', -0.408, (152.269, 106.406, 131.428)), (' A 157  VAL HG22', ' A 158  ALA  N  ', -0.408, (134.22, 171.987, 152.597)), (' B 325  LYS  O  ', ' B 329  PRO  CD ', -0.408, (148.485, 120.098, 157.652)), (' A 341  ALA  O  ', ' A 344  PRO  HD2', -0.408, (157.359, 168.209, 151.261)), (' A 196  ALA  HA ', ' A 220  ILE  O  ', -0.407, (159.432, 152.019, 144.148)), (' A 203  VAL  O  ', ' A 207  VAL HG23', -0.407, (151.6, 158.782, 145.032)), (' A 102  VAL HG13', ' B 285  ALA  CB ', -0.406, (132.665, 151.543, 148.976)), (' A 272  LEU HD21', ' B 305  PRO  CD ', -0.406, (142.011, 150.151, 131.554)), (' A 293  GLY  O  ', ' B 309  LEU HD21', -0.406, (143.598, 154.685, 138.212)), (' A  89  VAL  HB ', ' A 157  VAL HG23', -0.406, (135.449, 173.078, 151.595)), (' A 291  ILE HG22', ' B 309  LEU  CD2', -0.406, (143.668, 153.734, 139.192)), (' B 341  ALA  O  ', ' B 344  PRO  HD2', -0.406, (128.791, 118.002, 151.518)), (' A 315  LYS  HG2', ' B 313  THR  OG1', -0.405, (140.848, 145.682, 146.519)), (' A 260  GLY  CA ', ' B 101  ARG  CZ ', -0.405, (162.264, 137.496, 146.249)), (' A 219  ILE  O  ', ' A 238  THR  N  ', -0.405, (163.855, 153.834, 147.609)), (' A 189  VAL  HB ', ' A 214  ALA  HB3', -0.404, (153.002, 151.678, 154.27)), (' B 348  HIS  HD2', ' B 367  SER  CB ', -0.404, (129.291, 113.356, 138.642)), (' A  26  VAL  CG1', ' A 130  PHE  HB3', -0.404, (131.372, 180.289, 134.964)), (' A 295  PRO  CD ', ' B 309  LEU HD13', -0.404, (141.59, 155.806, 136.667)), (' A  13  VAL HG21', ' A 137  ILE HD13', -0.403, (134.069, 179.69, 131.556)), (' A  36  VAL HG12', ' A  38  ILE HG13', -0.403, (132.275, 177.204, 149.155)), (' B 181  GLY  HA3', ' B 322  PHE  CE1', -0.402, (140.833, 127.669, 151.636)), (' A 335  PHE  CD1', ' A 342  LEU HD12', -0.402, (151.293, 170.464, 154.606)), (' A  47  ARG HH12', ' A 228  LYS  HZ1', -0.402, (155.744, 164.21, 136.157)), (' A 309  LEU HD21', ' B 293  GLY  O  ', -0.402, (142.217, 130.889, 138.212)), (' B 222  VAL  CG1', ' B 250  ILE  CD1', -0.402, (126.364, 133.879, 136.169)), (' A 325  LYS  O  ', ' A 329  PRO  CD ', -0.402, (137.139, 165.64, 157.493)), (' B 219  ILE  O  ', ' B 238  THR  N  ', -0.402, (121.995, 132.137, 147.518)), (' B  14  LEU  CD2', ' B  52  VAL  CG1', -0.402, (147.078, 116.023, 130.588)), (' B  26  VAL HG12', ' B 130  PHE  CD2', -0.402, (154.469, 105.182, 136.348)), (' B  40  MET  HE3', ' B 145  THR  O  ', -0.401, (146.152, 108.439, 142.353)), (' A 242  ASN  OD1', ' A 244  GLN  HB2', -0.401, (165.418, 155.776, 131.014)), (' A 170  CYS  SG ', ' A 371  ILE  CD1', -0.4, (148.898, 173.873, 145.969)), (' A 302  SER  C  ', ' B 301  LEU  O  ', -0.4, (144.515, 142.623, 129.198)), (' B 198  PHE  CE2', ' B 269  ILE  CD1', -0.4, (131.349, 131.463, 134.037)), (' B 203  VAL  O  ', ' B 207  VAL HG23', -0.4, (134.475, 127.093, 145.14))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
