# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = []
data['omega'] = [('A', '  62 ', 'PRO', None, (131.96099999999996, 173.57, 127.49100000000001)), ('A', ' 124 ', 'GLN', None, (124.54799999999997, 168.75, 141.535)), ('B', '  62 ', 'PRO', None, (153.991, 112.385, 127.49100000000001)), ('B', ' 124 ', 'GLN', None, (161.40499999999994, 117.20499999999998, 141.534))]
data['rota'] = []
data['cbeta'] = []
data['probe'] = [(' A 291  ILE  CG2', ' B 309  LEU HD21', -1.581, (144.942, 153.124, 137.697)), (' A 309  LEU HD21', ' B 291  ILE  CG2', -1.558, (141.008, 132.901, 137.72)), (' A 291  ILE HG22', ' B 309  LEU  CD2', -1.536, (143.514, 153.609, 138.341)), (' A 309  LEU  CD2', ' B 291  ILE HG22', -1.5, (142.437, 132.416, 138.318)), (' A 303  MET  SD ', ' B 303  MET  SD ', -1.394, (142.364, 142.365, 133.118)), (' A 295  PRO  HD3', ' B 309  LEU  CD1', -1.367, (142.271, 153.91, 136.469)), (' A 309  LEU  CD1', ' B 295  PRO  HD3', -1.366, (143.732, 132.095, 136.331)), (' A 107  GLU  CB ', ' B 286  TYR  CE2', -1.298, (137.091, 149.627, 152.229)), (' A 311  GLY  O  ', ' B 315  LYS  CE ', -1.296, (146.018, 137.055, 146.289)), (' A 315  LYS  CE ', ' B 311  GLY  O  ', -1.292, (139.815, 149.116, 146.343)), (' A 286  TYR  CE2', ' B 107  GLU  CB ', -1.291, (148.629, 136.747, 152.86)), (' A 309  LEU  CD2', ' B 291  ILE  CG2', -1.288, (141.848, 133.906, 138.556)), (' A 286  TYR  CE2', ' B 107  GLU  HB2', -1.269, (148.85, 137.619, 152.032)), (' B  69  ALA  O  ', ' B  91  PRO  HD2', -1.257, (145.18, 113.081, 147.37)), (' A 311  GLY  HA2', ' B 316  GLY  O  ', -1.252, (145.519, 134.618, 144.196)), (' A 291  ILE  CG2', ' B 309  LEU  CD2', -1.251, (144.292, 152.126, 138.681)), (' A  69  ALA  O  ', ' A  91  PRO  HD2', -1.246, (140.81, 172.688, 147.382)), (' A 301  LEU HD23', ' B 303  MET  CE ', -1.232, (144.338, 144.735, 132.92)), (' A 303  MET  CE ', ' B 301  LEU HD23', -1.23, (141.481, 141.241, 133.024)), (' A 107  GLU  HB2', ' B 286  TYR  CE2', -1.218, (136.918, 148.25, 152.004)), (' A 316  GLY  O  ', ' B 311  GLY  HA2', -1.212, (140.582, 151.124, 144.061)), (' B  67  HIS  ND1', ' B 174  CYS  SG ', -1.206, (143.361, 118.67, 143.173)), (' A  67  HIS  ND1', ' A 174  CYS  SG ', -1.166, (142.034, 167.919, 143.239)), (' B 284  GLU  HA ', ' B 312  ARG  HE ', -1.154, (133.37, 149.022, 142.649)), (' A 313  THR  CG2', ' B 315  LYS  HD2', -1.133, (145.131, 139.984, 146.503)), (' A 284  GLU  HA ', ' A 312  ARG  HE ', -1.12, (152.907, 136.977, 142.796)), (' A 315  LYS  HD2', ' B 313  THR  CG2', -1.114, (140.818, 146.04, 146.425)), (' A 205  LEU HD11', ' A 368  ILE HD13', -1.114, (158.236, 165.131, 144.311)), (' A 205  LEU HD22', ' A 235  VAL HG21', -1.109, (158.634, 163.704, 146.351)), (' A 295  PRO  CD ', ' B 309  LEU  CD1', -1.105, (141.968, 154.835, 135.577)), (' A 303  MET  HE3', ' B 301  LEU HD23', -1.104, (141.337, 139.786, 133.177)), (' A  67  HIS  CE1', ' A 174  CYS  HG ', -1.101, (142.276, 167.081, 142.044)), (' A 309  LEU  CD1', ' B 295  PRO  CD ', -1.098, (144.117, 131.033, 135.616)), (' A 291  ILE HG21', ' B 309  LEU HD21', -1.097, (144.072, 152.201, 138.097)), (' B 205  LEU HD11', ' B 368  ILE HD13', -1.097, (127.864, 119.769, 143.52)), (' A 309  LEU HD23', ' B 291  ILE HG22', -1.094, (142.435, 132.863, 139.972)), (' A 315  LYS  HE3', ' B 311  GLY  O  ', -1.094, (139.059, 148.355, 145.781)), (' A 295  PRO  HD3', ' B 309  LEU HD11', -1.089, (143.037, 153.896, 135.986)), (' A 309  LEU HD21', ' B 291  ILE HG21', -1.086, (141.421, 133.588, 137.956)), (' B 205  LEU HD22', ' B 235  VAL HG21', -1.08, (127.442, 123.295, 147.353)), (' A 284  GLU  OE2', ' B 110  PHE  CG ', -1.071, (152.381, 131.18, 142.897)), (' A 311  GLY  O  ', ' B 315  LYS  HE3', -1.071, (146.891, 137.706, 145.78)), (' A 308  LEU  O  ', ' B 316  GLY  HA3', -1.063, (145.047, 134.727, 142.44)), (' B 205  LEU HD22', ' B 235  VAL  CG2', -1.062, (126.535, 121.971, 147.124)), (' A 301  LEU HD23', ' B 303  MET  HE3', -1.062, (143.916, 145.507, 134.07)), (' A 291  ILE HG22', ' B 309  LEU HD23', -1.062, (143.679, 153.143, 140.125)), (' A 205  LEU HD22', ' A 235  VAL  CG2', -1.06, (159.702, 162.972, 147.145)), (' A  64  ILE HG13', ' A 137  ILE HG21', -1.058, (133.428, 177.365, 132.966)), (' A 316  GLY  HA3', ' B 308  LEU  O  ', -1.058, (141.387, 150.114, 141.488)), (' B  64  ILE HG13', ' B 137  ILE HG21', -1.044, (151.72, 108.619, 133.476)), (' A 309  LEU HD11', ' B 295  PRO  HD3', -1.041, (142.57, 131.68, 136.313)), (' A 315  LYS  HD2', ' B 313  THR HG22', -1.04, (141.732, 145.972, 147.367)), (' A 308  LEU  O  ', ' B 316  GLY  CA ', -1.031, (144.577, 135.998, 141.736)), (' A 316  GLY  CA ', ' B 308  LEU  O  ', -1.03, (141.896, 150.494, 141.763)), (' A 313  THR HG22', ' B 315  LYS  HD2', -1.02, (144.703, 139.088, 146.89)), (' B  92  LEU HD21', ' B 328  VAL HG21', -1.01, (146.901, 119.213, 151.684)), (' A  92  LEU HD21', ' A 328  VAL HG21', -1.009, (138.932, 167.112, 151.795)), (' B 284  GLU  HG3', ' B 310  SER  HB3', -1.005, (134.195, 150.894, 142.262)), (' A 286  TYR  HE2', ' B 107  GLU  CB ', -0.998, (148.348, 136.922, 152.651)), (' A 284  GLU  HG3', ' A 310  SER  HB3', -0.996, (151.65, 135.424, 142.291)), (' A 260  GLY  HA3', ' B 101  ARG HH11', -0.993, (161.249, 136.804, 144.648)), (' A 309  LEU HD11', ' B 295  PRO  CD ', -0.992, (143.2, 131.855, 135.395)), (' A 205  LEU  CD1', ' A 368  ILE HD13', -0.988, (157.382, 165.134, 143.872)), (' B 205  LEU  CD1', ' B 368  ILE HD13', -0.986, (128.102, 121.005, 143.96)), (' A 314  TRP  CE3', ' B 314  TRP  CE3', -0.985, (142.776, 142.485, 138.477)), (' A  66  GLY  O  ', ' A 145  THR  OG1', -0.983, (139.949, 173.865, 141.22)), (' A 101  ARG HH11', ' B 260  GLY  HA3', -0.983, (124.347, 149.023, 144.549)), (' B  73  VAL HG11', ' B  76  ILE  CG2', -0.982, (155.358, 107.648, 153.482)), (' A 110  PHE  CG ', ' B 284  GLU  OE2', -0.978, (133.939, 154.797, 143.003)), (' A 107  GLU  O  ', ' B 286  TYR  CE1', -0.978, (134.357, 149.589, 151.052)), (' A 316  GLY  N  ', ' B 308  LEU  O  ', -0.977, (141.479, 149.588, 141.722)), (' A 309  LEU HD23', ' B 291  ILE  CG2', -0.977, (142.555, 133.87, 139.45)), (' A  73  VAL HG11', ' A  76  ILE  CG2', -0.976, (130.58, 177.911, 153.224)), (' B 200  LEU HD22', ' B 232  ALA  HB2', -0.976, (124.839, 125.407, 142.389)), (' B 352  PHE  O  ', ' B 355  ILE HG13', -0.975, (140.63, 104.253, 135.638)), (' A 352  PHE  O  ', ' A 355  ILE HG13', -0.974, (145.393, 182.388, 136.02)), (' A 295  PRO  CD ', ' B 309  LEU HD11', -0.971, (142.749, 154.205, 135.394)), (' A 308  LEU  O  ', ' B 316  GLY  N  ', -0.971, (144.243, 136.061, 142.719)), (' A 286  TYR  CE1', ' B 107  GLU  O  ', -0.969, (151.717, 136.395, 151.143)), (' B  66  GLY  O  ', ' B 145  THR  OG1', -0.967, (146.011, 112.09, 141.361)), (' A 200  LEU HD22', ' A 232  ALA  HB2', -0.958, (161.281, 160.053, 142.914)), (' A 345  LEU  O  ', ' A 369  ARG  HB3', -0.956, (154.376, 170.066, 143.827)), (' B 343  ASP  O  ', ' B 346  ILE HG12', -0.953, (129.139, 113.52, 147.487)), (' A 343  ASP  O  ', ' A 346  ILE HG12', -0.953, (157.612, 172.113, 147.722)), (' B  73  VAL  CG1', ' B  76  ILE HG23', -0.951, (155.718, 106.955, 152.51)), (' B 345  LEU  O  ', ' B 369  ARG  HB3', -0.948, (131.58, 115.337, 143.825)), (' A  73  VAL  CG1', ' A  76  ILE HG23', -0.946, (129.592, 178.984, 153.091)), (' A  36  VAL HG13', ' A  73  VAL HG13', -0.946, (130.543, 178.719, 151.868)), (' A 301  LEU  CD2', ' B 303  MET  HE3', -0.946, (144.737, 146.207, 133.236)), (' A 303  MET  HE3', ' B 301  LEU  CD2', -0.944, (141.1, 139.9, 133.182)), (' A 284  GLU  OE2', ' B 110  PHE  CD1', -0.939, (152.505, 131.174, 141.889)), (' A 110  PHE  CD1', ' B 284  GLU  OE2', -0.936, (133.697, 154.813, 141.754)), (' A 311  GLY  CA ', ' B 316  GLY  O  ', -0.935, (146.032, 135.119, 144.081)), (' A 303  MET  CE ', ' B 301  LEU  CD2', -0.934, (141.108, 140.306, 132.769)), (' B  67  HIS  CE1', ' B 174  CYS  SG ', -0.932, (143.54, 119.192, 142.477)), (' A 301  LEU  CD2', ' B 303  MET  CE ', -0.928, (144.788, 145.571, 132.701)), (' A 198  PHE  HE1', ' A 265  SER  HG ', -0.927, (154.627, 147.81, 141.002)), (' A 316  GLY  O  ', ' B 311  GLY  CA ', -0.923, (139.817, 150.8, 144.252)), (' A 251  GLN HE21', ' A 277  THR  HA ', -0.922, (154.047, 145.134, 133.627)), (' A 291  ILE  CG2', ' B 309  LEU HD23', -0.92, (143.317, 152.403, 139.422)), (' B  36  VAL HG13', ' B  73  VAL HG13', -0.919, (155.181, 108.173, 151.493)), (' A  73  VAL  CG1', ' A  76  ILE  CG2', -0.919, (130.286, 178.712, 152.535)), (' A 107  GLU  CB ', ' B 286  TYR  HE2', -0.918, (137.601, 148.996, 152.726)), (' B  73  VAL  CG1', ' B  76  ILE  CG2', -0.912, (155.667, 107.317, 152.49)), (' A  92  LEU HD13', ' A 324  SER  HB3', -0.908, (135.803, 164.708, 151.296)), (' A 120  ARG HH12', ' A 124  GLN  HA ', -0.906, (125.172, 166.195, 140.75)), (' B  92  LEU HD13', ' B 324  SER  HB3', -0.905, (149.8, 120.596, 151.107)), (' B 120  ARG HH12', ' B 124  GLN  HA ', -0.905, (161.697, 119.762, 140.751)), (' A  15  TRP  CZ3', ' A  62  PRO  HG3', -0.902, (131.69, 176.645, 126.689)), (' B 251  GLN HE21', ' B 277  THR  HA ', -0.902, (131.848, 140.688, 133.589)), (' A 314  TRP  HE3', ' B 314  TRP  CE3', -0.902, (142.601, 143.35, 138.883)), (' B  69  ALA  O  ', ' B  91  PRO  CD ', -0.901, (146.044, 112.615, 147.804)), (' B  15  TRP  CZ3', ' B  62  PRO  HG3', -0.899, (154.411, 108.629, 126.351)), (' A  67  HIS  CE1', ' A 174  CYS  SG ', -0.897, (142.693, 167.258, 143.124)), (' B 198  PHE  HE1', ' B 265  SER  HG ', -0.894, (131.588, 137.989, 140.826)), (' A 205  LEU  CD2', ' A 235  VAL HG21', -0.889, (158.515, 162.988, 146.241)), (' A  69  ALA  O  ', ' A  91  PRO  CD ', -0.888, (139.868, 173.25, 147.842)), (' A 309  LEU HD22', ' B 291  ILE HG22', -0.878, (141.833, 131.491, 139.472)), (' A  64  ILE HG13', ' A 137  ILE  CG2', -0.876, (133.586, 176.499, 132.757)), (' B  64  ILE HG13', ' B 137  ILE  CG2', -0.875, (152.428, 109.424, 132.785)), (' B  88  LYS  NZ ', ' B 162  ALA  O  ', -0.873, (143.881, 105.649, 157.744)), (' A  88  LYS  NZ ', ' A 162  ALA  O  ', -0.871, (141.947, 180.185, 157.776)), (' B 223  ASP  O  ', ' B 243  PRO  HD2', -0.869, (124.222, 130.137, 133.985)), (' A 301  LEU HD23', ' B 303  MET  HE2', -0.868, (144.851, 144.753, 133.176)), (' A  16  GLU  HB2', ' A  19  LYS  HD2', -0.867, (139.13, 174.538, 121.411)), (' A 303  MET  HB3', ' B 303  MET  HE2', -0.867, (145.377, 143.647, 132.342)), (' A 291  ILE HG22', ' B 309  LEU HD22', -0.866, (143.711, 154.105, 139.79)), (' A 314  TRP  CE3', ' B 314  TRP  HE3', -0.865, (143.366, 143.455, 138.564)), (' B 208  ILE HG22', ' B 235  VAL HG12', -0.863, (127.614, 126.242, 149.123)), (' B 205  LEU  CD2', ' B 235  VAL HG21', -0.86, (127.437, 123.069, 146.26)), (' A 223  ASP  O  ', ' A 243  PRO  HD2', -0.86, (161.919, 155.387, 133.551)), (' B  14  LEU  CD2', ' B  52  VAL HG12', -0.859, (146.469, 116.367, 129.498)), (' A 223  ASP  O  ', ' A 243  PRO  CD ', -0.859, (162.489, 155.077, 133.885)), (' B 223  ASP  O  ', ' B 243  PRO  CD ', -0.859, (123.848, 130.875, 133.778)), (' A 205  LEU HD11', ' A 368  ILE  CD1', -0.855, (158.417, 165.573, 143.345)), (' B 205  LEU HD11', ' B 368  ILE  CD1', -0.848, (127.535, 120.482, 143.344)), (' B  16  GLU  HB2', ' B  19  LYS  HD2', -0.848, (146.677, 112.402, 121.574)), (' A  14  LEU  CD2', ' A  52  VAL HG12', -0.847, (138.977, 170.026, 129.228)), (' A 303  MET  HE2', ' B 303  MET  HB3', -0.845, (141.079, 142.451, 132.418)), (' A 295  PRO  CD ', ' B 309  LEU HD12', -0.845, (141.055, 154.403, 136.232)), (' A 208  ILE HG22', ' A 235  VAL HG12', -0.845, (158.872, 159.076, 148.983)), (' A  70  ALA  HB1', ' A 166  LEU HD22', -0.845, (142.572, 176.299, 151.27)), (' B  70  ALA  HB1', ' B 166  LEU HD22', -0.844, (143.515, 109.544, 151.252)), (' B 307  LEU HD22', ' B 312  ARG  NH2', -0.842, (132.945, 147.297, 138.047)), (' A 303  MET  HE2', ' B 301  LEU HD23', -0.837, (140.967, 141.154, 133.021)), (' A 107  GLU  HB2', ' B 286  TYR  HE2', -0.836, (137.264, 147.982, 152.291)), (' A 303  MET  SD ', ' B 303  MET  CG ', -0.832, (142.41, 143.184, 132.674)), (' A 105  HIS  CD2', ' B 286  TYR  CD1', -0.832, (132.45, 147.578, 151.465)), (' A 303  MET  CG ', ' B 303  MET  SD ', -0.828, (143.598, 142.692, 132.745)), (' A 307  LEU HD22', ' A 312  ARG  NH2', -0.823, (152.924, 139.393, 138.435)), (' A 286  TYR  CD1', ' B 105  HIS  CD2', -0.819, (153.5, 138.522, 151.441)), (' B 130  PHE  HE1', ' B 139  HIS  NE2', -0.817, (155.233, 110.377, 139.618)), (' A 231  LYS  NZ ', ' A 347  THR HG21', -0.816, (160.345, 170.703, 140.575)), (' A 309  LEU  CD2', ' B 291  ILE HG21', -0.816, (142.13, 133.783, 138.112)), (' A 309  LEU HD12', ' B 295  PRO  CD ', -0.812, (144.954, 131.692, 136.1)), (' B  23  ILE HG12', ' B 355  ILE HD12', -0.803, (142.515, 104.78, 133.72)), (' A  64  ILE  CG1', ' A 137  ILE HG21', -0.8, (134.115, 177.806, 133.5)), (' A 130  PHE  HE1', ' A 139  HIS  NE2', -0.8, (130.827, 175.519, 139.287)), (' B   9  CYS  HB2', ' B 148  GLN  HB2', -0.799, (148.661, 100.657, 140.339)), (' B  64  ILE  CG1', ' B 137  ILE HG21', -0.797, (152.025, 107.997, 133.682)), (' B 198  PHE  HE1', ' B 265  SER  OG ', -0.794, (131.657, 137.512, 141.275)), (' A 178  THR  HA ', ' A 320  GLY  HA3', -0.793, (144.412, 159.167, 146.887)), (' A 198  PHE  HE1', ' A 265  SER  OG ', -0.793, (154.434, 148.77, 141.458)), (' A  23  ILE HG12', ' A 355  ILE HD12', -0.792, (143.456, 181.484, 133.889)), (' B 231  LYS  NZ ', ' B 347  THR HG21', -0.791, (125.46, 115.111, 140.412)), (' A  73  VAL  O  ', ' A  85  PRO  O  ', -0.791, (133.243, 182.291, 154.245)), (' A 260  GLY  HA3', ' B 101  ARG  NH1', -0.791, (162.022, 136.603, 145.007)), (' B 130  PHE  CE1', ' B 139  HIS  NE2', -0.787, (155.231, 109.67, 138.515)), (' B 205  LEU HD12', ' B 368  ILE HG21', -0.786, (129.698, 119.464, 144.041)), (' A   9  CYS  HB2', ' A 148  GLN  HB2', -0.785, (137.266, 185.006, 140.33)), (' A 101  ARG  NH1', ' B 260  GLY  HA3', -0.783, (123.976, 149.428, 144.841)), (' B  67  HIS  CE1', ' B 174  CYS  HG ', -0.782, (143.53, 118.599, 142.172)), (' A 284  GLU  HA ', ' A 312  ARG  NE ', -0.782, (152.642, 138.103, 142.282)), (' A  92  LEU  CD2', ' A 328  VAL HG21', -0.78, (138.932, 166.621, 151.668)), (' B  92  LEU  CD2', ' B 328  VAL HG21', -0.78, (147.02, 119.438, 151.667)), (' A 205  LEU HD12', ' A 368  ILE HG21', -0.779, (156.689, 166.457, 143.938)), (' A 322  PHE  HE1', ' A 331  LEU HD22', -0.778, (144.014, 163.327, 154.038)), (' A 130  PHE  CE1', ' A 139  HIS  NE2', -0.777, (130.379, 176.549, 138.614)), (' A  41  VAL HG21', ' A 166  LEU HD12', -0.777, (142.767, 180.386, 151.692)), (' B 178  THR  HA ', ' B 320  GLY  HA3', -0.775, (141.342, 127.424, 147.3)), (' B  73  VAL  O  ', ' B  85  PRO  O  ', -0.773, (153.283, 103.229, 154.771)), (' B 284  GLU  HA ', ' B 312  ARG  NE ', -0.773, (133.64, 148.145, 142.231)), (' A 272  LEU  HB3', ' A 301  LEU HD13', -0.769, (145.738, 148.508, 130.055)), (' B  41  VAL HG21', ' B 166  LEU HD12', -0.767, (143.004, 105.35, 151.762)), (' B  73  VAL HG11', ' B  76  ILE HG21', -0.764, (156.256, 108.248, 153.906)), (' A 315  LYS  HD2', ' B 313  THR HG23', -0.763, (140.066, 146.062, 147.371)), (' A  73  VAL HG11', ' A  76  ILE HG21', -0.762, (129.896, 177.463, 154.102)), (' A  15  TRP  HZ2', ' A 132  CYS  HG ', -0.762, (132.776, 181.872, 127.417)), (' B 307  LEU  O  ', ' B 310  SER  HB2', -0.76, (137.018, 149.83, 140.312)), (' B 272  LEU  HB3', ' B 301  LEU HD13', -0.759, (140.076, 137.085, 129.691)), (' A 291  ILE  CB ', ' B 309  LEU HD23', -0.752, (144.327, 152.052, 139.657)), (' A 307  LEU  O  ', ' A 310  SER  HB2', -0.752, (148.854, 136.103, 140.35)), (' A 286  TYR  HE2', ' B 107  GLU  HB2', -0.751, (148.6, 138.158, 152.561)), (' A 309  LEU HD23', ' B 291  ILE  CB ', -0.75, (141.871, 134.104, 139.479)), (' B  93  PHE  CE1', ' B 141  LEU HD13', -0.747, (148.67, 121.567, 139.917)), (' A 172  ILE HG23', ' A 331  LEU HD23', -0.747, (144.193, 165.054, 153.289)), (' B  97  CYS  O  ', ' B 103  CYS  SG ', -0.745, (157.992, 127.391, 151.079)), (' B 322  PHE  HE1', ' B 331  LEU HD22', -0.744, (141.834, 122.715, 153.965)), (' A 301  LEU  CD2', ' B 303  MET  HE2', -0.744, (144.871, 145.367, 132.418)), (' A  93  PHE  CE1', ' A 141  LEU HD13', -0.744, (136.776, 163.841, 140.027)), (' A 101  ARG  NH1', ' B 260  GLY  CA ', -0.743, (123.241, 148.99, 144.905)), (' A 260  GLY  CA ', ' B 101  ARG  NH1', -0.741, (162.708, 136.887, 144.807)), (' A  97  CYS  O  ', ' A 103  CYS  SG ', -0.741, (128.592, 158.661, 150.784)), (' A 303  MET  HE2', ' B 301  LEU  CD2', -0.741, (140.778, 141.077, 133.127)), (' A 308  LEU HD21', ' B 314  TRP  CE3', -0.741, (144.547, 141.429, 139.285)), (' B  15  TRP  HZ2', ' B 132  CYS  HG ', -0.74, (152.5, 104.354, 127.362)), (' A 286  TYR  CD1', ' B 105  HIS  NE2', -0.74, (152.657, 139.136, 151.744)), (' A 246  TYR  CE1', ' A 253  VAL HG11', -0.739, (166.451, 148.469, 135.561)), (' B 246  TYR  CE1', ' B 253  VAL HG11', -0.739, (119.474, 137.992, 135.939)), (' B 180  TYR  CE1', ' B 340  PHE  HE2', -0.737, (133.818, 125.964, 155.618)), (' B 231  LYS  HZ1', ' B 347  THR HG21', -0.736, (125.671, 114.41, 140.207)), (' A 180  TYR  CE1', ' A 340  PHE  HE2', -0.736, (152.007, 160.079, 155.561)), (' A 314  TRP  CE3', ' B 308  LEU HD21', -0.736, (141.9, 144.654, 138.881)), (' B 172  ILE HG23', ' B 331  LEU HD23', -0.736, (141.635, 120.894, 153.375)), (' A 284  GLU  CG ', ' A 310  SER  HB3', -0.736, (151.598, 134.409, 142.496)), (' A 102  VAL HG13', ' B 285  ALA  HB2', -0.733, (132.605, 151.713, 148.004)), (' B 267  GLU  HG2', ' B 275  MET  HG2', -0.733, (137.732, 133.682, 136.764)), (' A 313  THR HG23', ' B 315  LYS  HD2', -0.733, (145.909, 139.791, 146.934)), (' B 194  THR HG22', ' B 262  VAL HG13', -0.732, (126.267, 139.251, 145.93)), (' B  12  ALA  HB3', ' B 146  PHE  CB ', -0.731, (145.029, 109.142, 135.872)), (' A 194  THR HG22', ' A 262  VAL HG13', -0.73, (159.587, 146.557, 146.067)), (' A 292  VAL HG12', ' A 317  ALA  HB3', -0.729, (144.156, 154.81, 144.219)), (' A 231  LYS  HZ1', ' A 347  THR HG21', -0.721, (160.814, 171.278, 140.35)), (' B  45  ILE  CD1', ' B 358  GLY  HA3', -0.721, (136.176, 110.593, 135.869)), (' A 301  LEU  O  ', ' B 302  SER  HA ', -0.72, (142.031, 144.2, 128.378)), (' A  12  ALA  HB3', ' A 146  PHE  CB ', -0.718, (140.531, 176.725, 135.812)), (' B 292  VAL HG12', ' B 317  ALA  HB3', -0.717, (141.858, 131.038, 144.267)), (' A  45  ILE  CD1', ' A 358  GLY  HA3', -0.717, (149.87, 176.077, 135.638)), (' A  12  ALA  HB3', ' A 146  PHE  HB3', -0.714, (141.021, 177.561, 135.362)), (' B  12  ALA  HB3', ' B 146  PHE  HB3', -0.713, (145.179, 108.063, 135.275)), (' A 285  ALA  HB2', ' B 102  VAL HG13', -0.713, (153.239, 134.216, 148.077)), (' B 291  ILE HD11', ' B 314  TRP  HE1', -0.712, (140.257, 137.925, 137.904)), (' A 310  SER  HA ', ' B 318  ILE HD11', -0.711, (148.662, 132.031, 141.419)), (' B 284  GLU  CG ', ' B 310  SER  HB3', -0.711, (134.361, 151.65, 142.295)), (' A 267  GLU  HG2', ' A 275  MET  HG2', -0.711, (147.972, 152.322, 136.858)), (' A 260  GLY  CA ', ' B 101  ARG HH11', -0.71, (161.793, 137.491, 144.822)), (' B   8  LYS  HG2', ' B  27  GLU  HG2', -0.71, (156.149, 97.871, 136.204)), (' A 302  SER  HA ', ' B 301  LEU  O  ', -0.709, (143.606, 141.979, 128.295)), (' B 166  LEU  HA ', ' B 169  VAL HG12', -0.708, (140.549, 110.447, 152.091)), (' A 260  GLY  N  ', ' B 101  ARG  NH1', -0.702, (162.711, 137.709, 144.851)), (' A 101  ARG  NH1', ' B 260  GLY  N  ', -0.701, (123.111, 148.572, 144.59)), (' A 318  ILE HD11', ' B 310  SER  HA ', -0.701, (137.162, 154.021, 141.506)), (' A  92  LEU HD21', ' A 328  VAL  CG2', -0.7, (139.63, 166.299, 152.239)), (' A 123  MET  O  ', ' A 126  GLY  N  ', -0.7, (122.73, 169.13, 138.546)), (' A 200  LEU HD22', ' A 232  ALA  CB ', -0.7, (161.201, 159.793, 143.153)), (' A 107  GLU  HB3', ' B 286  TYR  CE2', -0.7, (137.663, 149.102, 152.206)), (' B  23  ILE  CD1', ' B 355  ILE HD12', -0.699, (142.283, 104.545, 133.739)), (' A 291  ILE HD11', ' A 314  TRP  HE1', -0.698, (145.924, 147.551, 138.039)), (' B 275  MET  HE1', ' B 295  PRO  HG3', -0.698, (142.175, 132.515, 134.636)), (' B 200  LEU HD22', ' B 232  ALA  CB ', -0.697, (124.678, 126.019, 142.921)), (' A 107  GLU  HB3', ' B 286  TYR  HE2', -0.697, (137.661, 149.041, 152.482)), (' A 303  MET  CE ', ' B 303  MET  HB3', -0.697, (141.494, 142.206, 133.207)), (' A  23  ILE  CD1', ' A 355  ILE HD12', -0.696, (143.773, 181.725, 133.373)), (' A 275  MET  HE1', ' A 295  PRO  HG3', -0.696, (144.298, 153.461, 134.781)), (' B 251  GLN  HG3', ' B 277  THR HG23', -0.695, (129.365, 140.238, 133.871)), (' A 301  LEU  N  ', ' B 303  MET  O  ', -0.695, (141.122, 147.019, 129.518)), (' B 123  MET  O  ', ' B 126  GLY  N  ', -0.695, (163.119, 116.517, 138.371)), (' A   3  ALA  HA ', ' A  37  ARG  NH1', -0.693, (126.632, 186.012, 149.098)), (' A 251  GLN  HG3', ' A 277  THR HG23', -0.693, (157.132, 145.441, 133.667)), (' B   3  ALA  HA ', ' B  37  ARG  NH1', -0.693, (159.191, 99.977, 149.27)), (' B 282  CYS  HB3', ' B 287  GLY  HA3', -0.692, (134.001, 144.036, 143.963)), (' A 291  ILE HG21', ' B 309  LEU  CD2', -0.691, (143.822, 152.102, 138.208)), (' A 286  TYR  HE1', ' B 107  GLU  O  ', -0.691, (152.532, 135.813, 152.346)), (' A 129  ARG  H  ', ' A 139  HIS  HE1', -0.69, (127.404, 175.984, 137.982)), (' B 254  LEU HD12', ' B 281  CYS  SG ', -0.69, (127.4, 139.145, 137.369)), (' A 303  MET  O  ', ' B 301  LEU  N  ', -0.689, (145.013, 138.864, 129.488)), (' B 129  ARG  H  ', ' B 139  HIS  HE1', -0.689, (157.918, 110.096, 137.981)), (' A 282  CYS  HB3', ' A 287  GLY  HA3', -0.688, (152.195, 141.774, 144.396)), (' A   8  LYS  HG2', ' A  27  GLU  HG2', -0.688, (129.805, 188.155, 136.126)), (' A 254  LEU HD12', ' A 281  CYS  SG ', -0.688, (158.305, 146.312, 137.422)), (' A 303  MET  HB3', ' B 303  MET  CE ', -0.688, (144.497, 143.883, 133.047)), (' A 166  LEU  HA ', ' A 169  VAL HG12', -0.688, (145.608, 175.412, 152.213)), (' A 286  TYR  CE2', ' B 107  GLU  HB3', -0.686, (148.286, 136.838, 152.119)), (' A 105  HIS  NE2', ' B 286  TYR  CD1', -0.684, (133.293, 146.952, 151.764)), (' B 187  ALA  HA ', ' B 288  VAL HG11', -0.68, (138.765, 137.926, 149.161)), (' B 223  ASP  O  ', ' B 243  PRO  HD3', -0.68, (123.291, 131.142, 134.696)), (' A  28  VAL HG22', ' A 130  PHE  CD2', -0.675, (131.641, 180.847, 138.139)), (' B 251  GLN  NE2', ' B 277  THR  HA ', -0.675, (131.547, 141.238, 133.349)), (' A 319  PHE  CE2', ' A 322  PHE  CD2', -0.673, (140.151, 162.174, 150.561)), (' B 251  GLN  CG ', ' B 277  THR HG23', -0.672, (129.439, 140.281, 134.104)), (' A  23  ILE  CG1', ' A 355  ILE HD12', -0.671, (143.139, 182.159, 133.52)), (' B 120  ARG  NH1', ' B 124  GLN  HA ', -0.67, (161.004, 119.452, 140.399)), (' B 205  LEU  HB2', ' B 345  LEU HD21', -0.669, (131.058, 121.456, 145.793)), (' B  92  LEU  CD1', ' B 324  SER  HB3', -0.669, (150.115, 120.432, 151.349)), (' B 198  PHE  CE1', ' B 265  SER  OG ', -0.669, (131.852, 137.638, 140.678)), (' B  28  VAL HG22', ' B 130  PHE  CD2', -0.669, (154.391, 104.993, 138.058)), (' A 187  ALA  HA ', ' A 288  VAL HG11', -0.668, (147.934, 147.73, 148.802)), (' A 205  LEU  HB2', ' A 345  LEU HD21', -0.666, (155.049, 164.457, 145.91)), (' B   3  ALA  O  ', ' B  37  ARG  CZ ', -0.665, (159.706, 100.829, 147.557)), (' A 286  TYR  CE2', ' B 105  HIS  CE1', -0.663, (151.036, 138.768, 152.713)), (' A 251  GLN  CG ', ' A 277  THR HG23', -0.66, (156.817, 145.187, 133.889)), (' B  92  LEU HD21', ' B 328  VAL  CG2', -0.66, (146.215, 119.524, 152.312)), (' A 223  ASP  O  ', ' A 243  PRO  HD3', -0.66, (162.168, 154.681, 134.582)), (' A 169  VAL HG23', ' A 172  ILE HD12', -0.659, (146.027, 170.76, 154.178)), (' B 319  PHE  CE2', ' B 322  PHE  CD2', -0.658, (145.801, 123.925, 150.521)), (' A  35  GLU  OE2', ' A 129  ARG  NH1', -0.658, (123.542, 173.752, 142.814)), (' B  35  GLU  OE2', ' B 129  ARG  NH1', -0.657, (162.286, 112.084, 142.782)), (' B  71  GLY  HA2', ' B 166  LEU HD13', -0.656, (144.26, 106.978, 150.884)), (' A   3  ALA  O  ', ' A  37  ARG  CZ ', -0.656, (126.247, 184.574, 147.558)), (' B  23  ILE  CG1', ' B 355  ILE HD12', -0.655, (142.491, 104.352, 133.273)), (' A 286  TYR  HE2', ' B 107  GLU  HB3', -0.654, (148.001, 137.164, 152.415)), (' A  73  VAL HG12', ' A  76  ILE HG23', -0.652, (130.229, 179.75, 153.735)), (' B 208  ILE  CG2', ' B 235  VAL HG12', -0.652, (127.138, 126.49, 148.455)), (' A  71  GLY  HA2', ' A 166  LEU HD13', -0.652, (141.282, 178.687, 150.522)), (' A  92  LEU  CD1', ' A 324  SER  HB3', -0.651, (135.907, 165.477, 151.203)), (' A  15  TRP  HZ3', ' A  62  PRO  HG3', -0.651, (131.15, 177.407, 126.412)), (' A  51  HIS  HB3', ' A  57  LEU  HG ', -0.651, (141.953, 162.972, 131.749)), (' A 198  PHE  CE1', ' A 265  SER  OG ', -0.65, (153.964, 148.475, 140.603)), (' A 293  GLY  O  ', ' B 309  LEU  CD1', -0.649, (143.355, 155.244, 137.094)), (' A 309  LEU  CD1', ' B 293  GLY  O  ', -0.648, (142.914, 131.068, 137.008)), (' B  51  HIS  HB3', ' B  57  LEU  HG ', -0.648, (144.378, 123.457, 131.821)), (' A 105  HIS  HE1', ' B 286  TYR  CE2', -0.648, (135.362, 147.245, 153.278)), (' A 120  ARG  NH1', ' A 124  GLN  HA ', -0.647, (124.914, 166.461, 140.384)), (' A  36  VAL  CG1', ' A  73  VAL HG13', -0.646, (131.476, 178.047, 151.26)), (' B  36  VAL  CG1', ' B  73  VAL HG13', -0.645, (154.804, 107.857, 151.181)), (' B  15  TRP  HZ3', ' B  62  PRO  HG3', -0.645, (154.934, 108.302, 126.714)), (' A 208  ILE  CG2', ' A 235  VAL HG12', -0.645, (159.249, 159.431, 148.558)), (' B  14  LEU  HB2', ' B  21  PHE  CE2', -0.644, (145.596, 111.724, 130.798)), (' A  33  ALA  O  ', ' A  78  GLU  N  ', -0.644, (121.862, 176.925, 151.807)), (' B 169  VAL HG23', ' B 172  ILE HD12', -0.643, (139.742, 115.71, 153.951)), (' A 148  GLN  HG2', ' A 374  PHE  CE1', -0.643, (140.704, 186.183, 142.224)), (' B 168  LYS  HD3', ' B 335  PHE  HZ ', -0.642, (133.359, 112.272, 154.154)), (' A  56  THR HG23', ' A 296  PRO  HA ', -0.642, (142.921, 158.409, 129.198)), (' A  14  LEU  HB2', ' A  21  PHE  CE2', -0.641, (140.299, 174.297, 130.839)), (' B  33  ALA  O  ', ' B  78  GLU  N  ', -0.641, (163.988, 108.903, 151.717)), (' A 286  TYR  CE2', ' B 105  HIS  HE1', -0.641, (150.707, 138.735, 153.164)), (' A 168  LYS  HD3', ' A 335  PHE  HZ ', -0.641, (152.91, 173.485, 154.059)), (' B  56  THR HG23', ' B 296  PRO  HA ', -0.639, (142.954, 127.014, 129.208)), (' A 319  PHE  O  ', ' A 322  PHE  HB3', -0.638, (141.059, 159.86, 149.189)), (' A 251  GLN  NE2', ' A 277  THR  HA ', -0.638, (154.576, 144.656, 133.455)), (' B 148  GLN  HG2', ' B 374  PHE  CE1', -0.637, (145.08, 99.892, 142.171)), (' A 107  GLU  O  ', ' B 286  TYR  HE1', -0.636, (133.377, 150.228, 152.308)), (' B 322  PHE  CE1', ' B 331  LEU HD22', -0.633, (142.052, 123.199, 153.611)), (' A  33  ALA  HA ', ' A  78  GLU  H  ', -0.632, (120.682, 176.79, 150.828)), (' A  52  VAL HG21', ' A 140  PHE  CE1', -0.631, (138.051, 167.299, 133.697)), (' B  73  VAL HG12', ' B  76  ILE HG23', -0.63, (155.583, 106.392, 153.68)), (' B 319  PHE  O  ', ' B 322  PHE  HB3', -0.63, (144.893, 126.2, 149.189)), (' A 295  PRO  HD3', ' B 309  LEU HD13', -0.63, (142.461, 155.42, 137.04)), (' B  52  VAL HG21', ' B 140  PHE  CE1', -0.629, (147.435, 118.176, 133.703)), (' B 335  PHE  CE1', ' B 342  LEU HD12', -0.628, (134.492, 114.75, 154.394)), (' A 322  PHE  CE1', ' A 331  LEU HD22', -0.627, (143.732, 163.019, 153.561)), (' B   8  LYS  HE2', ' B  27  GLU  OE2', -0.627, (157.671, 96.332, 134.881)), (' A 180  TYR  CE1', ' A 340  PHE  CE2', -0.626, (151.503, 160.716, 155.826)), (' B  33  ALA  HA ', ' B  78  GLU  H  ', -0.626, (165.336, 109.003, 150.837)), (' A 335  PHE  CE1', ' A 342  LEU HD12', -0.625, (151.929, 170.448, 154.219)), (' A 352  PHE  O  ', ' A 355  ILE  CG1', -0.625, (145.115, 181.268, 136.14)), (' B  93  PHE  O  ', ' B 141  LEU HD22', -0.624, (150.473, 121.23, 142.993)), (' A 309  LEU  HA ', ' B 316  GLY  HA3', -0.624, (144.246, 133.968, 141.288)), (' B 267  GLU  O  ', ' B 292  VAL HG22', -0.624, (138.013, 130.536, 141.746)), (' A 267  GLU  O  ', ' A 292  VAL HG22', -0.624, (148.636, 155.488, 141.309)), (' B 352  PHE  O  ', ' B 355  ILE  CG1', -0.623, (140.506, 104.923, 136.234)), (' A  93  PHE  O  ', ' A 141  LEU HD22', -0.623, (135.548, 165.066, 143.124)), (' B 180  TYR  CE1', ' B 340  PHE  CE2', -0.623, (134.375, 125.259, 155.934)), (' A   8  LYS  HE2', ' A  27  GLU  OE2', -0.62, (128.142, 190.248, 134.96)), (' A 291  ILE HG22', ' B 309  LEU HD21', -0.618, (143.945, 153.928, 138.184)), (' A 314  TRP  CE3', ' B 308  LEU  CD2', -0.618, (141.74, 145.347, 139.111)), (' A  57  LEU HD21', ' A 294  VAL HG11', -0.617, (140.158, 159.875, 134.709)), (' A 132  CYS  HB2', ' A 137  ILE HD11', -0.617, (131.717, 181.041, 130.457)), (' B 203  VAL HG12', ' B 268  VAL  CG1', -0.616, (135.281, 127.609, 142.488)), (' A 105  HIS  CE1', ' B 286  TYR  CE2', -0.616, (134.778, 147.345, 152.638)), (' A 309  LEU HD21', ' B 291  ILE HG22', -0.616, (141.894, 132.042, 138.131)), (' A 291  ILE  HB ', ' B 309  LEU HD23', -0.615, (143.384, 152.037, 139.936)), (' B 246  TYR  CD1', ' B 253  VAL HG21', -0.614, (119.52, 137.917, 133.728)), (' A 316  GLY  HA3', ' B 309  LEU  HA ', -0.613, (141.822, 151.358, 141.418)), (' B 284  GLU  CA ', ' B 312  ARG  HE ', -0.61, (132.625, 148.924, 142.645)), (' B  57  LEU HD21', ' B 294  VAL HG11', -0.61, (145.487, 125.971, 134.24)), (' A 315  LYS  CD ', ' B 313  THR HG22', -0.61, (141.055, 146.796, 146.488)), (' A 272  LEU HD22', ' A 301  LEU  HB2', -0.608, (144.026, 148.255, 130.614)), (' A 308  LEU  CD2', ' B 314  TRP  CE3', -0.608, (144.232, 140.734, 139.255)), (' A 309  LEU HD23', ' B 291  ILE  HB ', -0.607, (142.145, 134.302, 139.993)), (' A 272  LEU  CD2', ' B 305  PRO  HG3', -0.606, (143.394, 150.635, 131.601)), (' A 305  PRO  HG3', ' B 272  LEU  CD2', -0.606, (142.826, 135.227, 132.082)), (' A 220  ILE HG12', ' A 239  GLU  HB2', -0.606, (165.318, 151.135, 144.157)), (' B  13  VAL HG22', ' B  64  ILE HG12', -0.605, (150.748, 107.852, 132.88)), (' A 293  GLY  O  ', ' B 309  LEU HD13', -0.605, (143.052, 155.688, 137.429)), (' B 132  CYS  HB2', ' B 137  ILE HD11', -0.602, (153.606, 105.156, 130.468)), (' A 246  TYR  CD1', ' A 253  VAL HG21', -0.602, (166.526, 147.56, 134.031)), (' B  15  TRP  CE3', ' B  62  PRO  HB3', -0.601, (152.78, 109.365, 126.476)), (' A 205  LEU HD12', ' A 345  LEU HD23', -0.601, (155.498, 165.933, 145.281)), (' A 203  VAL HG12', ' A 268  VAL  CG1', -0.597, (150.671, 158.415, 142.429)), (' A  15  TRP  CE3', ' A  62  PRO  HB3', -0.596, (133.252, 176.474, 126.396)), (' B 220  ILE HG12', ' B 239  GLU  HB2', -0.596, (120.73, 134.78, 144.091)), (' A  12  ALA  CB ', ' A 146  PHE  HB3', -0.595, (140.773, 177.995, 135.275)), (' A 341  ALA  O  ', ' A 344  PRO  HD2', -0.595, (156.939, 167.33, 151.321)), (' A 309  LEU HD13', ' B 293  GLY  O  ', -0.594, (143.385, 130.586, 137.448)), (' B 272  LEU HD22', ' B 301  LEU  HB2', -0.592, (142.171, 137.085, 130.461)), (' B 205  LEU HD12', ' B 345  LEU HD23', -0.59, (130.028, 119.893, 144.952)), (' B  12  ALA  CB ', ' B 146  PHE  HB3', -0.59, (145.313, 107.847, 135.292)), (' A 130  PHE  HE1', ' A 139  HIS  CD2', -0.589, (131.279, 175.491, 139.04)), (' B  28  VAL HG22', ' B 130  PHE  CE2', -0.589, (154.317, 105.053, 139.077)), (' A 313  THR HG22', ' B 315  LYS  CD ', -0.588, (144.895, 139.19, 146.389)), (' B 341  ALA  O  ', ' B 344  PRO  HD2', -0.588, (128.906, 118.648, 151.394)), (' B 272  LEU  HB3', ' B 301  LEU  CD1', -0.588, (139.298, 137.708, 129.897)), (' A   3  ALA  O  ', ' A  37  ARG  NH2', -0.587, (125.962, 184.604, 147.223)), (' A 124  GLN  HG2', ' A 153  ASP  OD2', -0.586, (126.206, 168.522, 144.283)), (' B  46  CYS  SG ', ' B  68  GLU  HB2', -0.586, (141.472, 116.859, 142.29)), (' A  13  VAL HG22', ' A  64  ILE HG12', -0.586, (135.667, 177.84, 133.251)), (' A  46  CYS  SG ', ' A  68  GLU  HB2', -0.585, (145.022, 169.281, 141.857)), (' B 124  GLN  HG2', ' B 153  ASP  OD2', -0.584, (159.622, 117.428, 144.197)), (' B   3  ALA  O  ', ' B  37  ARG  NH2', -0.584, (159.938, 101.382, 147.26)), (' A 272  LEU  HB3', ' A 301  LEU  CD1', -0.584, (146.521, 148.22, 129.793)), (' A 316  GLY  HA3', ' B 308  LEU  C  ', -0.583, (141.152, 150.592, 141.132)), (' B 130  PHE  HE1', ' B 139  HIS  CD2', -0.582, (154.674, 110.496, 139.124)), (' B   6  VAL HG22', ' B  30  PRO  HD3', -0.581, (161.988, 101.283, 141.544)), (' A 200  LEU  CD2', ' A 232  ALA  HB2', -0.581, (160.724, 160.06, 142.308)), (' A  28  VAL HG22', ' A 130  PHE  CE2', -0.579, (131.878, 181.019, 138.953)), (' A   6  VAL HG22', ' A  30  PRO  HD3', -0.578, (123.836, 184.61, 141.484)), (' A 116  LEU  O  ', ' A 119  PRO  HD3', -0.578, (132.46, 159.992, 134.519)), (' B 116  LEU  O  ', ' B 119  PRO  HD3', -0.575, (153.852, 126.014, 134.068)), (' A 109  ASN HD22', ' A 319  PHE  HB3', -0.575, (138.356, 159.466, 147.806)), (' A  92  LEU HD13', ' A 324  SER  CB ', -0.574, (136.452, 164.3, 151.278)), (' A  36  VAL HG13', ' A  76  ILE HG22', -0.574, (129.569, 177.938, 152.067)), (' B  52  VAL  CG2', ' B 140  PHE  CE1', -0.573, (147.56, 119.432, 133.789)), (' A  52  VAL  CG2', ' A 140  PHE  CE1', -0.572, (138.267, 166.658, 133.735)), (' B 115  ASP  O  ', ' B 119  PRO  HA ', -0.571, (155.322, 122.87, 135.394)), (' A 180  TYR  CD1', ' A 210  GLY  HA2', -0.571, (152.182, 158.214, 153.367)), (' B  36  VAL HG13', ' B  76  ILE HG22', -0.57, (156.189, 108.424, 151.543)), (' B 109  ASN HD22', ' B 319  PHE  HB3', -0.569, (147.621, 126.318, 147.977)), (' B  57  LEU HD21', ' B 294  VAL  CG1', -0.569, (144.94, 126.464, 134.35)), (' A  57  LEU HD21', ' A 294  VAL  CG1', -0.569, (141.011, 159.456, 134.251)), (' A 282  CYS  HB3', ' A 287  GLY  CA ', -0.565, (152.178, 142.633, 144.64)), (' A 115  ASP  O  ', ' A 119  PRO  HA ', -0.565, (130.587, 162.936, 135.405)), (' B 319  PHE  HE2', ' B 322  PHE  CD2', -0.565, (146.111, 123.102, 151.067)), (' A 314  TRP  HE3', ' B 314  TRP  HE3', -0.565, (143.068, 142.629, 139.228)), (' A 309  LEU HD13', ' B 295  PRO  HD3', -0.564, (143.737, 130.506, 137.0)), (' B 218  ARG  NE ', ' B 220  ILE HD11', -0.564, (121.013, 138.374, 145.233)), (' A  69  ALA  CB ', ' A 145  THR HG21', -0.562, (139.883, 173.79, 144.566)), (' B 180  TYR  CD1', ' B 210  GLY  HA2', -0.562, (134.095, 127.381, 153.47)), (' A 218  ARG  NE ', ' A 220  ILE HD11', -0.562, (164.871, 147.454, 145.244)), (' B  69  ALA  CB ', ' B 145  THR HG21', -0.562, (146.44, 111.65, 144.261)), (' B 235  VAL  O  ', ' B 235  VAL HG12', -0.56, (126.681, 125.537, 149.946)), (' A 319  PHE  HE2', ' A 322  PHE  CD2', -0.558, (139.513, 162.736, 151.167)), (' B 229  PHE  CD2', ' B 240  CYS  HB3', -0.557, (121.1, 128.184, 139.805)), (' A 235  VAL  O  ', ' A 235  VAL HG12', -0.555, (159.245, 160.122, 149.952)), (' B 115  ASP  HB2', ' B 141  LEU  HG ', -0.555, (153.072, 121.134, 139.304)), (' A 229  PHE  CD2', ' A 240  CYS  HB3', -0.553, (165.113, 157.7, 140.281)), (' B 282  CYS  HB3', ' B 287  GLY  CA ', -0.551, (133.772, 143.25, 144.618)), (' A 303  MET  N  ', ' B 301  LEU  O  ', -0.551, (144.528, 142.176, 129.542)), (' B  36  VAL HG13', ' B  73  VAL  CG1', -0.55, (155.41, 107.834, 152.532)), (' A  46  CYS  O  ', ' A  49  ASP  HB2', -0.55, (146.021, 169.234, 135.619)), (' A 291  ILE HD11', ' A 314  TRP  NE1', -0.55, (145.341, 147.563, 138.544)), (' B  93  PHE  CZ ', ' B 141  LEU HD13', -0.55, (148.889, 122.508, 140.713)), (' B  34  HIS  NE2', ' B  79  GLY  HA3', -0.548, (165.669, 113.81, 153.983)), (' B  46  CYS  O  ', ' B  49  ASP  HB2', -0.547, (139.992, 116.823, 135.668)), (' A 115  ASP  HB2', ' A 141  LEU  HG ', -0.547, (132.86, 164.68, 139.287)), (' A 316  GLY  HA3', ' B 309  LEU  CA ', -0.545, (141.147, 151.422, 141.04)), (' A 308  LEU  C  ', ' B 316  GLY  HA3', -0.544, (144.687, 135.517, 141.185)), (' A 286  TYR  CG ', ' B 105  HIS  CE1', -0.544, (151.571, 139.054, 152.456)), (' B 148  GLN  HG2', ' B 374  PHE  HE1', -0.543, (145.469, 99.561, 142.156)), (' A 284  GLU  CA ', ' A 312  ARG  HE ', -0.543, (153.553, 137.357, 142.813)), (' A  69  ALA  HB3', ' A 145  THR HG21', -0.543, (139.049, 173.946, 144.897)), (' B 172  ILE  CG2', ' B 331  LEU HD23', -0.543, (141.833, 119.959, 153.401)), (' A  34  HIS  NE2', ' A  79  GLY  HA3', -0.542, (120.155, 172.206, 153.923)), (' B 355  ILE  O  ', ' B 359  PHE  HD1', -0.541, (138.464, 109.13, 133.061)), (' B 199  GLY  HA3', ' B 268  VAL  CG2', -0.539, (132.039, 128.2, 139.429)), (' A 355  ILE  O  ', ' A 359  PHE  HD1', -0.539, (147.365, 176.86, 133.147)), (' B 291  ILE HD11', ' B 314  TRP  NE1', -0.537, (140.426, 138.447, 138.396)), (' A 286  TYR  CD2', ' B 105  HIS  CE1', -0.537, (150.939, 138.654, 152.038)), (' B  92  LEU HD13', ' B 324  SER  CB ', -0.536, (149.5, 121.687, 151.376)), (' B   3  ALA  O  ', ' B  37  ARG  NH1', -0.535, (159.535, 100.814, 148.128)), (' A 199  GLY  HA3', ' A 268  VAL  CG2', -0.535, (153.892, 157.572, 139.419)), (' A  64  ILE  CD1', ' A 137  ILE HG21', -0.535, (133.442, 178.104, 133.953)), (' A  41  VAL HG21', ' A 166  LEU  CD1', -0.534, (142.045, 180.128, 151.681)), (' B  37  ARG  HB3', ' B  75  SER  HB3', -0.533, (157.264, 104.033, 148.471)), (' A  93  PHE  CZ ', ' A 141  LEU HD13', -0.533, (137.256, 163.65, 140.157)), (' B  64  ILE  CD1', ' B 137  ILE HG21', -0.532, (152.511, 107.781, 133.879)), (' A 309  LEU HD12', ' B 295  PRO  HD2', -0.531, (144.858, 131.175, 135.637)), (' A 309  LEU  CA ', ' B 316  GLY  HA3', -0.531, (145.138, 134.375, 141.306)), (' A 207  VAL HG11', ' A 266  PHE  HB2', -0.531, (152.916, 153.991, 144.808)), (' A   3  ALA  O  ', ' A  37  ARG  NH1', -0.531, (126.796, 185.577, 147.965)), (' B 200  LEU  CD2', ' B 232  ALA  HB2', -0.531, (125.226, 125.963, 142.365)), (' B  69  ALA  HB3', ' B 145  THR HG21', -0.53, (146.847, 111.942, 144.858)), (' A 180  TYR  HD1', ' A 210  GLY  HA2', -0.527, (152.142, 158.831, 153.546)), (' A 153  ASP  O  ', ' A 157  VAL HG12', -0.526, (130.824, 171.241, 150.042)), (' B 153  ASP  O  ', ' B 157  VAL HG12', -0.526, (155.288, 115.051, 149.704)), (' A 309  LEU HD11', ' B 295  PRO  CG ', -0.526, (143.319, 132.078, 135.432)), (' A 295  PRO  CG ', ' B 309  LEU HD11', -0.525, (142.501, 153.771, 135.481)), (' B  12  ALA  HB2', ' B 355  ILE HD13', -0.525, (143.544, 106.278, 134.723)), (' A 105  HIS  CE1', ' B 286  TYR  CD2', -0.525, (135.144, 147.182, 152.169)), (' B   3  ALA  HA ', ' B  37  ARG HH12', -0.525, (158.863, 99.642, 148.734)), (' A  73  VAL HG23', ' A  89  VAL HG13', -0.524, (134.623, 176.687, 153.576)), (' B 231  LYS  HD3', ' B 368  ILE HD12', -0.523, (126.451, 118.414, 142.557)), (' B 218  ARG  HE ', ' B 220  ILE HD11', -0.522, (120.651, 137.725, 145.738)), (' A 253  VAL  O  ', ' A 257  MET  HG2', -0.522, (166.396, 145.437, 139.15)), (' B  41  VAL HG21', ' B 166  LEU  CD1', -0.521, (143.72, 105.841, 151.534)), (' B 328  VAL  N  ', ' B 329  PRO  CD ', -0.52, (146.971, 120.181, 157.026)), (' A  90  ILE HG12', ' A 160  ILE HG21', -0.52, (140.927, 171.35, 154.625)), (' A  12  ALA  HB2', ' A 355  ILE HD13', -0.52, (142.296, 179.73, 134.813)), (' A 305  PRO  HG2', ' B 295  PRO  HG2', -0.519, (144.441, 133.684, 133.575)), (' A 328  VAL  N  ', ' A 329  PRO  CD ', -0.518, (139.113, 165.506, 156.651)), (' B 207  VAL HG11', ' B 266  PHE  HB2', -0.518, (133.163, 131.982, 144.897)), (' A  37  ARG  HB3', ' A  75  SER  HB3', -0.518, (128.844, 181.881, 148.588)), (' B 253  VAL  O  ', ' B 257  MET  HG2', -0.518, (119.908, 140.929, 139.109)), (' A 231  LYS  HZ3', ' A 347  THR HG21', -0.517, (159.777, 170.588, 141.075)), (' B  73  VAL HG23', ' B  89  VAL HG13', -0.517, (151.223, 109.243, 153.501)), (' B  26  VAL  CG1', ' B 130  PHE  HB3', -0.516, (154.495, 105.208, 134.98)), (' A 305  PRO  HG2', ' B 295  PRO  CG ', -0.515, (144.249, 133.232, 133.643)), (' A  68  GLU  OE1', ' A 369  ARG  HD2', -0.514, (148.527, 170.646, 142.557)), (' B  68  GLU  OE1', ' B 369  ARG  HD2', -0.514, (137.86, 115.582, 142.338)), (' A 295  PRO  CG ', ' B 305  PRO  HG2', -0.513, (142.033, 152.707, 133.495)), (' B  90  ILE HG12', ' B 160  ILE HG21', -0.512, (145.034, 114.009, 154.623)), (' A 172  ILE  CG2', ' A 331  LEU HD23', -0.511, (144.077, 165.879, 153.275)), (' A 231  LYS  HD3', ' A 368  ILE HD12', -0.511, (159.559, 167.43, 142.762)), (' B 190  THR  OG1', ' B 193  SER  HB3', -0.51, (130.483, 140.599, 154.132)), (' B 180  TYR  CZ ', ' B 340  PHE  CZ ', -0.509, (135.376, 125.271, 157.074)), (' A 309  LEU  O  ', ' B 318  ILE  CD1', -0.508, (147.473, 131.638, 142.071)), (' A 148  GLN  HG2', ' A 374  PHE  HE1', -0.507, (140.517, 186.031, 141.688)), (' A 218  ARG  HE ', ' A 220  ILE HD11', -0.507, (165.089, 148.199, 145.315)), (' A 190  THR  OG1', ' A 193  SER  HB3', -0.507, (155.411, 145.42, 154.092)), (' A 105  HIS  CE1', ' B 286  TYR  CG ', -0.506, (134.639, 147.198, 152.455)), (' A 313  THR HG22', ' B 315  LYS  HB2', -0.505, (144.043, 139.655, 145.97)), (' A  26  VAL  CG1', ' A 130  PHE  HB3', -0.505, (131.487, 180.187, 135.034)), (' B  40  MET  HE3', ' B 374  PHE  HB2', -0.505, (142.852, 103.421, 143.124)), (' A 318  ILE  CD1', ' B 309  LEU  O  ', -0.504, (138.476, 154.326, 142.135)), (' B 180  TYR  HD1', ' B 210  GLY  HA2', -0.503, (133.365, 127.393, 153.352)), (' B  14  LEU HD21', ' B  52  VAL HG12', -0.503, (146.349, 115.889, 129.172)), (' B  15  TRP  HZ2', ' B 132  CYS  SG ', -0.503, (153.058, 104.193, 128.074)), (' A 295  PRO  HG2', ' B 305  PRO  HG2', -0.503, (141.697, 152.166, 133.675)), (' A 180  TYR  CZ ', ' A 340  PHE  CZ ', -0.503, (150.992, 160.096, 156.94)), (' A  36  VAL HG13', ' A  73  VAL  CG1', -0.501, (130.543, 178.023, 152.576)), (' A 246  TYR  CG ', ' A 253  VAL HG21', -0.501, (166.636, 147.295, 133.744)), (' A 284  GLU  HG3', ' A 310  SER  CB ', -0.501, (151.038, 134.774, 141.627)), (' B  43  THR HG22', ' B  44  GLY  N  ', -0.5, (140.708, 111.039, 141.545)), (' A  15  TRP  HZ2', ' A 132  CYS  SG ', -0.5, (133.186, 181.995, 127.921)), (' B 288  VAL HG12', ' B 290  VAL HG23', -0.5, (137.838, 138.209, 146.639)), (' A  43  THR HG22', ' A  44  GLY  N  ', -0.5, (145.484, 174.403, 141.719)), (' A 308  LEU  CG ', ' B 314  TRP  CZ3', -0.5, (144.389, 140.659, 138.038)), (' A   3  ALA  HA ', ' A  37  ARG HH12', -0.499, (126.915, 186.172, 148.667)), (' A 301  LEU  O  ', ' B 303  MET  N  ', -0.497, (141.38, 143.864, 129.503)), (' A  40  MET  HE3', ' A 374  PHE  HB2', -0.496, (142.951, 182.726, 143.61)), (' B 246  TYR  CG ', ' B 253  VAL HG21', -0.496, (119.198, 138.633, 133.865)), (' B 176  PHE  HZ ', ' B 340  PHE  CD2', -0.496, (134.713, 122.791, 155.15)), (' A 205  LEU  HB2', ' A 345  LEU  CD2', -0.495, (154.911, 164.995, 145.811)), (' A 176  PHE  HZ ', ' A 340  PHE  CD2', -0.495, (151.485, 163.363, 155.007)), (' A 167  GLU  HG3', ' A 371  ILE HG21', -0.494, (149.78, 177.54, 146.557)), (' A  69  ALA  C  ', ' A  91  PRO  HD2', -0.493, (140.667, 173.407, 147.62)), (' B 130  PHE  HE1', ' B 139  HIS  HE2', -0.493, (155.391, 109.966, 140.07)), (' B 169  VAL  CG2', ' B 172  ILE HD12', -0.492, (140.24, 115.295, 153.826)), (' B 167  GLU  HG3', ' B 371  ILE HG21', -0.492, (136.32, 108.138, 146.941)), (' A 235  VAL  CG1', ' A 235  VAL  O  ', -0.491, (159.314, 160.626, 149.974)), (' A 180  TYR  CZ ', ' A 340  PHE  CE2', -0.491, (151.068, 160.111, 156.326)), (' A 130  PHE  HE1', ' A 139  HIS  HE2', -0.491, (130.496, 176.048, 140.034)), (' A 324  SER  O  ', ' A 328  VAL HG23', -0.491, (137.961, 164.689, 154.062)), (' A 315  LYS  HB2', ' B 313  THR HG22', -0.491, (141.979, 145.959, 145.841)), (' A 276  VAL HG23', ' A 301  LEU HD11', -0.49, (147.65, 146.696, 131.102)), (' B 324  SER  O  ', ' B 328  VAL HG23', -0.49, (148.134, 120.992, 153.846)), (' A 295  PRO  HD2', ' B 309  LEU HD12', -0.49, (140.962, 154.841, 135.698)), (' B  93  PHE  O  ', ' B 141  LEU  CD2', -0.49, (151.276, 121.076, 142.753)), (' A 197  VAL HG12', ' A 199  GLY  O  ', -0.489, (155.834, 157.244, 141.821)), (' A 288  VAL HG12', ' A 290  VAL HG23', -0.488, (148.172, 147.807, 146.776)), (' A  13  VAL HG21', ' A 137  ILE HD13', -0.488, (134.278, 179.509, 131.667)), (' B 197  VAL HG12', ' B 199  GLY  O  ', -0.488, (130.002, 129.184, 141.96)), (' B 235  VAL  CG1', ' B 235  VAL  O  ', -0.488, (126.579, 125.302, 149.936)), (' B 231  LYS  HZ3', ' B 347  THR HG21', -0.487, (126.175, 115.331, 141.176)), (' B  49  ASP  HB3', ' B 359  PHE  HE2', -0.486, (141.573, 114.926, 134.021)), (' B 180  TYR  CZ ', ' B 340  PHE  CE2', -0.485, (134.772, 125.941, 156.454)), (' A  93  PHE  O  ', ' A 141  LEU  CD2', -0.484, (134.865, 164.743, 142.65)), (' B 176  PHE  HA ', ' B 206  SER  OG ', -0.483, (135.769, 122.406, 148.686)), (' B 276  VAL HG23', ' B 301  LEU HD11', -0.483, (138.265, 139.214, 131.086)), (' A 220  ILE  HA ', ' A 239  GLU  O  ', -0.483, (163.527, 152.958, 144.044)), (' A 169  VAL  CG2', ' A 172  ILE HD12', -0.483, (145.467, 170.605, 153.922)), (' A 311  GLY  C  ', ' B 315  LYS  HG3', -0.482, (145.951, 137.684, 144.849)), (' A  69  ALA  HB3', ' A  91  PRO  HG2', -0.482, (138.986, 173.645, 146.105)), (' B  13  VAL HG21', ' B 137  ILE HD13', -0.482, (152.163, 106.503, 131.741)), (' B 268  VAL HG12', ' B 292  VAL  CG2', -0.48, (137.114, 129.0, 142.392)), (' A 176  PHE  HA ', ' A 206  SER  OG ', -0.48, (150.526, 163.437, 148.363)), (' A 315  LYS  HG3', ' B 311  GLY  C  ', -0.479, (139.974, 148.18, 145.041)), (' A  36  VAL HG11', ' A  73  VAL HG22', -0.478, (132.443, 176.673, 151.556)), (' A 268  VAL HG12', ' A 292  VAL  CG2', -0.477, (149.258, 157.266, 142.423)), (' B 220  ILE  HA ', ' B 239  GLU  O  ', -0.477, (122.315, 132.54, 143.943)), (' A  49  ASP  HB3', ' A 359  PHE  HE2', -0.477, (144.397, 171.569, 133.896)), (' B  36  VAL HG11', ' B  73  VAL HG22', -0.476, (153.419, 108.838, 151.938)), (' A 305  PRO  HG3', ' B 272  LEU HD21', -0.476, (142.851, 135.386, 131.542)), (' A 314  TRP  CZ3', ' B 308  LEU  CG ', -0.476, (141.568, 145.234, 138.126)), (' B 203  VAL HG12', ' B 268  VAL HG11', -0.475, (134.988, 127.722, 143.183)), (' B  69  ALA  HB3', ' B  91  PRO  HG2', -0.474, (146.94, 112.127, 146.087)), (' B  33  ALA  CA ', ' B  78  GLU  H  ', -0.474, (164.966, 109.228, 150.757)), (' B  97  CYS  HB2', ' B 155  ILE HD13', -0.472, (159.948, 122.576, 149.75)), (' A  14  LEU HD21', ' A  52  VAL HG12', -0.472, (139.416, 169.96, 129.097)), (' B  59  THR  O  ', ' B  61  LEU  HG ', -0.472, (151.95, 118.305, 127.994)), (' B 207  VAL HG11', ' B 266  PHE  CB ', -0.471, (133.404, 131.871, 144.892)), (' A 172  ILE HG23', ' A 331  LEU  CD2', -0.47, (144.969, 165.006, 153.287)), (' B 172  ILE HG23', ' B 331  LEU  CD2', -0.469, (140.859, 120.845, 153.373)), (' B 205  LEU  HB2', ' B 345  LEU  CD2', -0.469, (131.152, 121.009, 145.969)), (' A 207  VAL HG11', ' A 266  PHE  CB ', -0.469, (152.664, 154.071, 144.812)), (' A 293  GLY  O  ', ' B 309  LEU  CD2', -0.468, (143.832, 154.368, 138.389)), (' A 145  THR  HA ', ' A 150  THR HG21', -0.468, (136.993, 176.864, 142.178)), (' A 309  LEU  CD2', ' B 293  GLY  O  ', -0.467, (142.381, 131.598, 138.259)), (' A 272  LEU HD21', ' B 305  PRO  HG3', -0.467, (143.218, 150.894, 131.533)), (' B  64  ILE HG22', ' B 144  SER  HB3', -0.466, (150.363, 110.507, 137.467)), (' A  97  CYS  HB2', ' A 155  ILE HD13', -0.465, (126.583, 163.208, 149.744)), (' B  95  PRO  HB2', ' B 155  ILE HG22', -0.465, (156.495, 121.797, 148.7)), (' A  95  PRO  HB2', ' A 155  ILE HG22', -0.464, (129.607, 164.37, 148.566)), (' A 319  PHE  CD2', ' A 322  PHE  CD2', -0.464, (140.148, 161.722, 150.483)), (' A  64  ILE HG22', ' A 144  SER  HB3', -0.463, (135.991, 175.771, 137.473)), (' B  69  ALA  C  ', ' B  91  PRO  HD2', -0.463, (145.383, 112.509, 147.552)), (' A  36  VAL HG22', ' A  76  ILE HG22', -0.462, (128.982, 176.96, 152.368)), (' B 319  PHE  CD2', ' B 322  PHE  CD2', -0.462, (145.766, 124.237, 150.926)), (' A 203  VAL HG12', ' A 268  VAL HG11', -0.461, (151.048, 158.343, 143.115)), (' A 231  LYS  NZ ', ' A 347  THR  CG2', -0.46, (160.192, 171.449, 141.3)), (' A  41  VAL  CG2', ' A 166  LEU HD12', -0.46, (142.538, 180.756, 151.186)), (' A 284  GLU  OE2', ' B 110  PHE  CB ', -0.46, (151.946, 131.816, 143.607)), (' A 110  PHE  CB ', ' B 284  GLU  OE2', -0.458, (134.003, 154.022, 143.651)), (' A  59  THR  O  ', ' A  61  LEU  HG ', -0.458, (134.054, 167.703, 128.133)), (' B 145  THR  HA ', ' B 150  THR HG21', -0.458, (148.636, 109.228, 141.854)), (' B 275  MET  HE2', ' B 291  ILE HG23', -0.458, (139.978, 132.987, 137.696)), (' B  41  VAL  CG2', ' B 166  LEU HD12', -0.458, (143.538, 105.333, 151.127)), (' A 110  PHE  CB ', ' B 284  GLU  CD ', -0.457, (133.559, 153.237, 143.583)), (' A 284  GLU  CD ', ' B 110  PHE  CB ', -0.457, (152.651, 132.784, 143.698)), (' B   3  ALA  CA ', ' B  37  ARG HH12', -0.457, (159.502, 99.614, 148.856)), (' B 335  PHE  CD1', ' B 342  LEU HD12', -0.456, (134.645, 115.668, 154.733)), (' A  43  THR  HB ', ' A 372  LEU  HB2', -0.455, (145.699, 177.686, 141.256)), (' B 125  ASP  OD1', ' B 127  THR  OG1', -0.455, (164.47, 113.123, 139.309)), (' A  45  ILE HD11', ' A 372  LEU HD21', -0.454, (148.625, 177.346, 137.209)), (' A 200  LEU HD11', ' A 229  PHE  CD2', -0.454, (162.73, 158.982, 139.844)), (' B  35  GLU  CD ', ' B 129  ARG  NH1', -0.454, (162.639, 111.438, 143.58)), (' A 125  ASP  OD1', ' A 127  THR  OG1', -0.453, (121.61, 172.9, 139.418)), (' A  35  GLU  CD ', ' A 129  ARG  NH1', -0.452, (123.538, 174.639, 143.471)), (' A   3  ALA  CA ', ' A  37  ARG HH12', -0.452, (126.847, 186.142, 148.646)), (' A  43  THR  CG2', ' A  44  GLY  N  ', -0.452, (144.609, 174.551, 141.773)), (' A 309  LEU  O  ', ' B 318  ILE HD13', -0.452, (146.917, 131.117, 142.307)), (' A  33  ALA  CA ', ' A  78  GLU  H  ', -0.452, (121.105, 176.546, 150.817)), (' B  45  ILE HD11', ' B 372  LEU HD21', -0.451, (137.362, 108.981, 137.024)), (' A 172  ILE  HA ', ' A 176  PHE  HB3', -0.451, (147.348, 165.963, 150.389)), (' A 348  HIS  ND1', ' A 367  SER  HB2', -0.451, (156.892, 173.044, 138.216)), (' B  43  THR  CG2', ' B  44  GLY  N  ', -0.451, (141.293, 111.372, 141.733)), (' B 348  HIS  ND1', ' B 367  SER  HB2', -0.45, (129.188, 112.822, 138.127)), (' B  47  ARG  HA ', ' B 362  LEU HD21', -0.449, (137.573, 118.662, 134.788)), (' A 309  LEU  CD1', ' B 295  PRO  CG ', -0.449, (143.73, 132.194, 135.574)), (' B 176  PHE  HE2', ' B 331  LEU HD11', -0.448, (137.855, 121.961, 154.86)), (' A 176  PHE  HE2', ' A 331  LEU HD11', -0.448, (148.17, 163.934, 154.911)), (' B 200  LEU HD11', ' B 229  PHE  CD2', -0.448, (123.199, 126.893, 139.862)), (' A 203  VAL HG12', ' A 268  VAL HG12', -0.447, (150.077, 157.921, 142.847)), (' B  43  THR  HB ', ' B 372  LEU  HB2', -0.447, (140.688, 108.421, 141.268)), (' A 275  MET  HE2', ' A 291  ILE HG23', -0.446, (145.974, 152.862, 137.677)), (' B 231  LYS  NZ ', ' B 347  THR  CG2', -0.445, (126.093, 114.735, 141.43)), (' A 141  LEU  O  ', ' A 141  LEU HD23', -0.445, (133.67, 166.899, 141.838)), (' B 319  PHE  HE2', ' B 322  PHE  CE2', -0.445, (145.859, 122.909, 151.774)), (' B  36  VAL HG22', ' B  76  ILE HG22', -0.445, (156.895, 109.434, 152.198)), (' A 335  PHE  CD1', ' A 342  LEU HD12', -0.443, (151.306, 170.186, 154.713)), (' A   6  VAL  CG2', ' A  30  PRO  HD3', -0.443, (123.758, 185.449, 141.28)), (' A 305  PRO  HG3', ' B 272  LEU HD23', -0.442, (141.938, 135.005, 132.109)), (' A 318  ILE HD13', ' B 309  LEU  O  ', -0.442, (139.04, 154.839, 142.157)), (' A  33  ALA  O  ', ' A  77  GLY  C  ', -0.442, (122.315, 176.999, 152.031)), (' B  26  VAL HG11', ' B 130  PHE  HB3', -0.441, (154.356, 105.821, 135.25)), (' B 141  LEU  O  ', ' B 141  LEU HD23', -0.44, (152.433, 119.479, 141.665)), (' A  44  GLY  HA3', ' A  68  GLU  OE1', -0.44, (147.084, 171.337, 142.767)), (' B  33  ALA  O  ', ' B  77  GLY  C  ', -0.44, (163.512, 108.852, 151.935)), (' B 172  ILE  HA ', ' B 176  PHE  HB3', -0.439, (138.887, 119.684, 150.551)), (' A 319  PHE  HE2', ' A 322  PHE  CE2', -0.439, (140.094, 162.963, 151.755)), (' A 315  LYS  HG3', ' B 312  ARG  O  ', -0.439, (140.217, 146.99, 144.244)), (' B  14  LEU  CD2', ' B  52  VAL  CG1', -0.438, (147.176, 116.036, 130.208)), (' B 203  VAL HG12', ' B 268  VAL HG12', -0.437, (135.933, 127.97, 142.711)), (' A 312  ARG  O  ', ' B 315  LYS  HG3', -0.437, (145.53, 138.449, 144.358)), (' A  14  LEU  CD2', ' A  52  VAL  CG1', -0.436, (138.779, 169.987, 130.304)), (' B 121  GLY  O  ', ' B 138  HIS  HB3', -0.436, (156.614, 115.2, 133.718)), (' A 218  ARG  NH2', ' A 258  SER  HA ', -0.435, (165.295, 144.495, 146.084)), (' A  47  ARG  HA ', ' A 362  LEU HD21', -0.435, (148.379, 167.323, 134.879)), (' A 122  THR  OG1', ' A 126  GLY  HA2', -0.434, (123.586, 168.56, 136.246)), (' A 197  VAL HG22', ' A 207  VAL HG12', -0.434, (154.533, 154.897, 146.2)), (' A  68  GLU  OE2', ' A 171  LEU HD23', -0.434, (148.576, 169.958, 145.378)), (' A 121  GLY  O  ', ' A 138  HIS  HB3', -0.433, (129.492, 170.692, 133.903)), (' A  52  VAL  CG2', ' A 140  PHE  HE1', -0.433, (138.109, 166.68, 133.526)), (' B 122  THR  OG1', ' B 126  GLY  HA2', -0.433, (162.022, 117.372, 136.0)), (' B 218  ARG  CZ ', ' B 220  ILE HD11', -0.432, (120.683, 138.687, 145.403)), (' A 108  GLY  HA3', ' B 285  ALA  HB1', -0.432, (134.447, 150.79, 149.567)), (' A 183  ALA  O  ', ' A 189  VAL HG23', -0.432, (150.208, 151.568, 152.304)), (' A  13  VAL  CG2', ' A 137  ILE HD13', -0.432, (133.934, 179.248, 132.007)), (' B  52  VAL  CG2', ' B 140  PHE  HE1', -0.432, (147.843, 119.2, 133.569)), (' B  68  GLU  OE2', ' B 171  LEU HD23', -0.432, (137.34, 115.811, 145.367)), (' B 267  GLU  HB3', ' B 291  ILE  HA ', -0.431, (138.071, 133.63, 140.126)), (' B  23  ILE HD11', ' B 355  ILE  HB ', -0.43, (140.859, 105.121, 133.318)), (' A 307  LEU HD22', ' A 312  ARG HH21', -0.43, (152.328, 139.36, 138.874)), (' A  26  VAL HG11', ' A 130  PHE  HB3', -0.43, (131.862, 180.457, 135.057)), (' B 183  ALA  O  ', ' B 189  VAL HG23', -0.43, (135.743, 134.351, 152.261)), (' B   6  VAL  CG2', ' B  30  PRO  HD3', -0.429, (162.382, 100.402, 141.379)), (' B 218  ARG  NH2', ' B 258  SER  HA ', -0.429, (120.753, 141.311, 146.017)), (' A 218  ARG  NH1', ' A 220  ILE HD11', -0.429, (165.56, 147.312, 144.853)), (' A 267  GLU  HB3', ' A 291  ILE  HA ', -0.429, (147.536, 152.357, 140.392)), (' B   3  ALA  CA ', ' B  37  ARG  NH1', -0.429, (159.354, 99.996, 149.069)), (' A 272  LEU HD23', ' B 305  PRO  HG3', -0.428, (143.989, 150.606, 132.104)), (' B  13  VAL  CG2', ' B 137  ILE HD13', -0.428, (151.601, 106.586, 131.898)), (' A  45  ILE HD13', ' A 358  GLY  HA3', -0.428, (149.681, 175.439, 135.794)), (' B  44  GLY  HA3', ' B  68  GLU  OE1', -0.428, (138.932, 114.177, 142.744)), (' B 197  VAL HG22', ' B 207  VAL HG12', -0.427, (131.115, 131.159, 145.882)), (' B  94  THR HG23', ' B 114  ASN HD22', -0.427, (152.232, 125.217, 144.531)), (' A  94  THR HG23', ' A 114  ASN HD22', -0.427, (133.992, 160.651, 144.878)), (' B  51  HIS  CB ', ' B  57  LEU  HG ', -0.427, (143.727, 122.878, 132.386)), (' A 282  CYS  CB ', ' A 287  GLY  HA3', -0.425, (152.212, 142.409, 143.664)), (' B  14  LEU HD23', ' B  52  VAL HG12', -0.425, (147.329, 115.624, 130.021)), (' B  44  GLY  HA3', ' B  68  GLU  CD ', -0.424, (138.936, 114.555, 143.373)), (' B 226  LYS  HA ', ' B 229  PHE  CD1', -0.422, (120.849, 125.899, 136.532)), (' A 226  LYS  HA ', ' A 229  PHE  CD1', -0.422, (165.216, 159.777, 136.837)), (' A  14  LEU HD23', ' A  52  VAL HG12', -0.422, (138.728, 170.42, 130.105)), (' A 285  ALA  HB1', ' B 108  GLY  HA3', -0.422, (151.545, 135.029, 149.405)), (' B 171  LEU HD21', ' B 369  ARG  HG2', -0.421, (134.869, 115.303, 144.945)), (' A  35  GLU  OE1', ' A 129  ARG  NH1', -0.42, (123.405, 175.208, 143.888)), (' B  35  GLU  OE1', ' B 129  ARG  NH1', -0.42, (162.618, 110.971, 143.511)), (' A  44  GLY  HA3', ' A  68  GLU  CD ', -0.42, (146.902, 171.806, 143.243)), (' A  46  CYS  SG ', ' A 369  ARG  NH2', -0.419, (146.876, 168.21, 141.153)), (' A 218  ARG  CZ ', ' A 220  ILE HD11', -0.418, (165.364, 147.302, 145.336)), (' A  82  THR HG21', ' A 325  LYS  HE2', -0.418, (129.483, 167.833, 158.078)), (' A 110  PHE  HZ ', ' A 117  SER  HB2', -0.418, (131.717, 156.141, 139.055)), (' A 123  MET  O  ', ' A 125  ASP  N  ', -0.418, (123.058, 169.382, 140.067)), (' B 218  ARG  NH1', ' B 220  ILE HD11', -0.417, (120.719, 138.378, 144.653)), (' B 109  ASN  ND2', ' B 319  PHE  HB3', -0.417, (148.001, 126.447, 148.435)), (' A 146  PHE  HE2', ' A 372  LEU HD12', -0.416, (145.167, 176.345, 138.653)), (' B  90  ILE HD11', ' B 160  ILE HD13', -0.416, (143.957, 112.834, 153.872)), (' A 251  GLN  HG2', ' A 277  THR HG23', -0.415, (156.885, 145.271, 134.881)), (' B  82  THR HG21', ' B 325  LYS  HE2', -0.415, (156.824, 117.862, 158.073)), (' A  23  ILE HD11', ' A 355  ILE  HB ', -0.414, (144.951, 181.222, 133.187)), (' B  46  CYS  SG ', ' B 369  ARG  NH2', -0.414, (139.076, 117.776, 141.129)), (' B 143  THR  HA ', ' B 152  VAL HG12', -0.413, (152.424, 113.503, 143.405)), (' B 276  VAL  CG2', ' B 301  LEU HD11', -0.413, (138.409, 139.433, 131.109)), (' B  13  VAL HG22', ' B  64  ILE  CG1', -0.413, (150.99, 107.856, 133.484)), (' A 200  LEU HD11', ' A 229  PHE  HD2', -0.412, (162.892, 158.963, 140.327)), (' A 171  LEU HD21', ' A 369  ARG  HG2', -0.411, (150.965, 170.531, 144.929)), (' B 354  LYS  HB3', ' B 357  GLU  HB2', -0.411, (134.139, 105.223, 134.142)), (' A 276  VAL  CG2', ' A 301  LEU HD11', -0.411, (147.75, 146.25, 131.361)), (' A 173  GLY  O  ', ' A 319  PHE  CE1', -0.41, (141.38, 165.259, 147.676)), (' B 123  MET  O  ', ' B 125  ASP  N  ', -0.41, (162.934, 116.538, 140.038)), (' A 295  PRO  CB ', ' B 305  PRO  HG2', -0.409, (141.859, 152.33, 133.179)), (' A  90  ILE HD11', ' A 160  ILE HD13', -0.409, (141.925, 173.238, 153.752)), (' B 347  THR  O  ', ' B 347  THR HG22', -0.408, (127.101, 112.145, 141.348)), (' A  21  PHE  CE1', ' A  53  VAL  CG2', -0.407, (143.276, 172.124, 130.438)), (' B 110  PHE  HZ ', ' B 117  SER  HB2', -0.407, (154.385, 129.895, 139.449)), (' A 354  LYS  HB3', ' A 357  GLU  HB2', -0.407, (151.737, 181.066, 134.385)), (' B 288  VAL HG12', ' B 290  VAL  CG2', -0.407, (138.255, 137.547, 146.875)), (' A  51  HIS  CB ', ' A  57  LEU  HG ', -0.406, (142.151, 163.193, 132.448)), (' A  64  ILE  O  ', ' A 144  SER  OG ', -0.406, (134.834, 173.181, 137.418)), (' B 146  PHE  HE2', ' B 372  LEU HD12', -0.406, (140.69, 109.644, 138.596)), (' B 200  LEU HD11', ' B 229  PHE  HD2', -0.404, (123.44, 126.805, 140.372)), (' A 348  HIS  CE1', ' A 367  SER  HB2', -0.404, (157.186, 172.578, 137.705)), (' A 143  THR  HA ', ' A 152  VAL HG12', -0.404, (133.239, 172.648, 143.623)), (' B 282  CYS  CB ', ' B 287  GLY  HA3', -0.404, (133.798, 143.512, 143.634)), (' A 231  LYS  HZ3', ' A 347  THR  CG2', -0.403, (159.793, 171.195, 141.542)), (' A 303  MET  CB ', ' B 303  MET  CE ', -0.402, (144.784, 143.031, 133.374)), (' B 251  GLN  HG2', ' B 277  THR HG23', -0.402, (129.193, 140.661, 134.969)), (' A 176  PHE  HZ ', ' A 340  PHE  CG ', -0.402, (151.268, 163.728, 155.393)), (' B 348  HIS  CE1', ' B 367  SER  HB2', -0.402, (128.484, 113.139, 137.908)), (' A 347  THR  O  ', ' A 347  THR HG22', -0.401, (158.973, 173.926, 141.257)), (' A 295  PRO  CG ', ' B 309  LEU  CD1', -0.401, (142.104, 153.607, 135.616)), (' B 173  GLY  O  ', ' B 319  PHE  CE1', -0.4, (144.865, 120.978, 147.596)), (' A 305  PRO  HG2', ' B 295  PRO  CB ', -0.4, (143.8, 133.284, 133.14)), (' A 203  VAL  O  ', ' A 207  VAL HG23', -0.4, (151.208, 159.009, 144.677)), (' A  13  VAL HG22', ' A  64  ILE  CG1', -0.4, (134.787, 177.632, 132.802)), (' A 288  VAL HG12', ' A 290  VAL  CG2', -0.4, (147.361, 148.012, 146.515))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
