# script auto-generated by phenix.molprobity


from __future__ import division
import cPickle
try :
  import gobject
except ImportError :
  gobject = None
import sys

class coot_extension_gui(object):
  def __init__(self, title):
    import gtk
    self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    scrolled_win = gtk.ScrolledWindow()
    self.outside_vbox = gtk.VBox(False, 2)
    self.inside_vbox = gtk.VBox(False, 0)
    self.window.set_title(title)
    self.inside_vbox.set_border_width(0)
    self.window.add(self.outside_vbox)
    self.outside_vbox.pack_start(scrolled_win, True, True, 0)
    scrolled_win.add_with_viewport(self.inside_vbox)
    scrolled_win.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  def finish_window(self):
    import gtk
    self.outside_vbox.set_border_width(2)
    ok_button = gtk.Button("  Close  ")
    self.outside_vbox.pack_end(ok_button, False, False, 0)
    ok_button.connect("clicked", lambda b: self.destroy_window())
    self.window.connect("delete_event", lambda a, b: self.destroy_window())
    self.window.show_all()

  def destroy_window(self, *args):
    self.window.destroy()
    self.window = None

  def confirm_data(self, data):
    for data_key in self.data_keys :
      outlier_list = data.get(data_key)
      if outlier_list is not None and len(outlier_list) > 0 :
        return True
    return False

  def create_property_lists(self, data):
    import gtk
    for data_key in self.data_keys :
      outlier_list = data[data_key]
      if outlier_list is None or len(outlier_list) == 0 :
        continue
      else :
        frame = gtk.Frame(self.data_titles[data_key])
        vbox = gtk.VBox(False, 2)
        frame.set_border_width(6)
        frame.add(vbox)
        self.add_top_widgets(data_key, vbox)
        self.inside_vbox.pack_start(frame, False, False, 5)
        list_obj = residue_properties_list(
          columns=self.data_names[data_key],
          column_types=self.data_types[data_key],
          rows=outlier_list,
          box=vbox)

# Molprobity result viewer
class coot_molprobity_todo_list_gui(coot_extension_gui):
  data_keys = [ "rama", "rota", "cbeta", "probe" ]
  data_titles = { "rama"  : "Ramachandran outliers",
                  "rota"  : "Rotamer outliers",
                  "cbeta" : "C-beta outliers",
                  "probe" : "Severe clashes" }
  data_names = { "rama"  : ["Chain", "Residue", "Name", "Score"],
                 "rota"  : ["Chain", "Residue", "Name", "Score"],
                 "cbeta" : ["Chain", "Residue", "Name", "Conf.", "Deviation"],
                 "probe" : ["Atom 1", "Atom 2", "Overlap"] }
  if (gobject is not None):
    data_types = { "rama" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "rota" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                             gobject.TYPE_STRING, gobject.TYPE_FLOAT,
                             gobject.TYPE_PYOBJECT],
                   "cbeta" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT],
                   "probe" : [gobject.TYPE_STRING, gobject.TYPE_STRING,
                              gobject.TYPE_FLOAT, gobject.TYPE_PYOBJECT] }
  else :
    data_types = dict([ (s, []) for s in ["rama","rota","cbeta","probe"] ])

  def __init__(self, data_file=None, data=None):
    assert ([data, data_file].count(None) == 1)
    if (data is None):
      data = load_pkl(data_file)
    if not self.confirm_data(data):
      return
    coot_extension_gui.__init__(self, "MolProbity to-do list")
    self.dots_btn = None
    self.dots2_btn = None
    self._overlaps_only = True
    self.window.set_default_size(420, 600)
    self.create_property_lists(data)
    self.finish_window()

  def add_top_widgets(self, data_key, box):
    import gtk
    if data_key == "probe" :
      hbox = gtk.HBox(False, 2)
      self.dots_btn = gtk.CheckButton("Show Probe dots")
      hbox.pack_start(self.dots_btn, False, False, 5)
      self.dots_btn.connect("toggled", self.toggle_probe_dots)
      self.dots2_btn = gtk.CheckButton("Overlaps only")
      hbox.pack_start(self.dots2_btn, False, False, 5)
      self.dots2_btn.connect("toggled", self.toggle_all_probe_dots)
      self.dots2_btn.set_active(True)
      self.toggle_probe_dots()
      box.pack_start(hbox, False, False, 0)

  def toggle_probe_dots(self, *args):
    if self.dots_btn is not None :
      show_dots = self.dots_btn.get_active()
      overlaps_only = self.dots2_btn.get_active()
      if show_dots :
        self.dots2_btn.set_sensitive(True)
      else :
        self.dots2_btn.set_sensitive(False)
      show_probe_dots(show_dots, overlaps_only)

  def toggle_all_probe_dots(self, *args):
    if self.dots2_btn is not None :
      self._overlaps_only = self.dots2_btn.get_active()
      self.toggle_probe_dots()

class rsc_todo_list_gui(coot_extension_gui):
  data_keys = ["by_res", "by_atom"]
  data_titles = ["Real-space correlation by residue",
                 "Real-space correlation by atom"]
  data_names = {}
  data_types = {}

class residue_properties_list(object):
  def __init__(self, columns, column_types, rows, box,
      default_size=(380,200)):
    assert len(columns) == (len(column_types) - 1)
    if (len(rows) > 0) and (len(rows[0]) != len(column_types)):
      raise RuntimeError("Wrong number of rows:\n%s" % str(rows[0]))
    import gtk
    self.liststore = gtk.ListStore(*column_types)
    self.listmodel = gtk.TreeModelSort(self.liststore)
    self.listctrl = gtk.TreeView(self.listmodel)
    self.listctrl.column = [None]*len(columns)
    self.listctrl.cell = [None]*len(columns)
    for i, column_label in enumerate(columns):
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn(column_label)
      self.listctrl.append_column(column)
      column.set_sort_column_id(i)
      column.pack_start(cell, True)
      column.set_attributes(cell, text=i)
    self.listctrl.get_selection().set_mode(gtk.SELECTION_SINGLE)
    for row in rows :
      self.listmodel.get_model().append(row)
    self.listctrl.connect("cursor-changed", self.OnChange)
    sw = gtk.ScrolledWindow()
    w, h = default_size
    if len(rows) > 10 :
      sw.set_size_request(w, h)
    else :
      sw.set_size_request(w, 30 + (20 * len(rows)))
    sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    box.pack_start(sw, False, False, 5)
    inside_vbox = gtk.VBox(False, 0)
    sw.add(self.listctrl)

  def OnChange(self, treeview):
    import coot # import dependency
    selection = self.listctrl.get_selection()
    (model, tree_iter) = selection.get_selected()
    if tree_iter is not None :
      row = model[tree_iter]
      xyz = row[-1]
      if isinstance(xyz, tuple) and len(xyz) == 3 :
        set_rotation_centre(*xyz)
        set_zoom(30)
        graphics_draw()

def show_probe_dots(show_dots, overlaps_only):
  import coot # import dependency
  n_objects = number_of_generic_objects()
  sys.stdout.flush()
  if show_dots :
    for object_number in range(n_objects):
      obj_name = generic_object_name(object_number)
      if overlaps_only and not obj_name in ["small overlap", "bad overlap"] :
        sys.stdout.flush()
        set_display_generic_object(object_number, 0)
      else :
        set_display_generic_object(object_number, 1)
  else :
    sys.stdout.flush()
    for object_number in range(n_objects):
      set_display_generic_object(object_number, 0)

def load_pkl(file_name):
  pkl = open(file_name, "rb")
  data = cPickle.load(pkl)
  pkl.close()
  return data

data = {}
data['rama'] = [('A', '  62 ', 'PRO', 0.0, (132.553, 174.451, 128.42700000000002)), ('A', ' 119 ', 'PRO', 0.08704005449573418, (130.225, 162.857, 134.439)), ('B', '  62 ', 'PRO', 0.0, (153.407, 111.50999999999995, 128.43300000000002)), ('B', ' 119 ', 'PRO', 0.0861656153956096, (155.739, 123.102, 134.449))]
data['omega'] = []
data['rota'] = [('A', '  43 ', 'THR', 0.2821765522817528, (144.513, 176.371, 143.83500000000004)), ('A', '  64 ', 'ILE', 0.1862220855736475, (135.774, 175.37399999999997, 134.575)), ('A', '  72 ', 'ILE', 0.09489994524982916, (137.10599999999994, 181.05899999999994, 152.66800000000006)), ('A', '  73 ', 'VAL', 0.24920884443980473, (133.357, 180.57599999999996, 152.472)), ('A', ' 253 ', 'VAL', 0.007351242675213143, (164.763, 144.299, 136.466)), ('A', ' 350 ', 'LEU', 0.23058200256386743, (152.189, 181.141, 140.42200000000003)), ('B', '  43 ', 'THR', 0.2955041164821657, (141.446, 109.593, 143.84000000000006)), ('B', '  64 ', 'ILE', 0.18451046872490778, (150.185, 110.587, 134.581)), ('B', '  72 ', 'ILE', 0.09574511446428452, (148.849, 104.9, 152.67400000000004)), ('B', '  73 ', 'VAL', 0.24848607201679515, (152.59799999999996, 105.38199999999999, 152.478)), ('B', ' 253 ', 'VAL', 0.007351242675213143, (121.208, 141.673, 136.47300000000007)), ('B', ' 350 ', 'LEU', 0.23079354737944885, (133.767, 104.82599999999998, 140.426))]
data['cbeta'] = [('A', '  52 ', 'VAL', ' ', 0.26784182774832155, (139.75499999999994, 167.568, 131.944)), ('A', ' 162 ', 'ALA', ' ', 0.31581117529884734, (140.32799999999995, 178.739, 160.553)), ('A', ' 203 ', 'VAL', ' ', 0.3408158620076225, (149.899, 161.15199999999996, 142.81100000000006)), ('A', ' 207 ', 'VAL', ' ', 0.27119465152317296, (152.379, 156.67999999999995, 146.74900000000002)), ('A', ' 246 ', 'TYR', ' ', 0.47330398618838043, (166.241, 149.043, 131.94500000000005)), ('A', ' 360 ', 'ASP', ' ', 0.2671080569837833, (153.4, 175.404, 129.21400000000003)), ('B', '  52 ', 'VAL', ' ', 0.2675596544230747, (146.208, 118.39499999999994, 131.952)), ('B', ' 162 ', 'ALA', ' ', 0.3137827483362629, (145.62699999999995, 107.22099999999999, 160.559)), ('B', ' 203 ', 'VAL', ' ', 0.338615820451199, (136.065, 124.814, 142.81700000000006)), ('B', ' 207 ', 'VAL', ' ', 0.2723197343340901, (133.586, 129.286, 146.756)), ('B', ' 246 ', 'TYR', ' ', 0.4731080190161827, (119.729, 136.93, 131.95100000000002)), ('B', ' 360 ', 'ASP', ' ', 0.26774601976372525, (132.56, 110.56499999999996, 129.218))]
data['probe'] = [(' B  97  CYS  SG ', ' B 100  CYS  HB3', -1.474, (159.444, 127.082, 148.446)), (' A  97  CYS  SG ', ' A 100  CYS  HB3', -1.467, (126.129, 158.956, 148.495)), (' B 325  LYS  O  ', ' B 329  PRO  CD ', -1.328, (147.885, 120.396, 156.204)), (' A 325  LYS  O  ', ' A 329  PRO  CD ', -1.326, (137.434, 165.119, 156.339)), (' B   6  VAL HG13', ' B  28  VAL  O  ', -1.293, (159.768, 101.359, 138.784)), (' A  97  CYS  O  ', ' A 100  CYS  SG ', -1.282, (127.456, 158.815, 151.009)), (' B  97  CYS  O  ', ' B 100  CYS  SG ', -1.279, (158.643, 127.043, 151.004)), (' A  69  ALA  HB2', ' A 145  THR  CG2', -1.265, (140.437, 175.348, 143.582)), (' A   6  VAL HG13', ' A  28  VAL  O  ', -1.265, (126.341, 184.559, 138.894)), (' B  69  ALA  HB2', ' B 145  THR  CG2', -1.259, (145.521, 110.72, 143.588)), (' B  61  LEU  CB ', ' B  62  PRO  HD2', -1.25, (152.675, 114.642, 125.547)), (' B  46  CYS  SG ', ' B  67  HIS  NE2', -1.238, (141.348, 119.484, 140.357)), (' A  46  CYS  SG ', ' A  67  HIS  NE2', -1.235, (145.026, 167.136, 140.527)), (' A  61  LEU  CB ', ' A  62  PRO  HD2', -1.217, (133.164, 171.321, 125.456)), (' B 199  GLY  O  ', ' B 200  LEU HD23', -1.205, (128.788, 128.108, 140.704)), (' B  84  ARG  HG2', ' B  85  PRO  CD ', -1.204, (156.749, 104.78, 158.184)), (' A  84  ARG  HG2', ' A  85  PRO  CD ', -1.202, (129.204, 181.281, 158.178)), (' A 199  GLY  O  ', ' A 200  LEU HD23', -1.186, (157.815, 158.13, 140.75)), (' B  46  CYS  SG ', ' B  67  HIS  CE1', -1.175, (141.108, 119.026, 139.306)), (' A  46  CYS  SG ', ' A  67  HIS  CE1', -1.171, (144.687, 166.52, 139.984)), (' B  39  LYS  HG3', ' B 149  TYR  CE1', -1.155, (150.966, 101.03, 146.553)), (' A  39  LYS  HG3', ' A 149  TYR  CE1', -1.15, (135.194, 184.492, 147.481)), (' B  46  CYS  CB ', ' B  67  HIS  CE1', -1.146, (141.895, 118.332, 139.562)), (' A  46  CYS  CB ', ' A  67  HIS  CE1', -1.139, (144.951, 168.236, 139.288)), (' B  46  CYS  HB3', ' B  67  HIS  CE1', -1.13, (142.167, 118.043, 138.683)), (' B  38  ILE HG22', ' B  73  VAL  HA ', -1.129, (152.714, 105.771, 151.355)), (' A  46  CYS  HB3', ' A  67  HIS  CE1', -1.127, (143.804, 167.813, 138.876)), (' A 105  HIS  ND1', ' A 106  PRO  HD2', -1.126, (131.353, 148.395, 154.397)), (' B 105  HIS  ND1', ' B 106  PRO  HD2', -1.119, (154.743, 138.041, 154.759)), (' A 172  ILE  O  ', ' A 177  SER  OG ', -1.119, (143.714, 165.094, 149.387)), (' A  97  CYS  SG ', ' A 100  CYS  CB ', -1.119, (127.138, 158.056, 148.926)), (' A  61  LEU  HB3', ' A  62  PRO  HD2', -1.118, (132.926, 172.438, 125.807)), (' A  69  ALA  HB2', ' A 145  THR HG21', -1.116, (139.77, 174.503, 144.156)), (' B  97  CYS  SG ', ' B 100  CYS  CB ', -1.113, (158.998, 127.9, 148.84)), (' B  69  ALA  HB2', ' B 145  THR HG21', -1.113, (145.144, 111.527, 144.027)), (' B 172  ILE  O  ', ' B 177  SER  OG ', -1.11, (141.614, 120.959, 149.506)), (' B 343  ASP  OD1', ' B 344  PRO  HD3', -1.099, (127.762, 114.753, 151.858)), (' B   6  VAL  CG1', ' B  28  VAL  O  ', -1.093, (160.295, 100.871, 138.793)), (' A 343  ASP  OD1', ' A 344  PRO  HD3', -1.089, (158.906, 170.797, 151.543)), (' A  84  ARG  HG2', ' A  85  PRO  HD2', -1.081, (129.516, 181.916, 158.439)), (' A   6  VAL  CG1', ' A  28  VAL  O  ', -1.076, (126.019, 185.165, 138.674)), (' B  61  LEU  HB3', ' B  62  PRO  HD2', -1.072, (152.245, 114.497, 126.024)), (' A 301  LEU  O  ', ' B 302  SER  HA ', -1.067, (142.808, 143.319, 128.62)), (' A  37  ARG  CZ ', ' A  74  GLU  OE1', -1.063, (128.741, 184.207, 146.119)), (' B 325  LYS  O  ', ' B 329  PRO  HD3', -1.063, (148.511, 119.254, 156.65)), (' A  38  ILE HG22', ' A  73  VAL  HA ', -1.061, (133.229, 179.512, 150.582)), (' A 302  SER  HA ', ' B 301  LEU  O  ', -1.06, (143.998, 141.532, 128.766)), (' B  35  GLU  OE1', ' B 123  MET  HE2', -1.048, (161.499, 111.797, 143.186)), (' B  37  ARG  CZ ', ' B  74  GLU  OE1', -1.046, (157.214, 101.87, 146.145)), (' A  35  GLU  OE1', ' A 123  MET  HE2', -1.045, (124.24, 174.055, 143.263)), (' B  84  ARG  HG2', ' B  85  PRO  HD2', -1.036, (156.019, 104.827, 159.214)), (' B   7  ILE HG13', ' B  37  ARG  NH1', -1.032, (156.696, 101.094, 144.322)), (' B  46  CYS  HB3', ' B  67  HIS  HE1', -1.032, (141.169, 117.968, 138.601)), (' A  61  LEU  HB3', ' A  62  PRO  CD ', -1.031, (133.443, 172.577, 125.58)), (' A   7  ILE  CD1', ' A  74  GLU  OE2', -1.026, (131.455, 185.463, 146.194)), (' A 325  LYS  O  ', ' A 329  PRO  HD3', -1.025, (137.489, 166.4, 156.021)), (' B   7  ILE  CD1', ' B  74  GLU  OE2', -1.025, (155.621, 100.567, 145.502)), (' A   7  ILE HG13', ' A  37  ARG  NH1', -1.024, (129.135, 184.811, 144.216)), (' B  61  LEU  HB3', ' B  62  PRO  CD ', -1.021, (152.815, 113.419, 125.73)), (' A  33  ALA  HA ', ' A  78  GLU  HB2', -1.019, (119.937, 175.959, 150.202)), (' B  33  ALA  HA ', ' B  78  GLU  HB2', -1.011, (165.861, 109.323, 150.874)), (' A 272  LEU  HA ', ' A 275  MET  HE3', -1.011, (146.148, 151.596, 131.698)), (' A  46  CYS  HB3', ' A  67  HIS  HE1', -0.991, (144.701, 168.364, 138.865)), (' B 272  LEU  HA ', ' B 275  MET  HE3', -0.985, (139.915, 134.725, 131.916)), (' A   7  ILE  CD1', ' A  37  ARG HH12', -0.978, (129.711, 186.093, 144.899)), (' B   7  ILE  CD1', ' B  37  ARG HH12', -0.972, (156.267, 99.694, 145.076)), (' B   7  ILE HD11', ' B  74  GLU  OE2', -0.967, (156.044, 100.089, 145.943)), (' A  69  ALA  CB ', ' A 145  THR HG21', -0.948, (140.791, 174.806, 144.945)), (' A   7  ILE HD11', ' A  74  GLU  OE2', -0.947, (129.833, 185.838, 145.994)), (' B   5  LYS  HD2', ' B   6  VAL  H  ', -0.947, (162.431, 96.857, 141.809)), (' A   5  LYS  HD2', ' A   6  VAL  H  ', -0.946, (123.522, 189.131, 141.877)), (' A 109  ASN  ND2', ' A 321  GLY  CA ', -0.944, (139.333, 155.668, 149.403)), (' B  69  ALA  CB ', ' B 145  THR HG21', -0.944, (145.131, 111.198, 144.935)), (' A  52  VAL HG21', ' A 140  PHE  CE1', -0.942, (137.466, 166.912, 133.907)), (' B  60  PRO  HB2', ' B 138  HIS  ND1', -0.942, (156.032, 116.374, 130.369)), (' A  60  PRO  HB2', ' A 138  HIS  ND1', -0.941, (129.1, 169.755, 129.98)), (' B  46  CYS  HG ', ' B  67  HIS  CE1', -0.94, (142.25, 119.406, 140.141)), (' B 109  ASN  ND2', ' B 321  GLY  CA ', -0.939, (146.095, 130.41, 149.614)), (' B  52  VAL HG21', ' B 140  PHE  CE1', -0.938, (147.979, 118.798, 133.493)), (' B 325  LYS  O  ', ' B 329  PRO  HD2', -0.934, (147.832, 121.004, 156.726)), (' A  46  CYS  HG ', ' A  67  HIS  CE1', -0.932, (143.714, 166.481, 140.094)), (' A 325  LYS  O  ', ' A 329  PRO  HD2', -0.918, (138.081, 165.444, 157.449)), (' A   7  ILE  CG1', ' A  37  ARG HH12', -0.915, (129.241, 186.044, 144.564)), (' A 229  PHE  HE1', ' A 242  ASN  HB2', -0.915, (165.92, 157.247, 135.928)), (' B   7  ILE  CG1', ' B  37  ARG HH12', -0.909, (156.963, 100.273, 145.383)), (' A 200  LEU HD13', ' A 232  ALA  HB2', -0.906, (161.364, 160.467, 141.726)), (' A   7  ILE  CD1', ' A  37  ARG  NH1', -0.903, (129.764, 184.979, 144.733)), (' B 200  LEU HD13', ' B 232  ALA  HB2', -0.903, (124.6, 125.608, 141.731)), (' A 195  CYS  HA ', ' A 262  VAL  CG1', -0.902, (157.393, 147.44, 146.123)), (' B   7  ILE  CD1', ' B  37  ARG  NH1', -0.897, (156.0, 100.287, 144.676)), (' A 164  SER  HA ', ' A 336  MET  HE1', -0.896, (147.992, 175.969, 158.952)), (' A  90  ILE HG13', ' A 160  ILE HD11', -0.896, (140.97, 172.889, 153.168)), (' B  97  CYS  O  ', ' B 103  CYS  CB ', -0.896, (157.58, 127.824, 152.056)), (' A  64  ILE HG22', ' A 144  SER  OG ', -0.893, (135.233, 174.599, 137.051)), (' B 229  PHE  HE1', ' B 242  ASN  HB2', -0.892, (119.926, 128.884, 135.014)), (' B  64  ILE HG22', ' B 144  SER  OG ', -0.892, (150.186, 110.996, 137.066)), (' B  61  LEU  CB ', ' B  62  PRO  CD ', -0.891, (153.357, 113.646, 126.512)), (' B  90  ILE HG13', ' B 160  ILE HD11', -0.89, (144.218, 113.149, 153.692)), (' B 164  SER  HA ', ' B 336  MET  HE1', -0.888, (138.513, 109.937, 158.101)), (' A  97  CYS  O  ', ' A 103  CYS  CB ', -0.887, (128.505, 158.245, 152.232)), (' A 108  GLY  O  ', ' A 323  LYS  HE2', -0.886, (133.698, 155.357, 152.526)), (' B  39  LYS  CG ', ' B 149  TYR  CE1', -0.886, (150.214, 100.8, 146.824)), (' B 195  CYS  HA ', ' B 262  VAL  CG1', -0.884, (128.52, 138.332, 146.916)), (' B 272  LEU  HB3', ' B 301  LEU HD13', -0.88, (140.115, 136.728, 129.542)), (' B 124  GLN  HG2', ' B 153  ASP  OD2', -0.88, (160.215, 117.659, 144.664)), (' A 124  GLN  HG2', ' A 153  ASP  OD2', -0.878, (125.73, 169.07, 144.31)), (' A  39  LYS  CG ', ' A 149  TYR  CE1', -0.875, (135.725, 184.995, 146.801)), (' B 108  GLY  O  ', ' B 323  LYS  HE2', -0.875, (152.267, 130.707, 152.536)), (' B  69  ALA  CB ', ' B 145  THR  CG2', -0.874, (146.03, 110.088, 144.92)), (' A 272  LEU  HB3', ' A 301  LEU HD13', -0.873, (146.388, 148.533, 129.832)), (' A   7  ILE  CG1', ' A  37  ARG  NH1', -0.872, (129.355, 185.832, 144.331)), (' A 258  SER  HB2', ' A 261  GLY  O  ', -0.871, (161.129, 142.058, 145.108)), (' A 325  LYS  O  ', ' A 329  PRO  CG ', -0.868, (136.892, 166.79, 157.266)), (' B   7  ILE  CG1', ' B  37  ARG  NH1', -0.865, (156.718, 100.003, 144.438)), (' B 160  ILE HG23', ' B 332  VAL HG11', -0.862, (143.286, 113.631, 157.598)), (' A 160  ILE HG23', ' A 332  VAL HG11', -0.859, (143.351, 172.327, 157.356)), (' A  73  VAL  O  ', ' A  85  PRO  O  ', -0.859, (132.588, 182.117, 153.795)), (' B 164  SER  OG ', ' B 336  MET  HE2', -0.859, (139.604, 111.209, 157.985)), (' B 258  SER  HB2', ' B 261  GLY  O  ', -0.857, (124.737, 142.918, 145.198)), (' B 249  PRO  HG2', ' B 252  GLU  HG3', -0.854, (124.559, 144.957, 131.869)), (' B 325  LYS  O  ', ' B 329  PRO  CG ', -0.852, (148.94, 119.147, 157.158)), (' A 164  SER  OG ', ' A 336  MET  HE2', -0.849, (146.286, 174.603, 157.991)), (' A  16  GLU  OE2', ' A  19  LYS  NZ ', -0.849, (138.709, 175.437, 119.265)), (' B 105  HIS  CG ', ' B 106  PRO  HD2', -0.846, (155.038, 136.973, 154.542)), (' A  69  ALA  CB ', ' A 145  THR  CG2', -0.845, (139.992, 175.961, 144.852)), (' B  73  VAL  O  ', ' B  85  PRO  O  ', -0.844, (152.989, 103.725, 153.79)), (' A 343  ASP  OD1', ' A 344  PRO  CD ', -0.841, (158.336, 170.764, 151.427)), (' B  73  VAL HG23', ' B  87  ASP  O  ', -0.839, (151.056, 106.888, 154.44)), (' B 105  HIS  CE1', ' B 106  PRO  HD2', -0.838, (154.118, 137.659, 154.444)), (' A  73  VAL HG23', ' A  87  ASP  O  ', -0.835, (134.857, 178.923, 154.444)), (' A 249  PRO  HG2', ' A 252  GLU  HG3', -0.835, (161.338, 141.434, 131.341)), (' A 186  VAL HG12', ' A 315  LYS  HD2', -0.834, (144.531, 148.448, 147.426)), (' B  64  ILE  O  ', ' B 144  SER  OG ', -0.834, (151.338, 111.42, 136.876)), (' A  64  ILE  O  ', ' A 144  SER  OG ', -0.834, (134.457, 174.145, 136.916)), (' A 105  HIS  CG ', ' A 106  PRO  HD2', -0.833, (130.895, 148.942, 154.548)), (' A  90  ILE  CG1', ' A 160  ILE HD11', -0.832, (142.011, 172.69, 152.782)), (' B  67  HIS  CD2', ' B 174  CYS  HG ', -0.831, (143.009, 120.033, 141.588)), (' B  16  GLU  OE2', ' B  19  LYS  NZ ', -0.83, (147.712, 111.008, 119.765)), (' A  97  CYS  O  ', ' A 103  CYS  HB2', -0.827, (127.457, 157.581, 152.462)), (' A 105  HIS  CE1', ' A 106  PRO  HD2', -0.827, (131.849, 148.395, 154.397)), (' A  67  HIS  CD2', ' A 174  CYS  HG ', -0.826, (142.59, 166.479, 141.306)), (' A 272  LEU HD23', ' A 275  MET  HE3', -0.826, (146.16, 151.336, 131.757)), (' B 109  ASN HD22', ' B 321  GLY  C  ', -0.823, (146.042, 129.306, 150.862)), (' B 186  VAL HG12', ' B 315  LYS  HD2', -0.823, (141.204, 136.861, 147.562)), (' A  61  LEU  CB ', ' A  62  PRO  CD ', -0.823, (132.258, 172.13, 126.636)), (' B  90  ILE  CG1', ' B 160  ILE HD11', -0.82, (144.2, 113.385, 152.808)), (' A   5  LYS  HD2', ' A   6  VAL  N  ', -0.819, (124.422, 188.548, 142.31)), (' B 272  LEU HD23', ' B 275  MET  HE3', -0.816, (140.322, 133.861, 131.647)), (' A 109  ASN HD22', ' A 321  GLY  C  ', -0.816, (139.018, 156.637, 150.613)), (' A 326  ASP  O  ', ' A 329  PRO  HD2', -0.815, (138.632, 164.112, 157.725)), (' B 343  ASP  OD1', ' B 344  PRO  CD ', -0.815, (127.622, 115.317, 151.476)), (' A 242  ASN  O  ', ' A 245  ASP  OD1', -0.814, (166.259, 153.052, 132.34)), (' A  39  LYS  HG3', ' A 149  TYR  HE1', -0.811, (134.111, 185.264, 147.377)), (' B  67  HIS  CD2', ' B 174  CYS  SG ', -0.81, (143.605, 119.606, 142.066)), (' B 326  ASP  O  ', ' B 329  PRO  HD2', -0.81, (147.244, 121.342, 157.315)), (' B 242  ASN  O  ', ' B 245  ASP  OD1', -0.808, (119.25, 132.918, 132.034)), (' A   7  ILE HD12', ' A  74  GLU  OE2', -0.808, (130.771, 185.256, 145.411)), (' B 192  GLY  HA2', ' B 217  ALA  HB2', -0.806, (124.224, 138.715, 154.948)), (' A 192  GLY  HA2', ' A 217  ALA  HB2', -0.804, (161.321, 147.61, 155.319)), (' B   5  LYS  HD2', ' B   6  VAL  N  ', -0.804, (161.636, 97.499, 142.4)), (' A  67  HIS  CD2', ' A 174  CYS  SG ', -0.804, (143.057, 166.145, 142.711)), (' A 196  ALA  N  ', ' A 262  VAL HG11', -0.802, (157.422, 148.284, 145.12)), (' B  97  CYS  O  ', ' B 103  CYS  HB2', -0.801, (158.254, 128.314, 152.59)), (' B 109  ASN HD22', ' B 322  PHE  N  ', -0.794, (146.509, 128.781, 150.353)), (' B 196  ALA  N  ', ' B 262  VAL HG11', -0.792, (128.168, 138.237, 144.853)), (' A  61  LEU  HB2', ' A  62  PRO  HD2', -0.791, (132.388, 171.172, 125.932)), (' A 200  LEU HD13', ' A 232  ALA  CB ', -0.788, (162.131, 160.212, 142.25)), (' B 115  ASP  HB3', ' B 141  LEU  HA ', -0.787, (153.399, 120.199, 138.377)), (' B  46  CYS  CB ', ' B  67  HIS  HE1', -0.784, (140.966, 118.325, 138.841)), (' B   7  ILE HD12', ' B  74  GLU  OE2', -0.782, (155.319, 100.605, 145.433)), (' A   7  ILE  HB ', ' A  28  VAL HG22', -0.782, (129.52, 184.961, 141.722)), (' A 109  ASN HD22', ' A 322  PHE  N  ', -0.782, (139.454, 157.299, 150.323)), (' B 200  LEU HD13', ' B 232  ALA  CB ', -0.778, (124.002, 125.708, 142.418)), (' B   7  ILE HG13', ' B  37  ARG HH12', -0.777, (157.137, 100.42, 145.28)), (' A 115  ASP  HB3', ' A 141  LEU  HA ', -0.777, (132.23, 165.351, 138.271)), (' A  46  CYS  CB ', ' A  67  HIS  HE1', -0.775, (144.995, 167.672, 138.834)), (' B   7  ILE  HB ', ' B  28  VAL HG22', -0.772, (156.689, 100.748, 141.784)), (' A 109  ASN  ND2', ' A 321  GLY  HA2', -0.77, (138.879, 155.178, 150.247)), (' B  90  ILE HG13', ' B 160  ILE  CD1', -0.764, (144.816, 112.326, 153.656)), (' A   7  ILE HD11', ' A  37  ARG HH12', -0.764, (129.488, 186.414, 145.883)), (' A 288  VAL HG22', ' A 313  THR HG22', -0.762, (147.374, 142.056, 147.363)), (' A 199  GLY  C  ', ' A 200  LEU HD23', -0.761, (157.444, 158.434, 140.378)), (' B 109  ASN  ND2', ' B 321  GLY  HA2', -0.759, (146.694, 130.734, 150.138)), (' A 128  SER  OG ', ' A 137  ILE  O  ', -0.759, (127.693, 176.208, 134.487)), (' B  61  LEU  HB2', ' B  62  PRO  HD2', -0.758, (153.693, 114.744, 126.035)), (' A 201  GLY  O  ', ' A 368  ILE HG23', -0.757, (155.465, 166.346, 141.402)), (' B 199  GLY  C  ', ' B 200  LEU HD23', -0.753, (128.455, 127.384, 140.374)), (' B   7  ILE HD11', ' B  37  ARG HH12', -0.753, (156.464, 99.511, 145.814)), (' A  90  ILE HG13', ' A 160  ILE  CD1', -0.752, (141.019, 173.63, 153.735)), (' B 201  GLY  O  ', ' B 368  ILE HG23', -0.75, (130.955, 119.203, 141.674)), (' B 288  VAL HG22', ' B 313  THR HG22', -0.75, (138.694, 143.871, 147.44)), (' A 130  PHE  CD1', ' A 139  HIS  CD2', -0.749, (130.462, 175.456, 137.054)), (' A 272  LEU HD23', ' A 275  MET  CE ', -0.747, (145.431, 151.164, 132.36)), (' B 272  LEU HD23', ' B 275  MET  CE ', -0.747, (140.701, 134.119, 131.856)), (' A  38  ILE HG22', ' A  73  VAL  CA ', -0.746, (132.867, 179.797, 151.873)), (' B  97  CYS  SG ', ' B 100  CYS  SG ', -0.745, (158.511, 127.674, 150.328)), (' A 335  PHE  HB2', ' A 340  PHE  CE2', -0.745, (149.447, 168.251, 156.04)), (' B 130  PHE  CD1', ' B 139  HIS  CD2', -0.739, (155.59, 109.863, 137.017)), (' B  37  ARG  NH1', ' B  74  GLU  OE1', -0.738, (156.973, 100.908, 146.289)), (' A  37  ARG  NH1', ' A  74  GLU  OE1', -0.738, (129.115, 184.869, 146.219)), (' B 229  PHE  CE1', ' B 242  ASN  HB2', -0.738, (120.589, 128.976, 135.668)), (' B 335  PHE  HB2', ' B 340  PHE  CE2', -0.738, (136.138, 118.032, 155.813)), (' A 229  PHE  CE1', ' A 242  ASN  HB2', -0.737, (165.322, 156.824, 135.703)), (' B  38  ILE HG22', ' B  73  VAL  CA ', -0.737, (153.306, 106.232, 151.815)), (' A  84  ARG  CG ', ' A  85  PRO  CD ', -0.732, (129.637, 180.763, 159.098)), (' B 164  SER  HA ', ' B 336  MET  CE ', -0.73, (138.536, 110.435, 158.558)), (' A  97  CYS  SG ', ' A 100  CYS  SG ', -0.73, (127.879, 158.71, 150.437)), (' A 164  SER  HA ', ' A 336  MET  CE ', -0.73, (147.23, 175.542, 158.7)), (' B  39  LYS  HG3', ' B 149  TYR  HE1', -0.73, (151.899, 100.723, 147.607)), (' A  67  HIS  HD2', ' A 174  CYS  CB ', -0.728, (142.928, 166.734, 143.375)), (' B  52  VAL HG22', ' B  57  LEU  HB3', -0.726, (146.743, 121.105, 131.84)), (' A 130  PHE  CE1', ' A 139  HIS  CD2', -0.726, (130.807, 175.329, 137.673)), (' A   7  ILE  HB ', ' A  28  VAL  CG2', -0.722, (130.187, 184.61, 141.94)), (' B   7  ILE  HB ', ' B  28  VAL  CG2', -0.721, (155.825, 101.286, 141.808)), (' B  67  HIS  HD2', ' B 174  CYS  CB ', -0.721, (142.938, 119.087, 143.436)), (' B 130  PHE  CE1', ' B 139  HIS  CD2', -0.72, (155.005, 110.026, 137.533)), (' B  72  ILE  N  ', ' B  72  ILE HD13', -0.718, (146.552, 105.089, 152.269)), (' A  72  ILE  N  ', ' A  72  ILE HD13', -0.717, (139.332, 181.067, 152.297)), (' A  52  VAL HG22', ' A  57  LEU  HB3', -0.716, (138.638, 165.333, 131.94)), (' B 179  GLY  HA3', ' B 206  SER  HB2', -0.713, (135.093, 125.084, 146.771)), (' B  67  HIS  CD2', ' B 174  CYS  CB ', -0.713, (142.833, 118.924, 142.629)), (' B  52  VAL HG21', ' B 140  PHE  HE1', -0.712, (148.359, 119.262, 134.16)), (' A  90  ILE  CD1', ' A 160  ILE HD11', -0.71, (142.125, 172.472, 152.852)), (' A  67  HIS  CD2', ' A 174  CYS  CB ', -0.71, (143.647, 166.808, 142.956)), (' A  32  LYS  HD2', ' A 129  ARG  NH2', -0.71, (121.097, 175.562, 141.784)), (' B 288  VAL HG22', ' B 313  THR  CG2', -0.709, (138.647, 143.167, 147.032)), (' A  52  VAL HG21', ' A 140  PHE  HE1', -0.708, (137.584, 166.41, 133.885)), (' B 278  ALA  O  ', ' B 281  CYS  SG ', -0.707, (131.302, 139.944, 138.717)), (' A 278  ALA  O  ', ' A 281  CYS  SG ', -0.707, (154.7, 145.954, 138.738)), (' B  90  ILE  CD1', ' B 160  ILE HD11', -0.707, (143.651, 113.405, 152.887)), (' B 128  SER  OG ', ' B 137  ILE  O  ', -0.706, (158.322, 109.811, 134.446)), (' A 179  GLY  HA3', ' A 206  SER  HB2', -0.705, (150.674, 160.338, 146.892)), (' B  32  LYS  HD2', ' B 129  ARG  NH2', -0.705, (164.753, 110.228, 141.824)), (' A 288  VAL HG22', ' A 313  THR  CG2', -0.703, (147.338, 142.751, 147.016)), (' A  88  LYS  HD2', ' A 162  ALA  HA ', -0.702, (141.928, 177.743, 158.536)), (' B  88  LYS  HD2', ' B 162  ALA  HA ', -0.702, (144.213, 108.324, 158.442)), (' A 228  LYS  HE3', ' A 365  GLY  O  ', -0.701, (159.322, 166.167, 135.646)), (' A 179  GLY  HA2', ' A 207  VAL HG12', -0.701, (149.934, 158.395, 146.455)), (' B 271  ARG  NH2', ' B 273  ASP  OD1', -0.697, (133.847, 133.397, 129.827)), (' A  39  LYS  CG ', ' A 149  TYR  CZ ', -0.695, (135.468, 185.695, 146.376)), (' B  84  ARG  CG ', ' B  85  PRO  CD ', -0.694, (156.257, 105.286, 159.015)), (' A 109  ASN HD21', ' A 321  GLY  N  ', -0.692, (140.366, 156.168, 149.223)), (' B 273  ASP  OD1', ' B 274  THR  N  ', -0.69, (133.926, 135.23, 130.65)), (' A 193  SER  HG ', ' A 264  PHE  HE2', -0.69, (155.44, 146.174, 151.978)), (' B 228  LYS  HE3', ' B 365  GLY  O  ', -0.69, (127.041, 119.438, 135.411)), (' B 109  ASN HD21', ' B 321  GLY  N  ', -0.688, (145.578, 129.394, 149.237)), (' A 116  LEU  CD1', ' A 318  ILE HD13', -0.687, (137.624, 158.724, 139.769)), (' B 109  ASN HD21', ' B 321  GLY  H  ', -0.687, (146.372, 129.921, 148.816)), (' A 109  ASN HD21', ' A 321  GLY  H  ', -0.687, (140.304, 156.194, 148.725)), (' B  39  LYS  CG ', ' B 149  TYR  CZ ', -0.686, (150.652, 100.271, 146.481)), (' A  92  LEU HD13', ' A 324  SER  HB3', -0.686, (135.345, 165.45, 151.006)), (' B 116  LEU  CD1', ' B 318  ILE HD13', -0.685, (148.264, 127.218, 139.739)), (' A 323  LYS  O  ', ' A 327  SER  HB2', -0.684, (138.118, 161.442, 154.222)), (' A 273  ASP  OD1', ' A 274  THR  N  ', -0.684, (152.178, 150.849, 130.743)), (' B 323  LYS  O  ', ' B 327  SER  HB2', -0.683, (147.844, 124.036, 154.23)), (' B 179  GLY  HA2', ' B 207  VAL HG12', -0.683, (136.07, 128.312, 146.381)), (' A  39  LYS  HD2', ' A 149  TYR  OH ', -0.682, (136.345, 187.092, 147.241)), (' B  39  LYS  HD2', ' B 149  TYR  OH ', -0.682, (149.97, 98.703, 146.906)), (' A 271  ARG  NH2', ' A 273  ASP  OD1', -0.677, (152.288, 153.141, 129.424)), (' A 195  CYS  HA ', ' A 262  VAL HG12', -0.677, (157.069, 146.591, 146.67)), (' B 195  CYS  HA ', ' B 262  VAL HG12', -0.677, (129.029, 139.396, 146.769)), (' A   7  ILE HG13', ' A  37  ARG HH12', -0.677, (128.683, 185.713, 145.323)), (' B  35  GLU  OE1', ' B 123  MET  CE ', -0.676, (160.566, 112.323, 143.039)), (' A  35  GLU  OE1', ' A 123  MET  CE ', -0.672, (125.605, 173.744, 143.187)), (' A 301  LEU  O  ', ' B 302  SER  CA ', -0.668, (141.677, 143.797, 128.641)), (' A  64  ILE  CG2', ' A 144  SER  OG ', -0.666, (135.011, 175.499, 136.702)), (' B 116  LEU HD13', ' B 318  ILE HD13', -0.666, (148.166, 127.319, 140.674)), (' A 326  ASP  C  ', ' A 329  PRO  HD2', -0.666, (137.925, 164.133, 157.221)), (' B 276  VAL HG23', ' B 301  LEU HD11', -0.665, (138.462, 139.167, 130.93)), (' B  92  LEU HD13', ' B 324  SER  HB3', -0.663, (149.887, 120.747, 150.835)), (' A  67  HIS  HD2', ' A 174  CYS  HB2', -0.662, (142.171, 167.11, 143.161)), (' A  38  ILE  HA ', ' A  74  GLU  H  ', -0.662, (132.895, 181.592, 149.464)), (' B  38  ILE  HA ', ' B  74  GLU  H  ', -0.661, (153.55, 104.388, 150.007)), (' A  33  ALA  HA ', ' A  78  GLU  CB ', -0.66, (119.121, 176.291, 150.728)), (' A 116  LEU HD13', ' A 318  ILE HD13', -0.658, (137.331, 159.05, 140.394)), (' A 247  LYS  HG2', ' A 247  LYS  O  ', -0.658, (167.795, 145.445, 126.554)), (' A 276  VAL HG23', ' A 301  LEU HD11', -0.658, (148.059, 146.954, 131.326)), (' A 109  ASN  ND2', ' A 321  GLY  N  ', -0.657, (140.229, 156.348, 150.056)), (' B  64  ILE  CG2', ' B 144  SER  OG ', -0.655, (151.07, 110.309, 136.816)), (' B  67  HIS  HD2', ' B 174  CYS  HB2', -0.655, (143.386, 119.167, 143.629)), (' B 171  LEU HD21', ' B 371  ILE HD11', -0.654, (136.374, 113.334, 145.113)), (' B 247  LYS  HG2', ' B 247  LYS  O  ', -0.654, (118.319, 141.35, 126.886)), (' B 326  ASP  C  ', ' B 329  PRO  HD2', -0.653, (148.156, 121.782, 157.325)), (' A 283  GLN  O  ', ' A 287  GLY  N  ', -0.653, (152.508, 139.514, 145.58)), (' A 350  LEU  O  ', ' A 373  THR  N  ', -0.653, (148.773, 180.959, 141.842)), (' B  37  ARG  NH2', ' B  74  GLU  OE1', -0.653, (158.321, 101.358, 146.876)), (' A  92  LEU HD11', ' A 158  ALA  HB2', -0.652, (136.011, 168.322, 152.914)), (' A  16  GLU  CD ', ' A  19  LYS  NZ ', -0.651, (138.001, 175.111, 119.443)), (' A  38  ILE  HB ', ' A  72  ILE  O  ', -0.648, (135.45, 180.025, 149.821)), (' B 350  LEU  O  ', ' B 373  THR  N  ', -0.647, (137.219, 104.326, 141.852)), (' A 267  GLU  HG3', ' A 275  MET  HA ', -0.646, (150.309, 150.45, 135.692)), (' B 109  ASN  ND2', ' B 321  GLY  N  ', -0.646, (146.408, 129.724, 149.556)), (' A 109  ASN HD22', ' A 321  GLY  CA ', -0.645, (139.23, 156.577, 150.47)), (' A  37  ARG  NH2', ' A  74  GLU  OE1', -0.642, (127.809, 184.785, 146.677)), (' A 232  ALA  O  ', ' A 237  ALA  HB3', -0.642, (163.298, 158.652, 146.157)), (' B  63  VAL HG23', ' B 138  HIS  O  ', -0.641, (154.04, 112.903, 133.971)), (' A 171  LEU HD21', ' A 371  ILE HD11', -0.641, (150.173, 172.24, 145.098)), (' A 271  ARG  HB2', ' A 271  ARG HH21', -0.64, (152.341, 154.365, 130.398)), (' B 232  ALA  O  ', ' B 237  ALA  HB3', -0.637, (123.175, 126.827, 146.192)), (' B 271  ARG  HB2', ' B 271  ARG HH21', -0.636, (134.157, 131.58, 130.463)), (' B 267  GLU  HG3', ' B 275  MET  HA ', -0.636, (135.454, 135.081, 135.843)), (' B  78  GLU  HA ', ' B  78  GLU  OE1', -0.635, (167.222, 107.165, 152.97)), (' B  16  GLU  CD ', ' B  19  LYS  NZ ', -0.634, (147.96, 110.821, 119.514)), (' B 239  GLU  OE1', ' B 257  MET  CE ', -0.634, (118.688, 137.079, 143.043)), (' B  38  ILE  HB ', ' B  72  ILE  O  ', -0.634, (150.622, 105.388, 150.023)), (' B  92  LEU HD11', ' B 158  ALA  HB2', -0.633, (149.825, 117.632, 152.836)), (' B 195  CYS  CA ', ' B 262  VAL  CG1', -0.631, (128.26, 138.116, 146.696)), (' A  67  HIS  NE2', ' A 174  CYS  SG ', -0.63, (143.76, 165.922, 141.72)), (' A 239  GLU  OE1', ' A 257  MET  CE ', -0.628, (167.224, 149.414, 143.45)), (' A  63  VAL HG23', ' A 138  HIS  O  ', -0.628, (132.593, 172.933, 133.858)), (' B  60  PRO  CB ', ' B 138  HIS  ND1', -0.627, (156.539, 116.669, 129.914)), (' B  16  GLU  OE2', ' B  19  LYS  CE ', -0.627, (146.514, 111.402, 119.2)), (' A  78  GLU  HA ', ' A  78  GLU  OE1', -0.627, (118.737, 178.263, 152.962)), (' A  97  CYS  O  ', ' A 103  CYS  SG ', -0.626, (128.573, 158.497, 151.989)), (' B  97  CYS  O  ', ' B 103  CYS  SG ', -0.626, (157.303, 126.863, 152.014)), (' B 212  LYS  HD2', ' B 236  GLY  HA3', -0.624, (124.488, 127.356, 152.326)), (' B 193  SER  HG ', ' B 264  PHE  HE2', -0.623, (131.08, 140.082, 152.03)), (' B  33  ALA  HA ', ' B  78  GLU  CB ', -0.622, (166.752, 109.507, 150.676)), (' A 124  GLN  CG ', ' A 153  ASP  OD2', -0.621, (125.389, 168.471, 144.548)), (' A  16  GLU  OE2', ' A  19  LYS  CE ', -0.62, (139.404, 174.717, 119.233)), (' A 115  ASP  OD2', ' A 119  PRO  HA ', -0.617, (129.57, 163.931, 136.027)), (' A 304  ASN  OD1', ' A 305  PRO  HD2', -0.617, (146.161, 135.456, 131.837)), (' A 359  PHE  HB3', ' A 363  ARG  NH1', -0.616, (148.731, 173.31, 130.357)), (' B  67  HIS  NE2', ' B 174  CYS  SG ', -0.616, (141.945, 119.94, 141.849)), (' B 115  ASP  OD2', ' B 119  PRO  HA ', -0.616, (155.975, 122.302, 135.71)), (' A 302  SER  CA ', ' B 301  LEU  O  ', -0.616, (144.361, 142.129, 128.7)), (' B 145  THR  O  ', ' B 145  THR HG22', -0.615, (145.582, 109.861, 142.366)), (' B  68  GLU  HG3', ' B  68  GLU  O  ', -0.614, (141.995, 113.338, 143.953)), (' A  46  CYS  HG ', ' A  67  HIS  HE2', -0.613, (144.146, 166.961, 141.832)), (' B 359  PHE  HB3', ' B 363  ARG  NH1', -0.612, (136.905, 112.511, 129.888)), (' A 212  LYS  HD2', ' A 236  GLY  HA3', -0.611, (161.401, 158.287, 152.861)), (' B 124  GLN  CG ', ' B 153  ASP  OD2', -0.611, (160.457, 117.577, 144.661)), (' A 195  CYS  CA ', ' A 262  VAL  CG1', -0.611, (157.64, 147.885, 146.59)), (' A 359  PHE  HB3', ' A 363  ARG HH12', -0.61, (148.92, 173.776, 129.893)), (' A  60  PRO  CB ', ' A 138  HIS  ND1', -0.609, (129.269, 169.114, 130.031)), (' A  68  GLU  HG3', ' A  68  GLU  O  ', -0.608, (144.479, 172.442, 143.728)), (' B 160  ILE HG22', ' B 161  ASP  N  ', -0.608, (144.451, 112.358, 159.372)), (' B 304  ASN  OD1', ' B 305  PRO  HD2', -0.605, (139.841, 151.178, 131.844)), (' B 108  GLY  O  ', ' B 323  LYS  CE ', -0.605, (151.705, 130.434, 153.334)), (' B  38  ILE  CG2', ' B  73  VAL  HA ', -0.605, (152.537, 106.342, 150.512)), (' B 359  PHE  HB3', ' B 363  ARG HH12', -0.604, (136.734, 111.933, 130.07)), (' A  56  THR  O  ', ' A 297  ASP  HB2', -0.604, (139.448, 160.13, 128.704)), (' B  76  ILE  O  ', ' B  76  ILE HG13', -0.603, (161.951, 106.42, 153.616)), (' A 283  GLN  HG2', ' A 286  TYR  CZ ', -0.601, (156.323, 137.499, 148.618)), (' A 108  GLY  O  ', ' A 323  LYS  CE ', -0.6, (134.316, 155.627, 153.241)), (' B 283  GLN  O  ', ' B 287  GLY  N  ', -0.6, (133.541, 146.499, 145.522)), (' A  88  LYS  NZ ', ' A 164  SER  O  ', -0.599, (144.791, 179.9, 157.207)), (' B  88  LYS  NZ ', ' B 164  SER  O  ', -0.599, (141.164, 106.052, 157.148)), (' B 109  ASN  ND2', ' B 321  GLY  C  ', -0.598, (146.988, 129.559, 150.595)), (' B 241  VAL HG13', ' B 246  TYR  CE2', -0.597, (119.668, 135.377, 136.279)), (' A 160  ILE HG22', ' A 161  ASP  N  ', -0.596, (141.447, 173.97, 158.736)), (' B 229  PHE  CD2', ' B 240  CYS  HB3', -0.596, (121.287, 128.853, 139.409)), (' A 130  PHE  HD1', ' A 139  HIS  CD2', -0.595, (129.931, 175.989, 136.686)), (' B 130  PHE  CD1', ' B 139  HIS  NE2', -0.595, (156.381, 109.477, 137.559)), (' A 145  THR  O  ', ' A 145  THR HG22', -0.594, (140.266, 175.943, 142.29)), (' A 229  PHE  CD2', ' A 240  CYS  HB3', -0.594, (165.273, 157.296, 139.899)), (' B 195  CYS  HB2', ' B 264  PHE  HB2', -0.594, (130.968, 137.14, 147.574)), (' B 283  GLN  HG2', ' B 286  TYR  CZ ', -0.594, (129.659, 147.876, 148.628)), (' B 130  PHE  HD1', ' B 139  HIS  CD2', -0.594, (155.838, 109.803, 137.014)), (' B 160  ILE  CG2', ' B 332  VAL HG11', -0.593, (142.878, 112.982, 157.57)), (' A 105  HIS  ND1', ' A 106  PRO  CD ', -0.593, (130.973, 149.105, 155.441)), (' A 241  VAL HG13', ' A 246  TYR  CE2', -0.592, (166.548, 150.762, 135.751)), (' A 305  PRO  HG2', ' B 272  LEU HD22', -0.592, (142.837, 135.546, 131.17)), (' A 292  VAL  O  ', ' A 292  VAL HG22', -0.592, (146.957, 157.636, 142.0)), (' B 292  VAL  O  ', ' B 292  VAL HG22', -0.589, (139.176, 128.59, 141.555)), (' B  56  THR  O  ', ' B 297  ASP  HB2', -0.588, (146.273, 125.885, 128.614)), (' A 350  LEU  O  ', ' A 372  LEU  HA ', -0.587, (149.207, 180.86, 140.848)), (' A 109  ASN  ND2', ' A 321  GLY  C  ', -0.586, (138.951, 156.39, 150.602)), (' B 350  LEU  O  ', ' B 372  LEU  HA ', -0.585, (136.626, 105.157, 140.751)), (' A 130  PHE  CD1', ' A 139  HIS  NE2', -0.585, (129.457, 175.9, 137.594)), (' A 235  VAL  O  ', ' A 235  VAL HG12', -0.584, (159.646, 160.942, 150.143)), (' A  90  ILE HD11', ' A 160  ILE HD11', -0.583, (142.653, 172.163, 153.343)), (' A 272  LEU HD22', ' B 305  PRO  HG2', -0.579, (143.102, 150.643, 131.149)), (' A 195  CYS  HB2', ' A 264  PHE  HB2', -0.579, (154.664, 148.516, 147.687)), (' A  76  ILE  O  ', ' A  76  ILE HG13', -0.577, (124.06, 179.637, 153.692)), (' A  38  ILE  CG2', ' A  73  VAL  HA ', -0.576, (133.744, 179.566, 150.584)), (' B  38  ILE HG22', ' B  73  VAL HG13', -0.575, (153.308, 107.274, 151.205)), (' A  23  ILE HD11', ' A 355  ILE HG22', -0.574, (144.417, 181.209, 132.529)), (' A  40  MET  CE ', ' A 145  THR HG23', -0.573, (137.972, 176.378, 143.876)), (' B 229  PHE  HZ ', ' B 241  VAL  O  ', -0.573, (121.999, 130.859, 136.58)), (' B  40  MET  CE ', ' B 145  THR HG23', -0.573, (148.065, 109.678, 144.07)), (' A  64  ILE  O  ', ' A  64  ILE HG22', -0.573, (135.719, 175.132, 136.718)), (' B 235  VAL  O  ', ' B 235  VAL HG12', -0.573, (126.317, 125.016, 150.067)), (' A 263  ASP  OD1', ' A 286  TYR  HE2', -0.572, (156.476, 140.374, 149.502)), (' B  58  VAL  O  ', ' B  58  VAL HG12', -0.572, (152.461, 123.038, 129.058)), (' A  69  ALA  HB2', ' A 145  THR HG23', -0.572, (139.306, 175.569, 144.436)), (' B 325  LYS  O  ', ' B 329  PRO  HG2', -0.571, (149.392, 120.005, 158.118)), (' B 283  GLN  HA ', ' B 283  GLN  OE1', -0.571, (129.26, 147.96, 144.236)), (' B  90  ILE HD11', ' B 160  ILE HD11', -0.571, (143.487, 113.829, 153.204)), (' A  84  ARG  HG2', ' A  85  PRO  HD3', -0.57, (128.61, 180.579, 158.552)), (' B  39  LYS  HG2', ' B 149  TYR  CZ ', -0.57, (150.097, 100.759, 146.541)), (' B 109  ASN HD22', ' B 321  GLY  CA ', -0.569, (146.296, 129.745, 150.881)), (' A  35  GLU  CD ', ' A 123  MET  HE2', -0.568, (124.29, 173.919, 144.245)), (' A  38  ILE HG22', ' A  73  VAL HG13', -0.567, (132.269, 178.597, 151.614)), (' B  23  ILE HD11', ' B 355  ILE HG22', -0.567, (141.015, 104.85, 132.707)), (' B  92  LEU HD21', ' B 328  VAL HG21', -0.566, (146.853, 118.817, 151.506)), (' A 229  PHE  HZ ', ' A 241  VAL  O  ', -0.566, (163.837, 155.142, 136.484)), (' A 283  GLN  HA ', ' A 283  GLN  OE1', -0.566, (157.009, 138.126, 144.089)), (' B 193  SER  OG ', ' B 264  PHE  HE2', -0.565, (130.504, 140.193, 151.978)), (' B 263  ASP  OD1', ' B 286  TYR  HE2', -0.564, (129.388, 145.133, 149.336)), (' B 362  LEU  HA ', ' B 367  SER  HG ', -0.564, (131.5, 115.432, 135.092)), (' A  12  ALA  HB3', ' A 146  PHE  HB3', -0.564, (140.615, 177.575, 136.029)), (' A  39  LYS  HG2', ' A 149  TYR  CZ ', -0.563, (135.633, 185.372, 146.026)), (' B 168  LYS  HA ', ' B 346  ILE HD11', -0.563, (134.516, 111.633, 149.223)), (' A  58  VAL  O  ', ' A  58  VAL HG12', -0.563, (133.383, 162.817, 129.063)), (' A 325  LYS  O  ', ' A 329  PRO  HG2', -0.562, (136.7, 166.136, 158.046)), (' B  41  VAL HG23', ' B  71  GLY  HA2', -0.562, (145.719, 105.223, 150.312)), (' A 168  LYS  HA ', ' A 346  ILE HD11', -0.562, (151.863, 174.339, 149.007)), (' A  41  VAL HG23', ' A  71  GLY  HA2', -0.561, (140.388, 180.038, 150.187)), (' B 328  VAL  N  ', ' B 329  PRO  CD ', -0.558, (147.342, 120.497, 156.285)), (' B 105  HIS  ND1', ' B 106  PRO  CD ', -0.558, (155.135, 136.925, 155.535)), (' A 196  ALA  H  ', ' A 262  VAL HG11', -0.558, (157.202, 148.146, 145.114)), (' B 179  GLY  HA2', ' B 207  VAL  CG1', -0.558, (135.713, 127.891, 146.129)), (' A 328  VAL  N  ', ' A 329  PRO  CD ', -0.557, (138.64, 165.62, 156.126)), (' A 305  PRO  HG2', ' B 272  LEU  CD2', -0.557, (142.475, 134.792, 130.966)), (' B  84  ARG  HG2', ' B  85  PRO  HD3', -0.556, (157.619, 105.018, 158.599)), (' A  92  LEU HD21', ' A 328  VAL HG21', -0.556, (139.059, 167.008, 151.46)), (' A 258  SER  CB ', ' A 261  GLY  O  ', -0.556, (161.209, 142.807, 144.806)), (' B 157  VAL  O  ', ' B 325  LYS  HE3', -0.556, (153.355, 117.539, 154.127)), (' A 160  ILE  CG2', ' A 332  VAL HG11', -0.553, (143.124, 172.925, 157.407)), (' B 303  MET  CE ', ' B 304  ASN  O  ', -0.553, (138.896, 147.0, 134.099)), (' A 193  SER  OG ', ' A 264  PHE  HE2', -0.552, (155.442, 145.654, 152.208)), (' A 303  MET  CE ', ' A 304  ASN  O  ', -0.552, (146.548, 139.282, 134.28)), (' A 343  ASP  N  ', ' A 344  PRO  HD2', -0.552, (156.969, 169.78, 151.606)), (' A 250  ILE  CG2', ' A 277  THR HG21', -0.551, (157.73, 148.005, 133.789)), (' B 290  VAL  HA ', ' B 315  LYS  O  ', -0.551, (140.209, 137.205, 143.085)), (' A 130  PHE  CE1', ' A 139  HIS  NE2', -0.55, (129.868, 175.873, 138.205)), (' A 179  GLY  HA2', ' A 207  VAL  CG1', -0.55, (150.322, 158.24, 146.074)), (' A 272  LEU  CD2', ' B 305  PRO  HG2', -0.55, (143.144, 150.913, 131.222)), (' A 157  VAL  O  ', ' A 325  LYS  HE3', -0.549, (132.355, 168.95, 153.855)), (' B  64  ILE  O  ', ' B  64  ILE HG22', -0.549, (150.503, 110.892, 136.852)), (' B  12  ALA  HB3', ' B 146  PHE  HB3', -0.547, (145.475, 108.302, 136.097)), (' B 186  VAL HG12', ' B 315  LYS  CD ', -0.547, (141.496, 137.434, 147.294)), (' B  46  CYS  HG ', ' B  67  HIS  HE2', -0.546, (141.68, 119.102, 141.935)), (' A   7  ILE HD12', ' A  37  ARG  NH1', -0.545, (130.323, 185.267, 144.976)), (' B 209  MET  CE ', ' B 235  VAL HG11', -0.544, (128.398, 122.615, 149.951)), (' A 290  VAL  HA ', ' A 315  LYS  O  ', -0.543, (146.18, 148.878, 143.167)), (' B  14  LEU HD22', ' B  53  VAL HG22', -0.543, (144.775, 113.912, 129.252)), (' B 250  ILE  CG2', ' B 277  THR HG21', -0.543, (128.795, 137.915, 134.316)), (' B 130  PHE  CE1', ' B 139  HIS  NE2', -0.541, (155.843, 109.536, 138.282)), (' B 198  PHE  HA ', ' B 222  VAL  HB ', -0.541, (127.984, 132.464, 138.37)), (' B  35  GLU  CD ', ' B 123  MET  HE2', -0.541, (161.766, 112.076, 144.186)), (' A 250  ILE  CG2', ' A 277  THR  CG2', -0.54, (157.216, 147.548, 133.803)), (' B 258  SER  CB ', ' B 261  GLY  O  ', -0.54, (124.684, 143.34, 144.755)), (' A  14  LEU HD22', ' A  53  VAL HG22', -0.539, (141.652, 171.945, 129.128)), (' B 343  ASP  N  ', ' B 344  PRO  HD2', -0.538, (129.418, 115.957, 151.433)), (' A 351  PRO  HA ', ' A 373  THR  O  ', -0.538, (148.433, 183.803, 141.246)), (' B 250  ILE  CG2', ' B 277  THR  CG2', -0.538, (128.303, 138.453, 133.913)), (' B 164  SER  CA ', ' B 336  MET  CE ', -0.537, (138.987, 110.018, 158.359)), (' A 209  MET  CE ', ' A 235  VAL HG11', -0.536, (158.264, 163.305, 149.981)), (' B 271  ARG  NH1', ' B 273  ASP  OD2', -0.535, (132.783, 133.191, 127.569)), (' A  35  GLU  HG2', ' A 151  VAL HG12', -0.534, (126.531, 175.765, 144.764)), (' A 164  SER  CA ', ' A 336  MET  CE ', -0.533, (146.751, 175.913, 158.438)), (' B 291  ILE HD11', ' B 314  TRP  CE2', -0.533, (140.144, 138.998, 137.682)), (' B 351  PRO  HA ', ' B 373  THR  O  ', -0.533, (137.921, 102.008, 141.444)), (' A 291  ILE HD11', ' A 314  TRP  CE2', -0.532, (145.606, 146.862, 137.588)), (' A 198  PHE  HA ', ' A 222  VAL  HB ', -0.532, (157.96, 153.427, 138.348)), (' B 196  ALA  H  ', ' B 262  VAL HG11', -0.529, (128.765, 137.854, 145.042)), (' B  37  ARG  NH1', ' B  74  GLU  OE2', -0.529, (156.268, 101.065, 145.986)), (' B  35  GLU  HG2', ' B 151  VAL HG12', -0.527, (159.554, 110.584, 145.125)), (' B 229  PHE  CZ ', ' B 241  VAL  O  ', -0.527, (122.237, 130.217, 137.035)), (' B 271  ARG  HB2', ' B 271  ARG  NH2', -0.526, (133.698, 132.044, 130.421)), (' B 303  MET  HE1', ' B 304  ASN  O  ', -0.524, (139.15, 147.28, 134.585)), (' A  37  ARG  NH1', ' A  74  GLU  OE2', -0.524, (129.842, 184.612, 145.94)), (' A 186  VAL HG12', ' A 315  LYS  CD ', -0.524, (144.286, 148.534, 147.43)), (' A 271  ARG  HB2', ' A 271  ARG  NH2', -0.524, (152.309, 154.102, 130.386)), (' A 229  PHE  CZ ', ' A 241  VAL  O  ', -0.523, (164.231, 155.613, 136.886)), (' B 194  THR HG23', ' B 218  ARG  HB2', -0.523, (123.027, 137.961, 148.967)), (' A 271  ARG  NH1', ' A 273  ASP  OD2', -0.523, (153.448, 152.716, 127.434)), (' B 105  HIS  CG ', ' B 106  PRO  CD ', -0.522, (154.243, 136.52, 155.099)), (' A 362  LEU  HA ', ' A 367  SER  HG ', -0.522, (154.552, 170.608, 135.035)), (' B   6  VAL HG22', ' B  30  PRO  HD3', -0.521, (162.733, 101.024, 141.24)), (' B 186  VAL  CG1', ' B 315  LYS  HD2', -0.519, (141.795, 136.815, 147.81)), (' A 194  THR HG23', ' A 218  ARG  HB2', -0.518, (162.916, 148.085, 148.977)), (' A   6  VAL HG22', ' A  30  PRO  HD3', -0.517, (123.759, 184.85, 141.683)), (' A 362  LEU  O  ', ' A 362  LEU HD12', -0.517, (153.287, 168.315, 134.11)), (' A 304  ASN  OD1', ' A 305  PRO  CD ', -0.517, (146.254, 135.694, 131.848)), (' B  16  GLU  OE2', ' B  19  LYS  HE3', -0.516, (146.87, 111.799, 119.283)), (' A 303  MET  HE1', ' A 304  ASN  O  ', -0.516, (146.404, 139.003, 134.763)), (' B 304  ASN  OD1', ' B 305  PRO  CD ', -0.515, (139.221, 150.238, 132.129)), (' B 362  LEU  O  ', ' B 362  LEU HD12', -0.515, (132.547, 117.77, 134.146)), (' A  23  ILE  O  ', ' A  23  ILE HG22', -0.514, (140.954, 186.081, 132.509)), (' B 107  GLU  HG2', ' B 107  GLU  O  ', -0.514, (148.96, 136.183, 152.132)), (' A  16  GLU  OE2', ' A  19  LYS  HE3', -0.514, (139.551, 174.199, 119.465)), (' B  37  ARG  NH1', ' B  74  GLU  CD ', -0.514, (156.101, 101.03, 146.556)), (' B 130  PHE  HE1', ' B 139  HIS  CD2', -0.513, (154.999, 110.297, 138.551)), (' B  92  LEU  O  ', ' B 156  SER  OG ', -0.512, (152.466, 117.823, 146.32)), (' B  38  ILE  CG2', ' B  73  VAL HG13', -0.511, (153.797, 107.787, 151.383)), (' A 209  MET  CG ', ' A 235  VAL HG11', -0.511, (157.806, 162.509, 150.208)), (' B  23  ILE  O  ', ' B  23  ILE HG22', -0.511, (145.407, 100.061, 132.366)), (' B   7  ILE HD12', ' B  37  ARG  NH1', -0.511, (155.631, 100.724, 144.937)), (' B 276  VAL  CG2', ' B 301  LEU HD11', -0.51, (138.022, 139.423, 131.146)), (' A 276  VAL  CG2', ' A 301  LEU HD11', -0.51, (147.948, 146.51, 131.073)), (' A 116  LEU HD11', ' A 318  ILE HD13', -0.51, (137.99, 158.789, 139.644)), (' A 107  GLU  HG2', ' A 107  GLU  O  ', -0.509, (137.078, 149.943, 152.171)), (' A 348  HIS  CE1', ' A 361  LEU  CD2', -0.506, (158.109, 175.506, 136.975)), (' A 192  GLY  CA ', ' A 217  ALA  HB2', -0.506, (161.429, 146.702, 155.529)), (' B 193  SER  OG ', ' B 264  PHE  CE2', -0.505, (130.489, 140.111, 151.634)), (' A 160  ILE  CG2', ' A 161  ASP  N  ', -0.505, (141.453, 173.466, 158.714)), (' A 130  PHE  HE1', ' A 139  HIS  CD2', -0.504, (131.179, 175.511, 138.397)), (' B 239  GLU  OE1', ' B 257  MET  HE1', -0.504, (119.017, 136.696, 143.026)), (' A  37  ARG  NH1', ' A  74  GLU  CD ', -0.503, (129.825, 184.948, 146.568)), (' A  38  ILE  CG2', ' A  73  VAL HG13', -0.503, (132.451, 178.256, 151.028)), (' B 209  MET  CG ', ' B 235  VAL HG11', -0.503, (128.156, 123.532, 150.169)), (' B 160  ILE  CG2', ' B 161  ASP  N  ', -0.502, (144.51, 112.109, 158.72)), (' A 313  THR  OG1', ' B 315  LYS  HB3', -0.502, (143.377, 141.258, 145.655)), (' A 294  VAL  O  ', ' A 294  VAL HG13', -0.501, (144.066, 158.429, 133.995)), (' B 239  GLU  OE1', ' B 257  MET  HE3', -0.501, (118.263, 137.37, 143.211)), (' A 315  LYS  HB3', ' B 313  THR  OG1', -0.5, (142.479, 144.761, 145.555)), (' A 322  PHE  CE2', ' A 331  LEU HD11', -0.5, (144.606, 161.512, 153.281)), (' A 248  LYS  HB2', ' A 249  PRO  HD2', -0.5, (163.918, 142.739, 129.808)), (' A 265  SER  OG ', ' A 289  SER  CB ', -0.5, (150.939, 146.159, 141.832)), (' B 348  HIS  CE1', ' B 361  LEU  CD2', -0.499, (128.199, 110.064, 136.726)), (' A 239  GLU  OE1', ' A 257  MET  HE1', -0.499, (166.776, 149.256, 143.148)), (' A 193  SER  OG ', ' A 264  PHE  CE2', -0.499, (155.479, 145.844, 151.605)), (' B 209  MET  HG2', ' B 235  VAL  CG1', -0.498, (127.817, 123.781, 150.681)), (' B 250  ILE HG21', ' B 277  THR HG21', -0.498, (128.715, 137.608, 133.988)), (' A 209  MET  HG2', ' A 235  VAL  CG1', -0.497, (157.867, 161.933, 151.035)), (' B 265  SER  OG ', ' B 289  SER  CB ', -0.497, (134.965, 139.952, 141.899)), (' B 251  GLN  HG3', ' B 252  GLU  N  ', -0.497, (125.932, 143.919, 134.029)), (' B 294  VAL  O  ', ' B 294  VAL HG13', -0.497, (141.9, 127.547, 133.905)), (' B 116  LEU HD11', ' B 318  ILE HD13', -0.496, (147.857, 126.79, 139.891)), (' A 239  GLU  OE1', ' A 257  MET  HE3', -0.496, (167.577, 148.691, 143.123)), (' A 251  GLN  HG3', ' A 252  GLU  N  ', -0.495, (160.396, 142.269, 134.153)), (' B 271  ARG  CB ', ' B 271  ARG  NH2', -0.495, (133.851, 131.745, 129.813)), (' A 250  ILE HG21', ' A 277  THR HG21', -0.494, (157.254, 148.395, 133.958)), (' B 248  LYS  HB2', ' B 249  PRO  HD2', -0.493, (121.997, 143.407, 129.855)), (' B 267  GLU  HG2', ' B 274  THR HG22', -0.493, (133.974, 133.745, 136.17)), (' B  16  GLU  OE1', ' B  19  LYS  NZ ', -0.492, (147.737, 109.843, 119.363)), (' B 147  SER  OG ', ' B 149  TYR  O  ', -0.492, (151.207, 105.565, 140.553)), (' B 179  GLY  CA ', ' B 207  VAL HG12', -0.492, (136.037, 127.574, 147.124)), (' A 105  HIS  CG ', ' A 106  PRO  CD ', -0.492, (131.39, 149.697, 155.128)), (' B 362  LEU  HA ', ' B 367  SER  OG ', -0.492, (131.642, 114.672, 135.305)), (' A   7  ILE  O  ', ' A  27  GLU  HA ', -0.492, (129.972, 186.352, 138.229)), (' A 147  SER  OG ', ' A 149  TYR  O  ', -0.491, (134.724, 180.359, 140.529)), (' A 362  LEU  HA ', ' A 367  SER  OG ', -0.491, (154.456, 170.968, 135.578)), (' B 322  PHE  CE2', ' B 331  LEU HD11', -0.49, (141.484, 124.537, 153.377)), (' B 348  HIS  CE1', ' B 361  LEU HD21', -0.49, (127.624, 109.866, 136.886)), (' A  16  GLU  OE1', ' A  19  LYS  NZ ', -0.489, (138.204, 175.807, 119.351)), (' A 271  ARG  CB ', ' A 271  ARG  NH2', -0.489, (152.081, 154.153, 129.768)), (' B  88  LYS  HD3', ' B 166  LEU HD11', -0.488, (143.636, 107.31, 154.89)), (' B 351  PRO  HG2', ' B 354  LYS  HG2', -0.488, (135.252, 101.329, 137.071)), (' A 351  PRO  HG2', ' A 354  LYS  HG2', -0.486, (150.601, 184.275, 136.713)), (' A 348  HIS  CE1', ' A 361  LEU HD21', -0.485, (157.9, 176.376, 136.759)), (' A 249  PRO  HG2', ' A 252  GLU  CG ', -0.484, (162.046, 141.123, 131.777)), (' A  70  ALA  HB1', ' A 166  LEU HD22', -0.484, (143.167, 176.118, 152.38)), (' A 251  GLN  OE1', ' A 280  SER  CB ', -0.483, (155.428, 141.83, 133.984)), (' A  88  LYS  HD3', ' A 166  LEU HD11', -0.483, (142.32, 178.757, 154.886)), (' A 267  GLU  HG2', ' A 274  THR HG22', -0.483, (151.993, 152.152, 136.184)), (' A 342  LEU  C  ', ' A 342  LEU HD12', -0.482, (153.897, 170.586, 151.105)), (' B 249  PRO  HG2', ' B 252  GLU  CG ', -0.481, (123.82, 144.717, 131.859)), (' B 251  GLN  OE1', ' B 280  SER  CB ', -0.48, (130.796, 144.377, 134.345)), (' A 125  ASP  OD2', ' A 129  ARG  NH2', -0.48, (121.738, 173.37, 142.023)), (' B 342  LEU  C  ', ' B 342  LEU HD12', -0.479, (132.403, 115.132, 151.254)), (' B 123  MET  HB3', ' B 123  MET  HE3', -0.479, (161.371, 114.608, 142.609)), (' A 350  LEU  HG ', ' A 351  PRO  HD2', -0.478, (152.465, 182.736, 138.366)), (' A 179  GLY  CA ', ' A 207  VAL HG12', -0.477, (149.926, 158.358, 147.208)), (' B 199  GLY  HA3', ' B 268  VAL  HB ', -0.477, (132.101, 128.195, 139.221)), (' A 199  GLY  HA3', ' A 268  VAL  HB ', -0.476, (153.503, 157.348, 139.394)), (' B   7  ILE  O  ', ' B  27  GLU  HA ', -0.475, (156.098, 99.705, 138.718)), (' B 125  ASP  OD2', ' B 129  ARG  NH2', -0.475, (164.173, 112.152, 141.799)), (' A  92  LEU  O  ', ' A 156  SER  OG ', -0.474, (133.494, 168.126, 146.394)), (' A 186  VAL  CG1', ' A 315  LYS  HD2', -0.474, (144.05, 149.116, 147.901)), (' A 302  SER  HA ', ' B 302  SER  HA ', -0.474, (143.225, 142.95, 128.818)), (' B 209  MET  HE2', ' B 235  VAL HG11', -0.472, (127.583, 122.636, 150.324)), (' B 335  PHE  HB2', ' B 340  PHE  CZ ', -0.472, (136.634, 118.638, 156.699)), (' A 301  LEU  O  ', ' B 303  MET  N  ', -0.472, (141.237, 144.11, 129.629)), (' A 294  VAL  CG2', ' A 295  PRO  HD2', -0.472, (141.178, 157.04, 135.096)), (' B  24  GLU  OE2', ' B 133  ARG  NH2', -0.472, (149.817, 102.065, 125.527)), (' B  68  GLU  CG ', ' B  68  GLU  O  ', -0.471, (141.956, 113.984, 143.815)), (' B 350  LEU  HG ', ' B 351  PRO  HD2', -0.47, (133.618, 103.211, 138.281)), (' B 192  GLY  CA ', ' B 217  ALA  HB2', -0.47, (124.537, 139.234, 155.58)), (' A 303  MET  N  ', ' B 301  LEU  O  ', -0.47, (144.735, 141.842, 129.662)), (' A 304  ASN  HA ', ' A 305  PRO  HD3', -0.469, (146.111, 137.255, 130.641)), (' B  40  MET  HB3', ' B 374  PHE  CE2', -0.469, (144.932, 105.723, 144.207)), (' A  40  MET  HB3', ' A 374  PHE  CE2', -0.468, (141.344, 180.322, 143.93)), (' A  24  GLU  OE2', ' A 133  ARG  NH2', -0.468, (136.051, 183.727, 125.444)), (' A 335  PHE  HB2', ' A 340  PHE  CZ ', -0.466, (149.196, 167.349, 156.588)), (' B  31  PRO  HD3', ' B  37  ARG  HE ', -0.466, (159.407, 103.726, 146.146)), (' B  70  ALA  HB1', ' B 166  LEU HD22', -0.465, (142.729, 109.498, 152.396)), (' B  57  LEU  HA ', ' B  57  LEU HD12', -0.464, (147.441, 125.001, 131.233)), (' B  97  CYS  SG ', ' B 113  LYS  NZ ', -0.464, (160.725, 125.55, 148.738)), (' B 265  SER  HG ', ' B 289  SER  HB2', -0.464, (134.309, 140.15, 142.218)), (' A 209  MET  HE2', ' A 235  VAL HG11', -0.463, (158.378, 163.363, 150.229)), (' B  18  LYS  HB2', ' B  18  LYS  HE3', -0.463, (142.351, 116.444, 120.545)), (' B  33  ALA  HB2', ' B  78  GLU  HG3', -0.462, (168.53, 109.824, 150.246)), (' B 265  SER  OG ', ' B 289  SER  HB2', -0.462, (134.806, 140.152, 141.908)), (' A 265  SER  OG ', ' A 289  SER  HB2', -0.462, (151.079, 145.945, 141.823)), (' B 150  THR HG23', ' B 152  VAL HG23', -0.46, (152.875, 110.153, 144.947)), (' B 294  VAL  CG2', ' B 295  PRO  HD2', -0.46, (144.658, 128.899, 135.001)), (' A  31  PRO  HD3', ' A  37  ARG  HE ', -0.46, (126.231, 182.002, 146.402)), (' A 354  LYS  HE2', ' A 357  GLU  OE1', -0.458, (152.884, 183.537, 133.385)), (' A  46  CYS  SG ', ' A  67  HIS  HE1', -0.458, (144.387, 167.198, 139.115)), (' B  83  VAL  O  ', ' B  83  VAL HG13', -0.457, (156.588, 109.535, 155.557)), (' A  33  ALA  HB2', ' A  78  GLU  HG3', -0.456, (117.653, 175.792, 149.97)), (' A  83  VAL  O  ', ' A  83  VAL HG13', -0.454, (129.368, 176.524, 155.509)), (' B  37  ARG  HA ', ' B 150  THR  O  ', -0.454, (154.893, 107.229, 145.866)), (' A 194  THR  OG1', ' A 218  ARG  HB2', -0.452, (162.925, 147.252, 149.821)), (' A 192  GLY  HA2', ' A 217  ALA  CB ', -0.451, (161.754, 147.471, 154.934)), (' A 150  THR HG23', ' A 152  VAL HG23', -0.451, (132.842, 175.445, 145.037)), (' A 295  PRO  HG3', ' B 305  PRO  HB2', -0.451, (142.214, 152.234, 133.995)), (' A  37  ARG  HA ', ' A 150  THR  O  ', -0.45, (131.032, 178.687, 145.845)), (' B 361  LEU  C  ', ' B 367  SER  OG ', -0.45, (130.956, 114.125, 134.997)), (' A  97  CYS  SG ', ' A 113  LYS  NZ ', -0.448, (125.083, 159.983, 148.77)), (' B  40  MET  SD ', ' B  69  ALA  HB1', -0.447, (146.426, 109.087, 145.72)), (' A 254  LEU  HA ', ' A 254  LEU HD23', -0.447, (163.515, 146.407, 139.88)), (' A 361  LEU  HB3', ' A 367  SER  HB3', -0.447, (155.737, 173.346, 136.274)), (' B 343  ASP  N  ', ' B 344  PRO  CD ', -0.446, (128.785, 115.76, 151.423)), (' A  40  MET  SD ', ' A  69  ALA  HB1', -0.446, (139.758, 177.004, 145.548)), (' A 343  ASP  N  ', ' A 344  PRO  CD ', -0.446, (157.174, 170.24, 151.373)), (' B 200  LEU  HG ', ' B 223  ASP  HB2', -0.446, (126.456, 127.538, 138.523)), (' B 171  LEU HD11', ' B 346  ILE HG13', -0.446, (133.371, 114.052, 147.44)), (' B  73  VAL  HB ', ' B  85  PRO  O  ', -0.445, (153.549, 104.632, 154.721)), (' A  73  VAL  HB ', ' A  85  PRO  O  ', -0.445, (132.46, 181.377, 154.577)), (' A 305  PRO  HB2', ' B 295  PRO  HG3', -0.445, (143.696, 133.335, 134.148)), (' A 313  THR  O  ', ' A 313  THR HG23', -0.444, (146.322, 143.299, 145.596)), (' B  16  GLU  HB2', ' B  19  LYS  HD2', -0.444, (146.5, 111.222, 121.779)), (' B 194  THR  OG1', ' B 218  ARG  HB2', -0.443, (123.014, 139.214, 149.861)), (' B 192  GLY  HA2', ' B 217  ALA  CB ', -0.443, (124.227, 138.452, 154.937)), (' B 201  GLY  O  ', ' B 368  ILE  CG2', -0.443, (130.26, 119.305, 142.173)), (' B 354  LYS  HE2', ' B 357  GLU  OE1', -0.442, (132.853, 102.326, 133.475)), (' B 294  VAL  HA ', ' B 295  PRO  HD3', -0.442, (143.474, 129.895, 136.665)), (' A 200  LEU  HG ', ' A 223  ASP  HB2', -0.442, (159.51, 158.538, 138.518)), (' B 209  MET  HG2', ' B 235  VAL HG11', -0.441, (127.924, 123.547, 150.671)), (' B 304  ASN  HA ', ' B 305  PRO  HD3', -0.441, (139.807, 148.883, 130.612)), (' A 278  ALA  HA ', ' A 281  CYS  SG ', -0.441, (155.086, 146.786, 138.558)), (' A 101  ARG  NH2', ' B 260  GLY  HA3', -0.441, (124.638, 149.854, 144.637)), (' B 361  LEU  HB3', ' B 367  SER  HB3', -0.441, (130.378, 112.51, 135.866)), (' A 171  LEU HD11', ' A 346  ILE HG13', -0.441, (152.587, 171.947, 147.392)), (' B 313  THR  O  ', ' B 313  THR HG23', -0.44, (139.576, 142.803, 145.617)), (' A 116  LEU  C  ', ' A 116  LEU HD23', -0.44, (134.268, 158.496, 137.903)), (' B  92  LEU  CD2', ' B 328  VAL HG21', -0.438, (147.317, 118.939, 151.266)), (' B  69  ALA  CB ', ' B 145  THR HG23', -0.437, (146.829, 110.484, 144.707)), (' A 361  LEU  C  ', ' A 367  SER  OG ', -0.437, (154.858, 171.927, 134.557)), (' A  68  GLU  CG ', ' A  68  GLU  O  ', -0.437, (144.113, 172.095, 143.713)), (' B 278  ALA  HA ', ' B 281  CYS  SG ', -0.437, (131.035, 138.93, 138.191)), (' B 186  VAL  CG1', ' B 315  LYS  CD ', -0.436, (142.017, 137.284, 147.605)), (' A  63  VAL HG22', ' A  64  ILE  N  ', -0.436, (134.764, 173.24, 134.105)), (' A  16  GLU  HB2', ' A  19  LYS  HD2', -0.435, (139.195, 174.483, 121.991)), (' A   7  ILE HD11', ' A  74  GLU  CD ', -0.435, (129.871, 185.727, 146.995)), (' B  63  VAL HG22', ' B  64  ILE  N  ', -0.434, (151.311, 112.275, 134.087)), (' A  92  LEU  CD2', ' A 328  VAL HG21', -0.434, (138.606, 166.838, 151.269)), (' B  39  LYS  HG2', ' B 149  TYR  CE1', -0.434, (150.188, 100.933, 146.571)), (' B  95  PRO  HB3', ' B 156  SER  HB2', -0.433, (154.924, 119.688, 147.369)), (' B 144  SER  O  ', ' B 150  THR  OG1', -0.433, (151.527, 110.15, 142.21)), (' A 186  VAL  CG1', ' A 315  LYS  CD ', -0.432, (143.942, 149.108, 147.697)), (' A 351  PRO  HG2', ' A 354  LYS  CG ', -0.432, (150.849, 184.209, 136.71)), (' B   7  ILE HD11', ' B  74  GLU  CD ', -0.432, (155.953, 100.17, 147.063)), (' A  18  LYS  HB2', ' A  18  LYS  HE3', -0.43, (143.075, 169.553, 120.906)), (' A 272  LEU HD23', ' A 275  MET  HE1', -0.428, (144.984, 152.015, 132.604)), (' A 194  THR  CG2', ' A 218  ARG  HB2', -0.427, (162.515, 147.464, 148.839)), (' A  33  ALA  CA ', ' A  78  GLU  HB2', -0.427, (119.426, 175.334, 150.552)), (' B 351  PRO  HG2', ' B 354  LYS  CG ', -0.427, (135.106, 101.855, 136.756)), (' B 194  THR  CG2', ' B 218  ARG  HB2', -0.427, (123.452, 138.577, 148.889)), (' B 116  LEU  C  ', ' B 116  LEU HD23', -0.427, (152.07, 127.302, 137.667)), (' B 109  ASN  ND2', ' B 322  PHE  N  ', -0.426, (146.379, 129.001, 150.363)), (' A   5  LYS  HA ', ' A   5  LYS  HD3', -0.426, (122.566, 188.895, 143.759)), (' B 178  THR HG22', ' B 292  VAL  CG2', -0.426, (139.39, 127.932, 144.451)), (' A  39  LYS  HG2', ' A 149  TYR  CE1', -0.426, (135.766, 185.015, 146.543)), (' A 209  MET  HG2', ' A 235  VAL HG11', -0.424, (158.144, 162.257, 150.699)), (' B 272  LEU  O  ', ' B 275  MET  HG2', -0.424, (137.84, 136.561, 132.726)), (' B 308  LEU  HA ', ' B 308  LEU HD23', -0.423, (139.084, 146.845, 140.369)), (' A 350  LEU  HA ', ' A 350  LEU HD12', -0.423, (153.622, 182.029, 140.147)), (' B 272  LEU HD23', ' B 275  MET  HE1', -0.423, (140.985, 133.845, 132.593)), (' B  36  VAL  N  ', ' B 152  VAL  O  ', -0.423, (158.011, 111.176, 148.377)), (' A 311  GLY  HA2', ' B 316  GLY  O  ', -0.422, (146.352, 135.081, 144.735)), (' B  46  CYS  SG ', ' B  67  HIS  HE1', -0.422, (141.528, 118.766, 139.084)), (' B 257  MET  HB3', ' B 257  MET  HE2', -0.421, (119.594, 139.462, 143.3)), (' B 171  LEU HD11', ' B 346  ILE  CG1', -0.42, (133.225, 113.436, 147.434)), (' A 185  LYS  HB3', ' A 185  LYS  HE2', -0.42, (142.119, 153.372, 153.813)), (' A 294  VAL  HA ', ' A 295  PRO  HD3', -0.418, (142.7, 155.326, 136.587)), (' B 160  ILE  CG2', ' B 161  ASP  H  ', -0.418, (144.368, 112.67, 159.286)), (' B  38  ILE HG22', ' B  73  VAL  CG1', -0.418, (153.613, 106.92, 151.845)), (' A 178  THR HG22', ' A 292  VAL  CG2', -0.417, (146.636, 157.813, 144.047)), (' B 196  ALA  HB2', ' B 262  VAL HG21', -0.417, (126.435, 138.746, 143.656)), (' A  69  ALA  CB ', ' A 145  THR HG23', -0.417, (139.103, 175.311, 144.712)), (' A  26  VAL HG22', ' A 132  CYS  HB2', -0.417, (131.974, 182.366, 132.364)), (' A 260  GLY  HA3', ' B 101  ARG  NH2', -0.416, (161.335, 136.084, 144.53)), (' B  26  VAL HG22', ' B 132  CYS  HB2', -0.415, (154.308, 103.742, 132.139)), (' B 130  PHE  CD1', ' B 139  HIS  HD2', -0.415, (155.423, 110.491, 136.954)), (' A 308  LEU  HA ', ' A 308  LEU HD23', -0.414, (146.836, 138.624, 140.645)), (' B 123  MET  HE1', ' B 153  ASP  OD1', -0.414, (160.123, 113.877, 145.014)), (' A 272  LEU  O  ', ' A 275  MET  HG2', -0.414, (148.391, 149.398, 132.374)), (' A 164  SER  HG ', ' A 336  MET  HE2', -0.414, (145.575, 174.682, 158.982)), (' A 316  GLY  O  ', ' B 311  GLY  HA2', -0.414, (139.938, 150.844, 144.428)), (' A  95  PRO  HB3', ' A 156  SER  HB2', -0.413, (130.939, 166.686, 147.214)), (' B 350  LEU  HA ', ' B 350  LEU HD12', -0.413, (131.896, 104.183, 140.021)), (' A  63  VAL HG23', ' A 138  HIS  C  ', -0.413, (131.743, 172.719, 134.267)), (' A  36  VAL  N  ', ' A 152  VAL  O  ', -0.412, (128.043, 174.81, 148.452)), (' B 195  CYS  C  ', ' B 262  VAL HG11', -0.412, (127.844, 137.681, 146.022)), (' A 171  LEU HD11', ' A 346  ILE  CG1', -0.412, (152.395, 172.29, 147.344)), (' A 195  CYS  C  ', ' A 262  VAL HG11', -0.411, (157.991, 148.25, 146.106)), (' A 123  MET  HE1', ' A 153  ASP  OD1', -0.411, (125.937, 172.088, 145.069)), (' A  37  ARG  O  ', ' A  74  GLU  HB3', -0.41, (131.131, 182.063, 149.019)), (' B 303  MET  O  ', ' B 303  MET  SD ', -0.409, (140.708, 146.081, 132.252)), (' A 160  ILE  CG2', ' A 161  ASP  H  ', -0.409, (141.852, 173.441, 158.959)), (' B 254  LEU  HA ', ' B 254  LEU HD23', -0.408, (122.45, 139.059, 139.887)), (' A 109  ASN  ND2', ' A 322  PHE  N  ', -0.408, (139.584, 157.078, 150.313)), (' B 146  PHE  HA ', ' B 146  PHE  HD1', -0.407, (144.758, 108.735, 139.497)), (' A 303  MET  O  ', ' A 303  MET  SD ', -0.404, (145.19, 140.188, 132.545)), (' A 369  ARG  HA ', ' A 369  ARG  HD3', -0.404, (150.798, 170.21, 141.143)), (' B  80  VAL  O  ', ' B  80  VAL HG12', -0.403, (159.888, 111.051, 156.416)), (' B 362  LEU  N  ', ' B 367  SER  OG ', -0.403, (131.662, 114.127, 134.727)), (' A  80  VAL  O  ', ' A  80  VAL HG12', -0.402, (126.017, 174.858, 156.371)), (' A 257  MET  HB3', ' A 257  MET  HE2', -0.402, (165.932, 146.456, 143.442)), (' A 195  CYS  SG ', ' A 211  CYS  SG ', -0.402, (156.371, 151.904, 149.394)), (' A 196  ALA  HB2', ' A 262  VAL HG21', -0.402, (159.36, 147.634, 143.717)), (' B 229  PHE  CZ ', ' B 241  VAL  C  ', -0.401, (121.399, 130.423, 137.118)), (' A 229  PHE  CZ ', ' A 241  VAL  C  ', -0.401, (164.5, 155.548, 136.999)), (' A  16  GLU  CD ', ' A  19  LYS  HZ2', -0.4, (138.245, 175.712, 120.308)), (' B  38  ILE HG21', ' B  89  VAL HG21', -0.4, (151.703, 108.906, 151.158)), (' A 107  GLU  CG ', ' A 107  GLU  O  ', -0.4, (137.763, 150.554, 152.422)), (' B  63  VAL HG23', ' B 138  HIS  C  ', -0.4, (154.2, 113.383, 133.742))]
handle_read_draw_probe_dots_unformatted("molprobity_probe.txt", 0, 0)
show_probe_dots(True, True)
gui = coot_molprobity_todo_list_gui(data=data)
